#!/bin/sh
# the next line restarts using tclsh \
exec tclsh "$0" "$@"

if {$argc != 1} then {
    puts "usage: help_find_unaccessed_files.tcl speedesdir"
    exit
}

set reg_list {
    /include/
    /src/obsoleteNames/
    /cleanup$
    /.since_this_file_exists_the_directory_containing_this_file_must_exist$
    /vacpp/
    /tot$
    /doc/
    /example/
    /src/comm/MPI/
    /uname_output$
    /gnumake.Z$
    /import/importmode.el$
    /Admin/README$
    /Admin/emacsNewLineAndIndent.el$
    /Admin/make3.75.tar.Z$
    /Changes$
    /Copyright$
    /demos/BmdSim/Readme$
    /exe/clearipcs$
    /inputfiles/speedes.par$
    /member_differences$
    /src/comm/shMemTCP/clientServer/doc.sock$
    /src/comm/shMemTCP/clientServer/notes.hrouter$
    /src/engine/modelFramework/processModel/SpProcDebug.H$
    /README$
    /import/README$
}

proc mycompare {a b} {
    set at [file atime $a]
    set bt [file atime $b]
    if ($at<$bt) then {
	return -1;
    } elseif ($at>$bt) then {
	return 1;
    } else {
	return 0;
    }
}

set relevant_files ""

proc clock_format {time} {
    return [clock format $time -format "%H:%M"]
    #%b %d :%S
}

#set start_time [clock scan [lindex $argv 1]]

set speedes_home [lindex $argv 0]

# The cat is used so that I will get the stderr of the find command
set fh [open "| find $speedes_home |& cat" RDONLY]

while {[gets $fh file]>0} {
    set relevant_p 1
    foreach reg $reg_list {
	if [regexp $reg $file] then {
	    set relevant_p 0
	    break;
	}
    }
    if $relevant_p then {
# 	set at [file atime $file]
# 	if {$at <= $start_time} then {
# 	    regexp ${speedes_home}(.*) $file dummy relativefile 
# 	    puts "access time [clock_format $at]\
#                   for $relativefile is BEFORE [clock_format $start_time]"
# 	}
	set relevant_files [concat $relevant_files $file]
    }
}

foreach file [lsort -command mycompare $relevant_files] {
   puts "[clock format [file atime $file] -format "%b %d %H:%M:%S"] $file"
}
