// AdaToCppFuncs.H file defines the functions that are called by ADA to C++

#ifndef AdaCpp_def
#define AdaCpp_def

#define EXTERNAL_CPP extern "C"

EXTERNAL_CPP void SetExtrapolatedMotion(double StartTime,
					double EndTime,
					double x0[3],
					double v0[3],
					double a0[3],
					int PositionType
					);
EXTERNAL_CPP int GetNumProxies();
EXTERNAL_CPP void GoToFirstProxy();
EXTERNAL_CPP void GoToNextProxy();
EXTERNAL_CPP char *GetProxyName();
EXTERNAL_CPP void GetProxyPosVelAcc(double time,
				    double x[3],
				    double v[3],
				    double a[3],
				    int coordinateSystem);
EXTERNAL_CPP void SetAlive();
EXTERNAL_CPP void ResetAlive();
EXTERNAL_CPP int GetAlive();
EXTERNAL_CPP int GetProxyAlive();

EXTERNAL_CPP void RB_PrintString(char *s);

#endif
