// E_Scan.C method file

#include "E_HLA_event_SCAN.H"
#include "S_RanMot.H"
#include "F_ProxyItem.H"
#include "EntityProxy.H"
#include "ScheduleEvent.H"
#include "AdaToCppFuncs.H"

OBJ_MGR_TYPE (RANDOM_MOTION);

/************************************************************************
* E_SCAN : constructor for the SCAN event				*
************************************************************************/
E_SCAN::E_SCAN() {

}

/************************************************************************
* process : optimistically process event				*
************************************************************************/
void E_SCAN::process() {
  double X[3];
  double X0[3];
  double X1[3];

  S_HLA *HLAobj = (S_HLA *)SIMOBJ;

  ENTITY_PROXY *EntityProxy0 = (ENTITY_PROXY *)HLAobj->GetObjectProxy();
  EntityProxy0->Get_Position(X0, ECR, TIME_TAG);

  C_XQUEUE *RemoteObjectProxies = HLAobj->GetRemoteObjectProxies();

  int len = RemoteObjectProxies->get_length();
  F_PROXY_ITEM *ProxyItem = (F_PROXY_ITEM *)RemoteObjectProxies->get_top();

  for (int i=0; i<len; i++) {
    ENTITY_PROXY *EntityProxy1 = (ENTITY_PROXY *)ProxyItem->GetObjectProxy();

    static int TEST_OBJECT_not_tested_p = 1;
    if (TEST_OBJECT_not_tested_p &&
	EntityProxy1->GetObjectType() == RANDOM_MOTION)
    {
      TEST_OBJECT_not_tested_p = 0;
      OBJECT_PROXY *op = EntityProxy1->GetObjectProxy("TEST_OBJECT", 1);
      if (op)
      {
	char *s = op->GetString("TestObjectName");
	if (s)
	  cout << "Got TEST_OBJECT, so it worked: " << s << endl;
      }
    }
    
    // This code verifies that it is possible to have a string in a
    // proxy be NULL.
    static int not_tested_p = 1;
    if (not_tested_p && EntityProxy1->GetString("NULLTest")  == NULL)
    {
      not_tested_p = 0;
      cout << "NULLTest is NULL, so it worked" << '\n';
    }

    EntityProxy1->Get_Position(X1, ECR, TIME_TAG);
    Difference(X0, X1, X);
/*
    double Distance = Magnitude(X);
    char s[256];

    sprintf(s, "Distance between %d and %d at time %f is %f km\n",
	    EntityProxy0->GetGlobalId(),
	    EntityProxy1->GetGlobalId(),
	    double(TIME_TAG),
	    Distance);
    RB_PRINT(stdout, s);
*/

    ProxyItem = (F_PROXY_ITEM *)ProxyItem->get_link();
  }

// Test the Ada object proxy calls

  int Nproxies = GetNumProxies();

//  cout << "Number of Proxies: " << Nproxies << endl;

  GoToFirstProxy();
  for (int j=0; j<Nproxies; j++) {
    double Xl[3];
    double Vl[3];
    double Al[3];
    GetProxyPosVelAcc(TIME_TAG, Xl, Vl, Al, ECR);

//    cout << GetProxyName() << ": X = " << X[0] << " " << X[1] << " "
//	 << X[2] << endl;

    GoToNextProxy();
  }

  SIMTIME NextTime = TIME_TAG;
  NextTime.SetTime(TIME_TAG + 1.0);
  ReScheduleEvent(NextTime);

  if (get_from_SpComm()) {
    cout << "Error, got Scan message from SpComm!" << endl;
  }

  if (MESSAGE->bytes) {
    cout << "Error, Scan message has bytes!" << endl;
  }

}
