// E_TestRanMot.C method file

#include "E_RANDOM_MOTION_event_TEST_RANMOT.H"
#include "S_RanMot.H"
#include "rollbackStreams.H"
#include "MovingEntityProxy.H"
#include "ConstMotion.H"
#include "ScheduleEvent.H"

#include "FreeDynamicAttributes.H"
extern FREE_DYNAMIC_ATTRIBUTES *FreeDynamicAttributes;

/************************************************************************
* TEST_RANMOT : construct a TEST_RANMOT event object			*
************************************************************************/
E_TEST_RANMOT::E_TEST_RANMOT() {
}

/************************************************************************
* process : optimistically process event				*
************************************************************************/
void E_TEST_RANMOT::process() {
  S_RANDOM_MOTION *RandomMotion;
  SIMTIME Time;
  MOVING_ENTITY_PROXY *ObjectProxy;
  double X[3];
  int TestInt;
  double TestFloat;
  char *TestString;
  int TestLogical;
  int temp;
  C_XLIST *TestXlist;
  DYNAMIC_POSITION_ATTRIBUTE *Position;
  CONSTANT_MOTION *ConstantMotion;
  char s[256];

/*
** Cast the SIMOBJ to RandomMotion since we know that this is the type of
** object this event operates on
*/

  RandomMotion = (S_RANDOM_MOTION *)SIMOBJ;
  ObjectProxy = (MOVING_ENTITY_PROXY *)RandomMotion->GetObjectProxy();

/*
  cout << "Checking Proxy in TestRanmot" << endl;
  int status = ObjectProxy->CheckProxy();
  cout << "Done Checking Proxy in TestRanmot: status = " << status << endl;
*/

  ObjectProxy->Get_Position(X, EARTH, TIME_TAG);

  TestInt = RandomMotion->GetTestInt();
  TestFloat = RandomMotion->GetTestFloat();
  TestString = RandomMotion->GetTestString();
  TestLogical = RandomMotion->GetTestLogical();
  TestXlist = RandomMotion->GetTestXlist();

  sscanf(TestString, "Random Motion %d", &temp);
  sprintf(s, "Random Motion %d", temp+100);

  RandomMotion->SetTestInt(TestInt+100);
  RandomMotion->SetTestFloat(TestFloat+100.0);
  RandomMotion->SetTestString(s);
  RandomMotion->SetTestLogical((TestLogical+1)%2);
  *TestXlist += RB_strdup(s);

  RandomMotion->SetTestIntArray(0, RandomMotion->GetTestIntArray(0) + 100);
  RandomMotion->SetTestIntArray(1, RandomMotion->GetTestIntArray(1) + 101);
  RandomMotion->SetTestIntArray(2, RandomMotion->GetTestIntArray(2) + 102);

  Position = RandomMotion->GetPosition();
  double EndTime = Position->GetEndTime();
  (*Position)(EndTime, EARTH, X);

  ConstantMotion = (CONSTANT_MOTION *)
    RB_FREE_NEW(FreeDynamicAttributes, CONSTANT_MOTION_ID);
  ConstantMotion->SetEARTH();
  ConstantMotion->SetStartTime(EndTime);
  ConstantMotion->SetEndTime(EndTime + 1.0);
  ConstantMotion->SetPosition(X[0], X[1], X[2]);
  *Position += ConstantMotion;

  RandomMotion->GetTestPosition(X);
  X[0]++;
  X[1]++;
  X[2]++;
  RandomMotion->SetTestPosition(X);

  TEST_OBJECT *TestObj = RB_NEW_TEST_OBJECT();
  LIST_ATTRIBUTE *TestList = RandomMotion->GetTestList();
  sprintf(s, "Testing %d", TestList->get_length());
  TestObj->SetName(s);
  *TestList += TestObj;

/*
** Reschedule the event to occur at a later time
*/

  Time = TIME_TAG + 100.0;
  Time.SetPriority1(GLOBAL_ID);
  //  Time.SetPriority1(0);

#define TEST_RESCHEDULE
#ifndef TEST_RESCHEDULE
  schedule(Time,
	   EVENT_TYPE,
	   OBJECT_TYPE,
	   LOCAL_ID,
	   NODE);
#else
  ReScheduleEvent(Time);
#endif

}
