// E_SIMOBJ_event_HELLO_WORLD.C source file

#include "E_SIMOBJ_event_HELLO_WORLD.H"
#include "ScheduleEvent.H"

// <BEGIN: Define include files>
#include "simobj.H"
// <END:   Define include files>

#include "SpHostUser.H"
extern SP_HOST_USER *HostUser;

// <BEGIN: Constructor>
/******************************************************************************
* E_HELLO_WORLD constructor                                                   *
******************************************************************************/
E_HELLO_WORLD::E_HELLO_WORLD() {

// set_lazy();

}
// <END:   Constructor>

// <BEGIN: Define public virtual methods>
/******************************************************************************
* process: Optimistically process the event                                   *
******************************************************************************/
void E_HELLO_WORLD::process() {

  cout << "Processing E_HELLO_WORLD with data, "
       << (char *)&MESSAGE[1] << ", ExternalId = " << MESSAGE->ExternalId
       << " at time " << TIME_TAG << endl;

  SIMTIME time = TIME_TAG;
  time.SetTime(TIME_TAG + 10);
  ReScheduleEvent(time, MESSAGE, (char *)&MESSAGE[1], MESSAGE->bytes);

}

/******************************************************************************
* commit: commit the event                                                    *
******************************************************************************/
void E_HELLO_WORLD::commit() {

  if (MESSAGE->ExternalId >= 0) {
    HostUser->SendData(TIME_TAG,
			 MESSAGE->ExternalId,
			 "Hello Jeff",
			 strlen("Hello Jeff") + 1,
			 GLOBAL_ID);
  }

}
// <END:   Define public virtual methods>

// <BEGIN: Define public methods>
// <END:   Define public methods>

