// H_HELLO_WORLD.C source file

#include "ScheduleEvent.H"
#include "H_HELLO_WORLD.H"

#include "SpHostUser.H"
extern SP_HOST_USER *HostUser;


H_HELLO_WORLD::H_HELLO_WORLD() {
}


void H_HELLO_WORLD::Process(char *eventName, SIMTIME &timeTag,
			    char *data, int dataBytes,
			    int externalId) {

  cout << "<H_HELLO_WORLD> Event = " << eventName
       << ", Data = " << data
       << " (" << dataBytes << " bytes), Time = " << double(timeTag)
       << ", External Id = " << externalId
       << ", Global Id = " << GlobalId << endl;

// Note, this eventually needs to be rollbackable (do this later)

  if (externalId >= 0) {
    HostUser->SendData(timeTag,
			 externalId,
			 "Hello World Event Handler Response",
			 sizeof("Hello World Event Handler Response") + 1,
			 GlobalId);
  }else{

    if (SimObj->CheckSubscription(eventName)) {

      HostUser->SendSubscribedData(timeTag,
				     eventName,
				     "Hello World...",
				     sizeof("Hello World...") + 1,
				     GlobalId);
    }

  }

// Reschedule ourselves if there is a subscription

  if (SimObj->CheckSubscription(eventName)) {

    ScheduleEventHandler(timeTag + 10,
			 eventName,
			 ObjectType,
			 LocalId,
			 Node,
			 data,
			 dataBytes);
  }


}
