// O_GROUND_RADAR.C source file

#include "O_GROUND_RADAR.H"
#include "E_HLA_event_SCAN.H"

// <BEGIN: Global reference>
O_GROUND_RADAR *GROUND_RADAR_OBJECT_MANAGER = NULL;
// <END:   Global reference>

// <BEGIN: Constructor>
/******************************************************************************
* O_GROUND_RADAR constructor                                                  *
******************************************************************************/
O_GROUND_RADAR::O_GROUND_RADAR() {
  int i,j;
  void *Mark;
  int offset;

  GROUND_RADAR_OBJECT_MANAGER = this;

  Parser = new DATA_PARSER("GROUND_RADAR.par");
  Mark = Parser->GoTo("Objects", NULL);

  N_TOT = Parser->GetNumReferences(Mark, "OBJECT");
  N_LOC = deal_me(N_TOT, offset);

  LocalObjects = new S_GROUND_RADAR[N_LOC];

  cout << "NODE " << NODE << " Created "
       << N_LOC << " out of " << N_TOT << " GROUND_RADAR objects" << endl;

  j=0;
  Parser->GoToFirstReference(Mark, "OBJECT");
  for (i=0; i<N_TOT; i++) {
    if ((i-offset+N_NODES)%N_NODES == 0) {
      LocalObjects[j].set_SEED(10000*Replication + 12345 + i);
      // This line is commented out since the call to init will set the name.
      //LocalObjects[j].set_NAME(Parser->GetReferenceName());
      LocalObjects[j].init(Parser);
      j++;
    }
    Parser->GoToNextReference(Mark, "OBJECT");
  }

  reserve_n_objects(N_LOC);
  for (i=0; i<N_LOC; i++) define_object(&LocalObjects[i]);
  TOTAL_OBJECTS += N_TOT;

  set_interact();

}
// <END:   Constructor>

// <BEGIN: Define public virtual methods>
/******************************************************************************
* init_events: Initializes the events for my objects                          *
******************************************************************************/
void O_GROUND_RADAR::init_events() {

  cout << "Initializing events for Ground Radars" << endl;

  for (int i=0; i<N_LOC; i++) {
    schedule(1.0, SCAN, OBJECT_TYPE, i, NODE);
  }

}

/******************************************************************************
* terminate: executed at the end of the simulation                            *
******************************************************************************/
void O_GROUND_RADAR::terminate(double /*tend*/) {
  delete [] LocalObjects;
}
// <END:   Define public virtual methods>

// <BEGIN: Define public methods>
// <END:   Define public methods>

