// O_ScenEl.C source file

#include "O_ScenEl.H"
#include "CppToAdaFuncs.H"
#include "SpScheduleEvent.H"

EVENT_TYPE (SCAN)
EVENT_TYPE (BROADCAST_PROXY)

// <BEGIN: Global reference>
O_ScenEl *ScenEl_OBJECT_MANAGER = NULL;
// <END:   Global reference>

// <BEGIN: Constructor>
/******************************************************************************
* O_ScenEl constructor                                                        *
******************************************************************************/
O_ScenEl::O_ScenEl() {
  int i,j;
  void *Mark;
  int offset;
  int Status;

  ScenEl_OBJECT_MANAGER = this;

  Parser = new DATA_PARSER("ScenEl.par");
  Mark = Parser->GoTo("Objects", NULL);
  int ManualAllocation = Parser->GetLogical("ManualAllocation");

  N_TOT = Parser->GetNumReferences(Mark, "OBJECT");

  if (ManualAllocation) {
    Parser->GoToFirstReference(Mark, "OBJECT");
    N_LOC = 0;
    for (i=0; i<N_TOT; i++) {
      if (Parser->GetInt("Node")%N_NODES == NODE) N_LOC++;
      Parser->GoToNextReference(Mark, "OBJECT");
    }
  }else{
    N_LOC = deal_me(N_TOT, offset);
  }

  if (N_LOC) reserve_n_objects(N_LOC);

  cout << "NODE " << NODE << " Created "
       << N_LOC << " out of " << N_TOT << " ScenEl objects" << endl;

  j=0;
  Parser->GoToFirstReference(Mark, "OBJECT");
  for (i=0; i<N_TOT; i++) {
    if ( (ManualAllocation && (Parser->GetInt("Node")%N_NODES == NODE)) ||
         (!ManualAllocation && (i-offset+N_NODES)%N_NODES == 0) ) {
      S_ScenEl *ScenElObj = new S_ScenEl(Parser->GetString("SSR"));
      ScenElObj->set_SEED(10000*Replication + 12345 + i);
      ScenElObj->set_NAME(Parser->GetReferenceName());
      ScenElObj->init(Parser);
      define_object(ScenElObj);
      j++;
    }else{
      Status = CreateScenEl(Parser->GetReferenceName(),
			    Parser->GetString("SSR"),
			    Parser->GetInt("ScenElId"),
			    0);
      if (Status < 0) {
	cout << "Bad ScenEl " << Parser->GetReferenceName() << endl;
      }
    }
    Parser->GoToNextReference(Mark, "OBJECT");
  }

  TOTAL_OBJECTS += N_TOT;

  set_interact();
  set_global_names();

}
// <END:   Constructor>

// <BEGIN: Define public virtual methods>
/******************************************************************************
* init_events: Initializes the events for my objects                          *
******************************************************************************/
void O_ScenEl::init_events() {

  cout << "Initializing events for ScenEls" << endl;

  for (int i=0; i<N_LOC; i++) {
    //schedule(0.0, BROADCAST_PROXY, OBJECT_TYPE, i, NODE);
    schedule(1.0, SCAN, OBJECT_TYPE, i, NODE);
    
  }
  // One call per node to schedule init events for ScenEls that are on the Node
  ScheduleInitScenElEvents();
}

/******************************************************************************
* terminate: executed at the end of the simulation                            *
******************************************************************************/
void O_ScenEl::terminate(double /*tend*/) {

}
// <END:   Define public virtual methods>

// <BEGIN: Define public methods>
// <END:   Define public methods>

