// S_DSP.C source file

#include "S_DSP.H"
#include "H_HELLO_WORLD.H"

// <BEGIN: Constructor>
/******************************************************************************
* S_DSP constructor                                                           *
******************************************************************************/
S_DSP::S_DSP() : S_FIXED_ENTITY("DSP") {
  DEFINE_ATTRIBUTE(ScanTime, "ScanTime");

  H_HELLO_WORLD *HelloWorld = new H_HELLO_WORLD();

//  SetEventHandlerHashSize(10);

  AddEventHandler("HelloWorld", HelloWorld);
  AddEventHandler("GoodByeWorld", HelloWorld);

}
// <END:   Constructor>

// <BEGIN: Define public virtual methods>
/******************************************************************************
* terminate: executed at the end of the simulation                            *
******************************************************************************/
void S_DSP::terminate(double /*tend*/) {

}
// <END:   Define public virtual methods>

// <BEGIN: Define public methods>
/******************************************************************************
* init: Initializes the object using the parser                               *
******************************************************************************/
void S_DSP::init(DATA_PARSER *Parser) {

  Altitude = Parser->GetFloat("Altitude");
  ScanTime = Parser->GetFloat("ScanTime");
  double Lon = Parser->GetFloat("Lon");

  Position.SetEARTH(0.0, Lon*RADDEG, Altitude);

//  cout << "Altitude for object " << GLOBAL_ID << " = " << Altitude << endl;
//  ObjectProxy->PrintStream(cout);

}
// <END:   Define public methods>

