// S_GROUND_RADAR.C source file

#include "S_GROUND_RADAR.H"

// <BEGIN: Constructor>
/******************************************************************************
* S_GROUND_RADAR constructor                                                  *
******************************************************************************/
S_GROUND_RADAR::S_GROUND_RADAR() : S_FIXED_ENTITY("GROUND_RADAR") {

  DEFINE_ATTRIBUTE(ScanTime, "ScanTime");

}
// <END:   Constructor>

// <BEGIN: Define public virtual methods>
/******************************************************************************
* terminate: executed at the end of the simulation                            *
******************************************************************************/
void S_GROUND_RADAR::terminate(double /*tend*/) {

}
// <END:   Define public virtual methods>

// <BEGIN: Define public methods>
/******************************************************************************
* init: Initializes the object using the parser                               *
******************************************************************************/
void S_GROUND_RADAR::init(DATA_PARSER *Parser) {

  ScanTime = Parser->GetFloat("ScanTime");
  double Lon = Parser->GetFloat("Lon");
  double Lat = Parser->GetFloat("Lat");
  NAME = Parser->GetString("Name");

  Position.SetEARTH(Lat*RADDEG, Lon*RADDEG, 0.0);

//cout << "Lat/Lon for object " << NAME << " = " << Lat << " " << Lon << endl;
//ObjectProxy->PrintStream(cout);

}
// <END:   Define public methods>


