// S_RanMot.C source file

#include "S_RanMot.H"
#include "GreatCircle.H"
#include "Defines.H"
#include "F_ProxyItem.H"

#include "StopWatch.H"

#include "FreeDynamicAttributes.H"
#include "random.H"
extern FREE_DYNAMIC_ATTRIBUTES *FreeDynamicAttributes;

extern OBJECT_FACTORY *ObjFact;

S_RANDOM_MOTION::S_RANDOM_MOTION() : S_MOVING_ENTITY("RANDOM_MOTION"){

//  cout << "Creating Random Motion Object" << endl;

  DEFINE_ATTRIBUTE(TestIntArray, "TestIntArray");
  DEFINE_ATTRIBUTE(TestInt, "TestInt");
  DEFINE_ATTRIBUTE(TestFloat, "TestFloat");
  DEFINE_ATTRIBUTE(TestString, "TestString");
  DEFINE_ATTRIBUTE(TestLogical, "TestLogical");
  DEFINE_ATTRIBUTE(TestPosition, "TestPosition");
  DEFINE_ATTRIBUTE(TestObject, "TEST_OBJECT");
  DEFINE_ATTRIBUTE(TestList, "TestList");

}

void S_RANDOM_MOTION::InitMotion() {
  GREAT_CIRCLE *GreatCircle;
  double Lat, Lon, Alt, Vel;
  double OldLat, OldLon, OldAlt, OldTime;
  double X[3];
  int i;
  TEST_OBJECT *TestObj;
  char s[256];

  X[0] = X[1] = X[2] = 1;
  TestPosition.SetECR(X);
  TestObject[0].SetName("string index 0");
  TestObject[1].SetName("string index 1");
  RANDOM->set_seed(SEED);

  for (i=0; i<3; i++) {
    TestObj = new TEST_OBJECT();
    sprintf(s, "Testing %d", i);
    TestObj->SetName(s);
    TestList += TestObj;
  }

  RANDOM->set_float_limits(-PI_OVER2, PI_OVER2);
  OldLat = RANDOM->get_random_float();

  RANDOM->set_float_limits(-PI, PI);
  OldLon = RANDOM->get_random_float();

  RANDOM->set_float_limits(0.0, 10.0);
  OldAlt = RANDOM->get_random_float();

  OldTime = 0.0;

  DATA_PARSER *parser = new DATA_PARSER("speedes.par");
  parser->GoTo("parameters", NULL);
  double tend = parser->GetFloat("tend");
  delete parser;

  while (OldTime < tend) {

    GreatCircle = (GREAT_CIRCLE *)
      FreeDynamicAttributes->new_object(GREAT_CIRCLE_ID);

    RANDOM->set_float_limits(-PI_OVER2, PI_OVER2);
    Lat = RANDOM->get_random_float();

    RANDOM->set_float_limits(-PI, PI);
    Lon = RANDOM->get_random_float();

    RANDOM->set_float_limits(0.0, 10.0);
    Alt = RANDOM->get_random_float();

    RANDOM->set_float_limits(0.0, 7.0);
    Vel = RANDOM->get_random_float();

    GreatCircle->init_Vconstant(OldLat, OldLon, OldAlt, OldTime,
				Lat, Lon, Alt, Vel);

    OldLat = Lat;
    OldLon = Lon;
    OldAlt = Alt;
    OldTime = GreatCircle->GetEndTime();

    Position += GreatCircle;
  }

  SEED = RANDOM->get_seed();

}

void S_RANDOM_MOTION::terminate(double /*tend*/) {
#ifdef COMMENTOUT
  OBJECT_PROXY *Op;
  int i;

  cout << endl;
  cout << "Terminating Random Motion Object at time " << tend << endl;
  cout << "Printing my Object Proxy First" << endl;
  ObjectProxy->PrintStream();

  cout << endl;
  cout << "Now Cloning myself" << endl;
  Op = ObjFact->Clone(ObjectProxy);
  Op->PrintStream();

  cout << endl;
  cout << "Now printing remote Object Proxies" << endl;
  F_PROXY_ITEM *ProxyItem = (F_PROXY_ITEM *)RemoteObjectProxies.get_top();
  for (i=0; i<RemoteObjectProxies.get_length(); i++) {
    Op = ProxyItem->GetObjectProxy();
    Op->PrintStream();
    ProxyItem = (F_PROXY_ITEM *)ProxyItem->get_link();
  }

//#define TIME_CLONE
#ifdef TIME_CLONE
  STOPWATCH StopWatch1("Object Proxy Message");
  StopWatch1.StartTimer();
  for (i=0; i<100; i++) {
    OBJECT_PROXY_MESSAGE *ObjectProxyMessage =
      ObjFact->GenerateMessage(ObjectProxy);
    ObjFact->GenerateObjectProxy(ObjectProxyMessage);
    delete ObjectProxyMessage;
  }
  StopWatch1.StopTimer();
  StopWatch1.print();


  STOPWATCH StopWatch2("Clone Object Proxy");
  StopWatch2.StartTimer();
  for (i=0; i<100; i++) {
    ObjFact->Clone(ObjectProxy);
  }
  StopWatch2.StopTimer();
  StopWatch2.print();
#endif
#endif

}
