// S_RanMot.H header file

#ifndef S_RanMot_object
#define S_RanMot_object

#include "S_MovingEntity.H"

class TEST_OBJECT : public OBJECT_ATTRIBUTE {
  public:
    STRING_ATTRIBUTE TestObjectName;
    TEST_OBJECT() /*: OBJECT_ATTRIBUTE("TEST_OBJECT")*/ {
      SetClassName("TEST_OBJECT");
      DEFINE_ATTRIBUTE(TestObjectName, "TestObjectName");
    }
    void SetName(char *n) {TestObjectName = n;}
    char *GetName() {return TestObjectName;}
    int GetSize() { return sizeof(*this); }
};
RB_DEFINE_CLASS(TEST_OBJECT);

extern int RANDOM_MOTION_OBJECT_TYPE;
  
/************************************************************************
*	Random Motion Simulation Object			  		*
************************************************************************/
class S_RANDOM_MOTION : public S_MOVING_ENTITY {

  private:

    double ScanTime;

    INT_ATTRIBUTE TestInt;
    INT_ATTRIBUTE TestIntArray[3];
    FLOAT_ATTRIBUTE TestFloat;
    STRING_ATTRIBUTE TestString;
    LOGICAL_ATTRIBUTE TestLogical;
    POSITION_ATTRIBUTE TestPosition;

    TEST_OBJECT TestObject[2];
    LIST_ATTRIBUTE TestList;

    XLIST TestXlist;

  public:

/*
** Methods that SPEEDES calls
*/

    S_RANDOM_MOTION();
    void InitMotion();

    void SetTestIntArray(int i, int t) {TestIntArray[i] = t;}
    int GetTestIntArray(int i) {return TestIntArray[i];}

    void SetTestInt(int t) {TestInt = t;}
    int GetTestInt() {return TestInt;}

    void SetTestFloat(double t) {TestFloat = t;}
    double GetTestFloat() {return TestFloat;}

    void SetTestString(char *t) {TestString = t;}
    char *GetTestString() {return TestString;}

    void SetTestLogical(int t) {TestLogical = t;}
    int GetTestLogical() {return TestLogical;}

    void SetTestPosition(double X[3]) {TestPosition.SetECR(X);}
    void GetTestPosition(double X[3]) {TestPosition.GetECR(X);}

    LIST_ATTRIBUTE *GetTestList() {return &TestList;}

    XLIST *GetTestXlist() {return &TestXlist;}

    void SetScanTime(double t) {ScanTime = t;}
    virtual double GetScanTime() {return ScanTime;}

    virtual void terminate(double tend);

};

#endif
