// S_ScenEl.H header file

#ifndef S_ScenEl_Object
#define S_ScenEl_Object

#include "S_HLA.H"

// <BEGIN: Include files>
#include "simobj.H"
#include "DataParser.H"
// <END:   Include files>

/******************************************************************************
* S_ScenEl class definition                                                   *
******************************************************************************/
class S_ScenEl : public S_HLA {

  private:

    int ScenElId;
    DYNAMIC_POSITION_ATTRIBUTE Position;
    LOGICAL_ATTRIBUTE Alive;  // Note, because we inherit from S_HLA
                              // (not moving entity, or entity) we can
                              // also define an alive flag

  protected:

  public:

// <BEGIN: Define constructors>
    S_ScenEl(char *ProxyType);
// <END:   Define constructors>

// <BEGIN: Define public methods>

    void init(DATA_PARSER *Parser);
    int GetScenElId() {return ScenElId;}
    DYNAMIC_POSITION_ATTRIBUTE *GetPosition() {return &Position;}

    int GetAlive() {return Alive;}
    void SetAlive() {Alive = 1;}
    void ResetAlive() {Alive = 0;}

// <END:   Define public methods>

// <BEGIN: Define public virtual methods>
    virtual void terminate(double tend);
// <END:   Define public virtual methods>

};

#endif
