// E_CheckRange.C source file

#include "E_CheckRange.H"
#include "SpScheduleEvent.H"
#include "S_MovingEntity.H"
#include "S_Entity.H"
#include "EntityProxy.H"
#include "F_SpProxyItem.H"
#include "SpConvert.H"
#include "SpGeoFunctions.H"
#include "LatLon.H"

/******************************************************************************
* E_CheckRange constructor                                                    *
******************************************************************************/
E_CheckRange::E_CheckRange() {

// set_lazy();

}

void E_CheckRange::process() {
  S_ENTITY *simobj1;
  double lookahead_interval;
  C_OBJMAN *objman = (C_OBJMAN *) SIMOBJ;

  if (objman->get_N_LOC()<=0) return;

  simobj1 = (S_ENTITY *) objman->get_obj(0);
  lookahead_interval = simobj1->GetLookAheadHour() * 3600.0;

  // Rechedule event
  SpSimTime event_time = TIME_TAG;
  event_time += lookahead_interval;
  ReScheduleEvent(event_time);
}

void E_CheckRange::commit() {
  double x1[3], v1[3], a1[3];
  double x2[3], v2[3], a2[3];
  double range, elAngle, azimuth;
  C_XQUEUE *remote_proxies;
  int p, found;
  F_SpProxyItem *proxy_item;
  int i, j;
  S_ENTITY *simobj1, *simobj2;
  ENTITY_PROXY *proxy;
  C_OBJMAN *objman = (C_OBJMAN *) SIMOBJ;

  for (i=0; i<objman->get_N_LOC(); i++){
    simobj1 = (S_ENTITY *) objman->get_obj(i);
    proxy   = (ENTITY_PROXY *) simobj1->GetObjectProxy();
    proxy->Get_Position(x1, v1, a1, EARTH, TIME_TAG);
    remote_proxies = simobj1->GetRemoteObjectProxies();

//#ifdef NOT_USED
    proxy_item = (F_SpProxyItem *) remote_proxies->get_top();
    for (p=0; p<remote_proxies->get_length(); p++){
      proxy = (ENTITY_PROXY *) proxy_item->GetObjectProxy();
      proxy->Get_Position(x2, v2, a2, EARTH, TIME_TAG);
      getRngeAzElAng(RAD_to_DEG(x1[0]), RAD_to_DEG(x1[1]), 0.0, 
                     RAD_to_DEG(x2[0]), RAD_to_DEG(x2[1]), 0.0, 
                     range, elAngle, azimuth);
      cout << TIME_TAG << simobj1->get_NAME() << " remote proxy " << proxy_item->GetName()
           << " range " << range << " max range " << simobj1->GetMaxSensorRangeNmi() 
//         << " (" << x1[0] << ", " << x1[1] << ") "
//         << " (" << RAD_to_DEG(x1[0]) << ", " << RAD_to_DEG(x1[1]) << ") "
//         << " (" << x2[0] << ", " << x2[1] << ") "
//         << " (" << RAD_to_DEG(x2[0]) << ", " << RAD_to_DEG(x2[1]) << ") "
           << endl;
      proxy_item = (F_SpProxyItem *) proxy_item->get_link();
    }
//#endif

    for (j=0; j<objman->get_N_LOC(); j++){
      if (j==i) continue;
      simobj2 = (S_ENTITY *) objman->get_obj(j);
      proxy   = (ENTITY_PROXY *) simobj2->GetObjectProxy();
      proxy->Get_Position(x2, v2, a2, EARTH, TIME_TAG);

      getRngeAzElAng(RAD_to_DEG(x1[0]), RAD_to_DEG(x1[1]), 0.0, 
                     RAD_to_DEG(x2[0]), RAD_to_DEG(x2[1]), 0.0, 
                     range, elAngle, azimuth);

      if (range>simobj1->GetMaxSensorRangeNmi())
        continue;

      proxy_item = (F_SpProxyItem *) remote_proxies->get_top();
      for (found=0, p=0; p<remote_proxies->get_length(); p++){
        if (proxy_item->GetGlobalId()==simobj2->GetGlobalId()) found = 1;
        proxy_item = (F_SpProxyItem *) proxy_item->get_link();
      }
      if (!found){
        cout << TIME_TAG << simobj1->get_NAME() << " and " << simobj2->get_NAME() 
             << " range " << range << " max range " << simobj1->GetMaxSensorRangeNmi()
             << " ERROR:: proxy not found." << endl;
        abort();
      }
    }// j
  }// i
}
