// EntityDB.H

#ifndef EntityDBGate
#define EntityDBGate

#include "DataParser.H"
#include "RB_BinaryTree.H"
#include "S_HLA.H"

class EntityDB {

  private:

  protected:

    DATA_PARSER *CurrentEntities;
    DATA_PARSER *CurrentEntityTypes;
    int Index;
    int NumObjects;
    void *Mark;

    static BINARY_TREE *EntitiesList;
    static BINARY_TREE *EntityTypesList;

    static DATA_PARSER *SensorComponents;
    static DATA_PARSER *SensorTypes;

    static DATA_PARSER *TrackCorrelationComponents;
    static DATA_PARSER *TrackCorrelationTypes;

    static DATA_PARSER *WeaponComponents;
    static DATA_PARSER *WeaponTypes;

    static DATA_PARSER *PlatformComponents;
    static DATA_PARSER *PlatformTypes;

    static DATA_PARSER *ComnmandControlComponents;
    static DATA_PARSER *CommandControlTypes;

    static DATA_PARSER *MotionComponents;
    static DATA_PARSER *MotionTypes;

    static DATA_PARSER *CommunicationComponents;
    static DATA_PARSER *CommunicationTypes;

    static int done;

    int ForMyNode(int index, int offset, int numNodes) {
      return ( (index-offset+numNodes) % numNodes == 0 );
    }

  public:

    EntityDB(char *entityFileName, char *entityTypeFileName);
    int GetNumObjects() {return NumObjects;}

    S_HLA *CreateFirstEntity(int numNodes, int offset, int replication, int &done);
    S_HLA *CreateNextEntity(int numNodes, int offset, int replication, int &done);
    virtual S_HLA *CreateEntity() = 0;

    void CreateComponents(S_HLA *entity) {
//      CreateSensorComponents(entity);
//      CreateTrackCorrelationComponents(entity);
//      CreateWeaponComponents(entity);
//      CreatePlatformComponents(entity);
//      CreateCommandControlComponents(entity);
//      CreateMotionComponents(entity);
//      CreateCommunicationsComponents(entity);
    }

};

#endif
