// FixedEntityProxy.H header file

#ifndef FixedEntityProxy_Object
#define FixedEntityProxy_Object

#include "EntityProxy.H"

class FIXED_ENTITY_PROXY : public ENTITY_PROXY {
  private:
    static int RefPosition;
  protected:
  public:
    FIXED_ENTITY_PROXY() {
      RefPosition = GetReference("Position", "FIXED_ENTITY");
    }

    virtual void Get_Position(double X[3],
			      int PT, double Time) {
      GetPosition(RefPosition, X, PT, Time);
    }

    virtual void Get_Position(double X[3], double V[3],
			      int PT, double Time) {
      GetPosition(RefPosition, X, V, PT, Time);
    }

    virtual void Get_Position(double X[3], double V[3], double A[3],
			      int PT, double Time) {
      GetPosition(RefPosition, X, V, A, PT, Time);
    }

    virtual int GetPositionTimes(double time,
				  double &startTime,
				  double &endTime) {
      startTime = -1.0e20;
      endTime = 1.0e20;
      return 1;
    }

    virtual double GetVmax() {return 0.0;}

    virtual char *WhoAmI() {return "FIXED_ENTITY";}
};

#endif
