// FreeObjectProxy.C

#include "FreeObjectProxy.H"

/*
** Include files for all of the free list objects
*/

#include "EntityProxy.H"
#include "MovingEntityProxy.H"
#include "FixedEntityProxy.H"

int FIXED_ENTITY_PROXY::RefPosition = -1;
int MOVING_ENTITY_PROXY::RefPosition = -1;
int MOVING_ENTITY_PROXY::RefVmax = -1;

/*
** Enumerate IDs for Free List Object Proxies and define global variables
*/

enum {
  MOVING_ENTITY_PROXY_ID_ENUM,
  FIXED_ENTITY_PROXY_ID_ENUM,
  N_FREE_PROXYS
};

int MOVING_ENTITY_PROXY_ID = MOVING_ENTITY_PROXY_ID_ENUM;
int FIXED_ENTITY_PROXY_ID = FIXED_ENTITY_PROXY_ID_ENUM;

/*
** Functions that create n objects at a time
*/

void *new_MOVING_ENTITY_PROXY(int n) 	{return new MOVING_ENTITY_PROXY[n];}
void *new_FIXED_ENTITY_PROXY(int n) 	{return new FIXED_ENTITY_PROXY[n];}

/*
** Constructor where free list is set up
*/

FREE_OBJECT_PROXY::FREE_OBJECT_PROXY(int n) {

/*
** Tell the free list base class how many free lists to create
*/

  set_ntypes(n);

/*
** Define free list objects
*/

  set_type("MOVING_ENTITY",
	   MOVING_ENTITY_PROXY_ID,
	   new_MOVING_ENTITY_PROXY,
	   sizeof(MOVING_ENTITY_PROXY),
	   100);

  set_type("FIXED_ENTITY",
	   FIXED_ENTITY_PROXY_ID,
	   new_FIXED_ENTITY_PROXY,
	   sizeof(FIXED_ENTITY_PROXY),
	   100);

}
