// H_RadarDiscoverObject.C file

#include "M_RadarPrecomp.H"
#include "ScheduleEvent.H"
EVENT_TYPE(RadarPrecomp);

void H_RADAR_DISCOVER_OBJECT::Process(char *eventName, SIMTIME &timeTag,
                         char *data, int dataBytes,
			 int externalId) {
  M_RadarPrecomp radarPrecompMsg;
  SIMTIME startTime;

#ifdef NOISY
  RB_cout << "RadarDiscoverObject event handler" << endl;
#endif

/*
** Schedule the RadarPrecomp process when we discover an object (i.e.,
** receive its proxy).
*/

  radarPrecompMsg.RadarComponent = RadarComponent;
  radarPrecompMsg.ProxyItem = (F_PROXY_ITEM *)data;

  startTime = timeTag;
  if (startTime < 0.0) startTime = 0.0;
#ifdef NOT_USED
  startTime.SetPriority1(0);
  startTime.SetPriority2(0);
#endif

  ScheduleProcess(startTime, RadarPrecomp, ObjectType, LocalId, Node,
		  &radarPrecompMsg);
}
