// H_RadarReflectAttributes.C file

#include "H_RadarReflectAttributes.H"
#include "F_ProxyItem.H"
#include "RadarComponent.H"

void H_RadarReflecAttributes::Process(char *eventName, SIMTIME &timeTag,
					 char *data, int dataBytes,
					 int externalId) {

/*
** The remote proxy that has been modified is contained in the proxy item
** which is referenced in the data that is passed into this event handler.
** Since the remote proxy has changed its attributes, we assume the worst
** (for now anyway) and assume that its motion has changed. This means that we
** want to interrupt the RadarPrecomp process since its computations are
** wrong. The interrupt is done using the remote proxy semaphore (there is one
** for every remote proxy - sensor pair).
*/

  F_PROXY_ITEM *ProxyItem = (F_PROXY_ITEM *)data;
  OBJECT_PROXY *ObjectProxy = ProxyItem->GetObjectProxy();

#ifdef NOISY
  RB_cout << "Radar Reflect Attributes Event Handler" << endl;
#endif

  RadarComponent->SetRemoteProxySemaphore(ObjectProxy->GetGlobalId());

}
