
/************************************************************************/
/*                                                                      */
/*                              Metron Inc.                             */
/*                          11911 Freedom Drive                         */
/*                              Suite 800                               */
/*                           Reston, Virginia                           */
/*                            (703) 787-8700                            */
/*                                                                      */
/*                       Copyright 1995 by METRON INC.                  */
/*                           ALL RIGHTS RESERVED                        */
/*                                                                      */
/************************************************************************/



#if !defined( LATLONCONSTANTSdotH )
# define LATLONCONSTANTSdotH

# if defined( LatLonConstants_Here )
#   include <SpMath.H>
#   include <float.h>

extern const double VERYSMALL=       sqrt(FLT_MIN);
extern const double FAIRLYSMALL=     sqrt(VERYSMALL);
extern const double LATLON_PI=       2*acos(0);

//The following is from Standard Mathematical Tables, 18th edition, page 7.
//Published by CRC.  I took the average between the polar and equatorial radii.
//Speed of light is meters per second.
extern const double M_PER_E_RAD=     (6378388+6356912)/2.0;
extern const double FT_PER_M=        3.280840;
extern const double SPEED_OF_LIGHT=  2.997925E8;

//The rest is routine.
extern const double NMI_PER_E_CIRC=  360*60;
extern const double NMI_PER_E_RAD=   0.5*NMI_PER_E_CIRC/LATLON_PI;
extern const double M_PER_NMI=       M_PER_E_RAD/NMI_PER_E_RAD;
extern const double FT_PER_E_RAD=    FT_PER_M * M_PER_E_RAD;

# else
extern const double VERYSMALL;
extern const double FAIRLYSMALL;
extern const double LATLON_PI;
extern const double M_PER_E_RAD;
extern const double FT_PER_M;
extern const double SPEED_OF_LIGHT;
extern const double NMI_PER_E_CIRC;
extern const double NMI_PER_E_RAD;
extern const double M_PER_NMI;
extern const double FT_PER_E_RAD;
# endif

#endif
