// MovingEntityProxy.H header file

#ifndef MovingEntityProxy_Object
#define MovingEntityProxy_Object

#include "EntityProxy.H"

class MOVING_ENTITY_PROXY : public ENTITY_PROXY {
  private:
    static int RefPosition;
    static int RefVmax;

  protected:
  public:
    MOVING_ENTITY_PROXY() {
      RefPosition = GetReference("Position", "MOVING_ENTITY");
      RefVmax = GetReference("Vmax", "MOVING_ENTITY");
    }

    virtual void Get_Position(double X[3],
			      int PT, double Time) {
      GetDynamicPosition(RefPosition, X, PT, Time);
    }

    virtual void Get_Position(double X[3], double V[3],
			      int PT, double Time) {
      GetDynamicPosition(RefPosition, X, V, PT, Time);
    }

    virtual void Get_Position(double X[3], double V[3], double A[3],
			      int PT, double Time) {
      GetDynamicPosition(RefPosition, X, V, A, PT, Time);
    }

    virtual int GetPositionTimes(double time,
				 double &startTime,
				 double &endTime) {
      return GetTimeInterval(RefPosition, time, startTime, endTime);
    }

    virtual double GetVmax() {
      return GetFloat(RefVmax);
    }

    virtual char *WhoAmI() {return "MOVING_ENTITY";}
};

#endif
