// O_PARAMETERS.C source file

#include "O_PARAMETERS.H"

// <BEGIN: Initialize static variables>
DATA_PARSER *O_PARAMETERS::ParmParser = NULL;
int O_PARAMETERS::Replication = 0;
// <END:   Initialize static variables>

DATA_PARSER *LocationParser = NULL;
DATA_PARSER *SensorParser = NULL;

int DebugRadarPrecomp = 0;
int DebugRadarScan = 0;
int DebugObjectProxy = 0;
int DebugRemoteObjectProxy = 0;

// <BEGIN: Constructor>
/******************************************************************************
* O_PARAMETERS constructor                                                    *
******************************************************************************/
O_PARAMETERS::O_PARAMETERS() {

  if (ParmParser == NULL) {

    cout << "Reading Parameters.par " << endl;

/*
** Read in the Parameters.par file and set up the replication number
*/

    ParmParser = new DATA_PARSER("Parameters.par");
    ParmParser->GoTo("Parameters", NULL);
    Replication = ParmParser->GetInt("Replication");
    cout << "Executing Replication " << Replication << endl;

/*
** Set up debug tags
*/

    ParmParser->GoTo("DebugTags", NULL);

    DebugRadarPrecomp = ParmParser->GetLogical("RadarPrecomp");
    DebugRadarScan = ParmParser->GetLogical("RadarScan");
    DebugObjectProxy = ParmParser->GetLogical("ObjectProxy");
    DebugRemoteObjectProxy = ParmParser->GetLogical("RemoteObjectProxy");

/*
** Reading in Locations.par file
*/

    cout << "Reading in Locations.par" << endl;
    LocationParser = new DATA_PARSER("Locations.par");

/*
** Reading in Sensors.par file
*/

    cout << "Reading in Sensors.par" << endl;
    SensorParser = new DATA_PARSER("Sensors.par");

    cout << "Done constructing Parameters" << endl;

  }

}
// <END:   Constructor>

