// DetectionId.H header file defines the OBJECT_ATTRIBUTE that defines a
// OBJECT_ID. Each sensor has a SensorListElement that will contain a list
// of its OBJECTS

#ifndef OBJECT_ID_OBJ
#define OBJECT_ID_OBJ

#include "ObjectProxy.H"

class OBJECT_ID : public OBJECT_ATTRIBUTE {

  private:

    INT_ATTRIBUTE ObjectId;
    STRING_ATTRIBUTE ObjectName;

  protected:

  public:

    OBJECT_ID() {
      SetClassName("OBJECT_ID");
      DEFINE_ATTRIBUTE(ObjectId, "ObjectId");
      DEFINE_ATTRIBUTE(ObjectName, "ObjectName");
    }

    void SetObjectId(int objectId) {ObjectId = objectId;}
    int GetObjectId() {return ObjectId;}

    void SetObjectName(char *objectName) {ObjectName = objectName;}
    char *GetObjectName() {return ObjectName;}

};

RB_DEFINE_CLASS(OBJECT_ID);

#endif
