// PlugInParNSS.C

/*
** Define the object managers for Parallel NSS
*/

#include "Speedes.H"

#include "O_Ship.H"
#include "S_Ship.H"

#include "O_RanMot.H"
#include "S_RanMot.H"

#include "P_RadarScan.H"
#include "P_RadarPrecomp.H"

#include "E_CheckRange.H"

#include "SpPlugInDDM.H"

/*
** Define the object managers for Parallel NSS
*/

DEFINE_OBJECT_MANAGER(Ship, O_Ship);
DEFINE_OBJECT_MANAGER(RanMot, O_RanMot);

/************************************************************************
* Plug in the object managers and events				*
************************************************************************/
void PlugInParNSS() {

/*
** Plug in the object managers for Parallel NSS
*/

   PlugInDDM();

   PLUG_IN_OBJECT_MANAGER(Ship);
   PLUG_IN_OBJECT_MANAGER(RanMot);

/*
** Plug in the events for Parallel NSS
*/

   PLUG_IN_EVENT(ToggleMotion);
   PLUG_IN_EVENT(RadarScan);
   PLUG_IN_EVENT(RadarPrecomp);

#ifdef VALIDATE_DDM
   PLUG_IN_EVENT(CheckRange);
#endif
}
