// RadarComponent.H header file

#ifndef RADAR_COMP_OBJ
#define RADAR_COMP_OBJ

#include "SensorComponent.H"
#include "DataParser.H"

#include "RadarSensorModel.H"

#include "H_RadarUpdateAttributes.H"
#include "H_RadarReflectAttributes.H"
#include "H_RadarDiscoverObject.H"

class RADAR_COMPONENT : public SENSOR_COMPONENT {

  private:

  protected:

    S_ENTITY *S_Entity;
    char *RadarType;
    int SensorId;

    double Range;
    double ScanTime;

    RADAR_SENSOR_MODEL RadarSensorModel;

    H_RadarUpdateAttributes UpdateAttributes;
    H_RadarReflecAttributes ReflectAttributes;
    H_RADAR_DISCOVER_OBJECT DiscoverObject;

  public:

    RADAR_COMPONENT(S_ENTITY *entity,
		    DATA_PARSER *parser,
		    char *radarType,
		    int sensorId);

    virtual void InitEvents();

    double GetRange() const {return Range;}
    double GetScanTime() {return ScanTime;}
    void *GetModel() {return &RadarSensorModel;}
    RADAR_SENSOR_MODEL *GetRadarSensorModel() {return &RadarSensorModel;}
    char *GetRadarType() {return RadarType;}
    int GetSensorId() {return SensorId;}
};

#endif
