// RadarSensor.H is a radar model for generic radar sensors

#include "SensorModel.H"
#include "RB_BinaryTree.H"
#include "Detection.H"

class RADAR_SENSOR_MODEL : public SENSOR_MODEL {

  private:

  protected:

    double Range;
    double ScanTime;

    double SigmaRange;
    double SigmaRangeRate;
    double SigmaAngle;

  public:

    RADAR_SENSOR_MODEL();

    void SetRange(double range) {Range = range;}
    void SetScanTime(double scanTime) {ScanTime = scanTime;}

    void SetSigmaRange(double sigmaRange) {SigmaRange = sigmaRange;}
    void SetSigmaRangeRate(double sigmaRangeRate) {
      SigmaRangeRate = sigmaRangeRate;
    }
    void SetSigmaAngle(double sigmaAngle) {SigmaAngle = sigmaAngle;}

    virtual void FormDetections(RB_BINARY_TREE *detections, int &seed);

};

