// S_Entity.H header file

#ifndef S_ENTITY_OBJ
#define S_ENTITY_OBJ

#include "S_HLA.H"
#include "RB_BinaryTree.H"
#include "DataParser.H"

class S_ENTITY : public S_HLA {

  private:

  protected:

    RB_BINARY_TREE PlatformComponents;
    RB_BINARY_TREE MotionComponents;
    RB_BINARY_TREE WeaponComponents;
    RB_BINARY_TREE SensorComponents;
    RB_BINARY_TREE TrackCorrelationComponents;
    RB_BINARY_TREE CommandControlComponents;
    RB_BINARY_TREE CommunicationComponents;

    LOGICAL_ATTRIBUTE Alive;
    LIST_ATTRIBUTE SensorList;

  public:

    S_ENTITY(char *ProxyType) : S_HLA(ProxyType) {
      Alive = 1;
      DEFINE_ATTRIBUTE(Alive, "Alive");
      DEFINE_ATTRIBUTE(SensorList, "SensorList");
    }

    LOGICAL_ATTRIBUTE GetAlive () { return Alive; }
    LIST_ATTRIBUTE *GetSensorList() {return &SensorList;}

    double GetMaxSensorRangeNmi(void);

};

#endif
