// S_Ship.H header file

#ifndef S_Ship_Object
#define S_Ship_Object

#include "S_MovingEntity.H"
#include "ScheduleEvent.H"
#include "Speedes.H"

// <BEGIN: Include files>
#include "simobj.H"
#include "DataParser.H"
// <END:   Include files>

/******************************************************************************
* S_Ship class definition                                                     *
******************************************************************************/
class S_Ship : public S_MOVING_ENTITY {

  private:

  protected:

  public:

// <BEGIN: Define constructors>
    S_Ship();
// <END:   Define constructors>

// <BEGIN: Define public methods>
    void init(DATA_PARSER *Parser);
// <END:   Define public methods>

// <BEGIN: Define public virtual methods>
    virtual void Query(double t, NAME_VALUE_LIST &NameValueList);
    virtual void NamedQuery(double t, NAME_VALUE_LIST &NameValueList,
			    char *queryName);

    virtual void terminate(double tend);
// <END:   Define public virtual methods>

    void InitEvents();

// Event methods

    void ToggleMotion(double time, int iteration);

    double GetLookAheadHour(void);
    double GetMaxSpeedKnots(void);
    double GetMinExpansionNmi(void);
    double GetMinRescheduleTimeHour(void);
    void   GetPositionRadKm(double time, double &latRad, double &lonRad, double &altKm);
};

DEFINE_EVENT_METHOD_2_ARG(ToggleMotion, 10, S_Ship, ToggleMotion, double, int);

#endif
