// SensorListElement.H header file defines the OBJECT_ATTRIBUTE that goes in
// the SensorList for simulated entities. This class contains list of
// OBJECT_ATTRIBUTES called Detections.

#ifndef SENSOR_LIST_ELEMENT_OBJ
#define SENSOR_LIST_ELEMENT_OBJ

#include "ObjectProxy.H"
#include "ObjectId.H"

class SENSOR_LIST_ELEMENT : public OBJECT_ATTRIBUTE {

  private:

    LIST_ATTRIBUTE DetectedObjects;

  protected:

  public:

    SENSOR_LIST_ELEMENT() {
      SetClassName("SENSOR_LIST_ELEMENT");
      DEFINE_ATTRIBUTE(DetectedObjects, "DetectedObjects");
    }

    void AddObjectId(OBJECT_ID *objectId) {
      DetectedObjects += objectId;
    }

    void RemoveObjectId(OBJECT_ID *objectId) {
      DetectedObjects -= objectId;
    }

    LIST_ATTRIBUTE *GetDetectedObjects() {return &DetectedObjects;}

};
RB_DEFINE_CLASS(SENSOR_LIST_ELEMENT);

#endif
