// TestOPSM.C is a test program that tests if the object proxy state manager
// is working.

#include <stdlib.h>
#include <iostream.h>

#include "SpExtFedStateMgr.H"
SpExtFedStateMgr *ExtFedStateMgr = NULL;

int main() {
  SpDataParser *Parser = new SpDataParser("speedes.par");

  ExtFedStateMgr = new SpExtFedStateMgr(Parser);
  ExtFedStateMgr->Connect("Test External Federate");

  sleep(1);
  ExtFedStateMgr->SetTimeLag(20.0);

  sleep(1);
  ExtFedStateMgr->Subscribe("ENTITY");

  SpSimTime timeGranted = ExtFedStateMgr->GetTimeGranted();

  for (int i=0; i<20; i++) {

    sleep(1);
    SpSimTime time = timeGranted;
    time += 25.0;

    ExtFedStateMgr->NextEventRequest(time);

    while (!ExtFedStateMgr->TimeAdvanceGranted()) {
      ExtFedStateMgr->ReadMessages();
    }

    timeGranted = ExtFedStateMgr->GetTimeGranted();
    cout << "Time Granted = " << timeGranted << endl;

    ExtFedStateMgr->GoToTime(timeGranted);
    ExtFedStateMgr->GoToTime(0.0);

    cout << "NumProxies at time 0.0 = "
	 << ExtFedStateMgr->GetNumProxies()
	 << endl;

    ExtFedStateMgr->GoToTime(timeGranted);

    cout << "NumProxies at time " << timeGranted << " = "
	 << ExtFedStateMgr->GetNumProxies()
	 << endl;

    SpObjProxy *objProxy = ExtFedStateMgr->GetFirstProxy();
    while (objProxy) {
      objProxy->PrintStream(cout);
      objProxy = ExtFedStateMgr->GetNextProxy();
    }

  }

  delete ExtFedStateMgr;

}
