// VectorOperatiions.H file defines more vector operations. These should
// be merged into the Convert.H file later on.

/*
** FormCoordinateSystem takes an input vector (u1) and computes u2 and u3 to
** form an orthogonal coordinate system
*/

void FormCoordinateSystem(double u1[3], double u2[3], double u3[3]);

/*
** CheckCoordinateSystem takes three vectors and checks if they form a
** correct right-hand-rule normalized coordinate system.
*/

int CheckCoordinateSystem(double u1[3], double u2[3], double u3[3]);

/*
** Rotate coordinate system about one of the axis
*/

void Rotate1(double u1[3], double u2[3], double u3[3], double angle);
void Rotate2(double u1[3], double u2[3], double u3[3], double angle);
void Rotate3(double u1[3], double u2[3], double u3[3], double angle);
