// O_ship.C source file

#include "O_ship.H"
#include "SpScheduleEvent.H"

SCHEDULE_1_ARG (RequestInt, int);
SCHEDULE_1_ARG (RequestDbl, int);
SCHEDULE (Add);
SCHEDULE (PrintResults);

O_ship *ship_OBJECT_MANAGER = NULL;

O_ship::O_ship(): numRequesters(3) { // test should pass for any positive
                                     // integer for numRequsters
                                     // (within memory limitations)
  int i,j;
  void *Mark;
  int offset;

  ship_OBJECT_MANAGER = this;

  Parser = new DATA_PARSER("ship.par");
  Mark = Parser->GoTo("Objects", NULL);

  N_TOT = Parser->GetNumReferences(Mark, "OBJECT");
  N_LOC = deal_me(N_TOT, offset);

  LocalObjects = new S_ship[N_LOC];

  cout << "NODE " << NODE << " Created "
       << N_LOC << " out of " << N_TOT << " ship objects" << endl;

  j=0;
  Parser->GoToFirstReference(Mark, "OBJECT");
  for (i=0; i<N_TOT; i++) {
    if ((i-offset+N_NODES)%N_NODES == 0) {
      LocalObjects[j].set_SEED(10000*Replication + 12345 + i);
      LocalObjects[j].set_NAME(Parser->GetReferenceName());
      j++;
    }
    Parser->GoToNextReference(Mark, "OBJECT");
  }

  reserve_n_objects(N_LOC);
  for (i=0; i<N_LOC; i++) define_object(&LocalObjects[i]);
  TOTAL_OBJECTS += N_TOT;

  set_interact();

}

void O_ship::init_events() {
   //ReentryMsg *msg;
   SpObjectHandle objectHandle;

   objectHandle.NodeId = NODE;
   objectHandle.ObjManId = OBJECT_TYPE;
   objectHandle.SimObjId = 0;

   for (int i=0; i<N_LOC; i++)
   {
      objectHandle.SimObjId = i;
      for (int j=0; j<numRequesters; j++)
      {
	 ScheduleRequestInt(0, objectHandle, j);
	 ScheduleRequestDbl(0, objectHandle, j);
      }
      ScheduleAdd(0, objectHandle);
      SchedulePrintResults(0, objectHandle);
   }   
}
