// S_ship.C source file

#include "S_ship.H"
#include "O_ship.H"

RB_DEFINE_CLASS(SpProcStackElement);

S_ship::S_ship():

   // this test should pass for any set of positive values for the following:
   
   intAmount(59),
   dblAmount(12.142),
   intIncrement(1),
   dblIncrement(5.24523)
{}

void S_ship::PrintResults()
P_VAR
   P_LV(int, dummy)
   P_LV(int, passed);
P_BEGIN(1)
// wait until all requesters are finished
REQUEST_RESOURCE (1, printResultsSem, numRequesters * 2, -1, dummy);

// terminate the Add process
terminateAddSem = 1;

// determine if the test passed, or why it failed
int correctIntTally = intAmount / intIncrement - 1;
int correctDblTally = (int) (dblAmount / dblIncrement + 0.0000000001);
if (dblAmount / dblIncrement - correctDblTally <= 0.0000000001)
   --correctDblTally;

passed = 1;
if (intTally != correctIntTally)
{
   cout << "test failed: intTally should be "
	<< correctIntTally 
	<< " but was "
	<< intTally
	<< endl;
   passed = 0;
}
if (dblTally != correctDblTally)
{
   cout << "test failed: dblTally should be "
	<< correctDblTally 
	<< " but was "
	<< dblTally
	<< endl;
   passed = 0;
}
if (passed) cout << "test passed" << endl;
P_END

void S_ship::RequestInt(int intRequesterId)
P_VAR
  P_LV(int, success);
P_BEGIN(1)
// There used to be a "while" loop here, but Insure++ cannot handle
// some kinds of conditional expressions being in "while" or "for"
// loops.  But it can handle those expressions being in if statements.
// Therefore I made the loop condition be always true, and moved the
// condition inside the loop into an if statement, but of course I had
// to prepend a boolean "not" symbol of the exclamation point to the
// expression.  Note that the kinds of expressions Insure++ cannot
// handle are demonstrated by a bug report I sent to parasoft.
for (;;)
{
   if (!(GetTime() >= 0.0)) break;
   REQUEST_RESOURCE (1, intSem, intAmount, 1, success);
   if (success) break;
   if (intRequesterId == 0) intTally += 1;
}
printResultsSem += 1;
P_END

void S_ship::RequestDbl(int dblRequesterId)
P_VAR
  P_LV(int, success);
P_BEGIN(1)
// There used to be a "while" loop here, but Insure++ cannot handle
// some kinds of conditional expressions being in "while" or "for"
// loops.  But it can handle those expressions being in if statements.
// Therefore I made the loop condition be always true, and moved the
// condition inside the loop into an if statement, but of course I had
// to prepend a boolean "not" symbol of the exclamation point to the
// expression.  Note that the kinds of expressions Insure++ cannot
// handle are demonstrated by a bug report I sent to parasoft.
for (;;)
{
  if (!(GetTime() >= 0.0)) break;
   REQUEST_RESOURCE (1, dblSem, dblAmount, 1, success);
   if (success) break;
   if (dblRequesterId == 0) dblTally += 1;
}
printResultsSem += 1;
P_END

void S_ship::Add()
P_VAR
P_BEGIN(2)

// number of processes requesting resources from the Add process
numRequesters = ((O_ship *) get_manager())->getNumRequesters();

// There used to be a "while" loop here, but Insure++ cannot handle
// some kinds of conditional expressions being in "while" or "for"
// loops.  But it can handle those expressions being in if statements.
// Therefore I made the loop condition be always true, and moved the
// condition inside the loop into an if statement, but of course I had
// to prepend a boolean "not" symbol of the exclamation point to the
// expression.  Note that the kinds of expressions Insure++ cannot
// handle are demonstrated by a bug report I sent to parasoft.
for (;;)
{
  if (!(GetTime() >= 0.0)) break;
   WAIT_FOR(1, terminateAddSem, 0);
   if (terminateAddSem) break;
   intSem += intIncrement;
   dblSem += dblIncrement;
   WAIT(2, 1);
}
P_END
