// O_ship.C source file

#include "O_ship.H"
#include "Semaphore.H"
#include "SpScheduleEvent.H"

EVENT_TYPE (e1);
EVENT_TYPE (e2);

// <BEGIN: Global reference>
O_ship *ship_OBJECT_MANAGER = NULL;
// <END:   Global reference>

// <BEGIN: Constructor>
/******************************************************************************
* O_ship constructor                                                          *
******************************************************************************/
O_ship::O_ship() {
  int i,j;
  void *Mark;
  int offset;

  ship_OBJECT_MANAGER = this;

  Parser = new DATA_PARSER("ship.par");
  Mark = Parser->GoTo("Objects", NULL);

  N_TOT = Parser->GetNumReferences(Mark, "OBJECT");
  N_LOC = deal_me(N_TOT, offset);

  LocalObjects = new S_ship[N_LOC];

  cout << "NODE " << NODE << " Created "
       << N_LOC << " out of " << N_TOT << " ship objects" << endl;

  j=0;
  Parser->GoToFirstReference(Mark, "OBJECT");
  for (i=0; i<N_TOT; i++) {
    if ((i-offset+N_NODES)%N_NODES == 0) {
      LocalObjects[j].set_SEED(10000*Replication + 12345 + i);
      LocalObjects[j].set_NAME(Parser->GetReferenceName());
      LocalObjects[j].init(Parser);
      j++;
    }
    Parser->GoToNextReference(Mark, "OBJECT");
  }

  reserve_n_objects(N_LOC);
  for (i=0; i<N_LOC; i++) define_object(&LocalObjects[i]);
  TOTAL_OBJECTS += N_TOT;

  set_interact();

}
// <END:   Constructor>

// <BEGIN: Define public virtual methods>
/******************************************************************************
* init_events: Initializes the events for my objects                          *
******************************************************************************/
void O_ship::init_events() {
   ReentryMsg *msg;

   for (int i=0; i<N_LOC; i++)
   {
     msg = (ReentryMsg *)
       schedule (0.0, e1, OBJECT_TYPE, i, NODE);
     msg->type = BEGIN_PROCESS;
     msg = (ReentryMsg *)
       schedule (0.0, e2, OBJECT_TYPE, i, NODE);
     msg->type = BEGIN_PROCESS;
   }   
}

/******************************************************************************
* terminate: executed at the end of the simulation                            *
******************************************************************************/
void O_ship::terminate(double) {

}
// <END:   Define public virtual methods>

// <BEGIN: Define public methods>
// <END:   Define public methods>

