// app1man.H header file

#ifndef app1man_object
#define app1man_object

#include "parsman.H"
#include "app1obj.H"

/************************************************************************
*	app1man object - manager of node objects			*
************************************************************************/
class C_APP1MAN : public C_PARSMAN {

  private:

    C_APP1OBJ *app1obj;			// hypercube node objects

    double compute_time;		// compute time for app1
    int fanout;				// number of fanouts
    int bytes;				// number of bytes per message
    int test_flag;			// test flag for debugging
    int HYPER_n_nodes;			// number of simulated nodes

  protected:

  public:

    C_APP1MAN();
    virtual void init_events();

    void set_compute_time(double ct) {compute_time = ct;}
    double get_compute_time() {return compute_time;}

    void set_fanout(int f) {fanout = f;}
    int get_fanout() {return fanout;}

    void set_bytes(int b) {bytes = b;}
    int get_bytes() {return bytes;}

    void set_test_flag(int tf) {test_flag = tf;}
    int get_test_flag() {return test_flag;}

    void set_HYPER_n_nodes(int nds) {HYPER_n_nodes = nds;}
    int get_HYPER_n_nodes() {return HYPER_n_nodes;}

    void terminate(double /*tend*/);
};

DEFINE_OBJECT_MANAGER(APP1, C_APP1MAN);

#endif
