// change_band.C method file

#include "SpStdio.H"

#include "change_band.H"
#include "nodeman.H"

/************************************************************************
* C_CHANGE_BAND : construct a change_band object			*
************************************************************************/
C_CHANGE_BAND::C_CHANGE_BAND() {
  set_lazy();
}

/************************************************************************
* init : initialize the event						*
************************************************************************/
void C_CHANGE_BAND::init(C_HEADER *header) {
  CHANGE_BAND_MESS *change_band_mess;

  change_band_mess = (CHANGE_BAND_MESS *)header;
  bandwidth = change_band_mess->bandwidth;

}

/************************************************************************
* exchange : exchange state variables                                   *
************************************************************************/
void C_CHANGE_BAND::exchange() {
  C_NODEOBJ *nodeobj;

  nodeobj = (C_NODEOBJ *)SIMOBJ;
  nodeobj->exchange_HYPER_bandwidth(bandwidth);

}

/************************************************************************
* lazy : lazy cancellation routine                                      *
************************************************************************/
int C_CHANGE_BAND::lazy() {

  return 1;

}

/************************************************************************
* temp_process : temporarily process event				*
************************************************************************/
void C_CHANGE_BAND::temp_process() {
  C_NODEMAN *nodeman;
  C_NODEOBJ *nodeobj;
  CHANGE_BAND_MESS *change_band_mess;
  int random_node, local_node, local_id;
  int n_broad;
  int i;

  nodeman = (C_NODEMAN *)get_manager(HYPE_NODE);
  nodeobj = (C_NODEOBJ *)SIMOBJ;

  n_broad = 3;

  for (i=0; i<n_broad; i++) {

    random_node = (	  nodeobj->get_HYPER_n_nodes()/2
			+ nodeobj->get_HYPER_node()
			+ i	)
			% nodeobj->get_HYPER_n_nodes();

    nodeman->get_nodeid(random_node, local_node, local_id);

    change_band_mess = (CHANGE_BAND_MESS *) schedule (
		TIME_TAG + 0.001,
		CHANGE_BAND,
		HYPE_NODE,
		local_id,
		local_node	);

    change_band_mess->bandwidth = bandwidth;

  }

//  fprintf(stderr,"Changing Bandwidth\n");

}

/************************************************************************
* perm_process : permanently process event				*
************************************************************************/
void C_CHANGE_BAND::perm_process() {

}

/************************************************************************
* cleanup : clean up data structures used				*
************************************************************************/
void C_CHANGE_BAND::cleanup() {

}



