// nodeman.H header file

#ifndef nodeman_object
#define nodeman_object

#include "parsman.H"
#include "nodeobj.H"
#include "freelist.H"

/************************************************************************
*	nodeman object - manager of node objects			*
************************************************************************/
class C_NODEMAN : public C_PARSMAN {

  private:

    C_NODEOBJ *nodeobj;			// hypercube node objects
    int HYPER_n_nodes;			// total number of hypercube nodes
    int HYPER_card_deal;		// card_deal flag
    double HYPER_bandwidth;		// bandwidth for sending a message
    double HYPER_send_latency;		// latency for sending a message
    double HYPER_receive_latency;	// latency for receiving a message
    int spin;				// spin loop for event processing (ms)
    int n_priorities;			// number of message priorities
    int test_cancel;			// test cancel flag

    int node0;				// actucal hardware node for node0
    int mask1;				// HYPER_n_nodes / n_nodes
    int mask2;				// mask1 * node

    C_FREELIST *freelist;		// free list object

  protected:

  public:

    C_NODEMAN();
    virtual void init_events();
    virtual void terminate(double tend);
    int get_HYPER_n_nodes() {return HYPER_n_nodes;}
    int get_HYPER_node(int lid) {return nodeobj[lid].get_HYPER_node();}
    void get_nodeid(int global_node, int &local_node, int &local_id);
    int get_n_priorities() {return n_priorities;}

    C_FREELIST *get_freelist() {return freelist;}

};

DEFINE_OBJECT_MANAGER(HYPE_NODE, C_NODEMAN);

#endif
