// nodeobj.H header file

#ifndef nodeobj_object
#define nodeobj_object

#include "simobj.H"
#include "xqueue.H"

/************************************************************************
*	nodeobj object 							*
************************************************************************/
#include "SpAntiMsg.H"
class C_NODEOBJ : public C_SIMOBJ {

  private:

  protected:

    double time;			// current time of the node
    int busy;				// flag for comm. service
    int HYPER_node;			// my simulated node id
    C_XQUEUE *message_queue;		// priority message queues
    C_CANCEL_HANDLE *cancel_handle;	// handle for event cancelation

    double HYPER_bandwidth;		// bandwidth for sending a message
    double HYPER_send_latency;		// latency for sending a message
    double HYPER_receive_latency;	// latency for receiving a message

    static int HYPER_n_nodes;		// total number simulated nodes
    static int HYPER_dimension;		// dimension of the hypercube
    static int n_priorities;		// number of priorities
    static int spin;			// spin loop time (ms)

  public:

    C_NODEOBJ();

    C_CANCEL_HANDLE *get_cancel_handle() {return cancel_handle;}
    void exchange_cancel_handle(void *&ch);

    void set_HYPER_n_nodes(int nds) {
	HYPER_n_nodes = nds;
	calculate_HYPER_dimension();
    }
    int get_HYPER_n_nodes() {return HYPER_n_nodes;}

    void calculate_HYPER_dimension();
    int get_HYPER_dimension() {return HYPER_dimension;}

    void set_HYPER_node(int nd) {HYPER_node = nd;}
    int get_HYPER_node() {return HYPER_node;}

    void set_HYPER_bandwidth(double b) {HYPER_bandwidth = b;}
    double get_HYPER_bandwidth() {return HYPER_bandwidth;}
    void exchange_HYPER_bandwidth(double &bw) {EXCHANGE(HYPER_bandwidth,bw);}

    void set_HYPER_send_latency(double l) {HYPER_send_latency = l;}
    double get_HYPER_send_latency() {return HYPER_send_latency;}

    void set_HYPER_receive_latency(double l) {HYPER_receive_latency = l;}
    double get_HYPER_receive_latency() {return HYPER_receive_latency;}

    void set_time(double t) {time = t;}
    double get_time() {return time;}

    void set_spin(int s) {spin = s;}
    int get_spin() {return spin;}

    void create_mqueues(int p);
    C_XQUEUE *get_message_queue(int p) {return &message_queue[p];}
    C_XQUEUE *get_next_message_queue();

    int get_n_priorities() {return n_priorities;}
    int get_n_messages();

    int get_route(int destination);

    void exchange_time(double &t) {EXCHANGE(time,t);}

    int get_busy() {return busy;}
    void set_busy(int b) {busy = b;}
    void exchange_busy(int &b) {EXCHANGE(busy,b);}

    virtual void terminate(double tend);

};


#endif
