// receive.C method file

#include "SpStdio.H"

#include "receive.H"
#include "appobj.H"
#include "msg.H"
#include "freelist.H"
#include "RB_SpContainerFuncs.H"


/************************************************************************
* C_RECEIVE : construct a receive object					*
************************************************************************/
C_RECEIVE::C_RECEIVE() {
  set_lazy();
}

/************************************************************************
* init : initialize the event		                                *
************************************************************************/
void C_RECEIVE::init(C_HEADER *header) {
  RECEIVE_MESS *receive_mess;

  receive_mess = (RECEIVE_MESS *)header;

  destination = receive_mess->destination;
  source = receive_mess->source;
  application = receive_mess->application;
  read_event = receive_mess->read_event;
  priority = receive_mess->priority;
  dummy_bytes = receive_mess->dummy_bytes;
  
}

/************************************************************************
* exchange : exchange state variables                                   *
************************************************************************/
void C_RECEIVE::exchange() {

}

/************************************************************************
* lazy : lazy cancellation routine                                      *
************************************************************************/
int C_RECEIVE::lazy() {

  return 1;

}

/************************************************************************
* temp_process : temporarily process event				*
************************************************************************/
void C_RECEIVE::temp_process() {
  C_APPOBJ *appobj;
  C_XQUEUE *message_queue;
  C_MSG *msg;

  msg = (C_MSG *)RB_FREE_NEW(FREE_LIST_MSG);

  msg->set_destination(destination);
  msg->set_source(source);
  msg->set_application(application);
  msg->set_read_event(read_event);
  msg->set_priority(priority);
  msg->set_dummy_bytes(dummy_bytes);

  appobj = (C_APPOBJ *)SIMOBJ;
  message_queue = appobj->get_message_queue();

  *message_queue += msg;

//...... start up a read application event

  if (read_event != -1) {
    schedule (
	TIME_TAG + 0.000000001,
	read_event,
	OBJECT_TYPE,
	LOCAL_ID,
	NODE);
  }

}

/************************************************************************
* perm_process : permanently process event				*
************************************************************************/
void C_RECEIVE::perm_process() {

}

/************************************************************************
* cleanup : clean up data structures used				*
************************************************************************/
void C_RECEIVE::cleanup() {

}



