// send.C method file

#include "SpStdio.H"

#include "send.H"
#include "nodeobj.H"
#include "msg.H"
#include "freelist.H"
#include "SpScheduleEvent.H"

#include "RB_SpContainerFuncs.H"

EVENT_TYPE (ROUTE);


/************************************************************************
* C_SEND : construct a send object					*
************************************************************************/
C_SEND::C_SEND() {
  set_lazy();
}

/************************************************************************
* init : initialize the event		                                *
************************************************************************/
void C_SEND::init(C_HEADER *header) {
  SEND_MESS *send_mess;

  send_mess = (SEND_MESS *)header;

  destination = send_mess->destination;
  source = send_mess->source;
  application = send_mess->application;
  read_event = send_mess->read_event;
  priority = send_mess->priority;
  dummy_bytes = send_mess->dummy_bytes;
  
}

/************************************************************************
* exchange : exchange state variables                                   *
************************************************************************/
void C_SEND::exchange() {
  C_NODEOBJ *nodeobj;

  nodeobj = (C_NODEOBJ *)SIMOBJ;
  nodeobj->exchange_busy(busy);

}

/************************************************************************
* lazy : lazy cancellation routing                                      *
************************************************************************/
int C_SEND::lazy() {
  C_NODEOBJ *nodeobj;

  nodeobj = (C_NODEOBJ *)SIMOBJ;
  if (lazy_busy != nodeobj->get_busy()) return 0;
  return 1;

}

/************************************************************************
* temp_process : temporarily process event				*
************************************************************************/
void C_SEND::temp_process() {
  C_NODEOBJ *nodeobj;
  C_MSG *msg;
  C_XQUEUE *message_queue;

  msg = (C_MSG *)RB_FREE_NEW(FREE_LIST_MSG);

  msg->set_destination(destination);
  msg->set_source(source);
  msg->set_application(application);
  msg->set_read_event(read_event);
  msg->set_priority(priority);
  msg->set_dummy_bytes(dummy_bytes);

  nodeobj = (C_NODEOBJ *)SIMOBJ;
  message_queue = nodeobj->get_message_queue(priority);

  *message_queue += msg;

//...... start up the comm. service if not currently busy

  lazy_busy = nodeobj->get_busy();
  busy = 1;

  if (!lazy_busy) {
    schedule (TIME_TAG + 0.0000000012345, ROUTE,
	      OBJECT_TYPE, LOCAL_ID, NODE);
  }

}

/************************************************************************
* perm_process : permanently process event				*
************************************************************************/
void C_SEND::perm_process() {

}

/************************************************************************
* cleanup : clean up data structures used				*
************************************************************************/
void C_SEND::cleanup() {

}



