// start_app1.C method file

#include "SpStdio.H"

#include "start_app1.H"
#include "app1obj.H"
#include "app1man.H"
#include "read_app1.H"
#include "SpScheduleEvent.H"
#include "send_mess.H"
#include "nodeman.H"

EVENT_TYPE (SEND);

/************************************************************************
* C_START_APP1 : construct a start_app1 object				*
************************************************************************/
C_START_APP1::C_START_APP1() {
  set_lazy();
}

/************************************************************************
* exchange : exchange state variables                                   *
************************************************************************/
void C_START_APP1::exchange() {
  C_APP1OBJ *app1obj;

  SIMOBJ->EXCHANGE_SEED(seed);

  app1obj = (C_APP1OBJ *)SIMOBJ;
  app1obj->exchange_time(time);
  app1obj->exchange_n_received(n_received);

}

/************************************************************************
* lazy : lazy cancellation routine                                      *
************************************************************************/
int C_START_APP1::lazy() {
  C_APP1OBJ *app1obj;
  double t;

  app1obj = (C_APP1OBJ *)SIMOBJ;

  if (lazy_seed != app1obj->get_SEED()) return 0;

  t = TIME_TAG;
  if (t < app1obj->get_time()) t = app1obj->get_time();
  if (lazy_time != time) return 0;

  return 1;

}

/************************************************************************
* temp_process : temporarily process event				*
************************************************************************/
void C_START_APP1::temp_process() {
  C_NODEMAN *nodeman;
  C_APP1OBJ *app1obj;
  SEND_MESS *send_mess;
  int random_node;
  int fanout;
  int i;

  lazy_seed = SIMOBJ->get_SEED();
  seed = lazy_seed;
  RANDOM->set_seed(seed);

  nodeman = (C_NODEMAN *)get_manager(HYPE_NODE);

  app1obj = (C_APP1OBJ *)SIMOBJ;
  fanout = app1obj->get_fanout();

  time = TIME_TAG;
  if (app1obj->get_time() > TIME_TAG) time = app1obj->get_time();
  lazy_time = time;
  time += app1obj->get_compute_time();

  n_received = 0;

//...... schedule the fanout messages to be sent

  for (i=0; i<fanout; i++) {

    time += 0.000000001;

    send_mess = (SEND_MESS *) schedule (
		time,
		SEND,
		HYPE_NODE,
		LOCAL_ID,
		NODE	);

    RANDOM->set_int_limits(0, nodeman->get_HYPER_n_nodes()-1);
    random_node = RANDOM->get_random_int();

    send_mess->destination = int(random_node);
    send_mess->source = app1obj->get_HYPER_node();
    send_mess->application = int(APP1);
    send_mess->read_event = int(READ_APP1);
    send_mess->priority = 0;
    send_mess->dummy_bytes = app1obj->get_bytes();

    RANDOM->set_int_limits(0, nodeman->get_n_priorities()-1);
    send_mess->priority = int(RANDOM->get_random_int());

  }

  seed = RANDOM->get_seed();

}

/************************************************************************
* perm_process : permanently process event				*
************************************************************************/
void C_START_APP1::perm_process() {

}

/************************************************************************
* cleanup : clean up data structures used				*
************************************************************************/
void C_START_APP1::cleanup() {

}



