// test_cancel.C method file

#include "SpStdio.H"

#include "test_cancel.H"
#include "antimess.H"
#include "SpScheduleEvent.H"
#include "nodeobj.H"
#include "nodeman.H"
#include "change_band_mess.H"

EVENT_TYPE (CHANGE_BAND);

/************************************************************************
* C_TEST_CANCEL : construct a test_cancel object			*
************************************************************************/
C_TEST_CANCEL::C_TEST_CANCEL() {}

/************************************************************************
* exchange : exchange state variables                                   *
************************************************************************/
void C_TEST_CANCEL::exchange() {
  C_NODEOBJ *nodeobj;

  nodeobj = (C_NODEOBJ *)SIMOBJ;
  nodeobj->exchange_cancel_handle(cancel_handle);

}

/************************************************************************
* lazy : lazy cancellation routine                                      *
************************************************************************/
int C_TEST_CANCEL::lazy() {

  return 1;

}

/************************************************************************
* temp_process : temporarily process event				*
************************************************************************/
void C_TEST_CANCEL::temp_process() {
  C_NODEMAN *nodeman;
  C_NODEOBJ *nodeobj;
  CHANGE_BAND_MESS *change_band_mess;
  C_CANCEL_HANDLE *lazy_cancel_handle;
  int random_node, local_node, local_id;
  double delta;
  double alpha;

  delta = 0.1;
  alpha = 0.001;

  nodeman = (C_NODEMAN *)get_manager(HYPE_NODE);
  nodeobj = (C_NODEOBJ *)SIMOBJ;

  lazy_cancel_handle = nodeobj->get_cancel_handle();

  if (lazy_cancel_handle == NULL) {

//    cancel_handle = (CANCEL_HANDLE *)RB_NEW(new CANCEL_HANDLE());
    cancel_handle = RB_NEW_CANCEL_HANDLE();

    random_node = (	  nodeobj->get_HYPER_n_nodes()/2
			+ nodeobj->get_HYPER_node()	)
			% nodeobj->get_HYPER_n_nodes();

    nodeman->get_nodeid(random_node, local_node, local_id);

    SIMTIME close_to_TIME_TAG;
    close_to_TIME_TAG = TIME_TAG + delta * (1.0 - alpha) + 0.001;
    change_band_mess = (CHANGE_BAND_MESS *) schedule (
		cancel_handle,
		close_to_TIME_TAG,
		CHANGE_BAND,
		HYPE_NODE,
		local_id,
		local_node	);

    change_band_mess->bandwidth = 1234.0;

    schedule(TIME_TAG + delta * (1.0 - alpha), TEST_CANCEL,
	     HYPE_NODE, LOCAL_ID, NODE);

  }else{

    cancel(lazy_cancel_handle);
//    RB_DELETE(lazy_cancel_handle);
    RB_DELETE_CANCEL_HANDLE(lazy_cancel_handle);
    cancel_handle = NULL;

    schedule(TIME_TAG + (delta * alpha), TEST_CANCEL,
	     HYPE_NODE, LOCAL_ID, NODE);

  }

}

/************************************************************************
* perm_process : permanently process event				*
************************************************************************/
void C_TEST_CANCEL::perm_process() {

}

/************************************************************************
* cleanup : clean up data structures used				*
************************************************************************/
void C_TEST_CANCEL::cleanup() {

}



