// servman.H header file

#ifndef servman_object
#define servman_object

#include "objman.H"
#include "PO.H"
/************************************************************************
*	servman object - manager of serv objects			*
************************************************************************/
class C_SERVMAN : public C_OBJMAN {

  private:

    int n_servers;		// number of servers in the network
    int n_customers_server;	// number of customers per server
    int starting_server;	// id of my starting server
    int fully_interconnected;	// fully interconnected flag (0 means circular)
    int beta_n1_serve;		// beta n1 for serving customer
    int beta_n2_serve;		// beta n2 for serving customer
    int beta_n1_travel;		// beta n1 for customer to travel to server
    int beta_n2_travel;		// beta n2 for customer to travel to server
    int const_serve_time;	// flag for constant service time (no beta)
    int const_travel_time;	// flag for constant travel time (no beta)
    double serve_time;		// value added to service time
    double travel_time;		// value added to travel time
    C_RANDOM random_serve;	// random number generator for service time
    C_RANDOM random_travel;	// random number generator for travel time

  protected:

  public:

    C_SERVMAN();
    virtual void init_events();
    virtual void terminate(double tend);
    int get_fully_interconnected() {return fully_interconnected;}
    int get_n_servers() {return n_servers;}
    void get_nodid(int server, int &nd, int &lid);
    int get_const_serve_time() {return const_serve_time;}
    int get_const_travel_time() {return const_travel_time;}
    double get_serve_time() {return serve_time;}
    double get_travel_time() {return travel_time;}
    virtual void ResetObjectForRestart();

};

PO_DEFINE_CLASS(C_SERVMAN);
PO_DEFINE_OBJECT_MANAGER(SERVER, C_SERVMAN);

#endif
