// servobj.C method file

#include "SpStdio.H"
#include "servobj.H"
#include "RB_SpDefineClass.H"
#include "random.H"
#ifdef __IBMCPP__
namespace {
#endif

#ifndef PO_VOID_TYPE_CLASS_DEFINED
typedef char PO_VOID_TYPE_CLASS;
RB_DEFINE_CLASS_PRIMATIVE(PO_VOID_TYPE_CLASS);
#define PO_VOID_TYPE_CLASS_DEFINED
#endif
#ifdef __IBMCPP__
}
#endif

/************************************************************************
* C_SERVOBJ : construct a servobj object				*
************************************************************************/
C_SERVOBJ::C_SERVOBJ() {

  random_serve = NULL;
  random_travel = NULL;

  server_time = 0.0;
  wait_time = 0.0;
  n_served = 0;

}

/************************************************************************
* service_time : compute the service time				*
************************************************************************/
double C_SERVOBJ::service_time(int &seed) {
  double value;

  random_serve->set_seed(seed);
  value = random_serve->get_random_beta();
  seed = random_serve->get_seed();
  return value;

}

/************************************************************************
* travel_time : compute the travel time					*
************************************************************************/
double C_SERVOBJ::travel_time(int &seed) {
  double value;

  random_travel->set_seed(seed);
  value = random_travel->get_random_beta();
  seed = random_travel->get_seed();
  return value;

}

void C_SERVOBJ::RegisterWithPersistence()
{
  PO_ATTACH_PTR(random_serve);
  PO_ATTACH_PTR(random_travel);
}
