// servobj.H header file

#ifndef servobj_object
#define servobj_object

#include "SpSimObj.H"
#include "SpReportStatus.H"

/************************************************************************
*	servobj object 							*
************************************************************************/
class C_SERVOBJ : public SpSimObj {

  private:

  protected:

    C_RANDOM *random_serve;	// random number generator for service
    C_RANDOM *random_travel;	// random number generator for travel

    STATE_INT n_served;		// number of customers served
    STATE_DOUBLE wait_time;	// total summed wait time for customers
    STATE_DOUBLE server_time;	// current time of the server

  public:

    C_SERVOBJ();
    void set_random_generators(C_RANDOM *rs, C_RANDOM *rt) {
		random_serve = rs;
		random_travel = rt;
	}

    double service_time(int &seed);
    double travel_time(int &seed);

    double get_server_time() {return server_time;}
    void set_server_time(double t) {server_time = t;}

    double get_wait_time() {return wait_time;}
    void set_wait_time(double t) {wait_time = t;}

    int get_n_served() {return n_served;}
    void set_n_served(int n) {n_served = n;}
    virtual void RegisterWithPersistence();

    virtual void terminate(double) {
      SpReportStatus("Qnet should pass", SP_REPORT_STATUS_PASSED);
      SpReportStatus("Qnet failed", SP_REPORT_STATUS_FAILED);
      SpReportStatus("Qnet is inconclusive", SP_REPORT_STATUS_INCONCLUSIVE);
    }

};

PO_DEFINE_CLASS(C_SERVOBJ);

#endif
