#include "SpServiceGroup.H"


class WeirdServer : public SERVICE_GROUP {
 public:
   enum { HDLR0=0, HDLR1, HDLR2, HDLR3, HDLR4, HDLR5, HDLR6, BIGMSG,  NUMHANDLERS };


   void hdlr0(CONNECTION *conn, GENERIC_MSG_HEADER *mh) {
      cout << mh->getNode() << "=> HDLR0 (i+0) = " << mh->data << endl;
   }

   void hdlr1(CONNECTION *conn, GENERIC_MSG_HEADER *mh) {
      cout << mh->getNode() << "=> HDLR1 (i+10) = " << mh->data+10 << endl;
   }

   void hdlr2(CONNECTION *conn, GENERIC_MSG_HEADER *mh) {
      cout << mh->getNode() << "=> HDLR2 (i+20) = " << mh->data+20 << endl;
   }

   void hdlr3(CONNECTION *conn, GENERIC_MSG_HEADER *mh) {
      cout << mh->getNode() << "=> HDLR3 (i+30) = " << mh->data+30 << endl;
   }

   void hdlr4(CONNECTION *conn, GENERIC_MSG_HEADER *mh) {
      cout << mh->getNode() << "=> HDLR4 (i+40) = " << mh->data+40 << endl;
   }

   void hdlr5(CONNECTION *conn, GENERIC_MSG_HEADER *mh) {
      cout << mh->getNode() << "=> HDLR5 (i+50) = " << mh->data+50 << endl;
   }

   void hdlr6(CONNECTION *conn, GENERIC_MSG_HEADER *mh) {
      cout << mh->getNode() << "=> HDLR6 (i+60) = " << mh->data+60 << endl;
   }

   void bigMsgHandler(CONNECTION *conn, GENERIC_MSG_HEADER *mh) {
      int numInts = mh->getData();
      cout << "Big msg #ints = " << numInts << endl;

      int *pt = (int *) (&mh[1]);

      for(int i=0; i<numInts; i++, pt++) {
	 if (*pt != i) {
	    cout << "Bad BIG msg received;  i, *pt = " << i << ", " << *pt << endl;
	    exit(1);
	 }
      }

      cout << "-------- MSG RECEIVED CORRECT!!! -----------" << endl;

      int bigSize = sizeof(GENERIC_MSG_HEADER) + numInts*sizeof(int);
      cout << "Sending BIG msg of #bytes= " << bigSize << endl;

      if (conn->sendMessage_blk((char *) mh, bigSize)) {
	 cout << "Sent entire BIG msg" << endl;
      }
      else {
	 cout << "Failed sending message!" << endl;
      }
   }




   WeirdServer(void) {
      allocateHandlerStorage(NUMHANDLERS);

      STORE_MSG_HANDLER(HDLR0, WeirdServer, hdlr0);
      STORE_MSG_HANDLER(HDLR1, WeirdServer, hdlr1);
      STORE_MSG_HANDLER(HDLR2, WeirdServer, hdlr2);
      STORE_MSG_HANDLER(HDLR3, WeirdServer, hdlr3);
      STORE_MSG_HANDLER(HDLR4, WeirdServer, hdlr4);
      STORE_MSG_HANDLER(HDLR5, WeirdServer, hdlr5);
      STORE_MSG_HANDLER(HDLR6, WeirdServer, hdlr6);

      STORE_MSG_HANDLER(BIGMSG, WeirdServer, bigMsgHandler);
   }
};

WeirdServer *makeWeirdServer(void);
