#ifndef _REALS_H
#define _REALS_H

#include "SpMath.H"

// The standard C library has a function called truncate whose purpose
// is very different than this one.  Since this one is not used, I
// commented it out since it causes a complier error.
//static inline int truncate(double x) { return (int) x; }


static inline int ceiling(double x)  { return (int) x + 1; }
static inline int round(double x)    { if (x >= 0) return (int) (x + 0.5);
                                       else return (int) (x - 0.5); }
static inline double arcsin(double x) { return asin(x); }
static inline double arccos(double x) { return acos(x); }
static inline double arctan(double x) { return atan(x); }
static inline double power(double x, double y) { return pow(x,y); }
static inline double ln(double x) { return log(x); }
static inline double toReal(int x) { return (double) x; }

/* shouldn't need since they are the same call in C
static inline double sin(double x) { return sin(x); }
static inline double cos(double x) { return cos(x); }
static inline double tan(double x) { return tan(x); }
static inline int floor(double x)    { return (int) x; }
static inline double exp(double x) { return (x); }
static inline double log10(double x) { return (x); }
static inline double sqrt(double x) { return (x); }
*/
#endif
