/**************************************************************************/
/*                         Format.c    Format.c                           */
/**************************************************************************/

/* Format abstraction for a tree structure 

	FormatNode	- A node to be printed 

	Formatter	- The pretty printer.  Responsible for converting
			  an AstNode into a list of strings and AstNodes
			  (its children).   Thus AstNodes need not be 
			  unparsed all the way 
*/

/* AUTHOR: Vance Morrison
   DATE  : 9/19/94                  */
/**************************************************************************/

#include "Format.H"
#include "Number.H"

/**************************************************************************/
Formatter& Formatter::operator<<(char c) {
    char str[2];
    str[0] = c;
    str[1] = 0;
    return(*this << str);
}

/**************************************************************************/
Formatter& Formatter::operator<<(int i) {
    char str[256];
    int2str(str, 256, i);
    return(*this << str);
}

/**************************************************************************/
Formatter& Formatter::operator<<(double d) {
    char str[256];
    float2str(str, 256, d, 8);
    return(*this << str);
}

