/**************************************************************************/ 
/*			   IOStream.h	 IOStream.h			  */ 
/**************************************************************************/ 
/*  Copyright (C) 1992,	 Vance Morrison	  */ 
/*  All rights reserved, see Copyright file for more information */ 
 
/* AUTHOR: Vance Morrison  
   DATE	 : 10/23/93		     */ 
/**************************************************************************/ 
 
#ifndef _FileStream_h 
#define _FileStream_h

#include "CharStream.H"
#include "SpIostream.H"

/* these are rather inefficient, we should at least consider buffering,
   or better yet, bypass the buffering of the iostream and do it ourself
   (if possible to do in a portable way) */

class IOInStream : public InStream {
public:
    IOInStream(istream& aIn) : in(&aIn) { next(); }

    const char& cur()		{ return(c); }
    Bool isEnd()		{ return(in->fail()); }
    void next()			{ in->get(c); }
private:
    istream* in;
    char c;
};

/**************************************************************************/ 

class IOOutStream : public OutStream {
public:
    IOOutStream(ostream& aOut) : out(&aOut) {}
    Bool put(const char& val)	    { out->put(val); return(TRUE); }
    void done()			    { out->flush(); }
private:
    ostream* out;
};

#endif

