#ifndef __RunProg__
#define __RunProg__

/*****************************************************************************/
/*                              runProg.h                                    */
/*****************************************************************************/

/* this file defines a program like 'system' which will run a particular
   program.   It is differen than the 'system command because
	1) It returns the error code of the program
	2) It allows stdin, stdout stderr to be set if desired
	3) It does NOT spawn a shell (no meta character replacement)
		(if you need it, just spawn a shell instead)	      */

/* AUTHOR: Vance Morrison
   DATE:  11/1/94              */
/*****************************************************************************/

	// run a program, command is a FILE name 
int runProg(const char* command, int stdIn=0, int stdOut=1, int stdErr=2);

	// run a program, command is a COMMAND name (look up in path
int runCommand(const char* command, int stdIn=0, int stdOut=1, int stdErr=2);

	// look up a COMMAND in the PATH variable and return the file name
char* getCommandPath(const char* command);

#endif
