/*****************************************************************************/
/*                               TypeStatus.H                                */
/*****************************************************************************/

/* TypeStatus defines a `TypeStatus' which defines a place to put error messages
   when code is typechecked */

/* AUTHOR: Vance Morrison
   DATE:  11/2/93              */
/*****************************************************************************/

#ifndef _TypeStatus_h 
#define _TypeStatus_h

#include "IDAST.H"
#include "SpStrstream.H"


struct TypeStatus {
public:
    TypeStatus();
    ~TypeStatus();
    Bool ok() { return(error == 0); }
    char* msg();
    const void* getAt() { return(at); }
    const TypeEnv* getEnv() { return(env); }

    void setIdentAmbiguous(const void*where,const Ident*name,const Type*type,
	const TypeEnv* env);
    void setIdentNotFound(const void*where,const Ident* name,const Type*type,
	const TypeEnv* env);
    void setIdentPrivate(const void*where,const Ident*name,const Type*type,
	const TypeEnv* env);
    void setSelfNotFound(const void* where);
    void setIdMultDefined(const void* where, const char* name,const Type* type);
    void setNotIndexAble(const void* where, const Type* type);
    void setTypeConflict(const void* where, const Type* actualType,
	const Type* neededType);
    void setNeedRetVal(const Stmt* where, const Type* retType);
    void setBadRetExp(const void* where);
    void setRetNotExpected(const void* where);
    void setNotConstant(const void* where);
    void setNotLvalue(const void* where);
    void setNotArray(const void* where);
    void setArgNotExpected(const void* where);
    void setNotObject(const void* where);
    void setNotVar(const void* where);
    void setNeedValue(const void* where);
    void setDeferedMeths(const void* where, PiList* meths);
    void setDomeIllegal(const void* where);
    void setVarIllegal(const void* where);
    void setPublicVarIllegal(const void* where);
    void setBadNewArgs(const void* where, const Type* newType);
    void setBadNumArgs(const void* where);
    void setBadOut(const void* where, int i);
    void setConstrAmbiguous(const void* where, const Type* type, 
	const Type*cType, const TypeEnv* env);
    void setConstrPrivate(const void* where, const Type* type, 
	const Type*cType, const TypeEnv* env);
    void setConstrNotFound(const void* where, const Type* type, 
	const Type* cType, const TypeEnv* env);
    void setBadInstance(const void* where, const char* name);

private:
    const void* at;		// where the error occured
    TypeEnv* env;		// optional environment in which error occured
    ostrstream& out;
    int error;
};

#endif
