/*****************************************************************************/ 
/*                             PiList.h   	                             */
/*****************************************************************************/

/* A simple, linked list implmentation */

/* AUTHOR: Vance Morrison
   DATE:  10/20/93		*/
/*****************************************************************************/

#ifndef _PiList_h
#define _PiList_h 1

/*****************************************************************************/
class PiList {
public:
    const void* first() const 	{ return(head); }
    void* first() 		{ return(head); }
    const PiList* rest() const	{ return(tail); }
    PiList* rest() 		{ return(tail); }
    int len() const;
    PiList* pop() 		{ PiList* ret = tail; tail = 0; 
				  delete this; return(ret); }
    PiList(void* aHead, PiList* aTail) : head(aHead), tail(aTail) {}
    ~PiList();
	
	// appends two lists descructively (ownership of both arguments
	// passes to the returned list.  
    friend PiList* append(PiList* front, PiList* back);	
    friend PiList* reverse(PiList* list);	// destructively reverses the list
    friend PiList* PiRemove(PiList* list, void* item);	

        // a shallow copy of a list (elements are aliased)
    friend PiList* copy(const PiList* list);
    friend PiList* sort(PiList* list, int (*cmp)(const void*, const void*));

private:
    void* head;
    PiList* tail;
};

	// delete the strings in a list 
void destroyStrPiList(PiList* elems);

#endif
