/****************************************************************************/
/*                                Time.cxx                                  */
/****************************************************************************/
/*  Copyright (C) 1994,  Vance Morrison   */
/*  All rights reserved, see Copyright file for more information */


/* Author Vance Morrison
   Date   6/5/94               */
/****************************************************************************/

#include "PiTime.H"
#include "SpOS.H"       // for gettimeofday (<sys/time.h> on UNIX)
#include "SpTime.H"	// for mktime 

/**************************************************************************/
unsigned long toTicks(unsigned int month, unsigned int day, unsigned int year, 
	unsigned int hour, unsigned int minute, unsigned int second, 
	unsigned int amPm) {

    struct tm myTime;

	/* check for really insane dates (2037 is when a signed long will */
	/* roll over int the negatives)) */
    if (month >= 12 || day > 31 || (year >= 100 && (year < 1970 || year > 2037))
	|| hour >= 24 || minute >= 60 || second >= 60 || 
	(amPm != 0 && amPm != 12))
	return((unsigned long) -1);
    
    time_t ticks;
    time(&ticks);
    myTime = *localtime(&ticks);

    myTime.tm_mon = month - 1;
    myTime.tm_mday = day;
    if (year != 0) {            /* zero means this year */
        if (year < 100) {       /* abreviated year */
            while (year <  (myTime.tm_year-50))
                year += 100;
            myTime.tm_year = year;
            }
        else
            myTime.tm_year = year - 1900;
        }
    hour = hour % 12;
    hour += amPm;
    myTime.tm_hour = hour;
    myTime.tm_min = minute;
    myTime.tm_sec = second;

    return(mktime(&myTime));
}

