// O_Radar.C source file

#include "SpObjFactory.H"
#include "SpObjTemplate.H"

#include "O_Ship.H"
#include "O_Radar.H"
#include "S_Radar.H"
#include "ScheduleEvent.H"
#include "ObjectProxy.H"
#include "E_RadarQueryEvent.H"
#include "E_RadarBroadcastEvent.H"

O_Radar::O_Radar() {
  int i, j, offset;
  int global_id;
  OBJECT_PROXY *ObjectProxy;

  N_TOT = 100;
  N_LOC = deal_me(N_TOT, offset);

  Radar = new S_Radar[N_LOC];
  global_id = TOTAL_OBJECTS + offset;

  for (i=0, j=0; i<N_TOT; i++) {
    if ((i-offset+N_NODES)%N_NODES == 0) {
      Radar[j].set_GLOBAL_ID(global_id);
      ObjectProxy = Radar[j].GetObjectProxy();
      ObjectProxy->SetGlobalId(global_id);
      global_id += N_NODES;
      j++;
    }
  }

  reserve_n_objects(N_LOC);
  for (i=0; i<N_LOC; i++) define_object(&Radar[i]);
  TOTAL_OBJECTS += N_TOT;
}

void 
O_Radar::init_events() {

  for (int i=0; i<N_LOC; i++)
    Radar[i].InitEvents();
}
