// O_Ship.C source file

#include "O_Ship.H"
#include "S_Ship.H"
#include "ScheduleEvent.H"
#include "ObjectProxy.H"


O_Ship::O_Ship() {
  int i, j, offset;
  int global_id;
  OBJECT_PROXY *ObjectProxy;

  N_TOT = 100;
  N_LOC = deal_me(N_TOT, offset);

  Ship = new S_Ship[N_LOC];
  global_id = TOTAL_OBJECTS + offset;

  for (i=0, j=0; i<N_TOT; i++) {
    if ((i-offset+N_NODES)%N_NODES == 0) {
      Ship[j].set_GLOBAL_ID(global_id);
      ObjectProxy = Ship[j].GetObjectProxy();
      ObjectProxy->SetGlobalId(global_id);
      global_id += N_NODES;
      j++;
    }
  }

  reserve_n_objects(N_LOC);
  for (i=0; i<N_LOC; i++) define_object(&Ship[i]);
  TOTAL_OBJECTS += N_TOT;
}

void 
O_Ship::init_events() {
  for (int i=0; i<N_LOC; i++)
    Ship[i].InitEvents();
}
