// PlugIn.C

/*
** Define the object managers for Ship
*/

#include "Speedes.H"

#include "O_Ship.H"
#include "S_Ship.H"
#include "O_Radar.H"
#include "S_Radar.H"
#include "E_RadarQueryEvent.H"
#include "E_RadarBroadcastEvent.H"

#include "SpPlugInDM.H"

extern void PlugInHLA();

/************************************************************************
* Plug in the object managers and events				*
************************************************************************/
void PlugIn() {

   PlugInHLA();
   PlugInDM();

   PLUG_IN_OBJECT_MANAGER(Ship);
   PLUG_IN_OBJECT_MANAGER(Radar);

   PLUG_IN_EVENT(ShipCreateProxyDistListEvent);
   PLUG_IN_EVENT(ShipRemoveProxyDistListEvent);
   PLUG_IN_EVENT(ShipAddProxyDistListEvent);

   PLUG_IN_EVENT(RadarQueryEvent);
   PLUG_IN_EVENT(RadarBroadcastEvent);

}
