// S_Ship.H header file

#ifndef S_SHIP_H
#define S_SHIP_H

#include "S_SpHLA.H"
#include "S_Ship.H"
#include "ScheduleEvent.H"
#include "RB_SpBinaryTree.H"

class S_Ship : public S_SpHLA {

  public:

    S_Ship(void);
    void CreateProxyDistList(void);
    void AddProxyDistList(void);
    void RemoveProxyDistList(void);

    void AddRadar(int local_id, int obj_type, int node, int global_id);
    void InitEvents(void);

  private:
    RB_SpBinaryTree Radars;
    RB_SpBinaryTree RemoveRadars;
};

DEFINE_EVENT_METHOD_0_ARG(ShipCreateProxyDistListEvent, 1, S_Ship, CreateProxyDistList);
DEFINE_EVENT_METHOD_0_ARG(ShipRemoveProxyDistListEvent, 1, S_Ship, RemoveProxyDistList);
DEFINE_EVENT_METHOD_0_ARG(ShipAddProxyDistListEvent,    1, S_Ship, AddProxyDistList);

#endif
