// S_TestInteractions.C source file

//#define NOISY_TEST_CANCEL

#include "S_TestInteractions.H"


O_TestInteractions *MgrTestInteractions = NULL;
extern SpEvent *CurrentEvent;

//----------------------------------------------------------------------------
// Init - Initializes my SimObj
//----------------------------------------------------------------------------
void S_TestInteractions::Init() {

  MyEventCounter = 0;

  MgrTestInteractions =
    (O_TestInteractions *) SpGetSimObjMgr(OBJECT_TYPE);

  cout << "Initializing " << NAME
       << " <" << NODE << ", " << OBJECT_TYPE << ", " << LOCAL_ID << ">"
       << endl;

  SpObjHandle objHandle = MgrTestInteractions->GetObjHandle(NUM_ID);

  if (objHandle.NodeId != NODE) {
    cout << "Error, bad NODE lookup" << endl;
  }

  if (objHandle.ObjManId != OBJECT_TYPE) {
    cout << "Error, bad OBJECT_TYPE lookup" << endl;
  }

  if (objHandle.SimObjId != LOCAL_ID) {
    cout << "Error, bad LOCAL_ID lookup" << endl;
  }

  // Obj 0 on node 3 schedules an interaction. All other objs 
  // subscribe to this interaction (named "kill"). Then, obj 0 on 
  // node 0 subscribes to an interaction named "countkill." During 
  // each of the event handlers of the "kill"ed objects, a 
  // "countkill" interaction is scheduled, to which obj 0 on node 0 
  // subscribes. Thus, the killcounter event handler on obj 0, node
  // 0 keeps a count of how many times all other objects had their
  // killhandlers invoked. During the terminate() method, obj 0 on
  // node 0 reports this number. If there are a total of ten objects,
  // this count should come out to nine.

  if (NODE == 3 && LOCAL_ID == 0) {
  // if (NODE == 0 && LOCAL_ID == 0) {
    SpParmSet paramset;
    paramset.InsertInt("myint",5);
    ScheduleInteraction(1.0,"kill",paramset);
  }
  else {
    AddSubscribeEventHandler("kill",&killhandler);
  }

  if (!LOCAL_ID) {
    AddSubscribeEventHandler("countkill",&killcounter);
  }

}
