// S_TestCancel.H header file

#ifndef S_TestInteractionsGate
#define S_TestInteractionsGate

#include "RB_Types.H"
#include "SpSimObj.H"
#include "SpRandom.H"
#include "SpBuiltInMacros.H"
#include "ScheduleEvent.H"
#include "Speedes.H"
#include "SpScheduleEvent.H"
#include "SpEventHandler.H"

class KillHandler: public SpInteractionHandler
{
public:
  KillHandler(): myint(0), igotcalled(0) {}

  void Process(SpParmSet &paramset) {
    igotcalled = 1;
    myint = paramset.GetInt("myint");
    ScheduleInteraction(GetTime()+1,"countkill",paramset);
  }
  int gotcalled() {
    return igotcalled;
  } 

  int Getmyint() {
    return myint;
  }
private:
  RB_int myint;
  RB_int igotcalled;
};

class KillCounter: public SpInteractionHandler
{
public:
  KillCounter(): killcount(0) {}
  void Process(SpParmSet &) {
    killcount++;
  }
  int GetCount() {
    return killcount;
  }
private:
  RB_int killcount;
};

const int DtSched = 10;

class S_TestInteractions : public SpSimObj {

  private:

    RB_int MyEventCounter;
  KillHandler killhandler;
  KillCounter killcounter;

  protected:
  public:

    virtual void Init();
    //void ScheduleMyEventTC(SpRandom random);
    //void RetractMyEventTC(SpCancelHandle cancelHandle);
    //void MyEvilEventTC(SpRandom random);

    virtual void terminate(double) {
//       int errorFlag = 0;

//       if (MyEventCounter < (tend/DtSched)) {
// 	errorFlag = 1;
//       }

//       if (MyEventCounter > (tend/DtSched + 1)) {
// 	errorFlag = 1;
//       }

//       if (errorFlag) {
// 	cout << "Test Cancel Failed: Wrong number of events "
// 	     << MyEventCounter << endl;
//       }else{
// 	cout << "Test Cancel Passed: Correct number of events "
// 	     << MyEventCounter << endl;
//       }
      if (killhandler.gotcalled()) {
	cout << "CALLED: Node " << GetNode() << " local id ";
	cout << GetLocalId() << " Value " << killhandler.Getmyint() << endl;
      }
      else {
	cout << "NOT called: Node " << GetNode() << " local id ";
	cout << GetLocalId() << endl;
      }

      if (!NODE && !LOCAL_ID) {
	cout << "Count of total killhandlers called: ";
	cout << killcounter.GetCount() << endl;
      }
    }

};

//inline int GetNumTC() {return SpCOmm_GetNumNodes();}
inline int GetNumTC() {return 10;}

// DEFINE_EVENT_METHOD_1_ARG(ScheduleMyEventTC,
// 			  10,
// 			  S_TestInteractions,
// 			  ScheduleMyEventTC,
// 			  SpRandom);

// DEFINE_EVENT_METHOD_1_ARG(RetractMyEventTC,
// 			  10,
// 			  S_TestInteractions,
// 			  RetractMyEventTC,
// 			  SpCancelHandle);

// DEFINE_EVENT_METHOD_1_ARG(MyEvilEventTC,
// 			  10,
// 			  S_TestInteractions,
// 			  MyEvilEventTC,
// 			  SpRandom);

DEFINE_SCATTER_DECOMP_OBJECT_MANAGER(TestInteractions,
				     S_TestInteractions,
				     GetNumTC(),
				     SPEEDES);

#endif
