// E_DoTest.C source file

#include "E_DoTest.H"
#include "E_EvilEvent.H"
#include "RB.H"
#include "ScheduleEvent.H"
#include "S_DoTest.H"

/******************************************************************************
* E_DoTest constructor                                                        *
******************************************************************************/
E_DoTest::E_DoTest() {

 set_lazy();

}

/******************************************************************************
* process: Optimistically process the event                                   *
******************************************************************************/
void E_DoTest::process() {

//  RB_cout << "E_DoTest at time " << TIME_TAG << endl;

  DoTest_OBJECT->DoTest(TIME_TAG);

  DoTest_OBJECT->IncrementRB_Counter();
  DoTest_OBJECT->IncrementCounter();

  SIMTIME time = TIME_TAG;
  time.SetTime(TIME_TAG + 100);
  ReScheduleEvent(time);

  time = TIME_TAG;
  time.IncrementPriority2();
  ScheduleEvent(time, EvilEvent, OBJECT_TYPE, 0, (NODE+1)%N_NODES);

}

/******************************************************************************
* lazy: pass lazy cancellation test half the time by checking the             *
* LazyCounter and seeing if it odd or even. Note that the way this test is    *
* constructed, it could always pass lazy cancellation...                      *
******************************************************************************/
int E_DoTest::lazy() {

  int retVal = (DoTest_OBJECT->GetLazyCounter() % 2);
  DoTest_OBJECT->IncrementLazyCounter(retVal);

  return retVal;

}
