// O_DoTest.C source file

#include "O_DoTest.H"
#include "E_DoTest.H"
#include "ScheduleEvent.H"

/******************************************************************************
* init_events: Initializes the events for my objects                          *
******************************************************************************/
void O_DoTest::PlugInObject(S_DoTest *doTest) {

  N_LOC = 1;
  N_TOT = N_NODES;

  reserve_n_objects(N_LOC);
  define_object(doTest);

  TOTAL_OBJECTS += N_TOT;

}

/******************************************************************************
* init_events: Initializes the events for my objects                          *
******************************************************************************/
void O_DoTest::init_events() {

  SIMTIME time = 0.000001;

  for (int i=0; i<N_LOC; i++) {
    time.SetPriority2(NODE + N_NODES*i);
    ScheduleEvent(time, DoTest, OBJECT_TYPE, i, NODE);
  }

}

/******************************************************************************
* terminate: executed at the end of the simulation                            *
******************************************************************************/
void O_DoTest::terminate(double /*tend*/) {

  S_DoTest *doTest = (S_DoTest *)get_obj(0);

  int errorFlag = doTest->GetErrorFlag();
  errorFlag = SpComm_GlobalSum(errorFlag);

  if (errorFlag) {
    ReportFail(NAME);
  }else{
    int numRollbacks = doTest->GetCounter() - doTest->GetRB_Counter();
    numRollbacks = SpComm_GlobalSum(numRollbacks);
    if (numRollbacks) {
      ReportPass(NAME);
    }else{
      ReportInconclusive(NAME);
    }
  }

}
