// S_tank.H header file

#ifndef S_tank_Object
#define S_tank_Object

#include "Speedes.H"
#include "simobj.H"
#include "DataParser.H"
#include "EventHandlerMethod.H"
#include "TurretComp.H"
#include "rollbackStreams.H"
#include "TestClass.H"
#include "SpIostream.H"
#include "SpFstream.H"
#include "SpStrstream.H"
#include "SpIomanip.H"

const int NUM_TURRETS = 2;

class S_tank : public C_SIMOBJ
{
   TURRET *turretArray[NUM_TURRETS];
   RB_int toggle;
   EVENT_HANDLER *ehm;
   
  public:

   EVENT_HANDLER_METHOD_H (S_tank, EHM_A)
   {
      RB_cout << (int) TIME_TAG.GetTime()
	      << ":"
	      << NODE+LOCAL_ID
	      << ": A"
	      << endl;

      // these lines prevent compiler warnings saying the variables are unused.
      void *v;
      v = (void*) EVENT_NAME;
      v = (void*) DATA_BYTES;
      v = (void*) EXTERNAL_ID;
      v = (void*) DATA;
      v = v;
   }

   EVENT_HANDLER_METHOD_H (S_tank, EHM_B);
   void TestMethod() { RB_cout << "0 arg WORKS !!!" << endl; }
   void TestMethod1(int a)
   {
      RB_cout << "1 arg WORKS !!!: "
	      << "a = " << a
	      << endl;
   } 
   void TestMethod2(int a, double b)
   {
      RB_cout << "2 arg WORKS !!!: "
	      << "a = " << a
	      << ", b = " << b
	      << endl;
   } 
   void TestMethod3(TestClass a, int b, double c)
   {
       ostrstream os;
       os << "3 arg WORKS !!!: "
	      << "a.a = " << a.a
	      << ", a.b = " << setprecision(4) << a.b
	      << ", b = " << b
	      << ", c = " << c
	      << endl << ends;
       RB_cout << os.str();
   } 
   void TestMethod4(TestClass a, int b, double c, double d)
   {
      RB_cout << "4 arg WORKS !!!: "
	      << "a.a = " << a.a
	      << ", a.b = " << a.b
	      << ", b = " << b
	      << ", c = " << c
	      << ", d = " << d
	      << endl;
   } 
   void TestMethod5(int v1, int v2, int v3, int v4, int v5)
   {
      RB_cout << "5 arg WORKS !!!: "
	      << "v1 = " << v1
	      << ", v2 = " << v2
	      << ", v3 = " << v3
	      << ", v4 = " << v4
	      << ", v5 = " << v5
	      << endl;
   } 
   void TestMethod6(int v1, int v2, int v3, int v4, int v5, int v6)
   {
      RB_cout << "6 arg WORKS !!!: "
	      << "v1 = " << v1
	      << ", v2 = " << v2
	      << ", v3 = " << v3
	      << ", v4 = " << v4
	      << ", v5 = " << v5
	      << ", v6 = " << v6
	      << endl;
   } 
   void TestMethod7(int v1, int v2, int v3, int v4, int v5, int v6, int v7)
   {
      RB_cout << "7 arg WORKS !!!: "
	      << "v1 = " << v1
	      << ", v2 = " << v2
	      << ", v3 = " << v3
	      << ", v4 = " << v4
	      << ", v5 = " << v5
	      << ", v6 = " << v6
	      << ", v7 = " << v7
	      << endl;
   } 
   void TestMethod8(int v1, int v2, int v3, int v4, int v5, int v6, int v7,
		    int v8)
   {
      RB_cout << "8 arg WORKS !!!: "
	      << "v1 = " << v1
	      << ", v2 = " << v2
	      << ", v3 = " << v3
	      << ", v4 = " << v4
	      << ", v5 = " << v5
	      << ", v6 = " << v6
	      << ", v7 = " << v7 << "," << endl
	      << "                 v8 = " << v8
	      << endl;
   } 
   void TestMethod9(int v1, int v2, int v3, int v4, int v5, int v6, int v7,
		    int v8, int v9)
   {
      RB_cout << "9 arg WORKS !!!: "
	      << "v1 = " << v1
	      << ", v2 = " << v2
	      << ", v3 = " << v3
	      << ", v4 = " << v4
	      << ", v5 = " << v5
	      << ", v6 = " << v6
	      << ", v7 = " << v7 << "," << endl
	      << "                 v8 = " << v8
	      << ", v9 = " << v9
	      << endl;
   } 
   void TestMethod10(int v1, int v2, int v3, int v4, int v5, int v6, int v7,
		     int v8, int v9, int v10)
   {
      RB_cout << "10 arg WORKS !!!: "
	      << "v1 = " << v1
	      << ", v2 = " << v2
	      << ", v3 = " << v3
	      << ", v4 = " << v4
	      << ", v5 = " << v5
	      << ", v6 = " << v6
	      << ", v7 = " << v7 << "," << endl
	      << "                  v8 = " << v8
	      << ", v9 = " << v9
	      << ", v10 = " << v10
	      << endl;
   } 
   void TestMethod11(int v1, int v2, int v3, int v4, int v5, int v6, int v7,
		     int v8, int v9, int v10, int v11)
   {
      RB_cout << "11 arg WORKS !!!: "
	      << "v1 = " << v1
	      << ", v2 = " << v2
	      << ", v3 = " << v3
	      << ", v4 = " << v4
	      << ", v5 = " << v5
	      << ", v6 = " << v6
	      << ", v7 = " << v7 << "," << endl
	      << "                  v8 = " << v8
	      << ", v9 = " << v9
	      << ", v10 = " << v10
	      << ", v11 = " << v11
	      << endl;
   } 
   void TestMethod12(int v1, int v2, int v3, int v4, int v5, int v6, int v7,
		     int v8, int v9, int v10, int v11, int v12)
   {
      RB_cout << "12 arg WORKS !!!: "
	      << "v1 = " << v1
	      << ", v2 = " << v2
	      << ", v3 = " << v3
	      << ", v4 = " << v4
	      << ", v5 = " << v5
	      << ", v6 = " << v6
	      << ", v7 = " << v7 << "," << endl
	      << "                  v8 = " << v8
	      << ", v9 = " << v9
	      << ", v10 = " << v10
	      << ", v11 = " << v11
	      << ", v12 = " << v12
	      << endl;
   } 
   void TestMethod13(int v1, int v2, int v3, int v4, int v5, int v6, int v7,
		     int v8, int v9, int v10, int v11, int v12, int v13)
   {
      RB_cout << "13 arg WORKS !!!: "
	      << "v1 = " << v1
	      << ", v2 = " << v2
	      << ", v3 = " << v3
	      << ", v4 = " << v4
	      << ", v5 = " << v5
	      << ", v6 = " << v6
	      << ", v7 = " << v7 << "," << endl
	      << "                  v8 = " << v8
	      << ", v9 = " << v9
	      << ", v10 = " << v10
	      << ", v11 = " << v11
	      << ", v12 = " << v12
	      << ", v13 = " << v13
	      << endl;
   } 
   void TestMethod14(int v1, int v2, int v3, int v4, int v5, int v6, int v7,
		     int v8, int v9, int v10, int v11, int v12, int v13,
		     int v14)
   {
      RB_cout << "14 arg WORKS !!!: "
	      << "v1 = " << v1
	      << ", v2 = " << v2
	      << ", v3 = " << v3
	      << ", v4 = " << v4
	      << ", v5 = " << v5
	      << ", v6 = " << v6
	      << ", v7 = " << v7 << "," << endl
	      << "                  v8 = " << v8
	      << ", v9 = " << v9
	      << ", v10 = " << v10
	      << ", v11 = " << v11
	      << ", v12 = " << v12
	      << ", v13 = " << v13 << "," << endl
	      << "                  v14 = " << v14
	      << endl;
   } 
   void TestMethod15(int v1, int v2, int v3, int v4, int v5, int v6, int v7,
		     int v8, int v9, int v10, int v11, int v12, int v13,
		     int v14, int v15)
   {
      RB_cout << "15 arg WORKS !!!: "
	      << "v1 = " << v1
	      << ", v2 = " << v2
	      << ", v3 = " << v3
	      << ", v4 = " << v4
	      << ", v5 = " << v5
	      << ", v6 = " << v6
	      << ", v7 = " << v7 << "," << endl
	      << "                  v8 = " << v8
	      << ", v9 = " << v9
	      << ", v10 = " << v10
	      << ", v11 = " << v11
	      << ", v12 = " << v12
	      << ", v13 = " << v13 << "," << endl
	      << "                  v14 = " << v14
	      << ", v15 = " << v15
	      << endl;
   } 
   void TestMethod16(int v1, int v2, int v3, int v4, int v5, int v6, int v7,
		     int v8, int v9, int v10, int v11, int v12, int v13,
		     int v14, int v15, int v16)
   {
      RB_cout << "16 arg WORKS !!!: "
	      << "v1 = " << v1
	      << ", v2 = " << v2
	      << ", v3 = " << v3
	      << ", v4 = " << v4
	      << ", v5 = " << v5
	      << ", v6 = " << v6
	      << ", v7 = " << v7 << "," << endl
	      << "                  v8 = " << v8
	      << ", v9 = " << v9
	      << ", v10 = " << v10
	      << ", v11 = " << v11
	      << ", v12 = " << v12
	      << ", v13 = " << v13 << "," << endl
	      << "                  v14 = " << v14
	      << ", v15 = " << v15
	      << ", v16 = " << v16
	      << endl;
   } 
   void TestMethod17(int v1, int v2, int v3, int v4, int v5, int v6, int v7,
		     int v8, int v9, int v10, int v11, int v12, int v13,
		     int v14, int v15, int v16, int v17)
   {
      RB_cout << "17 arg WORKS !!!: "
	      << "v1 = " << v1
	      << ", v2 = " << v2
	      << ", v3 = " << v3
	      << ", v4 = " << v4
	      << ", v5 = " << v5
	      << ", v6 = " << v6
	      << ", v7 = " << v7 << "," << endl
	      << "                  v8 = " << v8
	      << ", v9 = " << v9
	      << ", v10 = " << v10
	      << ", v11 = " << v11
	      << ", v12 = " << v12
	      << ", v13 = " << v13 << "," << endl
	      << "                  v14 = " << v14
	      << ", v15 = " << v15
	      << ", v16 = " << v16
	      << ", v17 = " << v17
	      << endl;
   } 
   void TestMethod18(int v1, int v2, int v3, int v4, int v5, int v6, int v7,
		     int v8, int v9, int v10, int v11, int v12, int v13,
		     int v14, int v15, int v16, int v17, int v18)
   {
      RB_cout << "18 arg WORKS !!!: "
	      << "v1 = " << v1
	      << ", v2 = " << v2
	      << ", v3 = " << v3
	      << ", v4 = " << v4
	      << ", v5 = " << v5
	      << ", v6 = " << v6
	      << ", v7 = " << v7 << "," << endl
	      << "                  v8 = " << v8
	      << ", v9 = " << v9
	      << ", v10 = " << v10
	      << ", v11 = " << v11
	      << ", v12 = " << v12
	      << ", v13 = " << v13 << "," << endl
	      << "                  v14 = " << v14
	      << ", v15 = " << v15
	      << ", v16 = " << v16
	      << ", v17 = " << v17
	      << ", v18 = " << v18
	      << endl;
   } 
   void TestMethod19(int v1, int v2, int v3, int v4, int v5, int v6, int v7,
		     int v8, int v9, int v10, int v11, int v12, int v13,
		     int v14, int v15, int v16, int v17, int v18, int v19)
   {
      RB_cout << "19 arg WORKS !!!: "
	      << "v1 = " << v1
	      << ", v2 = " << v2
	      << ", v3 = " << v3
	      << ", v4 = " << v4
	      << ", v5 = " << v5
	      << ", v6 = " << v6
	      << ", v7 = " << v7 << "," << endl
	      << "                  v8 = " << v8
	      << ", v9 = " << v9
	      << ", v10 = " << v10
	      << ", v11 = " << v11
	      << ", v12 = " << v12
	      << ", v13 = " << v13 << "," << endl
	      << "                  v14 = " << v14
	      << ", v15 = " << v15
	      << ", v16 = " << v16
	      << ", v17 = " << v17
	      << ", v18 = " << v18
	      << ", v19 = " << v19
	      << endl;
   } 
   void TestMethod20(int v1, int v2, int v3, int v4, int v5, int v6, int v7,
		     int v8, int v9, int v10, int v11, int v12, int v13,
		     int v14, int v15, int v16, int v17, int v18, int v19,
		     int v20)
   {
      RB_cout << "20 arg WORKS !!!: "
	      << "v1 = " << v1
	      << ", v2 = " << v2
	      << ", v3 = " << v3
	      << ", v4 = " << v4
	      << ", v5 = " << v5
	      << ", v6 = " << v6
	      << ", v7 = " << v7 << "," << endl
	      << "                  v8 = " << v8
	      << ", v9 = " << v9
	      << ", v10 = " << v10
	      << ", v11 = " << v11
	      << ", v12 = " << v12
	      << ", v13 = " << v13 << "," << endl
	      << "                  v14 = " << v14
	      << ", v15 = " << v15
	      << ", v16 = " << v16
	      << ", v17 = " << v17
	      << ", v18 = " << v18
	      << ", v19 = " << v19 << "," << endl
	      << "                  v20 = " << v20
	      << endl;
   } 
   S_tank(DATA_PARSER &);
};


#endif
