// O_Sem.C source file

#include "ScheduleEvent.H"
#include "O_Sem.H"

DECLARE_1_ARG(LogSemC, int)
DECLARE_1_ARG(LogSemR, int)

O_Sem::O_Sem(char *childType, int contEvent, int reqEvent):
   ContEvent(contEvent),
   ReqEvent(reqEvent),
   ReleaseRequestersBehindGateTestOn(0),
   Parser("speedes.par")
{
   strcpy(ChildType, childType);
}

int O_Sem::Configure(char *testName,
		     SIMOBJ_CONSTRUCTOR_FUNCTION simobjConstFunc)
{
   int numSimobj;

   if (!(Config.ConfigureTest(testName, numSimobj, start, end)))
   {
      N_TOT = N_LOC = 0;
      return 0;
   }
   CardDeal(numSimobj, LocalObjects, simobjConstFunc, Parser,
	    Config.GetReplication(), ChildType);
   return 1;
}

void O_Sem::EndConfigure()
{
   noisy = Config.GetNoisy();
   if (Config.ConfigureSubtest("Basic"))
   {
      ReleaseRequestersBehindGateTestOn = 1;
      numRequestorsPerObject =
	Config.GetSubtestParameter("numRequestorsPerObject");
      numSemsPerObject =
	Config.GetSubtestParameter("numSemsPerObject");
      numControllersPerObject =
	Config.GetSubtestParameter("numControllersPerObject");
      timeOutValue =
	Config.GetSubtestParameter("timeOutValue");
      waitValueC =
	Config.GetSubtestParameter("waitValueC");
      waitValueR =
	Config.GetSubtestParameter("waitValueR");
      for (int i=0; i<N_LOC; i++)
	GetLocalObject(i)->InitSem (numSemsPerObject);
   }
}

S_Sem *O_Sem::GetLocalObject(int i)
{
   return (S_Sem *) LocalObjects[i];
}

void O_Sem::init_events() {
   int i, j;
   cout << "--------------------------------------"
	<< "--------------------------------------"
	<< endl;
   for (i=0; i<N_LOC; i++)
   {
      SpObjectHandle objectHandle;

      objectHandle.NodeId = NODE;
      objectHandle.ObjManId = OBJECT_TYPE;
      objectHandle.SimObjId = i;

      for (j=0; j<numControllersPerObject; j++)
	 ScheduleLogSemC(start, objectHandle, j);
      for (j=0; j<numRequestorsPerObject; j++)
	 ScheduleLogSemR(start, objectHandle, j);
   }   
}
