// Main.C for the SPEEDES simulation

#include "Speedes.H"

/*
** Automatic Object Managers
*/

#include "S_TestAutoBlockDecomp.H"
#include "S_TestAutoScatterDecomp.H"
#include "S_TestAutoParserObjSD.H"
#include "S_TestAutoParserObjBD.H"

/*
** Object Managers
*/

#include "O_TestScatterDecomp.H"
#include "O_TestBlockDecomp.H"
#include "O_TestParserObjSD.H"
#include "O_TestParserObjBD.H"

int main (int argc, char **argv) {

/*
** Plug in the simulation objects and events
*/

  PLUG_IN_OBJECT_MANAGER(TestBlockDecomp);
  PLUG_IN_OBJECT_MANAGER(TestScatterDecomp);
  PLUG_IN_OBJECT_MANAGER(TestParserObjSD);
  PLUG_IN_OBJECT_MANAGER(TestParserObjBD);

  PLUG_IN_OBJECT_MANAGER(TestAutoBlockDecomp);
  PLUG_IN_OBJECT_MANAGER(TestAutoScatterDecomp);
  PLUG_IN_OBJECT_MANAGER(TestAutoParserObjSD);
  PLUG_IN_OBJECT_MANAGER(TestAutoParserObjBD);

  PLUG_IN_EVENT(TestBlockDecompEvent);
  PLUG_IN_EVENT(TestScatterDecompEvent);
  PLUG_IN_EVENT(TestParserObjBD_Event);
  PLUG_IN_EVENT(TestParserObjSD_Event);

  PLUG_IN_EVENT(TestAutoBlockDecompEvent);
  PLUG_IN_EVENT(TestAutoScatterDecompEvent);
  PLUG_IN_EVENT(TestAutoParserObjSD_Event);
  PLUG_IN_EVENT(TestAutoParserObjBD_Event);

/*
** Execute SPEEDES
*/

   ExecuteSpeedes(argc, argv);
   return 0;

}
