// S_TestAutoBlockDecomp.C source file

#include "S_TestAutoBlockDecomp.H"

O_TestAutoBlockDecomp *MgrTestAutoBlockDecomp = NULL;

/*
** Function that returns the number of object to create
*/

int GetNumTestAutoBlockDecomp() {return 7;}

/*
** Init method where all of the real work is done in constructing the object
*/

void S_TestAutoBlockDecomp::Init() {

  MgrTestAutoBlockDecomp =
    (O_TestAutoBlockDecomp *)SpGetSimObjMgr(OBJECT_TYPE);

  if (MgrTestAutoBlockDecomp !=
      (O_TestAutoBlockDecomp *)SpGetSimObjMgr("TestAutoBlockDecomp")) {
    cout << "Error, bad object manager lookup" << endl;
  }

  cout << "Initializing " << NAME
       << " <" << NODE << ", " << OBJECT_TYPE << ", " << LOCAL_ID << ">"
       << endl;

  SpObjHandle objHandle = MgrTestAutoBlockDecomp->GetObjHandle(NUM_ID);

  if (objHandle.NodeId != NODE) {
    cout << "Error, bad NODE lookup" << endl;
  }

  if (objHandle.ObjManId != OBJECT_TYPE) {
    cout << "Error, bad OBJECT_TYPE lookup" << endl;
  }

  if (objHandle.SimObjId != LOCAL_ID) {
    cout << "Error, bad LOCAL_ID lookup" << endl;
  }

  ScheduleTestAutoBlockDecompEvent(0.0, objHandle, NUM_ID);

}

/*
** A test event
*/

void S_TestAutoBlockDecomp::TestAutoBlockDecompEvent(int testVar) {
  cout << "TestAutoBlockDecompEvent " << testVar << endl;
}
