// S_TestAutoParserObjBD.C source file

#include "S_TestAutoParserObjBD.H"

O_TestAutoParserObjBD *MgrTestAutoParserObjBD = NULL;

void S_TestAutoParserObjBD::InitParser(SpDataParser *parser) {

  MgrTestAutoParserObjBD =
    (O_TestAutoParserObjBD *)SpGetSimObjMgr(OBJECT_TYPE);

  if (MgrTestAutoParserObjBD !=
      (O_TestAutoParserObjBD *)SpGetSimObjMgr("TestAutoParserObjBD")) {
    cout << "Error, bad object manager lookup" << endl;
  }

  cout << "Initializing " << NAME
       << " <" << NODE << ", " << OBJECT_TYPE << ", " << LOCAL_ID << ">"
       << endl;

  SpObjHandle objHandle = MgrTestAutoParserObjBD->GetObjHandle(NUM_ID);

  if (objHandle.NodeId != NODE) {
    cout << "Error, bad NODE lookup" << endl;
  }

  if (objHandle.ObjManId != OBJECT_TYPE) {
    cout << "Error, bad OBJECT_TYPE lookup" << endl;
  }

  if (objHandle.SimObjId != LOCAL_ID) {
    cout << "Error, bad LOCAL_ID lookup" << endl;
  }

  if (NUM_ID != parser->GetInt("Value")) {
    cout << "Error, bad Value lookup in parser" << endl;
  }

  ScheduleTestAutoParserObjBD_Event(0.0, objHandle, NUM_ID);

}

void S_TestAutoParserObjBD::TestAutoParserObjBD_Event(int testVar) {
  cout << "TestAutoParserObjBD_Event " << testVar << endl;
}
