// S_TestAutoParserObjSD.C source file

#include "S_TestAutoParserObjSD.H"

O_TestAutoParserObjSD *MgrTestAutoParserObjSD = NULL;

void S_TestAutoParserObjSD::InitParser(SpDataParser *parser) {

  MgrTestAutoParserObjSD =
    (O_TestAutoParserObjSD *)SpGetSimObjMgr(OBJECT_TYPE);

  if (MgrTestAutoParserObjSD !=
      (O_TestAutoParserObjSD *)SpGetSimObjMgr("TestAutoParserObjSD")) {
    cout << "Error, bad object manager lookup" << endl;
  }

  cout << "Initializing " << NAME
       << " <" << NODE << ", " << OBJECT_TYPE << ", " << LOCAL_ID << ">"
       << endl;

  SpObjHandle objHandle = MgrTestAutoParserObjSD->GetObjHandle(NUM_ID);

  if (objHandle.NodeId != NODE) {
    cout << "Error, bad NODE lookup" << endl;
  }

  if (objHandle.ObjManId != OBJECT_TYPE) {
    cout << "Error, bad OBJECT_TYPE lookup" << endl;
  }

  if (objHandle.SimObjId != LOCAL_ID) {
    cout << "Error, bad LOCAL_ID lookup" << endl;
  }

  if (NUM_ID != parser->GetInt("Value")) {
    cout << "Error, bad Value lookup in parser" << endl;
  }

  ScheduleTestAutoParserObjSD_Event(0.0, objHandle, NUM_ID);

}

void S_TestAutoParserObjSD::TestAutoParserObjSD_Event(int testVar) {
  cout << "TestAutoParserObjSD_Event " << testVar << endl;
}
