// S_TestAutoScatterDecomp.C source file

#include "S_TestAutoScatterDecomp.H"

O_TestAutoScatterDecomp *MgrTestAutoScatterDecomp = NULL;

void S_TestAutoScatterDecomp::Init() {

  MgrTestAutoScatterDecomp =
    (O_TestAutoScatterDecomp *)SpGetSimObjMgr(OBJECT_TYPE);

  if (MgrTestAutoScatterDecomp !=
      (O_TestAutoScatterDecomp *)SpGetSimObjMgr("TestAutoScatterDecomp")) {
    cout << "Error, bad object manager lookup" << endl;
  }

  cout << "Initializing " << NAME
       << " <" << NODE << ", " << OBJECT_TYPE << ", " << LOCAL_ID << ">"
       << endl;

  SpObjHandle objHandle = MgrTestAutoScatterDecomp->GetObjHandle(NUM_ID);

  if (objHandle.NodeId != NODE) {
    cout << "Error, bad NODE lookup" << endl;
  }

  if (objHandle.ObjManId != OBJECT_TYPE) {
    cout << "Error, bad OBJECT_TYPE lookup" << endl;
  }

  if (objHandle.SimObjId != LOCAL_ID) {
    cout << "Error, bad LOCAL_ID lookup" << endl;
  }

  ScheduleTestAutoScatterDecompEvent(0.0, objHandle, NUM_ID);

}

void S_TestAutoScatterDecomp::TestAutoScatterDecompEvent(int testVar) {
  cout << "TestAutoScatterDecompEvent " << testVar << endl;
}
