// S_TestBlockDecomp.C source file

#include "O_TestBlockDecomp.H"
#include "S_TestBlockDecomp.H"

O_TestBlockDecomp *MgrTestBlockDecomp = NULL;

void S_TestBlockDecomp::Init() {

  MgrTestBlockDecomp = (O_TestBlockDecomp *)SpGetSimObjMgr(OBJECT_TYPE);
  if (MgrTestBlockDecomp !=
      (O_TestBlockDecomp *)SpGetSimObjMgr("TestBlockDecomp")) {
    cout << "Error, bad object manager lookup" << endl;
  }

  cout << "Initializing " << NAME
       << " <" << NODE << ", " << OBJECT_TYPE << ", " << LOCAL_ID << ">"
       << endl;

  SpObjHandle objHandle = MgrTestBlockDecomp->GetObjHandle(NUM_ID);

  if (objHandle.NodeId != NODE) {
    cout << "Error, bad NODE lookup" << endl;
  }

  if (objHandle.ObjManId != OBJECT_TYPE) {
    cout << "Error, bad OBJECT_TYPE lookup" << endl;
  }

  if (objHandle.SimObjId != LOCAL_ID) {
    cout << "Error, bad LOCAL_ID lookup" << endl;
  }

  ScheduleTestBlockDecompEvent(0.0, objHandle, NUM_ID);

}


void S_TestBlockDecomp::TestBlockDecompEvent(int testVar) {
  cout << "TestBlockDecompEvent " << testVar << endl;
}
