// S_TestParserObjBD.C source file

#include "O_TestParserObjBD.H"
#include "S_TestParserObjBD.H"

O_TestParserObjBD *MgrTestParserObjBD = NULL;

void S_TestParserObjBD::InitParser(SpDataParser *parser) {

  MgrTestParserObjBD = (O_TestParserObjBD *)SpGetSimObjMgr(OBJECT_TYPE);
  if (MgrTestParserObjBD !=
      (O_TestParserObjBD *)SpGetSimObjMgr("TestParserObjBD")) {
    cout << "Error, bad object manager lookup" << endl;
  }

  cout << "Initializing " << NAME
       << " <" << NODE << ", " << OBJECT_TYPE << ", " << LOCAL_ID << ">"
       << endl;

  SpObjHandle objHandle = MgrTestParserObjBD->GetObjHandle(NUM_ID);

  if (objHandle.NodeId != NODE) {
    cout << "Error, bad NODE lookup" << endl;
  }

  if (objHandle.ObjManId != OBJECT_TYPE) {
    cout << "Error, bad OBJECT_TYPE lookup" << endl;
  }

  if (objHandle.SimObjId != LOCAL_ID) {
    cout << "Error, bad LOCAL_ID lookup" << endl;
  }

  if (NUM_ID != parser->GetInt("Value")) {
    cout << "Error, bad Value lookup in parser" << endl;
  }

  ScheduleTestParserObjBD_Event(0.0, objHandle, NUM_ID);

}

void S_TestParserObjBD::TestParserObjBD_Event(int testVar) {
  cout << "TestParserObjBD_Event " << testVar << endl;
}
