// S_TestParserObjSD.C source file

#include "O_TestParserObjSD.H"
#include "S_TestParserObjSD.H"

O_TestParserObjSD *MgrTestParserObjSD = NULL;

void S_TestParserObjSD::InitParser(SpDataParser *parser) {

  MgrTestParserObjSD = (O_TestParserObjSD *)SpGetSimObjMgr(OBJECT_TYPE);
  if (MgrTestParserObjSD !=
      (O_TestParserObjSD *)SpGetSimObjMgr("TestParserObjSD")) {
    cout << "Error, bad object manager lookup" << endl;
  }

  cout << "Initializing " << NAME
       << " <" << NODE << ", " << OBJECT_TYPE << ", " << LOCAL_ID << ">"
       << endl;

  SpObjHandle objHandle = MgrTestParserObjSD->GetObjHandle(NUM_ID);

  if (objHandle.NodeId != NODE) {
    cout << "Error, bad NODE lookup" << endl;
  }

  if (objHandle.ObjManId != OBJECT_TYPE) {
    cout << "Error, bad OBJECT_TYPE lookup" << endl;
  }

  if (objHandle.SimObjId != LOCAL_ID) {
    cout << "Error, bad LOCAL_ID lookup" << endl;
  }

  if (NUM_ID != parser->GetInt("Value")) {
    cout << "Error, bad Value lookup in parser" << endl;
  }

  ScheduleTestParserObjSD_Event(0.0, objHandle, NUM_ID);

}

void S_TestParserObjSD::TestParserObjSD_Event(int testVar) {
  cout << "TestParserObjSD_Event " << testVar << endl;
}
