// S_TestScatterDecomp.C source file

#include "O_TestScatterDecomp.H"
#include "S_TestScatterDecomp.H"

O_TestScatterDecomp *MgrTestScatterDecomp = NULL;

void S_TestScatterDecomp::Init() {

  MgrTestScatterDecomp = (O_TestScatterDecomp *)SpGetSimObjMgr(OBJECT_TYPE);
  if (MgrTestScatterDecomp !=
      (O_TestScatterDecomp *)SpGetSimObjMgr("TestScatterDecomp")) {
    cout << "Error, bad object manager lookup" << endl;
  }

  cout << "Initializing " << NAME
       << " <" << NODE << ", " << OBJECT_TYPE << ", " << LOCAL_ID << ">"
       << endl;

  SpObjHandle objHandle = MgrTestScatterDecomp->GetObjHandle(NUM_ID);

  if (objHandle.NodeId != NODE) {
    cout << "Error, bad NODE lookup" << endl;
  }

  if (objHandle.ObjManId != OBJECT_TYPE) {
    cout << "Error, bad OBJECT_TYPE lookup" << endl;
  }

  if (objHandle.SimObjId != LOCAL_ID) {
    cout << "Error, bad LOCAL_ID lookup" << endl;
  }

  ScheduleTestScatterDecompEvent(0.0, objHandle, NUM_ID);

}

void S_TestScatterDecomp::TestScatterDecompEvent(int testVar) {
  cout << "TestScatterDecompEvent " << testVar << endl;
}
