// S_TestCancel.H header file

#ifndef S_TestCancelGate
#define S_TestCancelGate

#include "SpSimObj.H"
#include "SpRandom.H"
#include "SpBuiltInMacros.H"
#include "ScheduleEvent.H"
#include "Speedes.H"
#include "SpReportStatus.H"

const double DtSched = 10.0;

class S_TestCancel : public SpSimObj {

  private:

    RB_int MyEventCounter;

  protected:
  public:

    virtual void Init();
    void ScheduleMyEventTC(SpRandom random);
    void RetractMyEventTC(SpCancelHandle cancelHandle);
    void MyEvilEventTC(SpRandom random);

    virtual void terminate(double tend) {
      int errorFlag = 0;

      if ((tend/DtSched) > MyEventCounter) {
	errorFlag = 1;
      }

      if ((tend/DtSched + 1) < MyEventCounter) {
	errorFlag = 1;
      }

      if (errorFlag) {
	cout << "Test Cancel Failed: Wrong number of events "
	     << MyEventCounter << endl;
	SpReportStatus("Test Cancel", SP_REPORT_STATUS_FAILED);
      }else{
	cout << "Test Cancel Passed: Correct number of events "
	     << MyEventCounter << endl;
	SpReportStatus("Test Cancel", SP_REPORT_STATUS_PASSED);
      }
    }

};

//inline int GetNumTC() {return SpCOmm_GetNumNodes();}
inline int GetNumTC() {return 2;}

DEFINE_EVENT_METHOD_1_ARG(ScheduleMyEventTC,
			  10,
			  S_TestCancel,
			  ScheduleMyEventTC,
			  SpRandom);

DEFINE_EVENT_METHOD_1_ARG(RetractMyEventTC,
			  10,
			  S_TestCancel,
			  RetractMyEventTC,
			  SpCancelHandle);

DEFINE_EVENT_METHOD_1_ARG(MyEvilEventTC,
			  10,
			  S_TestCancel,
			  MyEvilEventTC,
			  SpRandom);

DEFINE_SCATTER_DECOMP_OBJECT_MANAGER(TestCancel,
				     S_TestCancel,
				     GetNumTC(),
				     SpeedesCluster);

#endif
