// S_ClusterA.C source file

#include "S_ClusterA.H"

O_ClusterA *MgrClusterA = NULL;

/*
** Function that returns the number of object to create
*/

int GetNumClusterA() {return 7;}

/*
** Init method where all of the real work is done in constructing the object
*/

void S_ClusterA::Init() {

  MgrClusterA =
    (O_ClusterA *)SpGetSimObjMgr(OBJECT_TYPE);

  if (MgrClusterA !=
      (O_ClusterA *)SpGetSimObjMgr("ClusterA")) {
    cout << "Error, bad object manager lookup" << endl;
  }

  cout << "Initializing " << NAME
       << " <" << NODE << ", " << OBJECT_TYPE << ", " << LOCAL_ID << ">"
       << endl;

  SpObjHandle objHandle = MgrClusterA->GetObjHandle(NUM_ID);

  if (objHandle.NodeId != NODE) {
    cout << "Error, bad NODE lookup " << objHandle.NodeId << endl;
  }

  if (objHandle.ObjManId != OBJECT_TYPE) {
    cout << "Error, bad OBJECT_TYPE lookup" << endl;
  }

  if (objHandle.SimObjId != LOCAL_ID) {
    cout << "Error, bad LOCAL_ID lookup" << endl;
  }

  ScheduleClusterAEvent(0.0, objHandle, NUM_ID);

}

/*
** A test event
*/

void S_ClusterA::ClusterAEvent(int testVar) {
  cout << "ClusterAEvent " << testVar << endl;
}
