// S_ClusterB.C source file

#include "S_ClusterB.H"

O_ClusterB *MgrClusterB = NULL;

/*
** Function that returns the number of object to create
*/

int GetNumClusterB() {return 7;}

/*
** Init method where all of the real work is done in constructing the object
*/

void S_ClusterB::Init() {

  MgrClusterB =
    (O_ClusterB *)SpGetSimObjMgr(OBJECT_TYPE);

  if (MgrClusterB !=
      (O_ClusterB *)SpGetSimObjMgr("ClusterB")) {
    cout << "Error, bad object manager lookup" << endl;
  }

  cout << "Initializing " << NAME
       << " <" << NODE << ", " << OBJECT_TYPE << ", " << LOCAL_ID << ">"
       << endl;

  SpObjHandle objHandle = MgrClusterB->GetObjHandle(NUM_ID);

  if (objHandle.NodeId != NODE) {
    cout << "Error, bad NODE lookup" << endl;
  }

  if (objHandle.ObjManId != OBJECT_TYPE) {
    cout << "Error, bad OBJECT_TYPE lookup" << endl;
  }

  if (objHandle.SimObjId != LOCAL_ID) {
    cout << "Error, bad LOCAL_ID lookup" << endl;
  }

  ScheduleClusterBEvent(0.0, objHandle, NUM_ID);

}

/*
** A test event
*/

void S_ClusterB::ClusterBEvent(int testVar) {
  cout << "ClusterBEvent " << testVar << endl;
}
