// S_ClusterC.C source file

#include "S_ClusterC.H"

O_ClusterC *MgrClusterC = NULL;

/*
** Function that returns the number of object to create
*/

int GetNumClusterC() {return 7;}

/*
** Init method where all of the real work is done in constructing the object
*/

void S_ClusterC::Init() {

  MgrClusterC =
    (O_ClusterC *)SpGetSimObjMgr(OBJECT_TYPE);

  if (MgrClusterC !=
      (O_ClusterC *)SpGetSimObjMgr("ClusterC")) {
    cout << "Error, bad object manager lookup" << endl;
  }

  cout << "Initializing " << NAME
       << " <" << NODE << ", " << OBJECT_TYPE << ", " << LOCAL_ID << ">"
       << endl;

  SpObjHandle objHandle = MgrClusterC->GetObjHandle(NUM_ID);

  if (objHandle.NodeId != NODE) {
    cout << "Error, bad NODE lookup" << endl;
  }

  if (objHandle.ObjManId != OBJECT_TYPE) {
    cout << "Error, bad OBJECT_TYPE lookup" << endl;
  }

  if (objHandle.SimObjId != LOCAL_ID) {
    cout << "Error, bad LOCAL_ID lookup" << endl;
  }

  ScheduleClusterCEvent(0.0, objHandle, NUM_ID);

}

/*
** A test event
*/

void S_ClusterC::ClusterCEvent(int testVar) {
  cout << "ClusterCEvent " << testVar << endl;
}
