// S_TestCreate.H header file

#ifndef S_TestCreateGate
#define S_TestCreateGate

#include "SpSimObj.H"
#include "SpRandom.H"
#include "SpBuiltInMacros.H"
#include "ScheduleEvent.H"
#include "Speedes.H"

const double DtSched = 100.0;

class S_TestCreate : public SpSimObj {

  private:

    RB_int MyEventCounter;

  protected:
  public:

    S_TestCreate() {
      cout << "Creating S_TestCreate" << endl;
    }

    ~S_TestCreate() {
      cout << "Destroying S_TestCreate" << endl;
    }

    virtual void Init();
    virtual void InitData(char *Data);

    void MyRepeatedEventTCR(SpRandom random);
    void MyEvilEventTCR(SpRandom random);

    virtual void terminate(double tend) {
      int errorFlag = 0;

      if (-1 != MyEventCounter) {
	if ((tend/DtSched) > MyEventCounter) {
	  errorFlag = 1;
	}

	if ((tend/DtSched + 1) < MyEventCounter) {
	  errorFlag = 1;
	}

	if (errorFlag) {
	  cout << "Test Create Failed: Wrong number of events "
	       << MyEventCounter << endl;
	}else{
	  cout << "Test Create Passed: Correct number of events "
	       << MyEventCounter << endl;
	}
      }

    }

};

//inline int GetNumTC() {return SpCOmm_GetNumNodes();}
inline int GetNumTC() {return 2;}

DEFINE_EVENT_METHOD_1_ARG(MyRepeatedEventTCR,
			  10,
			  S_TestCreate,
		          MyRepeatedEventTCR,
			  SpRandom);

DEFINE_EVENT_METHOD_1_ARG(MyEvilEventTCR,
			  10,
			  S_TestCreate,
			  MyEvilEventTCR,
			  SpRandom);

DEFINE_BLOCK_DECOMP_OBJECT_MANAGER(TestCreate,
				   S_TestCreate,
				   GetNumTC(),
				   SpeedesCluster);

#endif
