// S_TestDynEventHandler.C source file

#include "S_TestDynEventHandler.H"
O_TestDynEventHandler *MgrTestDynEventHandler = NULL;

void S_TestDynEventHandler::Init() {

  NumGoodEvents = 0;

  MgrTestDynEventHandler =
    (O_TestDynEventHandler *)SpGetSimObjMgr(OBJECT_TYPE);

  SpObjHandle objHandle;
  objHandle.NodeId = NODE;
  objHandle.ObjManId = OBJECT_TYPE;
  objHandle.SimObjId = LOCAL_ID;

  ScheduleDynEventHandlerEvent(1.0, objHandle, 1);

#ifdef EVIL_EVENT
  ScheduleEvilDynEventHandlerEvent(0.0, objHandle, 1);
#endif

}

void S_TestDynEventHandler::DynEventHandlerEvent(int addFlag) {
  SpSimTime time = GetSimTime();

  NumGoodEvents++;

  if (addFlag) {
    RB_cout << "Adding TestDynEventHandlerEvent at time "
	    << time << endl;
    AddEventHandler("TestEventHandler", &EventHandler);
  }else{
    RB_cout << "Removing TestDynEventHandlerEvent at time "
	    << time << endl;
    RemoveEventHandler("TestEventHandler", &EventHandler);
  }

  time += 100;
  SpObjHandle objHandle;
  objHandle.NodeId = NODE;
  objHandle.ObjManId = OBJECT_TYPE;
  objHandle.SimObjId = LOCAL_ID;
  ScheduleDynEventHandlerEvent(time, objHandle, (addFlag+1)%2);
}

void S_TestDynEventHandler::EvilDynEventHandlerEvent(SpRandom random) {
  int destination = random.GenerateInt(0,GetNumSimObjs()-1);
  SpObjHandle objHandle = MgrTestDynEventHandler->GetObjHandle(destination);

  SpSimTime time = GetSimTime()
    + random.GenerateDouble(0.0, 100.0);

  ScheduleEvilDynEventHandlerEvent(time, objHandle, random);
}

void S_TestDynEventHandler::terminate(double) {
  if (NumGoodEvents == 36) {
    cout << "TestDynEventHandler Passed" << endl;
  }else{
    cout << "TestDynEventHandler Failed" << endl;
  }
}
