// S_Ping.C

#include "S_Ping.H"
#include "SpIostream.H"
#include "SpString.H"

#include "SpTag.H"
extern SpTag *CurrentTag;
//extern int PingEvent;

S_Ping::S_Ping() {
  char s[120];
  sprintf(s, "Ping%d", NODE+LOCAL_ID);
  NAME = strdup(s);
}

void S_Ping::Query(double time, NAME_VALUE_LIST &nameValueList) {
  if (NAME) nameValueList.SetNameOfList(NAME);
  nameValueList.SetNameValue("time", time);
}

void S_Ping::PingEvent(double time) {
  cout << "Pinging " << NODE << " at time " << time << endl;
  *CurrentTag << "Hello World" << endl;

  SpObjectHandle objectHandle;
  objectHandle.ObjManId = OBJECT_TYPE;

  if (N_NODES == 1) {
    objectHandle.SimObjId = (LOCAL_ID + 1)%2;
    objectHandle.NodeId = 0;
  }else{
    objectHandle.SimObjId = 0;
    objectHandle.NodeId = (NODE + 1)%2;
  }

  SchedulePingEvent(time+1, objectHandle, time+1);
}
