// servman.C method file

#include "SpStdio.H"
#include "O_PersistenceTestObject.H"
#include "S_PersistenceTestObject.H"
#include "ScheduleEvent.H"
#include "SpPoDataBase.H"

EVENT_TYPE(PersistenceTest);



/************************************************************************
* O_PersistenceTestObject : construct a servman object		       	*
************************************************************************/
O_PersistenceTestObject::O_PersistenceTestObject() {
  if (SpPoDataBase::DoNotAllocateMemoryInConstructor){
  }
  else{
    testObject = new S_PersistenceTestObject;
    
    DATA_PARSER parFile("PersistenceTest.par");
    
    parFile.GoTo("parameters", NULL);
    
    testObject->SetMaxListLength(parFile.GetInt("MaxListLength"));
    testObject->SetAddProb(parFile.GetFloat("AddProb"));
    
    N_LOC = 1;
    N_TOT = N_NODES;
    
    TOTAL_OBJECTS += N_TOT;
    reserve_n_objects(1);
    define_object(testObject);
  }
}

/************************************************************************
* init_events : initialize events 				        *
************************************************************************/
void O_PersistenceTestObject::init_events() {

  ScheduleEvent (0.0, PersistenceTest, OBJECT_TYPE, 0, NODE);
}

