#include "SpStdio.H"
#include "PO.H"
#include "RB_SpDefineClass.H"
#include "SpPersistenceBaseClass.H"
#include "SpString.H"

PO_DEFINE_CLASS_NO_ARROW_OPERATORS(double);
PO_DEFINE_CLASS_NO_ARROW_OPERATORS(char);

enum ItemType {
  CONTAINED_CLASS,
  DERIVED_CLASS
};

class SomeClassWithVirtualFunctionTables : private SpPersistenceBaseClass{
public:
  virtual ~SomeClassWithVirtualFunctionTables(){};
};

class SomeOtherClassWithVirtualFunctionTables : private SpPersistenceBaseClass{
public:
  virtual ~SomeOtherClassWithVirtualFunctionTables(){};
};

class ContainedClass : private SpPersistenceBaseClass{
protected:
  SomeClassWithVirtualFunctionTables alsdfasdfasdf;
  double NotUsed;
  PO_PTR_char Name;
  int AlsoNotUsed;
  SomeOtherClassWithVirtualFunctionTables alsdfasdfasdfsdffds;
  SomeClassWithVirtualFunctionTables alsdfasdfasdfasdfsad;
  double NotUsedAsWell;
  char YouThinkThisIsUsed___Question_Mark_Question_Mark_Question_Mark;
  PO_PTR_double DoubleValue;
  long DontEvenThinkAboutUsingThis;
public:

  ContainedClass():Name(NULL), DoubleValue(NULL){}

  ~ContainedClass(){
    PO_DELETE_char(Name);
    PO_DELETE_double(DoubleValue);
  }

  void reset(){Name = NULL; DoubleValue = NULL;}

  virtual ItemType GetType(){return CONTAINED_CLASS;}

  virtual char* Getname(){
    char * name = new char[strlen(Name)+1 + strlen("Contained Class ")+1];
    sprintf(name, "Contained Class %s", (char*)Name);
    return (char*) name;}

  void SetName(char* nm){
    if (Name) PO_DELETE_ARRAY_char(Name);
    Name = PO_NEW_ARRAY_char(strlen(nm)+1);
    strcpy(Name, nm);
  }

  double GetDoubleValue (){
    double rc = 99;
    if (DoubleValue) rc = *DoubleValue;
    return rc;
  }
  

  double SetDoubleValue(double x) {
    if (DoubleValue){
      PO_DELETE_double(DoubleValue);
    }
    DoubleValue = PO_NEW_double();
    *DoubleValue = x;
    return *DoubleValue;
  }
};

class DerivedClass : private ContainedClass{
private:
  SomeClassWithVirtualFunctionTables alsdfasdfasdfsdffds;
  int asdfjlkjlkgjasfgfdsafkdsajfasdjflkjslkjglxiuoiyxziuyvbitbvuy;
  SomeOtherClassWithVirtualFunctionTables alsdfasdfasdfasdfsad;

public:
  virtual ItemType GetType(){return DERIVED_CLASS;}

  virtual char* GetName(){
    char * name = new char[strlen(Name)+1 + strlen("Contained Class ")+1];
    sprintf(name, "Derived Class %s", (char*)Name);
    return (char*) name;}
};

PO_DEFINE_CLASS(ContainedClass);
PO_DEFINE_CLASS(DerivedClass);
class  PersistenceListItem;
extern PersistenceListItem* ListTop;
PO_DEFINE_SMART_POINTERS_NO_ADDITIONAL_OPERATORS(PersistenceListItem);

class PersistenceListItem{
private:
  ItemType Type;
  PO_PTR_PersistenceListItem Next;
  PO_PTR_PersistenceListItem Previous;
  PO_PTR_ContainedClass Item;

public:
  double GetDoubleValue(){return Item->GetDoubleValue();}
  void SetDoubleValue(double v){ Item->SetDoubleValue(v);}
  void SetName(char* nm){ Item->SetName(nm);}

  PersistenceListItem():Next(NULL), Previous(NULL){}

  PersistenceListItem* GetNext(){return Next;}

  PersistenceListItem* GetPrevious(){return Previous;}

  ContainedClass* GetItem(){return Item;}

  int VerifyItem(){return Type == Item->GetType();}
  
  void SetItem(ContainedClass* c){ Item = c; Type = c->GetType();}

  void SetNext(PersistenceListItem* n){Next = n;}

  void SetPrevious(PersistenceListItem* p){Previous = p;}

  static void FibonacciFixup(PersistenceListItem* listItem){
    if (listItem){
      double v2 = listItem->GetDoubleValue();
      double v1 = (listItem->Previous) 
	? listItem->Previous->GetDoubleValue()
	: 0;
      PersistenceListItem* walker = listItem->Next;
      while (walker){
	walker->SetDoubleValue(v1 + v2);
	v1 = v2;
	v2 = walker->GetDoubleValue();
	walker = walker->Next;
      }
    }
  }

  static ContainedClass* Remove(PersistenceListItem* listItem);

  void SetTopName();

  static PersistenceListItem* PersistenceNewPersistenceListItem();
  static void PersistenceDeletePersistenceListItem(PersistenceListItem*);

  static void InsertAfter(PersistenceListItem* listItem, ContainedClass* item){
    PersistenceListItem* newListItem = PersistenceNewPersistenceListItem();
    if (listItem){
      newListItem->Next = listItem->Next;
      newListItem->Previous = listItem;
      listItem->Next = newListItem;
    }
    else{ //listItem == NULL means insert on the top
      newListItem->Next = ListTop;
      newListItem->Previous = NULL;
      newListItem->SetTopName();
      item->SetDoubleValue(1);
      listItem = newListItem;
      ListTop = newListItem;
    }
    newListItem->Item = item;
    if (newListItem->Next){
      newListItem->Next->Previous = newListItem;
    }

    FibonacciFixup(listItem);
    newListItem->Type = item->GetType();
  }

  static int VerifyList(){
    int rc = 1;
    PersistenceListItem* walker = ListTop;
    double v2 = 0, v1 = 0;
    if (walker){
      v2 = walker->GetDoubleValue();
      walker = walker->Next;
    }
    while (walker){
      if (walker->VerifyItem()){
	rc = 0;
	break;
      }
      if (walker->GetDoubleValue() != (v1 + v2)){
	cout<<"Not Fibonacci!!! "<<v1<<" "<<v2<<" "
	    <<walker->GetDoubleValue()<<endl;
      }
      v1 = v2;
      walker = walker->Next;
    };
    return rc;
  }

  static int GetListLength(){
    int len = 0;
    PersistenceListItem* walker = ListTop;
    while (walker){
      ++len;
      walker = walker->Next;
    }
    return len;
  }
};

PO_DEFINE_CLASS_SMART_POINTERS_DECLARED_PREVIOUSLY(PersistenceListItem);

static PersistenceListItem* GetList(char* databaseBuffer)
{
  PO_RECONSTRUCT_BUFFER(databaseBuffer);
  return PO_LOOKUP_NAME_PersistenceListItem("Top");
}

