// servobj.H header file

#ifndef S_PersistenceTestObject_H
#define S_PersistenceTestObject_H

#include "SpSimObj.H"

/************************************************************************
*	servobj object 							*
************************************************************************/
class S_PersistenceTestObject : public SpSimObj {
public:


  enum ErrorCodes {
    TOO_MANY_PERSISTENCE_LIST_ITEMS = 1,
    TOO_MANY_DERIVED_CLASS_ITEMS = 2,
    TOO_MANY_CONTAINED_CLASS_ITEMS = 4,
    WRONG_LIST_LENGTH = 8,
    SPFOO_ERROR = 16,
    GET_FIRST_ERROR = 32,
    GET_NEXT_ERROR = 64,
    GET_NUMBER_OF = 128,
    GET_FIRST_BLOCK_ERROR = 256,
    GET_NEXT_BLOCK_ERROR = 512,
    VOID_POINTER_LOST = 1024,
    NOT_USED_4 = 2048,
    NOT_USED_5 = 4096,
    NOT_USED_6 = 8192,
    UNKNOWN_GENERAL_ERROR = 16384
  };

  void SetError(ErrorCodes code){
    ErrorCode |= code;
  }

  S_PersistenceTestObject():ErrorCode(0){}

  int GetErrorCode(){return ErrorCode;}
  int GetMaxListLength(){return MaxListLength;}
  void SetMaxListLength(int len){ MaxListLength = len;}
  double GetAddProb(){ return AddProb;}
  void SetAddProb(double p){AddProb = p;}

private:
  int ErrorCode;
  int MaxListLength;
  double AddProb;
 
};


#endif
