#include "PO.H"

#ifdef __IBMCPP__
namespace {
#endif

#ifndef PO_VOID_TYPE_CLASS_DEFINED
PO_DEFINE_CLASS(PO_VOID_TYPE_CLASS);
#define PO_VOID_TYPE_CLASS_DEFINED
#endif 

#ifdef __IBMCPP__
}
#endif

class SpFoo{
public:
  SpFoo():testCharStar(NULL), testDoubleStar(NULL){};
  ~SpFoo(){}

  int DoTest();

private:
  int AllocateTestOne();
  int AllocateTestTwo();
  int DeallocateTestOne();
  int DeallocateTestTwo();

  char * testCharStar;
  double* testDoubleStar;
};

int SpFoo::AllocateTestOne(){
  int rc = 0;
  
  testCharStar = new char;
  PO_ADD_char(testCharStar);
  PO_ATTACH_PTR_char(testCharStar);
  if (SpPoDataBase::PO_errno){
    SpPoDataBase::PO_perror("SpFoo::AllocateTestOne error one");
    rc = 1;
  }
  
  testDoubleStar = new double[10];
  PO_ADD_double(testDoubleStar, 10);
  PO_ATTACH_PTR_double(testDoubleStar);
  if (SpPoDataBase::PO_errno){
    SpPoDataBase::PO_perror("SpFoo::AllocateTestOne error two");
    rc = 1;
  }
  return rc;
}


int SpFoo::DeallocateTestOne(){
  int rc = 0;

  PO_DETACH_PTR_char(testCharStar);
  PO_REMOVE_char(testCharStar);
  if (SpPoDataBase::PO_errno){
    SpPoDataBase::PO_perror("SpFoo::DeallocateTestOne error one");
    rc = 1;
  }
  delete testCharStar;
  
  PO_DELETE_ARRAY_double(testDoubleStar);
  if (SpPoDataBase::PO_errno){
    SpPoDataBase::PO_perror("SpFoo::DeallocateTestOne error two");
    rc = 1;
  }
  return rc;
}


int SpFoo::AllocateTestTwo(){
  int rc = 0;
  
  testCharStar = new char[100];
  PO_ADD(testCharStar, 100*sizeof(char));
  PO_ATTACH_PTR_char(testCharStar);
  PO_SET_NAME(testCharStar, "Foo testCharStar");
  if (SpPoDataBase::PO_errno){
    SpPoDataBase::PO_perror("SpFoo::AllocateTestTwo error one");
    rc = 1;
  }
  
  testDoubleStar = PO_NEW_ARRAY_double(10);
  PO_SET_NAME_double(testDoubleStar, "Foo testDoubleStar");
  PO_ATTACH_PTR_double(testDoubleStar);
  if (SpPoDataBase::PO_errno){
    SpPoDataBase::PO_perror("SpFoo::AllocateTestTwo error two");
    rc = 1;
  }
  return rc;
}


int SpFoo::DeallocateTestTwo(){
  int rc = 0;

  char* tst = (char*)PO_LOOKUP_NAME("Foo testCharStar");
  if (tst != testCharStar){
    SpPoDataBase::PO_perror("SpFoo::DeallocateTestTwo error one");
    rc = 1;
  }
  PO_DETACH_PTR(testCharStar);
  PO_REMOVE(testCharStar);
  if (SpPoDataBase::PO_errno){
    SpPoDataBase::PO_perror("SpFoo::DeallocateTestTwo error two");
    rc = 1;
  }
  delete [] testCharStar;
  
  double* tst2 = PO_LOOKUP_NAME_double("Foo testDoubleStar");
  if (tst2 != testDoubleStar){
    SpPoDataBase::PO_perror("SpFoo::DeallocateTestTwo error four");
    rc = 1;
  }
  PO_REMOVE_double(testDoubleStar);
  PO_DETACH_PTR_double(testDoubleStar);
  if (SpPoDataBase::PO_errno){
    SpPoDataBase::PO_perror("SpFoo::DeallocateTestTwo error three");
    rc = 1;
  }
  delete [] testDoubleStar;
  return rc;
}


int SpFoo::DoTest(){
  int rc = AllocateTestOne();
  if (rc == 0){
    DeallocateTestOne();
  }
  if (rc == 0){
    AllocateTestTwo();
  }
  if (rc == 0){
    DeallocateTestTwo();
  }
  return rc;
}

PO_DEFINE_CLASS(SpFoo);
