// E_ENTITY_event_READ.C source file

#include "E_ENTITY_event_TEST.H"
#include "F_ProxyItem.H"
#include "ScheduleEvent.H"
#include "O_ENTITY.H"
#include "SpIostream.H"
#include "SpFstream.H"
#include "SpStrstream.H"
#include "SpIomanip.H"

// <BEGIN: Define include files>
#include "S_ENTITY.H"
// <END:   Define include files>

// <BEGIN: Constructor>
// <END:   Constructor>

// <BEGIN: Define public virtual methods>
/******************************************************************************
* process: Optimistically process the event                                   *
******************************************************************************/
void E_TEST::process() {
  C_XQUEUE *RemoteObjectProxies
    = ENTITY_OBJECT->GetRemoteObjectProxies();

  RB_assert(RemoteObjectProxies->get_length() == 1)

  F_PROXY_ITEM *RemoteProxyItem
    = (F_PROXY_ITEM *)RemoteObjectProxies->get_top();
  OBJECT_PROXY *RemoteProxy = RemoteProxyItem->GetObjectProxy();
      
  // int test
  const int
    contained_attribute_int = ENTITY_OBJECT->TestInt[1],
    my_proxy_int = ENTITY_OBJECT->GetObjectProxy()->GetInt("TestInt", 1),
    remote_proxy_int = RemoteProxy->GetInt("TestInt", 1);

  RB_assert(contained_attribute_int == my_proxy_int)

  if (ENTITY_MANAGER->IdInMan(SIMOBJ->get_LOCAL_ID()) == 0)
    RB_assert(my_proxy_int == remote_proxy_int)
  else
    RB_assert(my_proxy_int == remote_proxy_int + 1)
    
  //RemoteProxy->UpdateRemoteInt("TestInt", 1,
  //			       RemoteProxy->GetInt("TestInt", 1) + 1);

  RB_assert(remote_proxy_int == RemoteProxy->GetInt("TestInt", 1))

  if (remote_proxy_int == 30)
    RB_cout << "two way proxy int test passed" << endl;

  // string test
  if (remote_proxy_int % 2 == 0)
  {
    //RemoteProxy->UpdateRemoteString("test_string", NULL);

    char *c = RemoteProxy->GetString("test_string");
    RB_assert(c != NULL)
    if (strcmp(c, "130") == 0)
      RB_cout << "two way proxy string test passed" << endl;
    istrstream is(c);
    int remote_proxy_string_converted_int;
    is >> remote_proxy_string_converted_int;
    assert(is.good());
    RB_assert(remote_proxy_string_converted_int - 100 == remote_proxy_int)
  }
  else
  {
    ostrstream os;
    os << remote_proxy_int + 101 << ends;
    //RemoteProxy->UpdateRemoteString("test_string", os.str());

    RB_assert(RemoteProxy->GetString("test_string") == NULL)
  }
    
  ReScheduleEvent(time_tag + 100);
}

/******************************************************************************
* commit: commit the event                                                    *
******************************************************************************/
void E_TEST::commit() {

}
// <END:   Define public virtual methods>

// <BEGIN: Define public methods>
// <END:   Define public methods>

