// O_ENTITY.C source file

#include "O_ENTITY.H"
#include "ScheduleEvent.H"
#include "E_ENTITY_event_TEST.H"
#include "E_SpBroadcastProxy.H"

// <BEGIN: Constructor>
/******************************************************************************
* O_ENTITY constructor                                                        *
******************************************************************************/
O_ENTITY::O_ENTITY() : StartingGloablId(TOTAL_OBJECTS) {
  N_TOT = 2;
  if (N_NODES == 1)
    N_LOC = 2;
  else
  {
    if (NODE < N_TOT)
      N_LOC = 1;
    else
      N_LOC = 0;
  }

  LocalObjects = new S_ENTITY[N_LOC];

  cout << "NODE " << NODE << " Created "
       << N_LOC << " out of " << N_TOT << " ENTITY objects" << endl;

  reserve_n_objects(N_LOC);
  for (int i=0; i<N_LOC; i++) define_object(&LocalObjects[i]);
  TOTAL_OBJECTS += N_TOT;

  set_interact();

}
// <END:   Constructor>


// <BEGIN: Define public virtual methods>
/******************************************************************************
* init_events: Initializes the events for my objects                          *
******************************************************************************/
void O_ENTITY::init_events() {
  for (int i=0; i < N_LOC; i++) {
    ScheduleEvent(0.0, BROADCAST_PROXY, OBJECT_TYPE, i, NODE);
    ScheduleEvent(1 + IdInMan(i), TEST, ENTITY, i, NODE);
  }
}

/******************************************************************************
* terminate: executed at the end of the simulation                            *
******************************************************************************/
void O_ENTITY::terminate(double /*tend*/) {

}
// <END:   Define public virtual methods>

// <BEGIN: Define public methods>
// <END:   Define public methods>

