// E_SpUnPublishGrid.C source file

#include "E_SpUnPublishGrid.H"
#include "S_SpGrid.H"
#include "SpBinaryTree.H"
#include "SpProxyObjHandle.H"
#include "SpScheduleEvent.H"
#include "SpDDMGrid.H"
#include "SpGridLookupOutput.H"
#include "RB_SpDefineClass.H"

RB_DEFINE_CLASS(MAIN_PUBSUB_ITEM);

E_SpUnPublishGrid::E_SpUnPublishGrid()
  : valid(0) {
//  set_lazy();
}

int 
E_SpUnPublishGrid::lazy() { 
  return (0);
}

void 
E_SpUnPublishGrid::process() {
  S_SpGrid *s_grid              = (S_SpGrid *)          SIMOBJ;
  M_SpUnPublishGrid *msg        = (M_SpUnPublishGrid *) get_MESSAGE();
  const NET_INT *lookup_item_id = (NET_INT *)           get_DATA();
  MAIN_PUBSUB_ITEM *publisher;
  int num_remove = 0;

#ifdef DDM_DEBUG
  cout << time_tag << " E_SpUnPublishGrid simobj " << msg->GlobalId 
       << " grid " << s_grid->get_GLOBAL_ID() << endl;
#endif

  for (int i=0; i<msg->NumLookupItem; i++){
    publisher = (MAIN_PUBSUB_ITEM *) 
                 s_grid->GetHiGrid()->RemovePublisher(lookup_item_id[i]);
    if (publisher){
      RB_DELETE_MAIN_PUBSUB_ITEM(publisher);
      num_remove++;
    }
  }

  valid = (num_remove==msg->NumLookupItem);
}

void 
E_SpUnPublishGrid::commit() {
  if (!valid){
    cout << time_tag << " ERROR::E_SpUnPublishGrid event processed invalid";
    abort();
  }
}
