// E_SpValidateDDMPublisher.C source file

#include "E_SpValidateDDMPublisher.H"
#include "SpPublishSpace.H"
#include "RB_SpBinaryTree.H"
#include "SpDDMGrid.H"
#include "SpSubscriberHandle.H"
#include "S_SpHLA.H"

/******************************************************************************
* E_SpValidateDDMPublisher constructor                                       *
******************************************************************************/
E_SpValidateDDMPublisher::E_SpValidateDDMPublisher() {

// set_lazy();

}
 
/******************************************************************************
* process: Optimistically process the event                                   *
******************************************************************************/

void E_SpValidateDDMPublisher::process() {
  S_SpHLA *simobj               = (S_SpHLA *) SIMOBJ;
  M_SpValidateDDMPublisher *msg = (M_SpValidateDDMPublisher *) get_MESSAGE();
  const char *space_name        = (const char *) get_DATA();
  SpPublishSpace *space         = simobj->GetPublishSpace(space_name);
  SpPublishGrid *grid           = space->FindGrid(msg->GridId);
  RB_SpBinaryTree &subscribers  = grid->GetSubscribers();
  SpSubscriberHandle *subscriber;
  int found = 0;

  subscriber = (SpSubscriberHandle *) subscribers.GetFirstElement();
  while (subscriber){
    if (subscriber->GetGlobalId()==msg->SubscriberGlobalId){
      found = 1;
      break;
    }
    subscriber = (SpSubscriberHandle *) subscribers.GetNextElement();
  } 
  if (!found){
    cout << "ERROR:: Unable to find subscriber " << msg->SubscriberGlobalId
         << " in publisher " << simobj->get_NAME()
         << " (" << simobj->get_GLOBAL_ID() << ")" << endl;
    abort();
  }
}

/******************************************************************************
* commit: commit the event                                                    *
******************************************************************************/
void E_SpValidateDDMPublisher::commit() {
}
