// E_SpValidateDDMSubscriber.C source file

#include "E_SpValidateDDMSubscriber.H"
#include "SpSubscribeSpace.H"
#include "RB_SpBinaryTree.H"
#include "S_SpHLA.H"

/******************************************************************************
* E_SpValidateDDMSubscriber constructor                                       *
******************************************************************************/
E_SpValidateDDMSubscriber::E_SpValidateDDMSubscriber() {

// set_lazy();

}
 
/******************************************************************************
* process: Optimistically process the event                                   *
******************************************************************************/

void E_SpValidateDDMSubscriber::process() {
  S_SpHLA *simobj = (S_SpHLA *) SIMOBJ;
  M_SpValidateDDMSubscriber *msg = (M_SpValidateDDMSubscriber *) get_MESSAGE();
  const char *space_name = (const char *) get_DATA();
  SpSubscribeSpace *space = simobj->GetSubscribeSpace(space_name);
  RB_SpBinaryTree &proxies = space->GetSubscribeObjectProxies(); 
  SpSubscribeProxy *sub_proxy;
  int found = 0;

  sub_proxy = (SpSubscribeProxy *) proxies.GetFirstElement();
  while (sub_proxy){
    if (sub_proxy->GetGlobalId()==msg->PublisherGlobalId){
      found = 1;
      break;
    }
    sub_proxy = (SpSubscribeProxy *) proxies.GetNextElement();
  }
  if (!found){
    cout << "ERROR:: Unable to find proxy " << msg->PublisherGlobalId
         << " in subscriber " << simobj->get_NAME() 
         << " (" << simobj->get_GLOBAL_ID() << ")" << endl;
    abort();
  }
}

/******************************************************************************
* commit: commit the event                                                    *
******************************************************************************/
void E_SpValidateDDMSubscriber::commit() {
}
