#ifndef H_SPADDPROXYSPACE_H
#define H_SPADDPROXYSPACE_H

#include "SpEventHandler.H"
#include "SpSimTime.H"

class SpSubscribeSpace;
class F_SpProxyItem;

class SpSubscribeSpaceAddProxy {
  public:
    SpSubscribeSpaceAddProxy(int spaceId, F_SpProxyItem *proxy, int numGrid)
      : SpaceId(spaceId), NumGrid(numGrid), Proxy(proxy), NumGridAdd(0) {}

    int GetSpaceId(void)          const { return (SpaceId); }
    int GetNumGrid(void)          const { return (NumGrid); }
    F_SpProxyItem *GetProxy(void) const { return (Proxy);   }

    void IncrNumGridAdd(void)      { NumGridAdd++;        }
    int  GetNumGridAdd(void) const { return (NumGridAdd); }

  private:
    int SpaceId;
    int NumGrid;
    F_SpProxyItem *Proxy;
    int NumGridAdd;
};

#ifdef NOT_USED
class H_SpAddProxySpace : public SpEventHandler {
  public:

    H_SpAddProxySpace(SpSubscribeSpace *space)
      : Space(space) {}

    void Process(char *eventName, SpSimTime &timeTag,
                 char *data, int dataBytes,
                 int externalId);

  private:
    SpSubscribeSpace *Space;
};
#endif

#endif
