// M_SpAddSubscriberSpace.H header file

#ifndef M_ADD_SUBSCRIBER_SPACE_H
#define M_ADD_SUBSCRIBER_SPACE_H

#include "SpMsg.H"

/******************************************************************************
* M_SpAddSubscriberSpace class definition                                       *
******************************************************************************/
class M_SpAddSubscriberSpace : public SpMsg {

  private:

  protected:

  public:
    M_SpAddSubscriberSpace(void)
      : SpaceId(-1), GridId(-1), GridReply(0), NumSubscribers(0), LookAhead(0.0) {}

    M_SpAddSubscriberSpace(int space_id, int grid_id, int grid_reply, float look_ahead=0.0)
      : SpaceId(space_id), GridId(grid_id), GridReply(grid_reply), NumSubscribers(0),
        LookAhead(look_ahead) {}

    void SetNumSubscribers(int v) { NumSubscribers = v; }
    void SetLookAhead(float v)    { LookAhead = v; }
    int  IsGridReply(void)  const { return (GridReply); }

    NET_INT    SpaceId;
    NET_INT    GridId;
    NET_INT    GridReply;
    NET_INT    NumSubscribers;
    NET_DOUBLE LookAhead;
};

#endif
