// SpPlugInDDM.C

/*
** Define the object managers for DDM
*/

#include "SpExecute.H"
#include "O_SpGrid.H"
#include "S_SpGrid.H"
#include "P_SpPublishSpace.H"
#include "P_SpSubscribeSpace.H"
#include "E_SpPublishGrid.H"
#include "E_SpUnPublishGrid.H"
#include "E_SpSubscribeGrid.H"
#include "E_SpUnSubscribeGrid.H"
#include "E_SpUnSubscribeSpace.H"
#include "E_SpAddSubscriberSpace.H"
//#include "E_SpUnPublishSpace.H"
#include "E_SpUndeliverProxyPtrSpace.H"
#include "E_SpDeliverProxyPtrSpace.H"
#include "SpPlugInDM.H"

#include "E_SpValidateDDMPublisher.H"
#include "E_SpValidateDDMSubscriber.H"


static int SpDDMPluggedIn = 0;

int SpDDMEnabled(){
  return (SpDDMPluggedIn);
}

void PlugInDDM() {

  if (SpDDMEnabled()) return;

    // object manager
  PLUG_IN_OBJECT_MANAGER(Grid);

    // event
  PLUG_IN_EVENT(PublishGrid);
  PLUG_IN_EVENT(UnPublishGrid);

  PLUG_IN_EVENT(SubscribeGrid);
  PLUG_IN_EVENT(UnSubscribeGrid);

  PLUG_IN_EVENT(RemSubscriberSpace);

//PLUG_IN_EVENT(UnPublishSpace);

  PLUG_IN_EVENT(AddSubscriberSpace);

  PLUG_IN_EVENT(DeliverProxyPtrSpace);
  PLUG_IN_EVENT(UndeliverProxyPtrSpace);

  PLUG_IN_EVENT(ValidateDDMPublisher);
  PLUG_IN_EVENT(ValidateDDMSubscriber);

    // process
  PLUG_IN_EVENT(PublishSpace);
  PLUG_IN_EVENT(SubscribeSpace);

  PlugInDM();

  SpDDMPluggedIn = 1;
}
