// SpSubscribeRoutingSpace.C file

#include "SpSubscribeRoutingSpace.H"
#include "S_SpHLA.H"
#include "M_SpSubscribeSpace.H"
#include "SpScheduleEvent.H"
#include "RB_SpBinaryTree.H"
#include "SpPublishRoutingSpace.H"
#include "SpGridLookupOutput.H"
#include "SpSpaceLookupItem.H"
#include "SpDDMGrid.H"
#include "RB_SpDefineClass.H"

RB_DEFINE_CLASS(SpSubscribeRoutingSpace);

#ifdef TODO
EVENT_TYPE(SubscribeSpace);
#else
#include "P_SubscribeSpace.H"
#endif

SpSubscribeRoutingSpace::SpSubscribeRoutingSpace() {}
  
SpSubscribeRoutingSpace::SpSubscribeRoutingSpace(S_SpHLA *hla, const SpSpace *space)
  : SpSubscribeSpace(hla, space) {}

SpSubscribeRoutingSpace::SpSubscribeRoutingSpace(const SpSimTime &time, 
                                                 S_SpHLA *hla, const SpSpace *space)
  : SpSubscribeSpace(hla, space) {
  M_SpSubscribeSpace msg(this);
  ScheduleProcess(time, SubscribeSpace, ObjectType, LocalId, Node, &msg);
}

SpSubscribeRoutingSpace::~SpSubscribeRoutingSpace() {}

void
SpSubscribeRoutingSpace::GetCurrentGrids(const SpSimTime &time, RB_SpBinaryTree &grids){
  SpPublishRoutingSpace::GetCurrentGrids(time, this, (S_SpHLA *) SimObj, *Regions,
                  &SpPublishRoutingSpace::CreateSpaceLookupItem,
                  &SpSubscribeGrid::RBCreate, grids);
}


void RB_Register_SpSubscribeRoutingSpace()
{
  RB_REGISTER_CLASS_SpSubscribeRoutingSpace();
}

