// SpSubscribeRoutingSpace.H header file defines the base class for
// managing DDM routing spaces used for subscribing

#ifndef SUBSCRIBE_ROUTING_SPACE_H
#define SUBSCRIBE_ROUTING_SPACE_H

#include "SpSubscribeSpace.H"
#include "SpSimTime.H"

class S_SpHLA;
class RB_SpBinaryTree;

class SpSubscribeRoutingSpace : public SpSubscribeSpace {
  friend class S_SpHLA;
  friend class SpSubscribeTheaterSpace;
public:
  SpSubscribeRoutingSpace(void);
  ~SpSubscribeRoutingSpace(void);

protected:
  SpSubscribeRoutingSpace(const SpSimTime &time, S_SpHLA *hla, const SpSpace *space);

  void GetCurrentGrids(const SpSimTime &time, RB_SpBinaryTree &grids);

  SpSubscribeRoutingSpace(S_SpHLA *hla, const SpSpace *space);

  double GetUpdateFreqHour(void) { return (-1.0); }
  double GetLookAheadHour(void)  { return ( 0.0); }
};

#endif
