// SpPublishTheaterSpace.H header file defines the base class for
// managing DDM theater spaces used for publishing

#ifndef SpPubTheatSpaceGate
#define SpPubTheatSpaceGate

#include "SpPublishRoutingSpace.H"
#include "RB_Types.H"
#include "SpSimTime.H"

class SpPublishTheaterSpace : public SpPublishRoutingSpace {
  friend class S_SpHLA;
  friend class SpSubscribeTheaterSpace;
public:
  SpPublishTheaterSpace(void);
  ~SpPublishTheaterSpace(void);

protected:
  SpPublishTheaterSpace(const SpSimTime &time, S_SpHLA *hla, const SpSpace *space);

  void GetCurrentGrids(const SpSimTime &time, RB_SpBinaryTree &grids);
  double GetUpdateFreqHour(void);	// cycle time between update

  static void CreateSpaceLookupItem(const SpSimTime &time, SpDDMSpace *space, SpDDMRegion *region, 
                                    SpSpaceLookupItem* &space_lookup);

  double GetLookAheadHour(void);

};

#endif
