// SpSubscribeTheaterSpace.C file

#include "SpPublishTheaterSpace.H"
#include "SpSubscribeTheaterSpace.H"
#include "M_SpSubscribeSpace.H"
#include "SpScheduleEvent.H"
#include "SpPublishRoutingSpace.H"
#include "SpDDMGrid.H"
#include "S_SpHLA.H"
#include "RB_SpDefineClass.H"

RB_DEFINE_CLASS(SpSubscribeTheaterSpace);

#ifdef TODO
EVENT_TYPE (SubscribeSpace);
#else
#include "P_SubscribeSpace.H"
#endif

SpSubscribeTheaterSpace::SpSubscribeTheaterSpace() {}

SpSubscribeTheaterSpace::SpSubscribeTheaterSpace(const SpSimTime &time, S_SpHLA *hla, 
                                                 const SpSpace *space)
  : SpSubscribeRoutingSpace(hla, space) {

  M_SpSubscribeSpace msg(this);
  ScheduleProcess(time, SubscribeSpace, ObjectType, LocalId, Node, &msg);
}

SpSubscribeTheaterSpace::~SpSubscribeTheaterSpace() {}

void
SpSubscribeTheaterSpace::GetCurrentGrids(const SpSimTime &time, RB_SpBinaryTree &grids){
  if (Regions->GetNumElements()<=0)
    SpPublishRoutingSpace::GetCurrentGrids(time, this, (S_SpHLA *) SimObj, (SpDDMRegion *) 0,
                  &SpPublishTheaterSpace::CreateSpaceLookupItem,
                  &SpSubscribeGrid::RBCreate, grids);
  else
    SpPublishRoutingSpace::GetCurrentGrids(time, this, (S_SpHLA *) SimObj, *Regions,
                  &SpPublishTheaterSpace::CreateSpaceLookupItem,
                  &SpSubscribeGrid::RBCreate, grids);
}

double
SpSubscribeTheaterSpace::GetUpdateFreqHour(){
  const double e = 1E-5;
  double expansion_interval_hour;
  S_SpHLA *hla = GetSimObj();

  expansion_interval_hour = (hla->GetMaxSpeedKnots()<e)
                            ? hla->GetMinRescheduleTimeHour()
                            : hla->GetMinExpansionNmi() / hla->GetMaxSpeedKnots();
  if (expansion_interval_hour<hla->GetMinRescheduleTimeHour())
    expansion_interval_hour = hla->GetMinRescheduleTimeHour();

  return (expansion_interval_hour);
}

double
SpSubscribeTheaterSpace::GetLookAheadHour(){
  return (GetSimObj()->GetLookAheadHour());
}

void RB_Register_SpSubscribeTheaterSpace()
{
  RB_REGISTER_CLASS_SpSubscribeTheaterSpace();
}

