// SpSubscribeTheaterSpace.H header file defines the base class for
// managing DDM theater spaces used for publishing

#ifndef SUBSCRIBE_THEATER_SPACE_H
#define SUBSCRIBE_THEATER_SPACE_H

#include "SpSubscribeRoutingSpace.H"

class S_SpHLA;
class RB_SpBinaryTree;

class SpSubscribeTheaterSpace : public SpSubscribeRoutingSpace {
  friend class S_SpHLA;
public:
  SpSubscribeTheaterSpace(void);
  ~SpSubscribeTheaterSpace(void);

protected:
  SpSubscribeTheaterSpace(const SpSimTime &time, 
                          S_SpHLA *hla, const SpSpace *space);
  
  void GetCurrentGrids(const SpSimTime &time, RB_SpBinaryTree &grids);
  double GetUpdateFreqHour(void);       // cycle time between update
  double GetLookAheadHour(void);
};

#endif
