// S_SpGrid.C method file

#include "S_SpGrid.H"
#include "SpIostream.H"
#include "SpFstream.H"
#include "SpStrstream.H"
#include "SpIomanip.H"
#include "O_SpGrid.H"

#define DEBUG_SPACEOBJ

extern O_SpGrid *Grid_OBJECT_MANAGER;

/************************************************************************
* S_SpGrid : construct a S_SpGrid object				*
************************************************************************/
S_SpGrid::S_SpGrid() {

}

/************************************************************************
* terminate : called at the end of the simulation      			*
************************************************************************/
void S_SpGrid::terminate(double /* tend */) {

#ifdef DEBUG_SPACEOBJ
//  if (HiGrid.get_Npubsub()>0){
//    cout << "HiGrid object (local,global) = (" 
//         << ID << ", "<< get_GLOBAL_ID() 
//         << ") terminated at time " << tend << endl;
//    HiGrid.print();
//    cout << endl;
//  }
#endif
  if (Grid_OBJECT_MANAGER->GetTraceHiGrid())
    HiGrid.stats(get_GLOBAL_ID(), GetCriticalPathTime());
}

/************************************************************************
* VerifyRegion : verifies that a region does overlap this HiGrid	*
************************************************************************/
int S_SpGrid::VerifyRegion(MAIN_PUBSUB_ITEM *MainPubSubItem) {
  int i;

  if (MainPubSubItem->GetNdimensions() != HiGrid.get_Ndimensions()) {
    cout << "Error (S_SpGrid): VerifyRegion - Bad Ndimensions" << endl;
    return 0;
  }

  for (i=0; i<HiGrid.get_Ndimensions(); i++) {
    if (HiGrid.get_Hi(i) < MainPubSubItem->GetLo(i)) {
      cout << "Error (S_SpGrid): VerifyRegion - Bad Lo" << endl;
    }
    if (HiGrid.get_Lo(i) > MainPubSubItem->GetHi(i)) {
      cout << "Error (S_SpGrid): VerifyRegion - Bad Hi" << endl;
    }
  }

#ifdef DEBUG_SPACEOBJ
  cout << "VerifyRegion: Ok for Local Object Id " << LOCAL_ID << endl;
#endif

  return 1;

}

