#include "SpDimLookupItem.H"
#include "SpIostream.H"
#include "SpFstream.H"
#include "SpStrstream.H"
#include "SpIomanip.H"
#include "SpAssert.H"
#include "SpString.H"

void 
SpDimLookupItem::CreateMessage(char* &msg, int &len){
  NET_INT dim_type  = get_DimType();
  //const char *name  = get_LookupItemName();
  char *cp;
  int bytes;

  len = sizeof(NET_INT) * 3;
  cp = msg;

  bytes = sizeof(NET_INT); memcpy(cp, &dim_type,   bytes); cp += bytes;
  bytes = sizeof(NET_INT); memcpy(cp, &DontCare_p, bytes); cp += bytes;
}

void 
SpDimLookupItem::CreateObj(const char *msg, int &obj_bytes, SpDimLookupItem* &){
  const char *cp = msg;
  NET_INT dim_type, dont_care_p;
  int bytes;

  obj_bytes = 0;

  bytes = sizeof(NET_INT); memcpy(&dim_type,    cp, bytes); cp += bytes; obj_bytes += bytes;
  bytes = sizeof(NET_INT); memcpy(&dont_care_p, cp, bytes); cp += bytes; obj_bytes += bytes;
}

ostream & operator <<
  (ostream &os, const SpDimLookupItem::DimensionTypes dimType)
{
  switch (dimType)
  {
    case SpDimLookupItem::Double:
      os << "Double";
      break;
    case SpDimLookupItem::Enum:
      os << "Enum";
      break;
    case SpDimLookupItem::LatLng:
      os << "LatLng";
      break;
    case SpDimLookupItem::Altitude:
      os << "Altitude";
      break;
    default:
      abort();
  }
  return  os;
}

ostream & operator<<
  (ostream &os, const SpDimLookupItem *dimensionLookupItem)
{
  os << "   " << setiosflags(ios::left) << setw(21)
     << dimensionLookupItem->get_LookupItemName();
  if (dimensionLookupItem->get_DontCare_p())
    os << "is a Don't Care" << endl;
  else
    dimensionLookupItem->print_work(os);
  return os;
}
