#ifndef __SpDoubleDim__
#define __SpDoubleDim__

#include "SpDim.H"
#include "SpDoubleLookupItem.H"
class HiGridRegion;

// This dimension is for measuring attributes which can be expressed as
// a double precision number.
class SpDoubleDim : public SpDim
{
  public:
    SpDoubleDim(SpDataParser &dataParser);

  protected:
    SpDoubleDim()
      : DimensionLo(0),
	DimensionHi(0)
    {abort();}

  private:
    SpDoubleDim(SpDoubleDim&)
      : DimensionLo(0),
	DimensionHi(0)
    {abort();}

    void InitSpHiGrid(int IdOfGridInDimension,
		     SpDimInfo DimInfo[MAX_DIMENSIONS],
		     int &number_of_dims_initialized) const;

    int HiGrid_Lookup
      (const SpDimLookupItem *dimensionLookupItem,
       SpHiGridRegionVec* &ids_of_grids_in_dimension) const;

    void print_work(ostream &os) const;

    SpDimLookupItem::DimensionTypes get_DimType() const
    { return SpDimLookupItem::Double; }

    int get_NumberOfHiGridDims() const { return 1; }

    SpDimLookupItem *GetDontCareLookupItem() const
	{ return new SpDoubleLookupItem(get_DimName()); }

    int id_of_grid_in_dimension(double low_or_hi) const;
    double GridLo(int id_of_grid_in_dimension) const;
    double GridHi(int id_of_grid_in_dimension) const;
    int ValidIdOfGridInDimension(int id_of_grid_in_dimension) const;

    const double
      DimensionLo,
      DimensionHi;
    
    int Nresolutions;
    double *Resolution;
};

typedef SpDoubleDim DoubleDimension;

#endif
