#include "SpDoubleLookupItem.H"
#include "SpPubSubItem.H"
#include "SpIostream.H"
#include "SpFstream.H"
#include "SpStrstream.H"
#include "SpIomanip.H"

void SpDoubleLookupItem::print_work(ostream &os) const
{
  os << setprecision(8) << resetiosflags(ios::left)
     << "Lo = " << setw(9) << Lo
     << ", Hi = " << setw(9) << Hi
     << ", Resolution = " << setw(9) << Res
     << '\n';
}

double SpDoubleLookupItem::get_Lo() const
{
  assert(!get_DontCare_p());
  return Lo;
}

double SpDoubleLookupItem::get_Hi() const
{
  assert(!get_DontCare_p());
  return Hi;
}

double SpDoubleLookupItem::get_Res() const
{
  assert(!get_DontCare_p());
  return Res;
}

void SpDoubleLookupItem::set_Lo(double lo)
{
  set_DontCare_p(0);
  Lo = lo;
}

void SpDoubleLookupItem::set_Hi(double hi)
{
  set_DontCare_p(0);
  Hi = hi;
}

void SpDoubleLookupItem::set_Res(double res)
{
  set_DontCare_p(0);
  Res = res;
}
