#ifndef __SpDoubleLookupItem__
#define __SpDoubleLookupItem__

#include "SpDimLookupItem.H"
#include "SpAssert.H"

class SpDoubleLookupItem : public SpDimLookupItem
{
  public:
    SpDoubleLookupItem(const char * const lookupItemName,
		     double lo, double hi, double res)
      : SpDimLookupItem(lookupItemName, 0),
	Lo(lo), Hi(hi), Res(res) { assert(Lo <= Hi); }
    
    SpDoubleLookupItem(const char * const lookupItemName)
      : SpDimLookupItem(lookupItemName, 1) {}
    
    double get_Lo() const;
    double get_Hi() const;
    double get_Res() const;

    void set_Lo(double lo);
    void set_Hi(double hi);
    void set_Res(double res);

  private:
    SpDoubleLookupItem(SpDoubleLookupItem&) {abort();}

    SpDoubleLookupItem() {abort();}

    double Lo, Hi, Res;

    DimensionTypes get_DimType() const { return Double; }

    void print_work(ostream &os) const;
};

typedef SpDoubleLookupItem DoubleLookupItem;

#endif
