#ifndef __SpEnumDim__
#define __SpEnumDim__

#include "SpDim.H"
#include "SpEnumLookupItem.H"

class SpEnumDim : public Dimension
{
  public:
    SpEnumDim(SpDataParser &DataParser);
    SpEnumDim(const char *name, int distribute,
                  int n, const char ** &value);

  private:
    SpEnumDim() : NEnums(0) {abort();}
    
    SpEnumDim(SpEnumDim&) : NEnums(0) {abort();}

    void InitSpHiGrid(int IdOfGridInDimension,
		     SpDimInfo DimInfo[MAX_DIMENSIONS],
		     int &number_of_dims_initialized) const;

    int HiGrid_Lookup
      (const SpDimLookupItem *dimensionLookupItem,
       SpHiGridRegionVec* &ids_of_grids_in_dimension) const;

    SpDimLookupItem *GetDontCareLookupItem() const
	{ return new SpEnumLookupItem(get_DimName(), Enums, NEnums); }

    void print_work(ostream &os) const;

    SpDimLookupItem::DimensionTypes get_DimType() const
    { return SpDimLookupItem::Enum; }

    int get_NumberOfHiGridDims() const { return 1; }

    const char **Enums;
    const int NEnums;
};

typedef SpEnumDim EnumDimension;

#endif
