// SpGreatCircle.H Header File

#ifndef CircularOrbit_object
#define CircularOrbit_object

#include "SpMath.H"
#include "SpDynItem.H"
#include "SpNetTypes.H"

class CIRCULAR_ORBIT : public DYNAMIC_POSITION_ITEM {

  private:

    NET_DOUBLE Ux[3];
    NET_DOUBLE Uy[3];
    NET_DOUBLE Uz[3];
    NET_DOUBLE Omega;
    NET_DOUBLE Amplitude;
    NET_DOUBLE Phase;
    NET_DOUBLE T0;

  protected:

  public:

    CIRCULAR_ORBIT() {PositionType = ECI;}
    int CheckUnitVectors();

    void init(double I, double A, double Altitude, double P, double Time); 

    virtual void operator () (double t, int PT, double X[3]);
    virtual void operator () (double, int, double [3], double [3]);
    virtual void operator () (double, int, double [3], double [3], double [3]);

    virtual char *GetType() {return "Circular Orbit Type";}

};

#endif
