#ifndef ConstMotion_Objects
#define ConstMotion_Objects

#include "SpStdarg.H"
#include "SpMath.H"
#include "SpNetTypes.H"

#include "SpDynItem.H"

class CONSTANT_MOTION : public DYNAMIC_POSITION_ITEM {
  private:
  protected:
    NET_DOUBLE Pos[3];
  public:

    CONSTANT_MOTION() {
      Pos[0] = 0.0;
      Pos[1] = 0.0;
      Pos[2] = 0.0;
    }

    void SetPosition(double x0, double x1, double x2) {
      Pos[0] = x0;
      Pos[1] = x1;
      Pos[2] = x2;
    }

    void SetPosition(double x[3]) {
      Pos[0] = x[0];
      Pos[1] = x[1];
      Pos[2] = x[2];
    }

    virtual void operator () (double t, int PT, double X[3]) {
      X[0] = Pos[0];
      X[1] = Pos[1];
      X[2] = Pos[2];

      Convert(X, PositionType, X, PT, t);
    }

    virtual void operator () (double t, int PT, double X[3], double V[3]) {
      X[0] = Pos[0];
      X[1] = Pos[1];
      X[2] = Pos[2];

      V[0] = 0.0;
      V[1] = 0.0;
      V[2] = 0.0;

      Convert(X, V, PositionType, X, V, PT, t);
    }

    virtual void operator () (double t, int PT, double X[3], double V[3],
			      double A[3]) {
      X[0] = Pos[0];
      X[1] = Pos[1];
      X[2] = Pos[2];

      V[0] = 0.0;
      V[1] = 0.0;
      V[2] = 0.0;

      A[0] = 0.0;
      A[1] = 0.0;
      A[2] = 0.0;

      Convert(X, V, A, PositionType, X, V, A, PT, t);
    }

    virtual char *GetType() {return "Constant Motion Type";}

};

#endif
