// SpGreatCircle.H Header File

#ifndef GreatCircle_object
#define GreatCircle_object

#include "SpMath.H"
#include "SpDynItem.H"
#include "SpNetTypes.H"

class GREAT_CIRCLE : public DYNAMIC_POSITION_ITEM {

  private:

    NET_DOUBLE U0[3];
    NET_DOUBLE U1[3];
    NET_DOUBLE Vpar;
    NET_DOUBLE Vperp;
    NET_DOUBLE DeltaAltitude;
    NET_DOUBLE Alt0;
    NET_DOUBLE Theta;

  protected:

  public:

    GREAT_CIRCLE() {PositionType = ECR;}

    double init_Vconstant(     
	    double LatInit, double LonInit, double AltInit, double TimeInit,
	    double LatFin, double LonFin, double AltFin,
	    double V);

    double init_Tconstant(     
	    double LatInit, double LonInit, double AltInit, double TimeInit,
	    double LatFin,  double LonFin,  double AltFin,  double TimeFin);

    virtual void operator () (double t, int PT, double X[3]);
    virtual void operator () (double, int, double [3], double [3]);
    virtual void operator () (double, int, double [3], double [3], double [3]);

    virtual char *GetType() {return "Great Circle Motion Type";}

};

#endif
