// SpRhumbLine.H Header File

#ifndef RhumbLine_object
#define RhumbLine_object

#include "SpMath.H"
#include "SpDynItem.H"
#include "SpGreatCircle.H"
#include "SpNetTypes.H"

/* This motion type is almost entirely based on code from NSS
 * and so does not, currently, do the "right thing" with
 * regards to altitude.
 */

class RHUMB_LINE : public DYNAMIC_POSITION_ITEM {

  private:

    NET_DOUBLE E0[3];
    NET_DOUBLE U1[3];
    NET_DOUBLE Speed;
    NET_DOUBLE Vpar;
    NET_DOUBLE Vperp;
    NET_DOUBLE Vground;
    NET_DOUBLE DeltaAltitude;

    NET_DOUBLE Bearing;

    GREAT_CIRCLE *G_C_Equiv;

  protected:

  public:

    RHUMB_LINE() {PositionType = ECR; G_C_Equiv = NULL;}
    ~RHUMB_LINE() {if (G_C_Equiv) delete G_C_Equiv;}

    double init_Vconstant(     
	    double LatInit, double LonInit, double AltInit, double TimeInit,
	    double LatFin, double LonFin, double AltFin,
	    double V);

    double init_Tconstant(     
	    double LatInit, double LonInit, double AltInit, double TimeInit,
	    double LatFin,  double LonFin,  double AltFin,  double TimeFin);

    virtual void operator () (double t, int PT, double X[3]);
    virtual void operator () (double, int, double [3], double [3]);
    virtual void operator () (double, int, double [3], double [3], double [3]);

    virtual char *GetType() {return "Rhumb Line Motion Type";}

};

#endif
