// E_SpAddProxy.C

#include "queue.H"

#include "E_SpAddProxy.H"
#include "M_SpDeliverProxyPtr.H"
#include "SpScheduleEvent.H"
#include "S_SpLocalProxyMgr.H"

#include "F_SpProxyListItem.H"
#include "F_SpSimObjRef.H"

#include "RB_SpContainerFuncs.H"

#include "SpFreeHLA.H"
extern SpFreeHLA *FreeHLA;

#ifdef TODO
EVENT_TYPE (DELIVER_PROXY_PTR);
#else
#include "E_SpDeliverProxyPtr.H"
#endif

/************************************************************************
* E_SpAddProxy : constructor for the ADD_PROXY event	*
************************************************************************/
E_SpAddProxy::E_SpAddProxy() {
  set_lazy();
}

/************************************************************************
* process : optimistically process event				*
************************************************************************/
void E_SpAddProxy::process() {
#ifdef NOT_USED
  int i;
  C_XQUEUE *local_subscriber_list;
  F_SpProxyListItem *proxy_list_item;
  F_SpSimObjRef *new_obj_ref;
  M_SpDeliverProxyPtr *deliver_proxy_ptr_msg;
  S_SpLocalProxyMgr *local_proxy_man  = (S_SpLocalProxyMgr *)           SIMOBJ;
  M_SpAddProxy *msg    = (M_SpAddProxy *) get_MESSAGE();
  ADD_PROXY_DESTINATION *destination = (ADD_PROXY_DESTINATION *)      get_DATA();

  if (msg->NumDestination<=0){
    RB_cout << "*** ERROR E_SpAddProxy::process() NumDestination<=0 - value : " 
            << msg->NumDestination << endl;
    return;
  }

  for (i=0; i<msg->NumDestination; i++){
    proxy_list_item = (F_SpProxyListItem *) 
                      local_proxy_man->GetProxyList()->find(destination[i].ProxyGlobalId); 

    if (!proxy_list_item){
      RB_cout << "WARNING:: COULD NOT FIND PROXY DURING ADD_PROXY : " 
              << destination[i].ProxyGlobalId << " to " << destination[i].GlobalId 
              << " node " << local_proxy_man->get_NODE()
              << " proxy list len (" << local_proxy_man->GetProxyList()->get_length() << ")" 
              << " @ " << msg->time_tag << endl;
      continue; 
    }

    new_obj_ref = (F_SpSimObjRef *) RB_FREE_NEW(FreeHLA, SIMOBJ_REF);
    new_obj_ref->SetNode(destination[i].Node);
    new_obj_ref->SetType(destination[i].ObjectType);
    new_obj_ref->SetLocalID(destination[i].LocalId);
    new_obj_ref->SetGlobalID(destination[i].GlobalId);

    local_subscriber_list = proxy_list_item->GetProxyList();

    RB_INSERT(local_subscriber_list, new_obj_ref);

    // deliver to HLA
    deliver_proxy_ptr_msg = (M_SpDeliverProxyPtr *) 
                            schedule(time_tag,
                                     DELIVER_PROXY_PTR,
                                     destination[i].ObjectType,
                                     destination[i].LocalId,
                                     destination[i].Node);
    deliver_proxy_ptr_msg->ObjectProxy = proxy_list_item->GetObjectProxy();
    deliver_proxy_ptr_msg->SpaceId     = msg->SpaceId;
    deliver_proxy_ptr_msg->GridId      = msg->GridId;
  }

  cout << time_tag << " E_SpAddProxy process - node "
       << local_proxy_man->get_NODE() << endl;
#endif
}

int E_SpAddProxy::lazy() {
  S_SpLocalProxyMgr *local_proxy_man = (S_SpLocalProxyMgr *) SIMOBJ;
  cout << time_tag << " E_SpAddProxy lazy - node "
       << local_proxy_man->get_NODE() << endl;
  return (0);

}
