// E_SpDecMgrUnpublish.C source file

#include "E_SpDecMgrUnpublish.H"

#include "S_SpDecMgr.H"
#include "M_SpDecMgrUnpublish.H"
#include "SpScheduleEvent.H"
#include "M_SpHlaUnpublish.H"

#ifdef TODO
EVENT_TYPE (UNPUBLISH_HLA);
#else
#include "E_SpHlaUnpublish.H"
#endif

/******************************************************************************
* E_SpDecMgrUnpublish constructor                                              *
******************************************************************************/
E_SpDecMgrUnpublish::E_SpDecMgrUnpublish() {

// set_lazy();

}

/******************************************************************************
* process: Optimistically process the event                                   *
******************************************************************************/

void E_SpDecMgrUnpublish::process() {
  int status;
  S_SpDecMgr *s_dec_man     = (S_SpDecMgr *)           SIMOBJ;
  M_SpDecMgrUnpublish *msg = (M_SpDecMgrUnpublish *) get_MESSAGE();

  status = s_dec_man->RemovePublisher(msg->Node, msg->ObjectType, msg->LocalId, msg->GlobalId);

#ifdef DEBUG
  RB_cout << s_dec_man->get_GLOBAL_ID() 
          << ") E_SpDecMgrUnpublish Removing publisher : " << msg->GlobalId;
  RB_cout << " at time (" << get_MESSAGE()->time_tag.GetTime()
          << ", " << get_MESSAGE()->time_tag.GetPriority1()
          << ", " << get_MESSAGE()->time_tag.GetPriority2() << ") status = " << status << endl;
#endif

  M_SpHlaUnpublish unpublish_msg(status);
  ScheduleEvent(get_MESSAGE()->time_tag, UNPUBLISH_HLA, 
                msg->ObjectType, msg->LocalId, msg->Node, unpublish_msg);
}

/******************************************************************************
* commit: commit the event                                                    *
******************************************************************************/
void E_SpDecMgrUnpublish::commit() {

}
