// E_SpNewProxy.H header file

#ifndef E_SP_NEW_PROXY_H
#define E_SP_NEW_PROXY_H

#include "SpEvent.H"
#include "M_SpNewProxy.H"
#include "SpExecute.H"

class SpProxyDestination;
class SpObjProxyMsg;

/************************************************************************
* New Proxy event object		 	       			*
************************************************************************/
class E_SpNewProxy : public SpEvent {
  public:

    E_SpNewProxy();
    virtual void process();
    int lazy();
    void commit();

  private:
    int valid, errcode;

    void ProcessNew(int space_id, float look_ahead,
                    int num_new_dest, SpProxyDestination *new_dest,
                    int num_dup_dest, SpProxyDestination *dup_dest, int *dup_dest_sent,
                    SpObjProxyMsg *proxy_msg);
    void ProcessAdd(int proxy_global_id, int space_id, float look_ahead,
                    int num_add_dest, SpProxyDestination *add_dest,
                    int num_dup_dest, SpProxyDestination *dup_dest, int *dup_dest_sent);
    void ProcessDup(int proxy_global_id, int space_id, float look_ahead,
                    int num_dest, SpProxyDestination *dest, int *dest_sent);
};

DEFINE_EVENT(NEW_PROXY_LOCAL_PROXYMAN, E_SpNewProxy, M_SpNewProxy, 10);

#endif
