// E_TouchProxy.C method file

#include "E_SpTouchProxy.H"
#include "S_SpHLA.H"

#include "F_SpProxyItem.H"

/************************************************************************
* TOUCH_PROXY : Construct a TOUCH_PROXY event object   			*
************************************************************************/
E_SpTouchProxy::E_SpTouchProxy() {
}

/************************************************************************
* process : optimistically process event				*
************************************************************************/
void E_SpTouchProxy::process() {
  int i;
  int len;
  F_SpProxyItem *ProxyItem;
  int GlobalId;
  C_XQUEUE *RemoteObjectProxies;

  S_SpHLA *HLAobj = (S_SpHLA *)SIMOBJ;
  M_SpTouchProxy *TouchProxyMessage = (M_SpTouchProxy *)MESSAGE;

  GlobalId = TouchProxyMessage->globalId;

  if (HLAobj->get_GLOBAL_ID()==GlobalId)
    return;

  RemoteObjectProxies = HLAobj->GetRemoteObjectProxies();

  ProxyItem = (F_SpProxyItem *)RemoteObjectProxies->get_top();
  len = RemoteObjectProxies->get_length();

  int found = 0;
  for (i=0; i<len; i++) {
    if (ProxyItem->GetGlobalId() == GlobalId) {
      ProxyItem->SetObjectProxy(TouchProxyMessage->ObjectProxy);
      found = 1;
      break;
    }
    ProxyItem = (F_SpProxyItem *)ProxyItem->get_link();
  }

  if (!found) {
    RB_cout << "Error (TouchProxy): "
            << HLAobj->get_NAME() << " (" << HLAobj->get_GLOBAL_ID() << ")"
            << " Could not find Object Proxy " << GlobalId << endl;
  }

  SIMOBJ->ProcessEventHandlers("Reflect Attributes",
			       TIME_TAG,
			       (char *)ProxyItem,
			       sizeof(F_SpProxyItem),
			       -1);

}
