// E_SpUnDeliverProxyPtrSpace.C 

#include "E_SpUndeliverProxyPtrSpace.H"
#include "S_SpHLA.H"
#include "SpSubscribeSpace.H"
#include "H_SpRemoveProxySpace.H"

#include "SpFreeHLA.H"
extern SpFreeHLA *FreeHLA;


/************************************************************************
* E_SpUndeliverProxyPtrSpace : constructor for the UnDeliverProxyPointer 	*
************************************************************************/
E_SpUndeliverProxyPtrSpace::E_SpUndeliverProxyPtrSpace()
  : valid(0) {
//  set_lazy();
}

/************************************************************************
* process : optimistically process event				*
************************************************************************/
int E_SpUndeliverProxyPtrSpace::lazy() {
  return (0);
}

void E_SpUndeliverProxyPtrSpace::process() {
  M_SpUndeliverProxyPtrSpace *msg = (M_SpUndeliverProxyPtrSpace *) get_MESSAGE();
  char *data                      = (char *) get_DATA();
  int buffer_len, len;
  char *buffer, *cp;

  valid = 1;

  SpSubscribeSpaceRemoveProxy remove_proxy(msg->SpaceId, msg->ProxyGlobalId, msg->NumGrid);
  buffer_len = sizeof(SpSubscribeSpaceRemoveProxy) + (msg->NumGrid * sizeof(int));
  cp = buffer = new char [buffer_len];

  len = sizeof(SpSubscribeSpaceRemoveProxy); memcpy(cp, &remove_proxy, len); cp += len;
  len = msg->NumGrid * sizeof(int);          memcpy(cp, data, len);
  SIMOBJ->ProcessEventHandlers("SubscribeSpace Remove Proxy Ptr",
                               TIME_TAG,
                               (char *) buffer, buffer_len, -1);
  SpSubscribeSpaceRemoveProxy *removed_proxy = (SpSubscribeSpaceRemoveProxy *) buffer;
  valid &= (removed_proxy->GetNumGridRemove()==msg->NumGrid);

#ifdef DDM_DEBUG
  if (valid){
    cout << time_tag << " E_SpUndeliverProxyPtrSpace event processed "
         << " simobj " << SIMOBJ->get_GLOBAL_ID() 
         << " proxy "  << msg->ProxyGlobalId
         << " grids : ";
    int *grid_id = (int *) get_DATA();
    for (int i=0; i<msg->NumGrid; i++)
      cout << grid_id[i] << ", ";
    cout << endl;
  }
#endif

  delete [] buffer;
}

void
E_SpUndeliverProxyPtrSpace::commit(){
  M_SpUndeliverProxyPtrSpace *msg = (M_SpUndeliverProxyPtrSpace *) get_MESSAGE();
  int *grid_id = (int *) get_DATA();
  if (!valid){
    cout << time_tag << " ERROR::E_SpUndeliverProxyPtrSpace event processed invalid "
         << " simobj " << SIMOBJ->get_GLOBAL_ID() 
         << " proxy "  << msg->ProxyGlobalId
         << " grids : ";
    for (int i=0; i<msg->NumGrid; i++)
      cout << grid_id[i] << ", ";
    cout << endl;
    abort();
  }
}
