// M_SpAddProxy.H message file

#ifndef M_LOCAL_PROXYMAN_EVENT_ADD_PROXY_H
#define M_LOCAL_PROXYMAN_EVENT_ADD_PROXY_H

#include "SpMsg.H"
#include "SpSubscriberHandle.H"
#include "SpNetTypes.H"

/************************************************************************
*	Deliver Proxy message 						*
************************************************************************/

class ADD_PROXY_DESTINATION {
public:
    ADD_PROXY_DESTINATION(void)
      : ProxyGlobalId(-1), Node(-1), ObjectType(-1), LocalId(-1), GlobalId(-1) {}

    ADD_PROXY_DESTINATION(int proxy_global_id, const SpProxyObjHandle &d)
      : ProxyGlobalId(proxy_global_id), 
        Node(d.GetNode()), ObjectType(d.GetObjType()), 
        LocalId(d.GetLocalId()), GlobalId(d.GetGlobalId()) {}

    NET_INT ProxyGlobalId;
    NET_INT Node, ObjectType, LocalId, GlobalId;
};

class M_SpAddProxy : public SpMsg {

  public:
    M_SpAddProxy(void)
      : SpaceId(-1), GridId(-1), NumDestination(0) {}

    M_SpAddProxy(int space_id, int grid_id, int num_destination)
      : SpaceId(space_id), GridId(grid_id), NumDestination(num_destination) {}

    NET_INT SpaceId, GridId, NumDestination;
};

typedef M_SpAddProxy M_ADD_PROXY_LOCAL_PROXYMAN;

#endif
