// M_SpDeliverProxyPtr.H message file

#ifndef M_DelProxPtr_mess
#define M_DelProxPtr_mess

#include "SpMsg.H"

#include "SpObjProxy.H"

/************************************************************************
*	Deliver Proxy Pointer message 	       				*
************************************************************************/
class M_SpDeliverProxyPtr : public SpMsg {

  public:

    M_SpDeliverProxyPtr(void)
      : ObjectProxy((SpObjProxy *) 0), SpaceId(-1), NumGrid(0) {}

    M_SpDeliverProxyPtr(SpObjProxy *proxy, int space_id, int num_grid)
      : ObjectProxy(proxy), SpaceId(space_id), NumGrid(num_grid) {}

    // Normally pointers should not be in messages since the message
    // might be sent to another node which may even be on a different
    // machine which uses different memory chips than the machine
    // sending the message which means the address is meaningless
    // since it refers to the memory on the sender's machine.  But in
    // this case, we know that this message is definitely going to an
    // object on this node.
    SpObjProxy *ObjectProxy;
    int SpaceId, NumGrid;
};

typedef M_SpDeliverProxyPtr M_DELIVER_PROXY_PTR;

#endif
