// M_SpNewProxy.H message file

#ifndef M_LOCAL_PROXYMAN_EVENT_NEW_PROXY_H
#define M_LOCAL_PROXYMAN_EVENT_NEW_PROXY_H

#include "SpMsg.H"
#include "SpSubscriberHandle.H"
#include "SpNetTypes.H"

/************************************************************************
*	Deliver Proxy message 						*
************************************************************************/
class SpProxyDestination {
public:
    SpProxyDestination(void)
      : Node(-1), ObjectType(-1), LocalId(-1), GlobalId(-1), GridId(-1) {}

    SpProxyDestination(int grid_id, const SpProxyObjHandle &d)
      : Node(d.GetNode()), ObjectType(d.GetObjType()), 
        LocalId(d.GetLocalId()), GlobalId(d.GetGlobalId()), GridId(grid_id) {}

    NET_INT Node, ObjectType, LocalId, GlobalId, GridId;
};

class M_SpNewProxy : public SpMsg {

  public:
    M_SpNewProxy(void)
      : ProxyGlobalId(-1), SpaceId(-1), 
        NumNewDest(0), NumAddDest(0), NumDupDest(0), LookAhead(0.0) {}
   
    M_SpNewProxy(int proxy_global_id, int space_id, 
                 int num_new_dest, int num_add_dest, int num_dup_dest)
      : ProxyGlobalId(proxy_global_id), SpaceId(space_id), 
        NumNewDest(num_new_dest), NumAddDest(num_add_dest), NumDupDest(num_dup_dest),
        LookAhead(0.0) {}

  void SetLookAhead(float v) { LookAhead = v; }

  NET_INT ProxyGlobalId, SpaceId;
  NET_INT NumNewDest, NumAddDest, NumDupDest;
  NET_DOUBLE LookAhead;
};

typedef M_SpNewProxy M_NEW_PROXY_LOCAL_PROXYMAN;

#endif
