// M_SpRemoveProxy.H message file

#ifndef M_LOCAL_PROXYMAN_EVENT_REMOVE_PROXY_H
#define M_LOCAL_PROXYMAN_EVENT_REMOVE_PROXY_H

#include "SpMsg.H"

/************************************************************************
*	Deliver Proxy message 						*
************************************************************************/

class M_SpRemoveProxy : public SpMsg {

  public:
    M_SpRemoveProxy(void)
      : ProxyGlobalId(-1), SpaceId(-1), 
        NumRemoveDest(0), NumUndeliverDest(0), LookAhead(0.0) {}

    M_SpRemoveProxy(int proxy_global_id, int space_id, 
                    int num_remove_dest, int num_undeliver_dest)
      : ProxyGlobalId(proxy_global_id), SpaceId(space_id),
        NumRemoveDest(num_remove_dest), NumUndeliverDest(num_undeliver_dest),
        LookAhead(0.0) {}

    void SetLookAhead(float v) { LookAhead = v; }

    NET_INT ProxyGlobalId, SpaceId;
    NET_INT NumRemoveDest, NumUndeliverDest;
    NET_DOUBLE LookAhead;
};

typedef M_SpRemoveProxy M_REMOVE_PROXY_LOCAL_PROXYMAN;

#endif
