// E_SpAddSubscriber.C source file

#include "S_SpHLA.H"
#include "S_SpDecMgr.H"
#include "E_SpAddSubscriber.H"
#include "SpProxyObjHandle.H"


/******************************************************************************
* E_SpAddSubscriber constructor                                            *
******************************************************************************/
E_SpAddSubscriber::E_SpAddSubscriber() {
//set_lazy();
}

/******************************************************************************
* process: Optimistically process the event                                   *
******************************************************************************/
void E_SpAddSubscriber::process() {
  S_SpHLA *obj           = (S_SpHLA *)                SIMOBJ;
  const char *data       = (const char *)           get_DATA();
  M_SpAddSubscriber *msg = (M_SpAddSubscriber *) get_MESSAGE(); 

  if (msg->GetNumSubscriber()<=0) return;

  int nbytes;
  SpBinaryTree subscribers;
  SpProxyObjHandle *s;

  SpProxyObjHandle::CreateObj(data, msg->GetNumSubscriber(), nbytes, subscribers);
  obj->AddSubscriber(subscribers);

  while ((s=(SpProxyObjHandle *) subscribers.RemoveFirstElement()))
    SpProxyObjHandle::Destroy(s);
}

/******************************************************************************
* commit: commit the event                                                    *
******************************************************************************/
void E_SpAddSubscriber::commit() {
}

int E_SpAddSubscriber::lazy() {
  RB_cout << time_tag << " E_SpAddSubscriber lazy" << endl;
  return (0);
}
