// E_SpHlaUpdateProxyDistList.C source file

#include "E_SpHlaUpdateProxyDistList.H"
#include "SpDistList.H"
#include "S_SpHLA.H"
#include "RB_SpBinaryTree.H"

E_SpHlaUpdateProxyDistList::E_SpHlaUpdateProxyDistList() {
}

void 
E_SpHlaUpdateProxyDistList::process() {
  S_SpHLA *simobj = (S_SpHLA *) SIMOBJ;
  SpDistList *dirty_list;
  SpBinaryTree add_subscribers, remove_subscribers;
  SpBinaryTree new_subscriber_holder, add_subscriber_holder;
  SpBinaryTree remove_subscriber_holder;
  SpBinaryTree remove_lists, *remove_items;
  SpProxyObjHandle *handle;
  int list_id;

  dirty_list = (SpDistList *) simobj->ProxyDistList->GetFirstElement();
  while (dirty_list){
    list_id = dirty_list->GetId();

    dirty_list->GetChanges(add_subscribers, remove_subscribers);

    simobj->AddSubscriber(list_id, add_subscribers,
                          &new_subscriber_holder, &add_subscriber_holder);

    while (add_subscribers.RemoveFirstElement());

    remove_items = new SpBinaryTree;
    remove_lists.Insert(remove_items, list_id); 
    while ((handle = (SpProxyObjHandle *) remove_subscribers.RemoveFirstElement()))
      remove_items->Insert(handle, handle->GetGlobalId());

    dirty_list = (SpDistList *) simobj->ProxyDistList->GetNextElement();
  }

  remove_items = (SpBinaryTree *) remove_lists.GetFirstElement();
  while (remove_items){
    list_id = int(remove_lists.GetCurrentKey());
    simobj->RemoveSubscriber(list_id, *remove_items, &remove_subscriber_holder);
    remove_items = (SpBinaryTree *) remove_lists.GetNextElement();
  }

  simobj->AddProxy(time_tag, &new_subscriber_holder, &add_subscriber_holder);
  simobj->RemoveProxy(time_tag, &remove_subscriber_holder);

  while ((remove_items = (SpBinaryTree *) remove_lists.RemoveFirstElement()))
    delete remove_items;

  dirty_list = (SpDistList *) simobj->ProxyDistList->GetFirstElement();
  while (dirty_list){
    dirty_list->UnDirty();
    dirty_list = (SpDistList *) simobj->ProxyDistList->GetNextElement();
  }

  S_SpHLA::ClearSubscriberHolder(new_subscriber_holder);
  S_SpHLA::ClearSubscriberHolder(add_subscriber_holder);

  simobj->UnDirtyProxyDistList();
}

void 
E_SpHlaUpdateProxyDistList::commit() {
}
