// C_SpRadar.C  source file for the Radar Component that works 
// with precomputations

#include "C_SpRadar.H"

 
/*
** Three Event Handlers attached to the Radar Component:
*/
/******************************************************************************
* BEGIN_PRECOMP event handler - enacted by a DeliverProxyPtr event
******************************************************************************/
//  Constructor 
H_RADAR_BEGIN_PRECOMP::H_RADAR_BEGIN_PRECOMP() {
;
}

// Process
void H_RADAR_BEGIN_PRECOMP::Process(
                       char *, SpSimTime &,
                       char *, int,
                       int) {
;
}

/******************************************************************************
* END_PRECOMP event handler - enacted by a RemoveProxyPtr event
******************************************************************************/
//  Constructor 
H_RADAR_END_PRECOMP::H_RADAR_END_PRECOMP() {
;
}

// Process
void H_RADAR_END_PRECOMP::Process(
                       char *, SpSimTime &,
                       char *, int,
                       int) {
;
}
/******************************************************************************
* REFLECT_ATTRIBUTES event handler - enacted by a TouchProxy event
******************************************************************************/
// Constructor 
H_RADAR_REFLECT_ATTRIBUTES::H_RADAR_REFLECT_ATTRIBUTES() {
;
}

//  Process
void H_RADAR_REFLECT_ATTRIBUTES::Process(
                       char *, SpSimTime &,
                       char *, int,
                       int) {
;
}

/******************************************************************************
* UPDATE_ATTRIBUTES event handler - enacted by a ScheduleUpdate event
******************************************************************************/
// Constructor 
H_RADAR_UPDATE_ATTRIBUTES::H_RADAR_UPDATE_ATTRIBUTES() {
;
}

// Process
void H_RADAR_UPDATE_ATTRIBUTES::Process(
                       char *, SpSimTime &,
                       char *, int,
                       int) {
;
}


/*
** Radar Component Class declaration 
*/
/******************************************************************************
* constructor - attaches the event handlers
******************************************************************************/
// Constructor 
C_SpRadar::C_SpRadar() {

  MaxRange = 1.0e20; 
  PowerConstant = 0;

  AddEventHandler("DeliverProxyPtr", &BeginPrecomp);
  AddEventHandler("TouchProxy", &EndPrecomp);
  AddEventHandler("ScheduleUpdate", &ReflectAttributes);
  AddEventHandler("RemoveProxyPtr", &UpdateAttributes);

}





