// F_SpProxyItem.H header file

#ifndef F_ProxyItem_Object
#define F_ProxyItem_Object

#include "SpObjProxy.H"
#include "sq_item.H"

/************************************************************************
 * This object stores a pointer to an object proxy      	.   	*
 ************************************************************************/
class F_SpProxyItem : public C_SQ_ITEM {

  private:

  protected:

    STATE_POINTER ObjectProxy;

  public:

    void SetGlobalId(int i) {id = i;}

    int GetGlobalId(void) { return id; }
    int GetLocalId(void)  { return GetObjectProxy()->GetLocalId(); }
    int GetObjType(void)  { return GetObjectProxy()->GetObjectType(); }
    int GetNode(void)     { return GetObjectProxy()->GetNode(); }

    void SetObjectProxy(SpObjProxy *o) {
      ObjectProxy = o;
      SetGlobalId(o->GetGlobalId());
    }

    SpObjProxy *GetObjectProxy() {
      void *v = ObjectProxy;
      return (SpObjProxy *)v;
    }

    virtual char *GetName() {return (GetObjectProxy())->GetObjectName();}

};

typedef F_SpProxyItem F_PROXY_ITEM;

#endif
