// F_SpSimObjRef.H header file that references a SPEEDES object

#ifndef F_SimObjRef_Object
#define F_SimObjRef_Object

#include "sq_item.H"

/************************************************************************
 * F_SpSimObjRef - This object contains a reference to a SPEEDES sim	*
 * object (node, type, local id). The Global ID is also included.   	*
 ************************************************************************/
class F_SpSimObjRef : public C_SQ_ITEM {

  private:

  protected:

    int Node;
    int Type;
    int LocalID;

  public:

    F_SpSimObjRef(): Node(-1), Type(-1), LocalID(-1) {
	C_ITEM::id = -1;
    }

    int GetNode() {return Node;}
    void SetNode(int n) {Node = n;}

    int GetType() {return Type;}
    void SetType(int t) {Type = t;}

    int GetLocalID() {return LocalID;}
    void SetLocalID(int i) {LocalID = i;}

    int GetGlobalID() {return C_ITEM::id;}
    void SetGlobalID(int g) {C_ITEM::id = g;}

};

//RB_DEFINE_CLASS(F_SpSimObjRef);

typedef F_SpSimObjRef F_SIMOBJ_REF;

#endif
