// H_SpObjProxy.C source file

#include "H_SpObjProxy.H"

#include "SpHostUser.H"
extern SpHostUser *HostUser;

#include "SpObjFactory.H"
extern SpObjFactory *ObjFact;

void H_SpObjProxy::Process(char *eventName, SpSimTime &timeTag,
			    char *data, int dataBytes,
			    int externalId) {

  cout << "<H_SpObjProxy> Event = " << eventName
       << ", Data = ";
  if (dataBytes){
    cout<<data;
  }
  else{
    cout<<"(null)";
  }
  cout<< " (" << dataBytes << " bytes), Time = " << double(timeTag)
      << ", External Id = " << externalId
      << ", Global Id = " << GlobalId << endl;

/*
** Make an object proxy message and send it out
*/

  int Size = ObjFact->GetMessageSize(ObjectProxy);
  SpObjProxyMsg *Message = ObjFact->GenerateMessage(ObjectProxy);

  if (externalId >= 0) {
    HostUser->SendData(timeTag,
			 externalId,
			 (char *)Message,
			 Size,
			 GlobalId);
  }

  delete [] (char *)Message;

}
