// O_SpDecMgr.C source file

#include "S_SpHLA.H"
#include "O_SpDecMgr.H"
#include "SpScheduleEvent.H"

O_SpDecMgr *DecMan_OBJECT_MANAGER = NULL;

/******************************************************************************
* O_SpDecMgr constructor                                                        *
******************************************************************************/
O_SpDecMgr::O_SpDecMgr() {
  int i, j, offset;
  C_QUEUE *object_templates = S_SpHLA::GetObjectFactory()->GetObjTemplate();
  SpObjTemplate **obj_template, *obj;

  DecMan_OBJECT_MANAGER = this;

  N_TOT = object_templates->length();
  N_LOC = deal_me(N_TOT, offset);

  obj_template = (N_TOT>0) ? new SpObjTemplate * [N_TOT]
                           : (SpObjTemplate **) 0;

  obj = (SpObjTemplate *) object_templates->get_top();
  i   = 0;
  while (obj){
    obj_template[i++] = obj;
    obj = (SpObjTemplate *) object_templates->next(obj);
  }
  
  const int n_loc = N_LOC;
  LocalObjects = new S_SpDecMgr[n_loc];
  cout << "NODE " << NODE << " Created "
       << N_LOC << " out of " << N_TOT << " DecMan objects" << endl;

  for (j=0, i=0; i<N_TOT; i++) {
    if ((i-offset+N_NODES)%N_NODES == 0) {
      LocalObjects[j].set_SEED(12345 + i);
      LocalObjects[j].set_NAME(obj_template[i]->GetName());
      LocalObjects[j].SetClassId(obj_template[i]->GetClassID());

      cout << "\tDecMan created on Node : " << NODE << " Obj Name/Local/Global : " 
           << LocalObjects[j].get_NAME()      << " / " 
           << LocalObjects[j].get_LOCAL_ID()  << " / " 
           << LocalObjects[j].get_GLOBAL_ID() << endl;

      j++;
    }
  }

  delete [] obj_template;

  reserve_n_objects(N_LOC);
  for (i=0; i<N_LOC; i++) define_object(&LocalObjects[i]);
  TOTAL_OBJECTS += N_TOT;

  set_global_names();
  set_interact();
}

O_SpDecMgr::~O_SpDecMgr() {
}

// init_events: Initializes the events for my objects
void O_SpDecMgr::init_events() {
}

// terminate: executed at the end of the simulation
void O_SpDecMgr::terminate(double /*tend*/) {
/*
  cout << "O_SpDecMgr node " << NODE
       << " critical path : "    << GetCriticalPathTime()
       << " commit : "           << GetCommittedTime() << endl;
*/
}
