#ifndef RB_SpObjProxyFuncs_Header
#define RB_SpObjProxyFuncs_Header

#include "SpObjProxy.H"

#include "SpAltMgr.H"
#include "SpAltObjProxyChange.H"

/**********************************************************************
 *
 **********************************************************************/
inline
SpObjProxy*
RB_Clone( SpObjProxy* proxy ) {
  SpAltObjProxyChange* altItem;
  
  SpObjProxy* proxyClone = ObjFact->Clone( proxy );
  
  if( SpCurrentAltMgr->GetOptimistic() ) {
    altItem = ALLOCATE_SpAltObjProxyChange();
    altItem->Alter( proxyClone, 0 );
    SpCurrentAltMgr->Insert( altItem );
  }
  
  return proxyClone;
}

/**********************************************************************
 *
 **********************************************************************/
inline
SpObjProxy*
RB_GenerateProxy( OBJECT_PROXY_MESSAGE* proxyMessage ) {
  SpAltObjProxyChange* altItem;

  SpObjProxy* proxy = ObjFact->GenerateObjectProxy( proxyMessage );

  if( SpCurrentAltMgr->GetOptimistic() ) {
    altItem = ALLOCATE_SpAltObjProxyChange();
    altItem->Alter( proxy, 0 );
    SpCurrentAltMgr->Insert( altItem );
  }

  return proxy;
}

/**********************************************************************
 *
 **********************************************************************/
inline
SpObjProxy*
RB_CreateProxy( char* type ) {
  SpAltObjProxyChange* altItem;

  SpObjProxy* proxy = ObjFact->Create( type );

  if( SpCurrentAltMgr->GetOptimistic() ) {
    altItem = ALLOCATE_SpAltObjProxyChange();
    altItem->Alter( proxy, 0 );
    SpCurrentAltMgr->Insert( altItem );
  }

  return proxy;
}

/**********************************************************************
 *
 **********************************************************************/
inline
void
RB_DestroyProxy( SpObjProxy* proxy ) {
  SpAltObjProxyChange* altItem;

  if( SpCurrentAltMgr->GetOptimistic() ) {
    altItem = ALLOCATE_SpAltObjProxyChange();
    altItem->Alter( proxy, 1 );
    SpCurrentAltMgr->Insert( altItem );
  }
  else {
    ObjFact->Destroy( proxy );
  }
}

#endif

