// S_SpDecMgr.H header file

#ifndef S_SpDecMgr_Object
#define S_SpDecMgr_Object

#include "SpSimObj.H"
class RB_SpBinaryTree;
#include "RB_Types.H"

/******************************************************************************
* S_SpDecMgr class definition                                                   *
******************************************************************************/
class S_SpDecMgr : public SpSimObj {
  public:
    S_SpDecMgr(void);
    ~S_SpDecMgr(void);

      // virtual methods
    virtual void terminate(double tend);

    void AddSubscriber(int node, int type, int local_id, int global_id);
    void AddPublisher(int node, int type, int local_id, int global_id);

    int  RemovePublisher(int node, int type, int local_id, int global_id);
    void RemoveSubscriber(int node, int global_id);

    int  GetClassId(void)    const { return (class_id);    }
    void SetClassId(int _class_id) { class_id = _class_id; }

  private:
    int class_id;
    RB_SpBinaryTree* publisher;
    RB_SpBinaryTree* subscriber;
};

typedef S_SpDecMgr S_DecMan;

#endif
