#ifndef SpAltObjProxyChange_Header
#define SpAltObjProxyChange_Header

#include "SpAlt.H"
#include "SpObjProxy.H"
#include "SpObjFactory.H"

/**********************************************************************
 * 
 **********************************************************************/
class SpAltObjProxyChange : public SpAlt {
public:
  void Alter( SpObjProxy* proxy, int destroy );
  virtual void Cleanup();
  virtual void Rollback();
private:
  SpObjProxy* Proxy;
  int Destroy;
};

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltObjProxyChange::Alter( SpObjProxy* proxy, int destroy ) {
  Proxy = proxy;
  Destroy = destroy;
}

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltObjProxyChange::Cleanup() {
  if( Destroy ) {
    ObjFact->Destroy( Proxy );
  }
}

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltObjProxyChange::Rollback() {
  Destroy = ! Destroy;
}

DEFINE_MEMPOOL( SpAltObjProxyChange, ALT_CHUNK_SIZE )

#endif

