//...... coverage calculation header file

#ifndef coverage_calculation
#define coverage_calculation

#include "SpConvert.H"

class SpObjProxy;

enum {
  CC_NONE_FOUND,
  CC_FOUND,
  CC_TRY_AGAIN,
  CC_IN,
  CC_OUT,
  CC_ENTER,
  CC_EXIT,
  CC_STABLE
};

// returns CC_IN, CC_OUT, CC_ENTER, CC_EXIT, CC_STABLE
int getSphericalCoverageState(SpObjProxy *sensor_plat_proxy,
			      SpObjProxy *target_plat_proxy,
			      char *position_ref,
			      double radius,
			      double time);

// returns CC_FOUND if a zero time is found, CC_NONE_FOUND otherwise
int findNextSphericalCoverageZero(SpObjProxy *sensor_plat_proxy,
				  SpObjProxy *target_plat_proxy,
				  char *position_ref,
				  double radius,
				  double begin_time,
				  double end_time,
				  double &zero_time);

#endif
