// SpDynObjs.C source file

#include "SpDynObjs.H"

void DYNAMIC_POLY_N::AddPoints(double ts, double te,
			  double t, double v, double err2,
			  ...) {
  va_list va;
  double Xi, Ti, Si;
  int i,j,n;
  BIG_FLOAT C[N_MAX_COEFF*2];

  StartTime = ts;
  EndTime = te;

  n = GetDim();

  if (A == NULL) {
    A = new BIG_FLOAT *[n];
    B = new BIG_FLOAT[n];
    for (i=0; i<n; i++) {
      A[i] = new BIG_FLOAT[n];
      for (j=0; j<n; j++) A[i][j] = 0.0;
      B[i] = 0.0;
    }
  }

  va_start(va, err2);

  Xi = v;
  Ti = t;
  Si = err2;

  for (;;) {
    ++NumPointsAdded;
    Ti -= StartTime;

    C[0] = 1.0/Si;
    for (i=1; i<2*n; i++) {
      C[i] = C[i-1]*Ti;
    }
    for (i=0; i<n; i++) {
      B[i] += Xi*C[i];
      for (j=0; j<n; j++) {
	A[i][j] += C[i+j];
      }
    }

    Ti = va_arg(va,double);
    if (Ti == END_POLY) break;
    Xi = va_arg(va,double);
    Si = va_arg(va,double);

  }

  va_end(va);

}

