// SpFreeDynAttributes.C

#include "SpFreeDynAttributes.H"

/*
** Include files for all of the free list objects
*/

#include "SpDynObjs.H"
#include "SpExtrapolate.H"
#include "SpSpline3Motion.H"
#include "SpSpline5Motion.H"
#include "SpPolyMotion.H"
#include "SpGreatCircle.H"
#include "SpRhumbLine.H"
#include "SpCircularOrbit.H"
#include "SpConstantPosition.H"
#include "SpLoiterMotion.H"
#include "SpExtrapolateMotion.H"

/*
** Functions that construct n objects at a time
*/

void *new_DYNAMIC_FLOAT_CONSTANT(int n) {
  return new DYNAMIC_FLOAT_CONSTANT[n];}

void *new_DYNAMIC_POLY_1(int n) {return new DYNAMIC_POLY_1[n];}
void *new_DYNAMIC_POLY_2(int n) {return new DYNAMIC_POLY_2[n];}
void *new_DYNAMIC_POLY_3(int n) {return new DYNAMIC_POLY_3[n];}
void *new_DYNAMIC_POLY_4(int n) {return new DYNAMIC_POLY_4[n];}
void *new_DYNAMIC_POLY_5(int n) {return new DYNAMIC_POLY_5[n];}
void *new_DYNAMIC_POLY_6(int n) {return new DYNAMIC_POLY_6[n];}
void *new_DYNAMIC_POLY_7(int n) {return new DYNAMIC_POLY_7[n];}
void *new_DYNAMIC_POLY_8(int n) {return new DYNAMIC_POLY_8[n];}
void *new_DYNAMIC_POLY_9(int n) {return new DYNAMIC_POLY_9[n];}
void *new_DYNAMIC_POLY_10(int n) {return new DYNAMIC_POLY_10[n];}

void *new_DYNAMIC_SPLINE_3(int n) {return new DYNAMIC_SPLINE_3[n];}
void *new_DYNAMIC_SPLINE_6(int n) {return new DYNAMIC_SPLINE_6[n];}

void *new_DYNAMIC_EXPONENTIAL(int n) {return new DYNAMIC_EXPONENTIAL[n];}
void *new_DYNAMIC_COMPLEX_EXPONENTIAL(int n) {
  return new DYNAMIC_COMPLEX_EXPONENTIAL[n];}

void *new_DYNAMIC_INT_CONSTANT(int n) {return new DYNAMIC_INT_CONSTANT[n];}

void *new_DYNAMIC_LOGICAL_CONSTANT(int n) {
  return new DYNAMIC_LOGICAL_CONSTANT[n];}

void *new_DYNAMIC_EXTRAPOLATE(int n) {return new DYNAMIC_EXTRAPOLATE[n];}

/*
** Dynamic positions
*/

void *new_GREAT_CIRCLE(int n) {return new GREAT_CIRCLE[n];}
void *new_RHUMB_LINE(int n) {return new RHUMB_LINE[n];}
void *new_CIRCULAR_ORBIT(int n) {return new CIRCULAR_ORBIT[n];}
void *new_CONSTANT_MOTION(int n) {return new CONSTANT_MOTION[n];}
void *new_LOITER_MOTION(int n) {return new LOITER_MOTION[n];}

void *new_SPLINE3_MOTION(int n) {return new SPLINE3_MOTION[n];}
void *new_SPLINE6_MOTION(int n) {return new SPLINE6_MOTION[n];}

void *new_POLY_1_MOTION(int n) {return new POLY_1_MOTION[n];}
void *new_POLY_2_MOTION(int n) {return new POLY_2_MOTION[n];}
void *new_POLY_3_MOTION(int n) {return new POLY_3_MOTION[n];}
void *new_POLY_4_MOTION(int n) {return new POLY_4_MOTION[n];}
void *new_POLY_5_MOTION(int n) {return new POLY_5_MOTION[n];}
void *new_POLY_6_MOTION(int n) {return new POLY_6_MOTION[n];}
void *new_POLY_7_MOTION(int n) {return new POLY_7_MOTION[n];}
void *new_POLY_8_MOTION(int n) {return new POLY_8_MOTION[n];}
void *new_POLY_9_MOTION(int n) {return new POLY_9_MOTION[n];}
void *new_POLY_10_MOTION(int n) {return new POLY_10_MOTION[n];}

void *new_EXTRAPOLATE_MOTION(int n) {return new EXTRAPOLATE_MOTION[n];}

/*
** Plug the objects into the free list in the FREE_LIST constructor
*/

SpFreeDynAttributes::SpFreeDynAttributes() {

  set_ntypes(N_FREE_LIST);

/*
** Define Dynamic Floating Point Types
*/

  set_type("DYNAMIC_FLOAT_CONSTANT",
	   DYNAMIC_FLOAT_CONSTANT_ID,
	   new_DYNAMIC_FLOAT_CONSTANT,
	   sizeof(DYNAMIC_FLOAT_CONSTANT),
	   100);

  set_type("DYNAMIC_POLY_1",
	   DYNAMIC_POLY_1_ID,
	   new_DYNAMIC_POLY_1,
	   sizeof(DYNAMIC_POLY_1),
	   100);

  set_type("DYNAMIC_POLY_2",
	   DYNAMIC_POLY_2_ID,
	   new_DYNAMIC_POLY_2,
	   sizeof(DYNAMIC_POLY_2),
	   100);

  set_type("DYNAMIC_POLY_3",
	   DYNAMIC_POLY_3_ID,
	   new_DYNAMIC_POLY_3,
	   sizeof(DYNAMIC_POLY_3),
	   100);

  set_type("DYNAMIC_POLY_4",
	   DYNAMIC_POLY_4_ID,
	   new_DYNAMIC_POLY_4,
	   sizeof(DYNAMIC_POLY_4),
	   100);

  set_type("DYNAMIC_POLY_5",
	   DYNAMIC_POLY_5_ID,
	   new_DYNAMIC_POLY_5,
	   sizeof(DYNAMIC_POLY_5),
	   100);

  set_type("DYNAMIC_POLY_6",
	   DYNAMIC_POLY_6_ID,
	   new_DYNAMIC_POLY_6,
	   sizeof(DYNAMIC_POLY_6),
	   100);

  set_type("DYNAMIC_POLY_7",
	   DYNAMIC_POLY_7_ID,
	   new_DYNAMIC_POLY_7,
	   sizeof(DYNAMIC_POLY_7),
	   100);

  set_type("DYNAMIC_POLY_8",
	   DYNAMIC_POLY_8_ID,
	   new_DYNAMIC_POLY_8,
	   sizeof(DYNAMIC_POLY_8),
	   100);

  set_type("DYNAMIC_POLY_9",
	   DYNAMIC_POLY_9_ID,
	   new_DYNAMIC_POLY_9,
	   sizeof(DYNAMIC_POLY_9),
	   100);

  set_type("DYNAMIC_POLY_10",
	   DYNAMIC_POLY_10_ID,
	   new_DYNAMIC_POLY_10,
	   sizeof(DYNAMIC_POLY_10),
	   100);

  set_type("DYNAMIC_SPLINE_3",
	   DYNAMIC_SPLINE_3_ID,
	   new_DYNAMIC_SPLINE_3,
	   sizeof(DYNAMIC_SPLINE_3),
	   100);

  set_type("DYNAMIC_SPLINE_6",
	   DYNAMIC_SPLINE_6_ID,
	   new_DYNAMIC_SPLINE_6,
	   sizeof(DYNAMIC_SPLINE_6),
	   100);

  set_type("DYNAMIC_EXPONENTIAL",
	   DYNAMIC_EXPONENTIAL_ID,
	   new_DYNAMIC_EXPONENTIAL,
	   sizeof(DYNAMIC_EXPONENTIAL),
	   100);

  set_type("DYNAMIC_COMPLEX_EXPONENTIAL",
	   DYNAMIC_COMPLEX_EXPONENTIAL_ID,
	   new_DYNAMIC_COMPLEX_EXPONENTIAL,
	   sizeof(DYNAMIC_COMPLEX_EXPONENTIAL),
	   100);

  set_type("DYNAMIC_EXTRAPOLATE",
	   DYNAMIC_EXTRAPOLATE_ID,
	   new_DYNAMIC_EXTRAPOLATE,
	   sizeof(DYNAMIC_EXTRAPOLATE),
	   100);

/*
** Define Dynamic Integer Types
*/

  set_type("DYNAMIC_INT_CONSTANT",
	   DYNAMIC_INT_CONSTANT_ID,
	   new_DYNAMIC_INT_CONSTANT,
	   sizeof(DYNAMIC_INT_CONSTANT),
	   100);

/*
** Define Dynamic Logical Types
*/

  set_type("DYNAMIC_LOGICAL_CONSTANT",
	   DYNAMIC_LOGICAL_CONSTANT_ID,
	   new_DYNAMIC_LOGICAL_CONSTANT,
	   sizeof(DYNAMIC_LOGICAL_CONSTANT),
	   100);

/*
** Define Dynamic Motion Types
*/

  set_type("GREAT_CIRCLE_ID",
	   GREAT_CIRCLE_ID,
	   new_GREAT_CIRCLE,
	   sizeof(GREAT_CIRCLE),
	   100);

  set_type("RHUMB_LINE_ID",
	   RHUMB_LINE_ID,
	   new_RHUMB_LINE,
	   sizeof(RHUMB_LINE),
	   100);

  set_type("CIRCULAR_ORBIT_ID",
           CIRCULAR_ORBIT_ID,
           new_CIRCULAR_ORBIT,
           sizeof(CIRCULAR_ORBIT),
           100);

  set_type("CONSTANT_MOTION_ID",
	   CONSTANT_MOTION_ID,
	   new_CONSTANT_MOTION,
	   sizeof(CONSTANT_MOTION),
	   100);

  set_type("LOITER_MOTION_ID",
	   LOITER_MOTION_ID,
	   new_LOITER_MOTION,
	   sizeof(LOITER_MOTION),
	   100);

  set_type("SPLINE3_MOTION_ID",
	   SPLINE3_MOTION_ID,
	   new_SPLINE3_MOTION,
	   sizeof(SPLINE3_MOTION),
	   100);

  set_type("SPLINE6_MOTION_ID",
	   SPLINE6_MOTION_ID,
	   new_SPLINE6_MOTION,
	   sizeof(SPLINE6_MOTION),
	   100);

  set_type("POLY_1_MOTION_ID",
	   POLY_1_MOTION_ID,
	   new_POLY_1_MOTION,
	   sizeof(POLY_1_MOTION),
	   100);

  set_type("POLY_2_MOTION_ID",
	   POLY_2_MOTION_ID,
	   new_POLY_2_MOTION,
	   sizeof(POLY_2_MOTION),
	   100);

  set_type("POLY_3_MOTION_ID",
	   POLY_3_MOTION_ID,
	   new_POLY_3_MOTION,
	   sizeof(POLY_3_MOTION),
	   100);

  set_type("POLY_4_MOTION_ID",
	   POLY_4_MOTION_ID,
	   new_POLY_4_MOTION,
	   sizeof(POLY_4_MOTION),
	   100);

  set_type("POLY_5_MOTION_ID",
	   POLY_5_MOTION_ID,
	   new_POLY_5_MOTION,
	   sizeof(POLY_5_MOTION),
	   100);

  set_type("POLY_6_MOTION_ID",
	   POLY_6_MOTION_ID,
	   new_POLY_6_MOTION,
	   sizeof(POLY_6_MOTION),
	   100);

  set_type("POLY_7_MOTION_ID",
	   POLY_7_MOTION_ID,
	   new_POLY_7_MOTION,
	   sizeof(POLY_7_MOTION),
	   100);

  set_type("POLY_8_MOTION_ID",
	   POLY_8_MOTION_ID,
	   new_POLY_8_MOTION,
	   sizeof(POLY_8_MOTION),
	   100);

  set_type("POLY_9_MOTION_ID",
	   POLY_9_MOTION_ID,
	   new_POLY_9_MOTION,
	   sizeof(POLY_9_MOTION),
	   100);

  set_type("POLY_10_MOTION_ID",
	   POLY_10_MOTION_ID,
	   new_POLY_10_MOTION,
	   sizeof(POLY_10_MOTION),
	   100);

  set_type("EXTRAPOLATE_MOTION",
	   EXTRAPOLATE_MOTION_ID,
	   new_EXTRAPOLATE_MOTION,
	   sizeof(EXTRAPOLATE_MOTION),
	   100);

}
