// SpFreeHLA.C

#include "SpFreeHLA.H"

/*
** Include files for all of the free list objects
*/

#include "F_SpSimObjRef.H"
#include "F_SpProxyListItem.H"
#include "F_SpProxyItem.H"
#include "F_SpUpdateListItem.H"

/*
** Functions that create n objects at a time
*/

void *new_SIMOBJ_REF(int n) 		{return new F_SpSimObjRef[n];}
void *new_PROXY_LIST_ITEM(int n)       	{return new F_SpProxyListItem[n];}
void *new_PROXY_ITEM(int n)       	{return new F_PROXY_ITEM[n];}
void *new_UPDATE_LIST_ITEM(int n)       {return new F_UPDATE_LIST_ITEM[n];}

/*
** Constructor where free list is set up
*/

SpFreeHLA::SpFreeHLA() {

/*
** Tell the free list base class how many free lists to create
*/

  set_ntypes(N_SpFreeHLA);

/*
** Define free list objects
*/

  set_type("SIMOBJ_REF",
	   SIMOBJ_REF,
	   new_SIMOBJ_REF,
	   sizeof(F_SpSimObjRef),
	   1000);

  set_type("PROXY_LIST_ITEM",
	   PROXY_LIST_ITEM,
	   new_PROXY_LIST_ITEM,
	   sizeof(F_SpProxyListItem),
	   1000);

  set_type("PROXY_ITEM",
	   PROXY_ITEM,
	   new_PROXY_ITEM,
	   sizeof(F_PROXY_ITEM),
	   1000);

  set_type("UPDATE_LIST_ITEM",
	   UPDATE_LIST_ITEM,
	   new_UPDATE_LIST_ITEM,
	   sizeof(F_UPDATE_LIST_ITEM),
	   1000);

}
