#include "SpObjTemplate.H"

SpObjTemplate::SpObjTemplate(char *name, int i) : ClassName(strdup(name))
{
  freeid = -1;
  ClassID = ClassCounter;
  ClassCounter++;
  ID = i;
  Ndefines = 0;
  Nobjects = 0;
  Ninherits = 0;
  Nattributes = 0;
  AttributeName = NULL;
  Nmethods = 0;
  Method = NULL;
  MethodName = NULL;
  Parent = NULL;
  Nsubscribe    = 0;
  SubscribeName = NULL;
}

SpObjTemplate::~SpObjTemplate()
{
  delete [] AttributeTypeID;
  for (int i=0; i<Nsubscribe; i++)
    if (SubscribeName[i]!=(char *) 0) delete [] SubscribeName[i];
  if (SubscribeName!=(char **) 0) delete [] SubscribeName;
}

void SpObjTemplate::Inherit(SpObjTemplate *ParentTemplate)
 {
      int i;

      Parent = ParentTemplate;
      if (ParentTemplate == NULL) {
        Nattributes = Ndefines + Nobjects;
      }else{
        Nattributes = Ndefines + Nobjects + ParentTemplate->GetNattributes();
      }

      AttributeName = new char *[Nattributes];
      AttributeType = new char *[Nattributes];
      AttributeTypeID = new int[Nattributes];
      ClassReference = new SpObjTemplate*[Nattributes];
      ArraySize = new int[Nattributes];

      for (i=0; i<Nattributes; i++) {
	AttributeName[i] = NULL;
	AttributeType[i] = NULL;
	AttributeTypeID[i] = -1;
	ClassReference[i] = this;
	ArraySize[i] = 1;
      }
      if (ParentTemplate) {
        for (i=0; i<ParentTemplate->GetNattributes(); i++) {
	  AttributeName[i] = strdup(ParentTemplate->GetAttributeName(i));
	  AttributeType[i] = strdup(ParentTemplate->GetAttributeType(i));
	  AttributeTypeID[i] = ParentTemplate->GetAttributeTypeID(i);
	  ClassReference[i] = ParentTemplate->GetClassReference(i);
	  ArraySize[i] = ParentTemplate->GetArraySize(i);
        }
      }
    }
