// ProxySubscriber.H Source File

#ifndef PROXY_SUBSCRIBER_H
#define PROXY_SUBSCRIBER_H

#include "SpDestination.H"
#include "RB_Types.H"

#include "SpBinaryTree.H"
class RB_SpBinaryTree;

class SpSubscriberHandle;

class SpProxySubscriber {
public:
  enum DefaultDistList { DM=0, DDM, NUM_DEFAULT_DIST_LIST };

  SpProxySubscriber(void);
  ~SpProxySubscriber(void);

  void Add(int dist_list_id,
           int _node, int _type, int _local_id, int _global_id, 
           int &deliver,          // TRUE  : if need to deliver proxy to the subscriber's node
                                  // FALSE : if proxy has already been delivered to the
                                  //         subscriber node, only need to notify subscriber 
           int &duplicate,        // TRUE  : if proxy has already been delivered/notified
           SpSubscriberHandle* &subscriber);

  int  Remove(int dist_list_id, int _node, int _global_id);
  void Remove(int dist_list_id, BINARY_TREE &subscriber_nodes);

  void SetDestination(SpDestination &destination);

  void debug(ostream &os);

  static int GetNewDistListId(void);

private:
    // binary tree of binary tree (top level key = subscriber's node id)
    //                            (sub-tree  key = subscriber's global id)
  RB_SpBinaryTree *node;
  static int DistListId;
};

#endif
