// SpSubscriberHandle.H header file

#ifndef SUBSCRIBER_HANDLE_H
#define SUBSCRIBER_HANDLE_H

#include "RB_Types.H"
#include "SpProxyObjHandle.H"
#include "SpProxySubscriber.H"

class SpSubscribeDistList;
class RB_SpBinaryTree;

class SpSubscriberHandle : public SpProxyObjHandle {
public:
  SpSubscriberHandle(void);
  SpSubscriberHandle(int _local_id, int _node, int _object_type, int _global_id);
  ~SpSubscriberHandle(void);

  SpSubscriberHandle(const SpSubscriberHandle&)            { abort(); }
  SpSubscriberHandle& operator=(const SpSubscriberHandle&) { abort(); return (*this); }

  int getNumSubscribe(void);
  int getNumSubscribe(int id);
  int incrNumSubscribe(int id);
  int decrNumSubscribe(int id);
  int resetNumSubscribe(int id);

private:
  RB_SpBinaryTree *SubscribeDistLists;

  SpSubscribeDistList *GetSubscribeDistList(int id);
};

#endif
