// SpDistList.H

#ifndef SP_DIST_LIST_H
#define SP_DIST_LIST_H

#include "SpProxyObjHandle.H"

class S_SpHLA;
class RB_SpBinaryTree;
class RB_SpList;

class SpDistList {
public:
  SpDistList(void);
  SpDistList(const char *name, int id, S_SpHLA *simobj);
  ~SpDistList(void);
    
  int Insert(const SpProxyObjHandle *handle);
  int Remove(const SpProxyObjHandle *handle);

  int         GetNumObjHandles(void);
  const char *GetName(void) const { return (Name); }

  int IsDirty(void);
  void Process(SpBinaryTree &add, SpBinaryTree &remove);
  int GetId(void) const { return (Id); }
  void GetChanges(SpBinaryTree &add, SpBinaryTree &remove);
  void UnDirty(void);

private:
  int Id;
  char *Name;
  S_SpHLA         *SimObj;
  RB_SpBinaryTree *ObjHandles; 
  RB_SpList       *RemoveHandles;
  RB_SpList       *AddHandles;

  void Dirty(void);
};

#endif
