// O_SpFedGhost.H header file defines the ghost federate object manager class

#ifndef O_SpFedGhostGate
#define O_SpFedGhostGate

#include "SpSimObjMgr.H"
#include "S_SpFedGhost.H"

#include "SpEventHandler.H"
#include "SpScheduleEvent.H"

class H_SpCreateFedGhost : public SpEventHandler {

 private:
 protected:
 public:

  void Process(char *,
	       SIMTIME &timeTag,
	       char *data,
	       int dataBytes,
	       int externalId);
};

// temporary measure to handle create/destroy fedex
class H_SpCreateFedEx : public SpEventHandler {
public:
  void Process(char *,
	       SIMTIME &timeTag,
	       char *data,
	       int dataBytes,
	       int externalId);
};
class H_SpDestroyFedEx : public SpEventHandler {
public:
  void Process(char *,
	       SIMTIME &timeTag,
	       char *data,
	       int dataBytes,
	       int externalId);
};

class O_SpFedGhost : public SpSimObjMgr {
  
 private:
  
  H_SpCreateFedGhost CreateFedGhost;

  // temporary measure to handle create/destroy fedex
  H_SpCreateFedEx CreateFedEx;
  H_SpDestroyFedEx DestroyFedEx;

 protected:
  
 public:
  
  O_SpFedGhost();
  
  virtual SpSimObj *CreateSimObj();
  
  virtual void DestroySimObj(SpSimObj *simObj);

  // temporary measure to handle create/destroy fedex
  SpBinaryTree *FEDs;
};

DEFINE_OBJECT_MANAGER(SpFedGhost, O_SpFedGhost);

#endif
