
/*  This C include file includes all of the structures  required
    for building the derived MPI data types required by the SPEEDES
    MPI communications library.  The functions for building the
    derived data types are in Speedes_MPI.h.                     

    =============================================================
    Roger Hillson
    Code 5583, Naval Research Laboratory
    Initial version:   21 October   1997  
    Last revised:      16 September 1998
    =============================================================  */

/*  MPISimTime is the prototype for a derived type corresponding to
    the SPEEDES class SIMTIME.  See speedes/src/utilities/simtime.H
    (SPEEDES version 0.6).                                         */

//  Declare groups and communicators


#ifndef MPI_STRUCS_H
#define MPI_STRUCS_H

#define MAX_MESG_SIZE 51200

typedef struct {
  double Time;       /*  physical time.                           */
  int Priority1;     /*  first priority field.                    */
  int Priority2;     /*  second priority field.                   */
  int counter;       /*  counter priority field.                  */
  int uniqueId;      /*  unique id tie-breaking field.            */
} MPIst;

typedef struct {
  char buffer[MAX_MESG_SIZE]; 
  /* buffer for Speedes messages.        */
  int  size;       /* number of chars in Speedes message. */
  int  type;       /* Speedes message type.               */
} SpeedesMsg;

#endif






