#ifndef Generic_Msg_Header
#define Generic_Msg_Header


#include "SpNetTypes.H"


// geb3.98
// This class contains the minimum info the server needs to get the
// msg to the right handler;  an application should create its own class
// that inherits from this one.
// serviceType:  this specifies the service desired (the server can offer
//               more than one service;  see idsOfSrvTypes.H)
// group:  for each service, there can be more than one group of nodes
//         requesting that service (eg 2 simulations, 5 nodes and 8 nodes
//         respectively, asking for comms service, are put in diff groups
//         [we don't want msgs from sim0 going to sim1]
// handlerNum:  # of method that will deal with this message.
// bytes:  #bytes following the header
class GENERIC_MSG_HEADER {
public:
  NET_INT serviceType;
  NET_INT group;
  NET_INT handlerNum;
  NET_INT bytes;
  
   
   //geb3.98: give these guys bogus vals to avoid accidentally getting
   //         legit ones
   GENERIC_MSG_HEADER(void) :
     serviceType(-1), 
     group(-1),
     handlerNum(-1),
     bytes(-1),
     TotalBytes(-1),
     EightByteAllignmentJunk(0) {}


  void Init(){
    serviceType = 0;
    group = 0;
    handlerNum = 0;
    bytes = 0;
    TotalBytes = 0;
    EightByteAllignmentJunk = 0;
  }  

   // geb3.98 new constructor
   // In order for a msg to get routed to the right service group, we MUST
   // know the service type# and the group#; we also need to know which handler
   // to invoke.
   GENERIC_MSG_HEADER(int srvTypeID, int groupID, int handler) : serviceType(srvTypeID), 
     group(groupID), handlerNum(handler) {
   }
  
    int getSrvType(void) { return serviceType; }
    void setSrvType(int srvNum) { serviceType = srvNum; }
  
    int getGroupNum(void) { return group; }
    void setGroupNum(int grpNum) { group = grpNum; }
  
    int getHandlerNum(void) { return handlerNum; }
    void setHandlerNum(int hnum) { handlerNum = hnum; }

    int getBytes(void) { return bytes; }
    void setBytes(int b) { bytes = b; } 

private:
  void SetTotalBytes(int t){
    TotalBytes = t;
    EightByteAllignmentJunk = 0;
  }
  friend class SpEmHostUser;
  friend class STREAM_SOCK;
  NET_INT TotalBytes;  //DO NOT TOUCH!!!!
  NET_INT EightByteAllignmentJunk; //DO NOT TOUCH!
};

#endif
