#include "SpStdlib.H"
#include <sys/types.h>

#ifndef __SPEEDES_NT__
#include <sys/time.h>
#include <unistd.h>
#else
#include <windows.h>
#endif

#include "SpIostream.H"
#include "SpFstream.H"
#include "SpStrstream.H"
#include "SpIomanip.H"
#include "SpMsgHeader.H"
#include "SpServiceGroup.H"

SERVICE_GROUP::~SERVICE_GROUP()
{
  for (CONNECTION *conn = (CONNECTION *) Connlist.get_top();
       conn;
       conn = (CONNECTION *) conn->get_link())
  {
    //conn->closeConnection(); This line leads to an incorrect closing of a file descriptor.
  }
  Connlist.clear();
  delete [] MsgHandlerArr;
}

SERVICE_GROUP::HandlerStatus SERVICE_GROUP::ErrorMethod(CONNECTION *conn, GENERIC_MSG_HEADER *hdr) {
  cerr << "Handler array element NEVER assigned a method ptr!"  << endl;
  cerr << "Group, handler# = " << hdr->getGroupNum() << ", " << hdr->getHandlerNum() << endl;
  cerr << "fd = " << conn->getfd() << endl;
  return handler_ok;
}

void SERVICE_GROUP::allocateHandlerStorage(int numHandlers)  {
      MsgHandlerArr = new MsgMethodPtr[numHandlers];
      NumHandlers = numHandlers;
      for(int i=0; i<numHandlers; i++)
	MsgHandlerArr[i] = &SERVICE_GROUP::ErrorMethod;
      // If you change SERVICE_GROUP::ErrorMethod to NULL in the line
      // above, it will probably compile on the o2 with the -64
      // option.  It is probably a bug that the -64 option cannot
      // handle it the way it is.
   }

void SERVICE_GROUP::storeHandler(int methNumber, MsgMethodPtr methptr) {
  if ((methNumber < 0) || (methNumber >= NumHandlers)) {
    cerr << "Method # out-of-range.  meth#=" << methNumber
	 << ", #handlers=" << NumHandlers << endl;
    exit(1);
  }
  else
    MsgHandlerArr[methNumber] = methptr;
}
