#ifndef sock_Msg_Type
#define sock_Msg_Type

#include "qitem.H"


class SockMsgType : public C_ITEM {
 private:
   char *Buff;          // msg buffer
   long int Length;     // #bytes in whole msg
   long int BytesRecvd; // #bytes actually received--partial msg is possible
   int DeleteBuff_p;    // if true, delete[] Buff when done with it geb5.98


 public:
   SockMsgType(char *buf=NULL, int len=0) {
      Buff=buf; Length=len; BytesRecvd=0; DeleteBuff_p=0; //geb5.98 DeleteBuff_p
   }

   //geb5.98 whole fcn
   SockMsgType(char *buf, int len, int deleteIt_p) : 
      Buff(buf), Length(len), DeleteBuff_p(deleteIt_p) {
   }
   char *getMsgBuff(void) { return Buff; }
   void setMsgBuff(char *pt) { Buff = pt; }

   int getMsgLength(void) { return Length; }
   void setMsgLength(long int len) { Length = len; }

   int getBytesRecvd(void) { return BytesRecvd; }
   void setBytesRecvd(long int nbytes) { BytesRecvd = nbytes; }

   int partialMsgp(void) { return BytesRecvd < Length; }
   int emptyMsgp(void) { return BytesRecvd == 0; }

   int getDeleteBuff_p(void) { return DeleteBuff_p; } //geb5.98
   void setDeleteBuff_p(int deleteIt_p) { DeleteBuff_p = deleteIt_p; } //geb5.98

   void deleteMsgBuff(void) { //geb5.98 whole fcn
      if (DeleteBuff_p) delete[] (getMsgBuff()); 
   }  //geb3.98 must have "[]"!


   // partial internal hdr noted w/neg # bytes rcvd!
   int getHdrBytesRecvd(void) { return( -BytesRecvd ); }
   void setHdrBytesRecvd(int hdrBytesRecvd) { setBytesRecvd( -hdrBytesRecvd ); }

   void savePartialHdr(long *hdr, int hdrLen, int hdrBytesRead) {
      setMsgBuff((char *)hdr);
      setMsgLength(hdrLen);
      setHdrBytesRecvd(hdrBytesRead); // partial internal hdr noted w/neg # bytes rcvd!
   }

   int havePartialHdr_p(void) {
      return( BytesRecvd < 0 );
   }


};


#endif
