// SpEmConnectionHolder.H header file is a holder for external module
// connections. It keeps track of things like whether or not the connection
// is doing barrier synchronizations or monitoring anything.

#ifndef EM_CONNECTION_HOLDER_OBJECT
#define EM_CONNECTION_HOLDER_OBJECT

#include "SpConnection.H"

class EM_CONNECTION_HOLDER : public C_ITEM {
  private:

    CONNECTION *Connection;
    int Barrier;
    int BarrierNode;

  protected:
  public:

    EM_CONNECTION_HOLDER(CONNECTION *C) {
      Connection = C;
      id = C->get_id();
      Barrier = 0;
      BarrierNode = -1;
    }

    ~EM_CONNECTION_HOLDER() {
    }

    CONNECTION *GetConnection() {return Connection;}

    void SetBarrier() {
      Barrier = 1;
    }

    void ResetBarrier() {
      Barrier = 0;
      BarrierNode = -1;
    }

    void SetBarrierNode(int Node) {
      BarrierNode = Node;
    }

    int GetBarrier() {return Barrier;}
    int GetBarrierNode() {return BarrierNode;}

};

#endif
