#include "SpIostream.H"
#include "SpFstream.H"
#include "SpStrstream.H"
#include "SpIomanip.H"
#include "SpStdlib.H"
#ifdef __SPEEDES_NT__
#include <winsock.h>
#endif


#include "SpSimTime.H"
#include "SpNetTypes.H"
#include "SpServer.H"
#include "SpCommServerMsgs.H"
#include "SpCommServer.H"
#include "SpDataParser.H"
#include "SpMsgServer.H"

/*
** Header files for the servers supported in the SpeedesServer
*/

#include "SpHostRouter.H"

/*
** Functions that create the server objects when new groups join
*/

HOST_ROUTER *NewHostRouter(void) {
  cout << "Creating a new Host Router object" << endl;
  return new HOST_ROUTER();
}

CommServer *makeCommServer(void)
{
  cout<<"Returning a new comm server"<<endl;
  return new CommServer;
};


int main(int argc, char **argv) {
  int Port;
  SpEndianNature::DetermineEndianNature();

  if (argc == 2) {
    Port = atoi(argv[1]);
    if (Port == 0) {
      cout << "Error, bad port command line argument: " << argv[1] << endl;
      exit(1);
    }
    else if (Port == -1){
      Port = 10000 + 
#ifndef __SPEEDES_NT__
	int(getuid())
#else
        0
#endif
	;
      cout<<"Negative 1 means use 10000 + getuid() = "<<Port
	  <<" for the port"<<endl;
    }
  }
  else{
    Port = 10000 + 
#ifndef __SPEEDES_NT__
      int(getuid())
#else
      0
#endif
      ;
    cout<<"No port specified, using 10000 + getuid() = "<<Port
	<<" for the port"<<endl;
  }
  
  cout << "Starting up the SpeedesServer using Port " << Port << endl;

/*
** Tell the Message server how many service group objects to support
** (1 for now)
*/

#ifdef __SPEEDES_NT__
  WORD wVersionRequested = MAKEWORD(2,0);
  WSADATA wsaData;
  int err = WSAStartup(wVersionRequested, &wsaData);
  if (err){
    cout<<"Unable to initialize the windows sockets libraries."
	<<" WinSock must be installed.\a"<<endl;
    exit(0);
  }
  if ((LOBYTE(wsaData.wVersion) != 2) || (HIBYTE(wsaData.wVersion) != 0)) {
    cout<<"Could not load winsock version 2.0 or lower.\a"<<endl;
    exit(0);
  }
  cout<<"Winsocket libraries initialized!"<<endl;
#endif

  MESSAGE_SERVER MessageServer(N_SERVICE_GROUPS, Port);

  MessageServer.saveSrvMaker(HOST_ROUTER_ID,
			     (SERVICE_OBJ_MAKER) &NewHostRouter);

  MessageServer.saveSrvMaker(SPEEDES_COMM_SERVER_ID,
			     (SERVICE_OBJ_MAKER) &makeCommServer);

/*
** Loop forever servicing messages
*/

  MessageServer.serviceMessages();

  return 0;
}
