// SpSubscriptionName.C source file

#include "SpSubscriptionName.H"

int SUBSCRIPTION_NAME::AddSubItem(SUBSCRIPTION_ITEM *SubItem) {

  if (SubItem == NULL) {
    cout << "Warning, trying to add a NULL SubItem to a SubName" << endl;
    return 1;
  }

  if (SubItem->get_link()) {
    cout << "Warning, trying to add a SubItem twice to a SubName" << endl;
  }

  SubItems.push_bot(SubItem);
  return 0;
}


int SUBSCRIPTION_NAME::RemoveSubItem(SUBSCRIPTION_ITEM *SubItem) {
  int RetVal = 0;

  if (SubItem == NULL) {
    cout << "Warning, trying to remove a NULL SubItem from a SubName" << endl;
    return 1;
  }

  int len = SubItems.get_length();
  SUBSCRIPTION_ITEM *item = (SUBSCRIPTION_ITEM *)SubItems.get_top();

  for (int i=0; i<len; i++) {

    if (SubItem->Compare(item)) {
      SubItems.deque(item);
      delete item;
      RetVal = 1;
      break;
    }

    item = (SUBSCRIPTION_ITEM *)item->get_link();

  }

  return RetVal;
}


int SUBSCRIPTION_NAME::CheckSubSet(SUBSCRIPTION_ITEM *SubItem) {
  SUBSCRIPTION_ITEM *item = (SUBSCRIPTION_ITEM *)SubItems.get_top();
  int len = SubItems.get_length();;
  int i;

/*
** This is the case where we are subscribing to an object. We should return
** 1 if any of the items in the list have a wild-card for type (i.e., -1)
** or if their ObjectType is the same as mine, and either has a wild-card for
** LocalId or the same LocalId as mine.
*/

  if (SubItem->GetLocalId() != -1) {

    for (i=0; i<len; i++) {
      if (item->GetObjectType() == -1) return 1;

      if (item->GetObjectType() == SubItem->GetObjectType()) {
	if (item->GetLocalId() == -1) return 1;
	if (item->GetLocalId() == SubItem->GetLocalId()) return 1;
      }

      item = (SUBSCRIPTION_ITEM *)item->get_link();
    }

    return 0;

  }

/*
** This is the case where we are subscribing to an object type. We should
** return 1 if we find any other items with wild-card for type (i.e., -1) or
** with the same type as mine and also having a wild-card for LocalId.
*/

  if (SubItem->GetObjectType() != -1) {

    for (i=0; i<len; i++) {
      if (item->GetObjectType() == -1) return 1;

      if (item->GetObjectType() == SubItem->GetObjectType()) {
	if (item->GetLocalId() == -1) return 1;
      }

      item = (SUBSCRIPTION_ITEM *)item->get_link();
    }

    return 0;

  }

/*
** This is the case where we are subscribing to all objects. We should only
** return 1 when we find an item that also has a wild-card (i.e., -1) for its
** ObjectType.
*/

  for (i=0; i<len; i++) {
    if (item->GetObjectType() == -1) return 1;
    item = (SUBSCRIPTION_ITEM *)item->get_link();
  }

  return 0;

}
