// SpCommand.C file

#include "SpIostream.H"
#include "SpFstream.H"
#include "SpStrstream.H"
#include "SpIomanip.H"
#include "SpStdlib.H"
#include "SpString.H"

#include "SpEmHostUser.H"

/*
*****************************************************************************
* Command sends a command to SPEEDES which schedules an event. The event can
* either be the name of a user-provided event in SPEEDES, or it can be the
* name of a user-provided event handler type. There must be two or more
* command-line arguments passed in. The first argument is the name of the
* command (event). The second argument is the name of the object. The last
* argument is a string that is passed in as data for the event. Note that for
* some events, this would be totally wrong, so the user should be aware that
* this command-line tool is not general enough to schedule arbitrary events
* with possibly complex data in the message.
*****************************************************************************
*/

int main(int argc, char **argv) {
  SpEmHostUser *EmHostUser;

  if (argc == 4) {
    EmHostUser = new SpEmHostUser();
    EmHostUser->SendCommand(argv[1], argv[2], argv[3], strlen(argv[3]) + 1);
    delete EmHostUser;
    return 0;
  }

  if (argc == 6) {
    EmHostUser = new SpEmHostUser();
    EmHostUser->SendCommand(argv[1],
			    atoi(argv[2]), atoi(argv[3]), atoi(argv[4]),
			    argv[5], strlen(argv[5]) + 1);
    delete EmHostUser;
    return 0;
  }

  cout << "Error, Command <CommandName, ObjectName, DataString>" << endl;
  cout << "or...  Command <CommandName, Node, ObjectType, LocalId, "
       << "DataString>" << endl;


  return 0;
}
