// SpObjNames.C file

#include "SpIostream.H"
#include "SpFstream.H"
#include "SpStrstream.H"
#include "SpIomanip.H"
#include "SpStdlib.H"
#include "SpSignal.H"

#include "SpEmHostUser.H"
#include "SpNameValueList.H"

SpEmHostUser *EmHostUser = NULL;

void sigintfunc(int) {
  cout << "Interupt" << endl;
  signal(SIGINT, sigintfunc);
  if (EmHostUser) delete EmHostUser;
  EmHostUser = NULL;
  exit(1);
}

/*
*****************************************************************************
* ObjectNames: returns the names of the object in SPEEDES. Optional command
* line argument is the <object type> which is a filter that only returns
* object names of the specified type.
*****************************************************************************
*/

int main(int argc, char **argv) {
  SpNameValueList *NameValueList;

  signal(SIGINT, sigintfunc);

/*
** Make sure that there is no more than one argument (the type of objects)
*/

  if (argc > 2) {
    cout << "Error, ObjectName <ObjectType>" << endl;
    exit(1);
  }

/*
** Create the External Module Host User object. It assumes that there is a
** speedes.par file to tell it SpeedesServer information.
*/

  EmHostUser = new SpEmHostUser();

/*
** Do the ObjectName call and then print out the NameValueList that is
** returned.
*/

  if (argc == 1) {
    NameValueList = EmHostUser->ObjectNames();
  }else{
    NameValueList = EmHostUser->ObjectNames(argv[1]);
  }

  delete EmHostUser;

  if (NameValueList) {
    NameValueList->Print();
    delete NameValueList;
  }

  return 0;
}
