// SpObjType.C file

#include "SpIostream.H"
#include "SpFstream.H"
#include "SpStrstream.H"
#include "SpIomanip.H"
#include "SpStdlib.H"
#include "SpSignal.H"

#include "SpEmHostUser.H"

SpEmHostUser *EmHostUser = NULL;

void sigintfunc(int) {
  cout << "Interupt" << endl;
  signal(SIGINT, sigintfunc);
  if (EmHostUser) delete EmHostUser;
  EmHostUser = NULL;
  exit(1);
}

/*
*****************************************************************************
* ObjectType: returns the names of the object types in SPEEDES if there are
* no command line arguments. Returns the object manager id if there is one
* command line argument.
*****************************************************************************
*/

int main(int argc, char **argv) {
  int Type;

  signal(SIGINT, sigintfunc);

/*
** Check the arguments
*/

  if (argc > 2) {
    cout << "ObjectType <optional argument - ObjectManagerType>" << endl;
    exit(1);
  }

/*
** Create the External Module Host User object. It assumes that there is a
** speedes.par file to tell it SpeedesServer information.
*/

  EmHostUser = new SpEmHostUser();

/*
** Do the ObjectManagerType call and then print out the returned value.
*/

  if (argc == 1) {
    SpNameValueList *NameValueList = EmHostUser->ObjectManagerTypes();
    delete EmHostUser;
    if (NameValueList) NameValueList->Print();
    if (NameValueList) delete NameValueList;
  }else{
    Type = EmHostUser->ObjectManagerType(argv[1]);
    delete EmHostUser;
    cout << argv[1] << " = " << Type << endl;
  }

  return 0;
}
