// SpQuery.C file

#include "SpIostream.H"
#include "SpFstream.H"
#include "SpStrstream.H"
#include "SpIomanip.H"
#include "SpStdlib.H"
#include "SpSignal.H"

#include "SpEmHostUser.H"

/*
** Create the External Module Host User object. It assumes that there is a
** speedes.par file to tell it SpeedesServer information.
*/

SpEmHostUser EmHostUser;

void sigintfunc(int) {
  cout << "Interupt" << endl;
  signal(SIGINT, sigintfunc);
  exit(1);
}

/*
*****************************************************************************
* Query <ObjectName>: queries the SPEEDES object and prints out the response
*****************************************************************************
*/

int main(int argc, char **argv) {
  SpNameValueList *NameValueList;

  signal(SIGINT, sigintfunc);

/*
** Make sure that there is exactly one argument (the name of the object that
** is being queried).
*/

  if ((argc < 2) || (3 < argc)) {
    cout << "Error, Query <ObjectName>"
	 << " or Query <ObjectName> <QueryName>" << endl;
    exit(1);
  }

/*
** Do the query and then print out the NameValueList that is returned.
*/

  if (argc == 2) {
    NameValueList = EmHostUser.Query(argv[1], "");
  }else{
    NameValueList = EmHostUser.Query(argv[1], argv[2]);
  }

  //delete EmHostUser;

  if (NameValueList) NameValueList->Print();
  delete NameValueList;

  return 0;
}
