// SpScheduleEvent.C file

#include "SpIostream.H"
#include "SpFstream.H"
#include "SpStrstream.H"
#include "SpIomanip.H"
#include "SpStdlib.H"
#include "SpString.H"

#include "SpMsg.H"
#include "SpEmHostUser.H"

int main(int argc, char **argv) {
  SpEmHostUser *EmHostUser;
  SCHEDULE_EVENT_REPLY_MESSAGE* schedReply = NULL;

  if ((argc >= 4) && (argc <= 5)) {
    EmHostUser = new SpEmHostUser();
    SpMsg theM_Underscore;
    double time = strtod(argv[1], NULL);
    char * data = (argc == 5) ? argv[4] : "";
    char * eventName = argv[3];

    cout<<"Scheduling "<<eventName<<" for "<<argv[2]<<" at time "<<time<<endl;
    schedReply = EmHostUser->ScheduleEvent(time, argv[2], eventName,
					   (char*)&theM_Underscore,
					   sizeof(SpMsg),
					   data, strlen(data));
    if (schedReply){
      switch (schedReply->ErrorCode)
	{
	case NOT_SCHEDULED_BECAUSE_IN_PAST:
	  cout<<"Event arrived in past and was ignored"<<endl;
	  break;
	case OBJECT_SPECIFIED_DOES_NOT_EXIST:
	  cout<<"Object specified does not exist.  Schedule is then ignored"
	      <<endl;
	  break;
	case EVENT_SCHEDULED:
	case EVENT_SCHEDULED_AT_GVT:
	  cout<<"Scheduled at time "<<schedReply->Time
	      <<" with cancel handle :=---> "<<schedReply->CancelHandle<<endl;
	  break;
	case EVENT_HANDLER_SCHEDULED:
	case EVENT_HANDLER_SCHEDULED_AT_GVT:
	  cout<<"Scheduled Event at time "<<schedReply->Time
	      <<" with cancel handle :=---> "<<schedReply->CancelHandle<<endl;
	  break;
	default:
	  cout<<"Unknown error code :=--->"<<schedReply->ErrorCode<<endl;
	  break;
	}
      delete schedReply;
    }
    
    delete EmHostUser;
  }else{
    cout << "Error, Command <Time object_name event_name> <data>"<<endl;
  }

  return 0;
}
