// SpSubscribe.C file

#include "SpIostream.H"
#include "SpFstream.H"
#include "SpStrstream.H"
#include "SpIomanip.H"
#include "SpStdlib.H"
#include "SpString.H"
#include "SpSignal.H"

#include "SpEmHostUser.H"

SpEmHostUser *EmHostUser = NULL;
int ARGC_SpSubscribe = 0;
char **ARGV_SpSubscribe = NULL;
/*
** Unsubscribe and delete the EmHostUser when control C is hit by the user
*/

void sigintfunc(int) {
  cout << "Interupt" << endl;
  signal(SIGINT, sigintfunc);

  if (ARGC_SpSubscribe == 3) {

    EmHostUser->UnSubscribe(ARGV_SpSubscribe[2]);

  }else{

    if (!strcasecmp(ARGV_SpSubscribe[1], "OBJECT")) {
      EmHostUser->UnSubscribeObject(ARGV_SpSubscribe[3], ARGV_SpSubscribe[2]);
    }

    if (!strcasecmp(ARGV_SpSubscribe[1], "TYPE")) {
      EmHostUser->UnSubscribeType(ARGV_SpSubscribe[3], ARGV_SpSubscribe[2]);
    }

  }

  if (EmHostUser) delete EmHostUser;
  EmHostUser = NULL;
  exit(1);

}

/*
** Print out an error message that describes what the command line options are
*/

void HandleError() {
    cout << "Error, options are" << endl;
    cout << "Subscribe OBJECT <ObjectName> <SubscriptionType>" << endl;
    cout << "Subscribe TYPE <ObjectType> <SubscriptionType>" << endl;
    cout << "Subscribe ALL <SubscriptionType>" << endl;
    exit(1);
}

/*
*****************************************************************************
* Subscribe sends a subscription request to the Host Router and then tries
* to read messages until control C is hit by the user
*****************************************************************************
*/

int main(int argc, char **argv) {
  char *Data;
  double Time;
  int Bytes;
  int GlobalId;
  char *Name;

  signal(SIGINT, sigintfunc);
  ARGC_SpSubscribe = argc;
  ARGV_SpSubscribe = argv;

  if ((argc < 3) || (argc > 4)) {
    HandleError();
  }

  if (argc == 3) {

    if (!strcasecmp(argv[1], "ALL")) {
      Name = argv[2];
      EmHostUser = new SpEmHostUser();
      EmHostUser->Subscribe(argv[2]);
    }else{
      HandleError();
    }

  }

  if (argc == 4) {

    Name = argv[3];

    if (!strcasecmp(argv[1], "OBJECT")) {
      EmHostUser = new SpEmHostUser();
      EmHostUser->SubscribeObject(argv[3], argv[2]);
    }

    if (!strcasecmp(argv[1], "TYPE")) {
      EmHostUser = new SpEmHostUser();
      EmHostUser->SubscribeType(argv[3], argv[2]);
    }

    if (EmHostUser == NULL) {
      HandleError();
    }

  }

  while (EmHostUser->SpeedesExecuting()) {

    Data = EmHostUser->ReceiveData(Time, Bytes, GlobalId);
    if (Data == NULL) {
      Data = EmHostUser->ReceiveSubscribedData(Name, Time, Bytes, GlobalId);
    }

    if (Data) {
      cout << endl;
      cout << "Got subscribed data at time " << Time
	   << " from " << GlobalId
	   << " with " << Bytes << " bytes" << endl;
      cout << "Data = " << Data << endl;
      delete Data;
    }

  }

  delete EmHostUser;

  return 0;
}
