// SpTime.C file

#include "SpIostream.H"
#include "SpFstream.H"
#include "SpStrstream.H"
#include "SpIomanip.H"
#include "SpStdlib.H"
#include "SpSignal.H"

#include "SpEmHostUser.H"

SpEmHostUser *EmHostUser = NULL;

void sigintfunc(int) {
  cout << "Interupt" << endl;
  signal(SIGINT, sigintfunc);
  if (EmHostUser) delete EmHostUser;
  EmHostUser = NULL;
  exit(1);
}

/*
*****************************************************************************
* Query <ObjectName>: queries the SPEEDES object and prints out the response
*****************************************************************************
*/

int main(int argc, char **argv) {
  double Time;
  double Lag;

  signal(SIGINT, sigintfunc);

/*
** No arguments means just get the time and exit.
*/

  if (argc == 1) {
    EmHostUser = new SpEmHostUser();
    Time = EmHostUser->GetTime();
    delete EmHostUser;
    cout << "Simulation Time = " << Time << endl;
    exit(1);
  }

/*
** One argument is the time lag - the program loops until control C is hit.
*/

  if (argc == 2) {

    cout << argv[1] << endl;
    sscanf(argv[1], "%lf", &Lag);
    cout << "Lag = " << Lag << endl;

    EmHostUser = new SpEmHostUser();
    while (EmHostUser->SpeedesExecuting()) {
      EmHostUser->TimeAdvanceRequest(Lag);
      while (1) {
	if (!EmHostUser->SpeedesExecuting()) {
	  break;
	}
	if (EmHostUser->TimeAdvanceGranted()) break;
      }
      Time = EmHostUser->GetTimeGranted();
      cout << "Simulation Time = " << Time << endl;
    }
  }

  delete EmHostUser;
  EmHostUser = NULL;

  return 0;
}
