// E_SpCancel.C method file

#include "SpStdio.H"
#include "SpTime.H"

#include "E_SpCancel.H"
#include "RB_SpDefineClass.H"
#include "RB_SpBinaryTree.H"

#ifdef __IBMCPP__
namespace {
#endif
RB_DEFINE_CLASS_PRIMATIVE(int)
#ifdef __IBMCPP__
  }
#endif

int E_SpCancel::done = 0;
int E_SpCancel::CANCEL = 0;

/************************************************************************
* E_SpCancel : construct a cancel object					*
************************************************************************/
E_SpCancel::E_SpCancel() {

  if (!done) {
    CANCEL = event_type("CANCEL");
    done = 1;
  }

  set_lazy();

}

/************************************************************************
* init : initialize the event with the message                          *
************************************************************************/
void E_SpCancel::init(SpMsg *header) {
  M_SpCancel *cancel_mess;

  cancel_mess = (M_SpCancel *)header;
  CANCEL_ID = cancel_mess->CANCEL_ID;

}

/************************************************************************
* temp_process : temporarily process event				*
************************************************************************/
void E_SpCancel::temp_process() {
  RB_SpBinaryTree *CancelTree;
  int *element;
  
  element = RB_NEW_int();
  *element = CANCEL_ID;

  if (CANCEL_ID < 0) {
    cout << "Error, negative cancel_id" << endl;
    return;
  }

  CancelTree = SIMOBJ->GetCancelTree();
  if (CancelTree->Find(CANCEL_ID)) {
     cout << "Error, trying to add cancel_item twice" << endl;
  }

  CancelTree->Insert(element, CANCEL_ID);

}

/************************************************************************
* perm_process : permanently process event				*
************************************************************************/
void E_SpCancel::perm_process() {
}
