// E_SpCreate.C method file

#include "SpStdio.H"
#include "SpStdlib.H"
#include "SpTime.H"

#include "SpScheduleEvent.H"

#include "E_SpCreate.H"
#include "SpSimObjMgr.H"

#include "M_SpInitData.H"
EVENT_TYPE(SpInitData);

/************************************************************************
* E_SpCreate : construct a create object					*
************************************************************************/
E_SpCreate::E_SpCreate() {

}

/************************************************************************
* temp_process : temporarily process event				*
************************************************************************/
void E_SpCreate::process() {

//  RB_cout << "Creating SimObj with data: " << DATA << endl;

  SpSimObjMgr *simObjMgr = (SpSimObjMgr *)SIMOBJ;

/*
** Initialize the static variables that are used to set the (about to be
** created) simObj LOCAL_ID and OBJECT_TYPE (note, we add one to the
** N_OBJECT_TYPES since the SpSimObj constructor subtracts one).
*/

  CREATE_MESS *createMess = (CREATE_MESS *)MESSAGE;

  simObjMgr->set_nlobjs(createMess->NewLocalId);
  simObjMgr->set_N_OBJECT_TYPES(OBJECT_TYPE+1);

/*
** Call the constructor for creating the new SimObj
*/

  SpSimObj *simObj1 = simObjMgr->CreateSimObj();

/*
** Initialize the newly created SimObj and then add it to the object manager
*/

  ScheduleEvent(TIME_TAG, SpInitData,
		OBJECT_TYPE,
		simObj1->get_LOCAL_ID(),
		NODE,
		NULL,
		DATA,
		MESSAGE->bytes);

  simObjMgr->add_object(simObj1);

}
