// E_SpEventHandler.C source file implements the event handler event object
// that processes user-provided event handlers.

#include "E_SpEventHandler.H"

E_SpEventHandler::E_SpEventHandler() {

}

void E_SpEventHandler::process() {
  char *eventName;
  int eventNameSize;
  int dataOffset;
  char *data;
  int dataBytes;
  int externalId;

  // type of event handler to invoke; only ones of this
  // type will be invoked as a result of this process() method
  int ehtype; 
  int undirected;


  M_SpEventHandler *EventHandlerEventMessage =
    (M_SpEventHandler *)MESSAGE;

  set_eventHandlerName(eventName = (char *)&EventHandlerEventMessage[1]);

  
  eventNameSize = strlen(eventName) + 1;

//   dataOffset = ( sizeof(double) - (eventNameSize % sizeof(double)) )
//                % sizeof(double);

//   dataOffset = eventNameSize;

  // Align to nearest double
#define ALIGNMENT sizeof(double)  
  dataOffset = ALIGNMENT*(eventNameSize/ALIGNMENT + (eventNameSize%ALIGNMENT?1:0));
#undef ALIGNMENT

  data = &eventName[dataOffset];
  dataBytes = EventHandlerEventMessage->DataBytes;

  externalId = EventHandlerEventMessage->ExternalId;
  ehtype = EventHandlerEventMessage->EHtype;
  undirected = EventHandlerEventMessage->Undirected;

  SIMOBJ->ProcessEventHandlers(eventName,
			       TIME_TAG,
			       data,
			       dataBytes,
			       externalId,
			       ehtype,
			       undirected);
  
}
