// E_SpMasterSimObjMgrUnsubscribe.C source file implements the UnSubscription event.

#include "RB_Types.H"
#include "E_SpMasterSimObjMgrUnsubscribe.H"
#include "SpSubscriptionItem.H"
#include "SubType.H"

#include "RB_SpContainerFuncs.H"

RB_DEFINE_CLASS(SUB_TYPE);

E_SpMasterSimObjMgrUnsubscribe::E_SpMasterSimObjMgrUnsubscribe() {

}

void E_SpMasterSimObjMgrUnsubscribe::process() {
  int i;
  M_SpMasterSimObjMgrUnsubscribe *UnSubscribe_Mess = (M_SpMasterSimObjMgrUnsubscribe *)MESSAGE;
  //M_SpMasterSimObjMgrUnsubscribe *UnSubscribe_Mess1;
  SUBSCRIPTION_ITEM SubItem;
  SpMasterSimObjMgr *Objects;
  SpSimObjMgr *ObjMan;
  char *Buff;
  int DataBytes = UnSubscribe_Mess->bytes;
  C_XQUEUE *ExtSubs;
  SUB_TYPE *SubType;
  int FoundFlag;

  SpSimTime NextTime = TIME_TAG;
  NextTime.IncrementPriority1();

  SubItem.UnPackBuffer((char *)&UnSubscribe_Mess[1]);
//  SubItem.Print();

/*
** This is the case where we are at the SpMasterSimObjMgr class on node 0. In this
** case, we want to schedule this event for all of the object managers on my
** node and for each of the SpMasterSimObjMgr on the other nodes.
*/

  if (OBJECT_TYPE == -1) {

    if (NODE == 0) {
      for (i=1; i<N_NODES; i++) {

	/*UnSubscribe_Mess1 = (M_SpMasterSimObjMgrUnsubscribe *)*/
	  schedule(TIME_TAG, EVENT_TYPE, -1, -1, i, DataBytes, Buff);

	memcpy(Buff, (char *)&UnSubscribe_Mess[1], DataBytes);

      }
    }

    Objects = (SpMasterSimObjMgr *)SIMOBJ;
    for (i=0; i<Objects->GetNmanagers(); i++) {

      /*UnSubscribe_Mess1 = (M_SpMasterSimObjMgrUnsubscribe *)*/
	schedule(NextTime, EVENT_TYPE, i, -1, NODE, DataBytes, Buff);

      memcpy(Buff, (char *)&UnSubscribe_Mess[1], DataBytes);
    }
    
    return;

  }

/*
** This is the case where we are at an objman. In this case, we want to
** schedule an event for every other objman if the SubItem's object type is
** not -1. We then want to schedule an event for every simobj in the
** object manager
*/

  if (LOCAL_ID == -1) {

    if ((NODE == 0) && (SubItem.GetObjectType() != -1)) {
      for (i=1; i<N_NODES; i++) {

	/*UnSubscribe_Mess1 = (M_SpMasterSimObjMgrUnsubscribe *)*/
	  schedule(TIME_TAG, EVENT_TYPE, OBJECT_TYPE, -1, i, DataBytes, Buff);

	memcpy(Buff, (char *)&UnSubscribe_Mess[1], DataBytes);

      }
    }

    ObjMan = (SpSimObjMgr *)SIMOBJ;
    for (i=0; i<ObjMan->get_N_LOC(); i++) {

      /*UnSubscribe_Mess1 = (M_SpMasterSimObjMgrUnsubscribe *)*/
	schedule(NextTime, EVENT_TYPE, OBJECT_TYPE, i, NODE, DataBytes, Buff);

      memcpy(Buff, (char *)&UnSubscribe_Mess[1], DataBytes);
    }

    return;

  }

/*
** If we made it to here, then we are at a simobj. Here, we need to remove
** a subscription item from the simobj's subscription list.
*/

  cout << "UnSubscribing " << SubItem.GetName() << " from object "
       << SIMOBJ->get_NAME() << " <"
       << OBJECT_TYPE << ", "
       << LOCAL_ID << ", "
       << NODE << ">" << endl;

  ExtSubs = SIMOBJ->get_EXTSUBS();
  FoundFlag = 0;
  SubType = (SUB_TYPE *)ExtSubs->get_top();

  for (i=0; i<ExtSubs->get_length(); i++) {

    if (SubType->Compare(SubItem.GetName(), SubItem.GetExternalId())) {
      cout << "Removing subscription" << endl;
      FoundFlag = 1;
      *ExtSubs -= SubType;
      RB_DELETE_SUB_TYPE(SubType);
      break;
    }

    SubType = (SUB_TYPE *)SubType->get_link();

  }

  if (!FoundFlag) {
    cout << "Warning, could not find subscription" << endl;
  }

}


void RB_Register_SUB_TYPE()
{
  RB_REGISTER_CLASS_SUB_TYPE();
}

