// E_SpMonitor.C method file

#include "SpStdio.H"
#include "SpTime.H"

#include "E_SpMonitor.H"

int E_SpMonitor::done = 0;
int E_SpMonitor::MONITOR = 0;

/************************************************************************
* E_SpMonitor : construct a monitor object					*
************************************************************************/
E_SpMonitor::E_SpMonitor() {

  excon = NULL;

  if (!done) {
    done = 1;
    MONITOR = event_type("MONITOR");
  }

}

/************************************************************************
* init : initialize the event with the message                          *
************************************************************************/
void E_SpMonitor::init(SpMsg *header) {
  M_SpMonitor *monitor_mess;

  monitor_mess = (M_SpMonitor *)header;

  exid = monitor_mess->EM_socket;
  flag = monitor_mess->EM_flag;

  if (monitor_mess->EM_interaction & EM_CONNECT) {
    connect = 1;
    excon = new C_EXCON();
    excon->set_id(exid);
    excon->set_flag(flag);
    fprintf(stderr,"MONITOR: connecting to %d\n",(int)id);
  }else{
    connect = 0;
    excon = NULL;
    fprintf(stderr,"MONITOR: disconnecting from %d\n",(int)id);
  }

  if (connect) {

  }


  toggle = connect;
  proc_flag = 0;

}

/************************************************************************
* exchange : exchange the state						*
************************************************************************/
void E_SpMonitor::exchange() {
  C_QUEUE *qmon;

  if (proc_flag) return;
  proc_flag = 1;

  qmon = SIMOBJ->get_qmon();

  if (toggle) {
    qmon->push_top(excon);
    toggle = 0;
  }else{
    excon = (C_EXCON *)qmon->deque(exid);
    if (excon == NULL) {
      fprintf(stderr,"Error, (monitor) could not remove excon\n");
    }
    toggle = 1;
  }

}

/************************************************************************
* temp_process : temporarily process event				*
************************************************************************/
void E_SpMonitor::temp_process() {

}

/************************************************************************
* perm_process : permanently process event				*
************************************************************************/
void E_SpMonitor::perm_process() {

  if (connect == 0) {
    if (excon != NULL) delete excon;
  }
  excon = NULL;

}
