// E_SpPause.C method file

#include "SpStdio.H"

#include "E_SpPause.H"
#include "M_SpPause.H"
#include "RB_SpDefineClass.H"

RB_DEFINE_CLASS(C_ITEM);


// #define GONE 1.0000000001 GEB2

/************************************************************************
* E_SpPause : construct a pause object					*
************************************************************************/
E_SpPause::E_SpPause() {

}

/************************************************************************
* init : initialize the event with the message				*
************************************************************************/
void E_SpPause::init(SpMsg *header) {
  M_SpPause *pause_mess;

  pause_mess = (M_SpPause *)header;
  sockid = pause_mess->EM_socket;
  PauseFlag = pause_mess->PauseFlag;

}

/************************************************************************
* exchange : exchange state variables                                   *
************************************************************************/
void E_SpPause::exchange() {

  if (PauseFlag) {
    if (toggle) {
      SIMOBJ->add_block(item);
      toggle = 0;
    }else{
      SIMOBJ->remove_block(item);
      toggle = 1;
      fprintf(stderr, "This should never be executed\n");
    }
  }

}

/************************************************************************
* temp_process : temporarily process event				*
************************************************************************/
void E_SpPause::temp_process() {

  toggle = 1;
  if (PauseFlag) {
    item = RB_NEW_C_ITEM(new C_ITEM());

    SpSimTime tt = get_time_tag(); //GEB2: 3 lines replace GONE*TIME_TAG stuff
    tt.IncrementPriority1();

    item->set_time_tag(tt);
    // REPLACES THIS:  item->set_time_tag(GONE*TIME_TAG);
    item->set_id(sockid);
  }

}


/************************************************************************
* perm_process : permanently process event				*
************************************************************************/
void E_SpPause::perm_process() {

  if (PauseFlag) {
    cerr << "PAUSING";
  }else{
    cerr << "RESUMING";
  }
  cerr << " simulation at " << TIME_TAG << endl;
}


/************************************************************************
* cleanup : cleanup this event event					*
************************************************************************/
void E_SpPause::cleanup() {

}


