// E_SpSubscribe.C source file implements the subscription event.

#include "E_SpSubscribe.H"
#include "SpSubscriptionItem.H"
#include "SubType.H"

#include "RB_SpContainerFuncs.H"

E_SpSubscribe::E_SpSubscribe() {

}

void E_SpSubscribe::process() {
  int i;
  M_SpSubscribe *Subscribe_Mess = (M_SpSubscribe *)MESSAGE;
  //M_SpSubscribe *Subscribe_Mess1;
  SUBSCRIPTION_ITEM SubItem;
  SpMasterSimObjMgr *Objects;
  SpSimObjMgr *ObjMan;
  char *Buff;
  int DataBytes = Subscribe_Mess->bytes;
  C_XQUEUE *ExtSubs;
  SUB_TYPE *SubType;

  SpSimTime NextTime = TIME_TAG;
  NextTime.IncrementPriority1();

  SubItem.UnPackBuffer((char *)&Subscribe_Mess[1]);
//  SubItem.Print();

/*
** This is the case where we are at the SpMasterSimObjMgr class on node 0. In this
** case, we want to schedule this event for all of the object managers on my
** node and for each of the SpMasterSimObjMgr on the other nodes.
*/

  if (OBJECT_TYPE == -1) {

    if (NODE == 0) {
      for (i=1; i<N_NODES; i++) {

	/*Subscribe_Mess1 = (M_SpSubscribe *)*/
	  schedule(TIME_TAG, EVENT_TYPE, -1, -1, i, DataBytes, Buff);

	memcpy(Buff, (char *)&Subscribe_Mess[1], DataBytes);

      }
    }

    Objects = (SpMasterSimObjMgr *)SIMOBJ;
    for (i=0; i<Objects->GetNmanagers(); i++) {

      /*Subscribe_Mess1 = (M_SpSubscribe *)*/
	schedule(NextTime, EVENT_TYPE, i, -1, NODE, DataBytes, Buff);

      memcpy(Buff, (char *)&Subscribe_Mess[1], DataBytes);
    }
    
    return;

  }

/*
** This is the case where we are at an objman. In this case, we want to
** schedule an event for every other objman if the SubItem's object type is
** not -1. We then want to schedule an event for every simobj in the
** object manager
*/

  if (LOCAL_ID == -1) {

    if ((NODE == 0) && (SubItem.GetObjectType() != -1)) {
      for (i=1; i<N_NODES; i++) {

	/*Subscribe_Mess1 = (M_SpSubscribe *)*/
	  schedule(TIME_TAG, EVENT_TYPE, OBJECT_TYPE, -1, i, DataBytes, Buff);

	memcpy(Buff, (char *)&Subscribe_Mess[1], DataBytes);

      }
    }

    ObjMan = (SpSimObjMgr *)SIMOBJ;
    for (i=0; i<ObjMan->get_N_LOC(); i++) {

      /*Subscribe_Mess1 = (M_SpSubscribe *)*/
	schedule(NextTime, EVENT_TYPE, OBJECT_TYPE, i, NODE, DataBytes, Buff);

      memcpy(Buff, (char *)&Subscribe_Mess[1], DataBytes);
    }

    return;

  }

/*
** If we made it to here, then we are at a simobj. Here, we need to add
** a subscription item to the simobj's subscription list and then wake up the
** simobj by calling its event handler.
*/

  cout << "Subscribing " << SubItem.GetName() << " to object "
       << SIMOBJ->get_NAME() << " <"
       << OBJECT_TYPE << ", "
       << LOCAL_ID << ", "
       << NODE << ">" << endl;

  SubType = new SUB_TYPE(SubItem.GetName(), SubItem.GetExternalId());

  ExtSubs = SIMOBJ->get_EXTSUBS();
  *ExtSubs += SubType;

  SIMOBJ->ProcessEventHandlers(SubItem.GetName(),
			       TIME_TAG,
			       NULL,
			       0,
			       SubItem.GetExternalId());

}
