// PlugInBuiltInEvents.H

#define __IN_BUILTIN_EVENTS__
#include "E_SpInitial.H"
#include "E_SpEventHandler.H"
#include "E_SpCancel.H"
#include "E_SpQuery.H"
#include "E_SpMonitor.H"
#include "E_SpCreate.H"
#include "E_SpDestroy.H"
#include "E_SpPause.H"
#include "E_SpInitData.H"
#include "SpMasterSimObjMgr.H"
#include "SpSimObj.H"
#include "SpBuiltInMacros.H"
#include "ScheduleEvent.H"
#include "SpMasterSimObjMgr.H"

DEFINE_EVENT_METHOD_3_ARG(AddSimObjInteraction,
			  10,
			  SpMasterSimObjMgr,
			  AddSimObjInteraction,
			  SpString80,SpObjHandle,int);

DEFINE_EVENT_METHOD_2_ARG(AddNodeInteraction,
			  10,
			  SpMasterSimObjMgr,
			  AddNodeInteraction,
			  SpString80,NET_INT);

DEFINE_EVENT_METHOD_2_ARG(RemoveSimObjInteraction,
			  10,
			  SpMasterSimObjMgr,
			  RemoveSimObjInteraction,
			  SpString80,int);

DEFINE_EVENT_METHOD_2_ARG(RemoveNodeInteraction,
			  10,
			  SpMasterSimObjMgr,
			  RemoveNodeInteraction,
			  SpString80,NET_INT);


DEFINE_EVENT_METHOD_3_ARG(ScheduleUndirectedEventHandlers,
			  10,
			  SpMasterSimObjMgr,
			  ScheduleUndirectedEventHandlers,
			  SpString80, 
			  NET_INT,NET_INT);
	

void PlugInBuiltInEvents()
{
   PLUG_IN_EVENT(INITIAL_EVENT);
   PLUG_IN_EVENT(EVENT_HANDLER_EVENT);
   PLUG_IN_EVENT(CANCEL);
   PLUG_IN_EVENT(QUERY);
   PLUG_IN_EVENT(MONITOR);
   PLUG_IN_EVENT(CREATE);
   PLUG_IN_EVENT(DESTROY);
   PLUG_IN_EVENT(PAUSE);
   PLUG_IN_EVENT(SpInitData);
   PLUG_IN_EVENT(AddSimObjInteraction);
   PLUG_IN_EVENT(AddNodeInteraction);
   PLUG_IN_EVENT(RemoveSimObjInteraction);
   PLUG_IN_EVENT(RemoveNodeInteraction);
   PLUG_IN_EVENT(ScheduleUndirectedEventHandlers);
   cout << "sizeof(M_AddNodeInteraction) = ";
   cout << sizeof(M_AddNodeInteraction_ARG) << endl;
   M_AddNodeInteraction_ARG addnodemsg;
   cout << "Byte offset of v1 in M_AddNodeInteraction = ";
   cout << (char *) &addnodemsg.v1 - (char *) &addnodemsg << endl;
}

