// SpOptMessager.H header file

#ifndef twosmess_object
#define twosmess_object

#include "SpMsg.H"
#include "SpAntiMsg.H"
#include "SpEvent.H"
#include "holder.H"
#include "SpEventTypes.H"
#include "hash.H"

/************************************************************************
*	twosmess object 						*
************************************************************************/
class SpOptMessager {

  private:

    SpEventTypes *evtype;
    C_HASH *ham;
    C_QUEUE qfree_antimess;
    int nanti;
    int messcount;

    int seed;
    int node;
    int n_nodes;

  protected:

  public:

    SpOptMessager(int nd, int n_nds, SpEventTypes *evt);
    void send_messages(SpEvent *event);
    SpEvent *receive_message(int &status);
    void send_antimessages(SpEvent *event);
    SpEvent *receive_antimessage(int &status);

    SpAntiMsg *new_antimess();
    void delete_antimess(SpAntiMsg *antimess) {
				qfree_antimess.push_top(antimess);}
    void free_antimess(C_QUEUE *qanti, int r);

    void reset_messcount() {messcount = 0;}
    int get_messcount() {return messcount;}
    int check_messcount();

    void print();


};


typedef SpOptMessager C_TWOSMESS;

#endif
