// SpSimObjMgrCreator.C method file

#include "SpStdio.H"
#include "SpSimObjMgrCreator.H"

/************************************************************************
* SpSimObjMgrCreator : construct a base event type object			*
************************************************************************/
SpSimObjMgrCreator::SpSimObjMgrCreator() {
  free_list = NULL;
}

/************************************************************************
* SpSimObjMgrCreator : construct a base event type object			*
************************************************************************/
void SpSimObjMgrCreator::set_ntypes(int n) {
  int i;

  ntypes = n;
  manager_constructor = new manager_constructor_function[ntypes];
  manager = new void*[ntypes];
  name = new char*[ntypes];

  for (i=0; i<ntypes; i++) {
    manager_constructor[i] = NULL;
    manager[i] = NULL;
    name[i] = NULL;
  }

}

/************************************************************************
* get_obid : get the object type id					*
************************************************************************/
int SpSimObjMgrCreator::get_obid(char *nm) {
  int i;

  for (i=0; i<ntypes; i++) {
    if (!strcmp(nm, name[i])) return i;
  }

  fprintf(stderr,"Error, could not find object type %s\n",nm);
  return -1;

}

/************************************************************************
* new_manager : construct an object manager 				*
************************************************************************/
void *SpSimObjMgrCreator::new_manager(int type) {
  void *man;

  if (manager[type] == NULL) {
    manager_constructor_function f = manager_constructor[type];
    man = f();
    manager[type] = man;
  }

  return manager[type];

}

/************************************************************************
* define_manager : define an object manager 				*
************************************************************************/
void SpSimObjMgrCreator::define_manager(char *type, int itype, manager_constructor_function f) {

  manager_constructor[itype] = f;
  name[itype] = strdup(type);

}

