//...... types of events (messages)

#ifndef base_obman_object
#define  base_obman_object

#include "SpAssert.H"
#include "parser.H"
#include "free_list.H"
typedef void * (*manager_constructor_function)();
/************************************************************************
*       base_obman object                                               *
************************************************************************/
class SpSimObjMgrCreator {

  private:
    manager_constructor_function *manager_constructor;

  protected:

    int ntypes;

    void **manager;
    char **name;
    C_FREE_LIST *free_list;

  public:

    SpSimObjMgrCreator();
    void RB_SET_FREE(C_FREE_LIST *f) {free_list = f;}
    C_FREE_LIST *get_free_list() {return free_list;}
    void set_ntypes(int n);
    int get_ntypes() {return ntypes;}
    int get_obid(char *name);
    char *get_obname(int object_type)
    {
      assert(-1 <= object_type);
      assert(object_type < ntypes);
      return object_type == -1 ? "OBJECTS" : name[object_type];
    }
    void *new_manager(int type);
    void define_manager(char *type, int itype, manager_constructor_function f);

};

typedef SpSimObjMgrCreator C_BASE_OBMAN;

#endif
