// O_SpBuiltIn.C source file

#include "O_SpBuiltIn.H"
#include "SpClusterMgr.H"

RB_int O_SpBuiltIn::NumTotCreated = 0;

SpBinaryTree *O_SpBuiltIn::SimObjMgrNames = NULL;
SpBinaryTree *O_SpBuiltIn::SimObjMgrTypes = NULL;

extern SpClusterMgr *GlobalClusterMgr;

//-----------------------------------------------------------------------------
// O_SpBuiltIn constructor
//-----------------------------------------------------------------------------
O_SpBuiltIn::O_SpBuiltIn() {

  Parser = NULL;

  if (SimObjMgrTypes == NULL) {
    SimObjMgrNames = new SpBinaryTree();
    SimObjMgrTypes = new SpBinaryTree();
  }

}

//-----------------------------------------------------------------------------
// GetClusterInfo - returns the number of cluster nodes and my cluster node
// id given a cluster name.
//-----------------------------------------------------------------------------
void O_SpBuiltIn::GetClusterInfo(char *clusterName,
			      int &numClusterNodes,
			      int &clusterNode) {

  GlobalClusterMgr->GetClusterInfo(clusterName, numClusterNodes, clusterNode);

}

//-----------------------------------------------------------------------------
// GetNode - returns the SPEEDES node given cluster name and cluster node
// inputs.
//-----------------------------------------------------------------------------
int O_SpBuiltIn::GetNode(char *clusterName, int clusterNode) {

  return GlobalClusterMgr->GetNodeId(clusterName, clusterNode);

}

//-----------------------------------------------------------------------------
// GetObjHandle - returns the object handle for an object who's name
// is passed in.
//-----------------------------------------------------------------------------
SpObjHandle O_SpBuiltIn::GetObjHandle(char *simObjName) {

  int *num = (int *)SimObjNames.Find(simObjName);

  if (num) {
    return GetObjHandle(*num);
  }else{
    SpObjHandle objHandle;
    objHandle.NodeId   = -1;
    objHandle.ObjManId = -1;
    objHandle.SimObjId = -1;
    return objHandle;
  }

}
