// O_SpBuiltIn.H header file

#ifndef O_SpBuiltInGate
#define O_SpBuiltInGate

#include "SpSimObjMgr.H"
#include "SpDataParser.H"
#include "SpBinaryTree.H"
#include "SpObjHandle.H"
#include "Speedes.H"

//-----------------------------------------------------------------------------
// O_SpBuiltIn class definition
//-----------------------------------------------------------------------------
class O_SpBuiltIn : public SpSimObjMgr {

  private:

  protected:

    static RB_int NumTotCreated;	// cummulative number of objects created
    int NumClusterNodes;	// number of nodes in my cluster
    int ClusterNode;		// my cluster node id
    int Offset;			// numId of my first object
    int FirstClusterNode;	// cluster node with object who's numId=0
    SpDataParser *Parser;	// data parser input file
    SpBinaryTree SimObjNames;	// SimObj names using numId as key

    static SpBinaryTree *SimObjMgrNames; // SimObjMgr pointers by name
    static SpBinaryTree *SimObjMgrTypes; // SimObjMgr pointers by OBJECT_TYPE

  public:

    O_SpBuiltIn();

    void GetClusterInfo(char *clusterName,
		       int &numClusterNodes,
		       int &clusterNode);

    int GetNode(char *clusterName, int clusterNode);

    virtual void DecompInfo(int numTotalObjects,
			    int numClusterNodes,
			    int clusterNode,
			    int &firstClusterNode,
			    int &numLoc,
			    int &offset) = 0;

    virtual SpObjHandle GetObjHandle(int numId) = 0;
    virtual SpObjHandle GetObjHandle(char *simObjName);

    virtual SpSimObj *CreateSimObj()=0;
    virtual void DestroySimObj(SpSimObj *) {
      cout << "Warning, no destructor defined for built-in Mgr" << endl;
    }

    virtual char *GetSimObjMgrName()=0;
    virtual char *GetClusterName() {return NULL;}

    static O_SpBuiltIn *GetSimObjMgr(int type) {
      return (O_SpBuiltIn *)SimObjMgrTypes->Find(type);
    }

    static O_SpBuiltIn *GetSimObjMgr(char *name) {
      return (O_SpBuiltIn *)SimObjMgrNames->Find(name);
    }

    virtual void init_events() {
      for (int i=0; i<N_LOC; i++) {
//	SpSimObj *simObj = 
	get_obj(i);
//	simObj->InitEvents();
      }	
    }

};

inline O_SpBuiltIn *SpGetSimObjMgr(int type) {
  return O_SpBuiltIn::GetSimObjMgr(type);
}

inline O_SpBuiltIn *SpGetSimObjMgr(char *name) {
  return O_SpBuiltIn::GetSimObjMgr(name);
}

#endif
