#include "SpAntiMsg.H"
#include "SpAltAntiMsgChange.H"
#include "RB_SpDefineClass.H"

#ifdef __IBMCPP__
namespace {
#endif
RB_DEFINE_CLASS_PRIMATIVE(char);
#ifdef __IBMCPP__
}
#endif

C_FREE_LIST* SpCurrentFreeList = ( C_FREE_LIST* ) NULL;

/**********************************************************************
 * 
 **********************************************************************/
SpCancelHandle*
RB_NEW_CANCEL_HANDLE()
{
  SpAltAntiMsgChange* altItem;
  SpCancelHandle* handle;

  if( ! SpCurrentAntiMsgFreeList ) {
    SpCurrentAntiMsgFreeList = new C_ANTI_MSG_FREE_LIST;
  }

  handle = ( SpCancelHandle* ) SpCurrentAntiMsgFreeList->new_object( AMESS );

  if( SpCurrentAltMgr->GetOptimistic() ) {
    altItem = ALLOCATE_SpAltAntiMsgChange();
    altItem->Alter( handle, 1 );
    SpCurrentAltMgr->Insert( altItem );
  }

  return handle;
}

/**********************************************************************
 * 
 **********************************************************************/
void
RB_DELETE_CANCEL_HANDLE( SpCancelHandle* handle )
{
  SpAltAntiMsgChange* altItem;

  if( ! SpCurrentAntiMsgFreeList ) {
    SpCurrentAntiMsgFreeList = new C_ANTI_MSG_FREE_LIST;
  }

  if( handle == NULL ) {
    return;
  }

  if( SpCurrentAltMgr->GetOptimistic() ) {
    altItem = ALLOCATE_SpAltAntiMsgChange();
    altItem->Alter( handle, 0 );
    SpCurrentAltMgr->Insert( altItem );
  }
  else {
    ( ( C_ITEM* ) handle )->set_id( AMESS );
    SpCurrentAntiMsgFreeList->delete_object( ( C_ITEM* ) handle );
  }
}

/**********************************************************************
 *
 **********************************************************************/
char*
RB_strdup( char* src ) {
  return( strcpy( RB_NEW_ARRAY_char( strlen( src ) + 1 ), src ) );
}

