#ifndef SpAltBlockChange_Header
#define SpAltBlockChange_Header

#include "queue.H"

#include "SpAlt.H"

/**********************************************************************
 * 
 **********************************************************************/
class SpAltBlockChange : public SpAlt {
public:
  void Alter( C_QUEUE* queue, C_ITEM* block );
  virtual void Cleanup();
  virtual void Rollback();
private:
  C_QUEUE* Queue;
  C_ITEM* Block;
  int RolledBack;
};

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltBlockChange::Alter( C_QUEUE* queue, C_ITEM* block ) {
  Queue = queue;
  Block = block;
  RolledBack = 0;
}

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltBlockChange::Cleanup() {
  if( RolledBack ) {
    delete Block;
  }
}

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltBlockChange::Rollback() {
  if( RolledBack ) {
    Queue->insert_after( Block );
  }
  else {
    Queue->deque( Block );
  }
  RolledBack = ! RolledBack;
}

DEFINE_MEMPOOL( SpAltBlockChange, ALT_CHUNK_SIZE )

#endif

