#ifndef SpAltBufferChange_Header
#define SpAltBufferChange_Header

#include "SpAlt.H"

/**********************************************************************
 * 
 **********************************************************************/
class SpAltBufferChange : public SpAlt {
  typedef void ( *SpDeleteFunc ) ( void* );
public:
  void Alter( SpDeleteFunc deleteFunc, void* valuePtr, int objectExists );
  virtual void Cleanup();
  virtual void Rollback();
private:
  SpDeleteFunc DeleteFunc;
  void* ValuePtr;
  int ObjectExists;
};

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltBufferChange::Alter( SpDeleteFunc deleteFunc, void* valuePtr, int objectExists ) {
  DeleteFunc = deleteFunc;
  ValuePtr = valuePtr;
  ObjectExists = objectExists;
}

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltBufferChange::Cleanup() {
  if( ! ObjectExists ) {
    DeleteFunc( ValuePtr );
  }
}

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltBufferChange::Rollback() {
  ObjectExists = ! ObjectExists;
}

DEFINE_MEMPOOL( SpAltBufferChange, ALT_CHUNK_SIZE )

#endif

