#ifndef SpAltDoubleDivisor_Header
#define SpAltDoubleDivisor_Header

#include "SpAlt.H"

/**********************************************************************
 * 
 **********************************************************************/
class SpAltDoubleDivisor : public SpAlt {
public:
  void Alter( double* valuePtr, double divisor );
  virtual void Rollback();
private:
  double* ValuePtr;
  double Divisor;
  double Value;
  int RolledBack;
};

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltDoubleDivisor::Alter( double* valuePtr, double divisor ) {
  ValuePtr = valuePtr;
  Value = *ValuePtr;
  Divisor = divisor;
  RolledBack = 0;
}

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltDoubleDivisor::Rollback() {
  if( RolledBack ) {
    *ValuePtr /= Divisor;
  }
  else {
    *ValuePtr = Value;
  }
  RolledBack = ! RolledBack;
}

DEFINE_MEMPOOL( SpAltDoubleDivisor, ALT_CHUNK_SIZE )

#endif

