#ifndef SpAltDoubleFactor_Header
#define SpAltDoubleFactor_Header

#include "SpAlt.H"

/**********************************************************************
 * 
 **********************************************************************/
class SpAltDoubleFactor : public SpAlt {
public:
  void Alter( double* valuePtr, double factor );
  virtual void Rollback();
private:
  double* ValuePtr;
  double Factor;
  double Value;
  int RolledBack;
};


/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltDoubleFactor::Alter( double* valuePtr, double factor ) {
  ValuePtr = valuePtr;
  Value = *ValuePtr;
  Factor = factor;
  RolledBack = 0;
}


/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltDoubleFactor::Rollback() {
  if( RolledBack ) {
    *ValuePtr *= Factor;
  }
  else {
    *ValuePtr = Value;
  }
  RolledBack = ! RolledBack;
}

DEFINE_MEMPOOL( SpAltDoubleFactor, ALT_CHUNK_SIZE )

#endif

