#ifndef SpAltHostDataSend_Header
#define SpAltHostDataSend_Header

#include "SpHostUser.H"

#include "SpAlt.H"

/**********************************************************************
 * 
 **********************************************************************/
class SpAltHostDataSend : public SpAlt {
public:
  void Alter( SpHostUser* hostUser, char* data, int externalID, int globalID, int bytes, SpSimTime time );
  virtual void Cleanup();
  virtual void Rollback();
private:
  SpHostUser* HostUser;
  char* Data;
  int ExternalID;
  int GlobalID;
  int Bytes;
  int Send;
  SpSimTime Time;
};

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltHostDataSend::Alter( SpHostUser* hostUser, char* data, int externalID, int globalID, int bytes, SpSimTime time ) {
  HostUser = hostUser;
  Data = ( char* ) malloc( bytes );
  memcpy( Data, data, bytes );
  ExternalID = externalID;
  GlobalID = globalID;
  Bytes = bytes;
  Send = 1;
  Time = time;
}

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltHostDataSend::Cleanup() {
  if( Send ) {
    HostUser->SendData( Time, ExternalID, Data, Bytes, GlobalID );
  }
  free( Data );
}

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltHostDataSend::Rollback() {
  Send = ! Send;
}

DEFINE_MEMPOOL( SpAltHostDataSend, ALT_CHUNK_SIZE )

#endif

