#ifndef SpAltIntAnd_Header
#define SpAltIntAnd_Header

#include "SpAlt.H"

/**********************************************************************
 * 
 **********************************************************************/
class SpAltIntAnd : public SpAlt {
public:
  void Alter( int* valuePtr, int mask );
  virtual void Rollback();
private:
  int* ValuePtr;
  int Mask;
  int Value;
  int RolledBack;
};

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltIntAnd::Alter( int* valuePtr, int mask ) {
  ValuePtr = valuePtr;
  Value = *ValuePtr;
  Mask = mask;
  RolledBack = 0;
}

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltIntAnd::Rollback() {
  if( RolledBack ) {
    *ValuePtr &= Mask;
  }
  else {
    *ValuePtr = Value;
  }
  RolledBack = ! RolledBack;
}

DEFINE_MEMPOOL( SpAltIntAnd, ALT_CHUNK_SIZE )

#endif

