#ifndef SpAltIntFactor_Header
#define SpAltIntFactor_Header

#include "SpAlt.H"

/**********************************************************************
 * 
 **********************************************************************/
class SpAltIntFactor : public SpAlt {
public:
  void Alter( int* valuePtr, int factor );
  virtual void Rollback();
private:
  int* ValuePtr;
  int Factor;
  int Value;
  int RolledBack;
};

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltIntFactor::Alter( int* valuePtr, int factor ) {
  ValuePtr = valuePtr;
  Value = *ValuePtr;
  Factor = factor;
  RolledBack = 0;
}

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltIntFactor::Rollback() {
  if( RolledBack ) {
    *ValuePtr *= Factor;
  }
  else {
    *ValuePtr = Value;
  }
  RolledBack = ! RolledBack;
}

DEFINE_MEMPOOL( SpAltIntFactor, ALT_CHUNK_SIZE )

#endif

