#ifndef SpAltIntOr_Header
#define SpAltIntOr_Header

#include "SpAlt.H"

/**********************************************************************
 * 
 **********************************************************************/
class SpAltIntOr : public SpAlt {
public:
  void Alter( int* valuePtr, int mask );
  virtual void Rollback();
private:
  int* ValuePtr;
  int Mask;
  int Value;
  int RolledBack;
};

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltIntOr::Alter( int* valuePtr, int mask ) {
  ValuePtr = valuePtr;
  Value = *ValuePtr;
  Mask = mask;
  RolledBack = 0;
}

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltIntOr::Rollback() {
  if( RolledBack ) {
    *ValuePtr |= Mask;
  }
  else {
    *ValuePtr = Value;
  }
  RolledBack = ! RolledBack;
}

DEFINE_MEMPOOL( SpAltIntOr, ALT_CHUNK_SIZE )

#endif

