#ifndef SpAltIntRemainder_Header
#define SpAltIntRemainder_Header

#include "SpAlt.H"

/**********************************************************************
 * 
 **********************************************************************/
class SpAltIntRemainder : public SpAlt {
public:
  void Alter( int* valuePtr, int divisor );
  virtual void Rollback();
private:
  int* ValuePtr;
  int Divisor;
  int Value;
  int RolledBack;
};

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltIntRemainder::Alter( int* valuePtr, int divisor ) {
  ValuePtr = valuePtr;
  Value = *ValuePtr;
  Divisor = divisor;
  RolledBack = 0;
}

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltIntRemainder::Rollback() {
  if( RolledBack ) {
    *ValuePtr %= Divisor;
  }
  else {
    *ValuePtr = Value;
  }
  RolledBack = ! RolledBack;
}

DEFINE_MEMPOOL( SpAltIntRemainder, ALT_CHUNK_SIZE )

#endif

