#ifndef SpAltMemoryExchange_Header
#define SpAltMemoryExchange_Header

#include "SpString.H"

#include "SpAlt.H"

/**********************************************************************
 * 
 **********************************************************************/
class SpAltMemoryExchange : public SpAlt {
public:
  void Alter( void* value1, void* value2, size_t size );
  virtual void Rollback();
private:
  void* Value1;
  void* Value2;
  size_t Size;
};

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltMemoryExchange::Alter( void* value1, void* value2, size_t size ) {
  Value1 = value1;
  Value2 = value2;
  Size = size;
}

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltMemoryExchange::Rollback() {
  void* temp;

  temp = malloc( Size );
  memcpy( temp, Value1, Size );
  memcpy( Value1,Value2, Size );
  memcpy( Value2, temp, Size );
  free( temp );
}

DEFINE_MEMPOOL( SpAltMemoryExchange, ALT_CHUNK_SIZE )

#endif

