#ifndef SpAltMemoryValue_Header
#define SpAltMemoryValue_Header

#include "SpStdlib.H"
#include "SpString.H"

#include "SpAlt.H"

/**********************************************************************
 * 
 **********************************************************************/
class SpAltMemoryValue : public SpAlt {
public:
  void Alter( void* valuePtr, size_t size );
  virtual void Cleanup();
  virtual void Rollback();
private:
  void* ValuePtr;
  void* Value;
  size_t Size;
};

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltMemoryValue::Alter( void* valuePtr, size_t size ) {
  ValuePtr = valuePtr;
  Size = size;
  Value = malloc( Size );
  memcpy( Value, ValuePtr, Size );
}

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltMemoryValue::Cleanup() {
  free( Value );
}

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltMemoryValue::Rollback() {
  void* temp;

  temp = malloc( Size );
  memcpy( temp, ValuePtr, Size );
  memcpy( ValuePtr, Value, Size );
  free( Value );
  Value = temp;
}

DEFINE_MEMPOOL( SpAltMemoryValue, ALT_CHUNK_SIZE )

#endif

