#ifndef SpAltObjectChange_Header
#define SpAltObjectChange_Header

#include "SpFreeList.H"

#include "SpAlt.H"

/**********************************************************************
 * 
 **********************************************************************/
class SpAltObjectChange : public SpAlt {
public:
  void Alter( C_FREE_LIST* freelist, C_ITEM* valuePtr, int objectExists );
  virtual void Cleanup();
  virtual void Rollback();
private:
  C_FREE_LIST* Freelist;
  C_ITEM* ValuePtr;
  int ObjectExists;
};

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltObjectChange::Alter( C_FREE_LIST* freelist, C_ITEM* valuePtr, int objectExists ) {
  Freelist = freelist;
  ValuePtr = valuePtr;
  ObjectExists = objectExists;
}

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltObjectChange::Cleanup() {
  if( ! ObjectExists ) {
    Freelist->delete_object( ValuePtr );
  }
}

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltObjectChange::Rollback() {
  ObjectExists = ! ObjectExists;
}

DEFINE_MEMPOOL( SpAltObjectChange, ALT_CHUNK_SIZE )

#endif

