#ifndef SpAltOstreamPut_Header
#define SpAltOstreamPut_Header

#include "SpIostream.H"

#include "SpAlt.H"
#include "SpSimTime.H"
#include "SpString.H"


typedef ostream& ( *SpOmanip ) ( ostream& );

/**********************************************************************
 * 
 **********************************************************************/
class SpAltOstreamPut : public SpAlt {
public :
  virtual void Rollback();
protected:
  int RolledBack;
  ostream* Ostream;
};

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltOstreamPut::Rollback() {
  RolledBack = ! RolledBack;
}

/**********************************************************************
 * 
 **********************************************************************/
#define DEFINE_ALT_OSTREAM_TYPE_BY_NAME( type, name )			\
									\
class SpAltOstreamPut##name : public SpAltOstreamPut {			\
private:								\
  type Data;								\
public :								\
  void Alter( ostream* ostream, type data );				\
  virtual void Cleanup();						\
};									\
									\
inline									\
void									\
SpAltOstreamPut##name##::Alter( ostream* ostream, type data ) {		\
  Ostream = ostream;							\
  Data = data;								\
  RolledBack = 0;							\
}									\
									\
inline									\
void									\
SpAltOstreamPut##name##::Cleanup() {					\
  if( ! RolledBack ) {							\
    *Ostream << Data;							\
  }									\
}									\
									\
DEFINE_MEMPOOL( SpAltOstreamPut##name##, ALT_CHUNK_SIZE )		\
/*********************************************************************/

/**********************************************************************
 * 
 **********************************************************************/
#define DEFINE_ALT_OSTREAM_QUAL_TYPE_BY_NAME( qual, type, name )	\
									\
class SpAltOstreamPut##name : public SpAltOstreamPut {			\
private:								\
  qual type Data;							\
public :								\
  void Alter( ostream* ostream, qual type data );			\
  virtual void Cleanup();						\
};									\
									\
inline									\
void									\
SpAltOstreamPut##name##::Alter( ostream* ostream, qual type data ) {	\
  Ostream = ostream;							\
  Data = data;								\
  RolledBack = 0;							\
}									\
									\
inline									\
void									\
SpAltOstreamPut##name##::Cleanup() {					\
  if( ! RolledBack ) {							\
    *Ostream << Data;							\
  }									\
}									\
									\
DEFINE_MEMPOOL( SpAltOstreamPut##name##, ALT_CHUNK_SIZE )		\
/*********************************************************************/

/**********************************************************************
 * 
 **********************************************************************/
#define DEFINE_ALT_OSTREAM_STR_TYPE_BY_NAME( type, name )		\
									\
class SpAltOstreamPut##name : public SpAltOstreamPut {			\
private:								\
  type Data;								\
public :								\
  void Alter( ostream* ostream, type data );				\
  virtual void Cleanup();						\
};									\
									\
inline									\
void									\
SpAltOstreamPut##name##::Alter( ostream* ostream, type data ) {		\
  Ostream = ostream;							\
  if (data==NULL)                                                       \
    Data = "(null)";							\
  else							                \
    Data = strdup( ( char* ) data );					\
  RolledBack = 0;							\
}									\
									\
inline									\
void									\
SpAltOstreamPut##name##::Cleanup() {					\
  if( ! RolledBack ) {							\
    *Ostream << Data;							\
  }									\
  free( ( void* )Data );						\
}									\
									\
DEFINE_MEMPOOL( SpAltOstreamPut##name##, ALT_CHUNK_SIZE )		\
/*********************************************************************/

/**********************************************************************
 * 
 **********************************************************************/
#define DEFINE_ALT_OSTREAM_QUAL_STR_TYPE_BY_NAME( qual, type, name )	\
									\
class SpAltOstreamPut##name : public SpAltOstreamPut {			\
private:								\
  qual type Data;							\
public :								\
  void Alter( ostream* ostream, qual type data );			\
  virtual void Cleanup();						\
};									\
									\
inline									\
void									\
SpAltOstreamPut##name##::Alter( ostream* ostream, qual type data ) {	\
  Ostream = ostream;							\
  if (data==NULL)							\
    Data = NULL;							\
  else				                  			\
    Data = (qual type) strdup( (char *) data );				\
  RolledBack = 0;							\
}									\
									\
inline									\
void									\
SpAltOstreamPut##name##::Cleanup() {					\
  if( ! RolledBack ) {							\
    *Ostream << Data;							\
  }									\
  free( ( void* ) Data );						\
}									\
									\
DEFINE_MEMPOOL( SpAltOstreamPut##name##, ALT_CHUNK_SIZE )		\
/*********************************************************************/

DEFINE_ALT_OSTREAM_TYPE_BY_NAME( char, Char )
DEFINE_ALT_OSTREAM_TYPE_BY_NAME( short, Short )
DEFINE_ALT_OSTREAM_TYPE_BY_NAME( int, Int )
DEFINE_ALT_OSTREAM_TYPE_BY_NAME( long, Long )
DEFINE_ALT_OSTREAM_QUAL_TYPE_BY_NAME( unsigned, char, UnsignedChar )
DEFINE_ALT_OSTREAM_QUAL_TYPE_BY_NAME( unsigned, short, UnsignedShort )
DEFINE_ALT_OSTREAM_QUAL_TYPE_BY_NAME( unsigned, int, UnsignedInt )
DEFINE_ALT_OSTREAM_QUAL_TYPE_BY_NAME( unsigned, long, UnsignedLong )
DEFINE_ALT_OSTREAM_TYPE_BY_NAME( float, Float )
DEFINE_ALT_OSTREAM_TYPE_BY_NAME( double, Double )
DEFINE_ALT_OSTREAM_TYPE_BY_NAME( void*, VoidPtr )
DEFINE_ALT_OSTREAM_STR_TYPE_BY_NAME( char*, CharPtr )
DEFINE_ALT_OSTREAM_QUAL_STR_TYPE_BY_NAME( const, char*, ConstCharPtr )
DEFINE_ALT_OSTREAM_QUAL_STR_TYPE_BY_NAME( unsigned, char*, UnsignedCharPtr )
DEFINE_ALT_OSTREAM_TYPE_BY_NAME( SpOmanip, Omanip )
DEFINE_ALT_OSTREAM_TYPE_BY_NAME( SpSimTime, SpSimTime )

#endif

