#ifndef SpAltSubscribedDataSend_Header
#define SpAltSubscribedDataSend_Header

#include "SpHostUser.H"

#include "SpAlt.H"

/**********************************************************************
 * 
 **********************************************************************/
class SpAltSubscribedDataSend : public SpAlt {
public:
  void Alter( SpHostUser* hostUser, char* data, char* name, int globalID, int bytes, double time );
  virtual void Cleanup();
  virtual void Rollback();
private:
  SpHostUser* HostUser;
  char* Data;
  char* Name;
  int GlobalID;
  int Bytes;
  int Send;
  double Time;
};

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltSubscribedDataSend::Alter( SpHostUser* hostUser, char* data, char* name, int globalID, int bytes, double time ) {
  HostUser = hostUser;
  Data = ( char* ) malloc( bytes );
  memcpy( Data, data, bytes );
  Name = strdup( name );
  GlobalID = globalID;
  Bytes = bytes;
  Send = 1;
  Time = time;
}

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltSubscribedDataSend::Cleanup() {
  if( Send ) {
    HostUser->SendSubscribedData( Time, Name, Data, Bytes, GlobalID );
  }
  free( Data );
  free( Name );
}

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltSubscribedDataSend::Rollback() {
  Send = ! Send;
}

DEFINE_MEMPOOL( SpAltSubscribedDataSend, ALT_CHUNK_SIZE )

#endif

