// SpEventHandler.C source file

#include "SpEventHandler.H"
#include "RB_SpDefineClass.H"
RB_DEFINE_CLASS(SpEventHandler);

int SpBaseEventHandler::Node = 0;

SpBaseEventHandler::SpBaseEventHandler(enum SpEventHandlerType ehType): 
  Component(NULL), EHtype(ehType) {}

void SpEventHandler::ProcessEventHandler(char *eventName, SpSimTime &timeTag,
					 char *data, int dataBytes,
					 int externalId)
{
   Process(eventName, timeTag, data, dataBytes, externalId);
}



// This method determines which kind of string-based event handler
// this is. If an SpInteractionHandler, it unpacks an SpParmSet and 
// passes this argument to the virtual Process(SpParmSet *) function.
// Otherwise, it passes arguments to Process() appropriate to a 
// legacy SpEventHandler, 


void SpEventHandler::Process(char *, SpSimTime &, char *,
			     int , int) {}

void SpInteractionHandler::ProcessEventHandler(char *,
					       SpSimTime &, char *data,
					       int dataBytes, int)
{
  // Restore paramset from data buffer
  SpParmSet paramset(data,dataBytes);
  Process(paramset);
}


void RB_Register_SpEventHandler()
{
  RB_REGISTER_CLASS_SpEventHandler();
}


