// SpMasterSimObjMgr.C method file

#include "SpStdio.H"
#include "SpString.H"

#include "RB_SpDefineClass.H"
#ifdef __IBMCPP__
namespace {
#endif
RB_DEFINE_CLASS_PRIMATIVE(char);
RB_DEFINE_CLASS_PRIMATIVE(PO_VOID_TYPE_CLASS);
#define PO_VOID_TYPE_CLASS_DEFINED
#define PO_DEFINED_CHAR
#ifdef __IBMCPP__
}
#endif

#include "speedes_comm.H"
#include "SpMasterSimObjMgr.H"
#include "SpEvent.H"
#include "RB_Types.H"
#include "RB_SpFrameworkFuncs.H"
#include "SpScheduleEvent.H"
#include "E_SpEventHandler.H"
#include "SpNetTypes.H"
#include "SpTag.H"
#include "RB_SpDefineClass.H"
#include "SpPoDataBase.H"


#include "RB_SpHashTree.H"

RB_DEFINE_CLASS(SpInteractionName);
RB_DEFINE_CLASS(SpObjHandle);

extern SpTag *CurrentTag;

//RB_DEFINE_CLASS(SpObjHandle);
//RB_DEFINE_CLASS(SpInteractionName);

#define REMOTELYSCHEDULED 0

extern SpEvent *CurrentEvent;


DEFINE_EVENT_METHOD_3_ARG(AddSimObjInteraction,
			  10,
			  SpMasterSimObjMgr,
			  AddSimObjInteraction,
			  SpString80,SpObjHandle,int);

DEFINE_EVENT_METHOD_2_ARG(AddNodeInteraction,
			  10,
			  SpMasterSimObjMgr,
			  AddNodeInteraction,
			  SpString80,NET_INT);

DEFINE_EVENT_METHOD_2_ARG(RemoveSimObjInteraction,
			  10,
			  SpMasterSimObjMgr,
			  RemoveSimObjInteraction,
			  SpString80,int);

DEFINE_EVENT_METHOD_2_ARG(RemoveNodeInteraction,
			  10,
			  SpMasterSimObjMgr,
			  RemoveNodeInteraction,
			  SpString80,NET_INT);

// DECLARE_3_ARG(ScheduleUndirectedEventHandlers,
// 	      SpString80,
// 	      int,
// 	      int
// 	      );


// DEFINE_EVENT_METHOD_3_ARG(ScheduleUndirectedEventHandlers,
// 			  10,
// 			  SpMasterSimObjMgr,
// 			  ScheduleUndirectedEventHandlers,
// 			  SpString80, 
// 			  int,int);
			  
			  

/************************************************************************
* SpMasterSimObjMgr : construct a objects object				*
************************************************************************/
SpMasterSimObjMgr::SpMasterSimObjMgr(): Interactions(NULL) {
  if (SpPoDataBase::DoNotAllocateMemoryInConstructor){
    cout<<"Creating a SpMasterSimObjMgr with persistence"<<endl;
  }
  else{
    int i;
    SpEvent *event;
    SpSimObjMgrTypes *obman_temp;

    event = NULL;			// do this on purpose!!!
    event->set_objects(this);

    OBJECT_TYPE = -1;
    LOCAL_ID = -1;

    init_objs();

    obman_temp = get_obman();
    ntypes = obman_temp->get_ntypes();
    objman = new SpSimObjMgr*[ntypes];
    ManagerName = new char *[ntypes];

    for (i=0; i<ntypes; i++) {
      objman[i] = (SpSimObjMgr *)obman_temp->new_manager(i);
      char *TempName = ((SpSimObjMgr *)obman_temp)->get_obname(i);
      ManagerName[i] = strdup(TempName);
      if (objman[i]->get_NAME() == NULL) {
	objman[i]->set_NAME(strdup(TempName));
      }
      objman[i]->combine_total_objects();
    }

    /*
  for (i=0; i<ntypes; i++) {
    go = get_obj(i,0);
    temp = go->get_unique_id();
    scombine(&temp,SP_MININT,sizeof(temp),1);
    fprintf(stderr, "%d.) first unique id = %d\n",i,temp);
  }
*/

    printf("OBJECTS created\n");
  }
}

/************************************************************************
* init_events : initialize the events					*
************************************************************************/
void SpMasterSimObjMgr::init_events() {
  int i;

  for (i=0; i<ntypes; i++) objman[i]->init_events();

}

/************************************************************************
* term : call the term method for all object manager, which will call	*
* 	 the Terminate virtual function for all object managers and	*
*	 their simobjs.							*
************************************************************************/
void SpMasterSimObjMgr::term(double tend) {
  int i;

  for (i=0; i<ntypes; i++) {
    objman[i]->term(tend);
  }

}

/************************************************************************
* CriticalPathTime : Determines the critical path of the simulation.	*
*		     This method should be  called at the end of the	*
*		     simulation						*
************************************************************************/
void SpMasterSimObjMgr::ComputeCriticalPath(double &CPU_Time,
				    double &criticalPathTime,
				    double &maxSpeedup) {
  int i;

  criticalPathTime = 0.0;
  CPU_Time = 0.0;

  for (i=0; i<ntypes; i++) {
    objman[i]->ComputeCriticalPath(CPU_Time, criticalPathTime);
  }

  CPU_Time = SpComm_GlobalSum(CPU_Time);
  criticalPathTime = SpComm_GlobalMax(criticalPathTime);
  maxSpeedup = CPU_Time / criticalPathTime;

}

/************************************************************************
* get_allids : get a buffer of all object ids				*
************************************************************************/
char *SpMasterSimObjMgr::get_allids(int &size) {
  int i;
  int size1;
  char *buff;
  char *buff1;

  size = 0;
  for (i=0; i<ntypes; i++) {
    size += objman[i]->get_allids_size();
  }

  if (size == 0) return NULL;

  buff = new char[size];

  size = 0;
  for (i=0; i<ntypes; i++) {
    size1 = objman[i]->get_allids_size();
    buff1 = objman[i]->get_allids();
    memcpy(&buff[size], buff1, size1);
    delete [] buff1;
    size += size1;
  }

  return buff;

}

/************************************************************************
* print : print out the object states					*
************************************************************************/
void SpMasterSimObjMgr::print() {
  int i,j,n;
  SpSimObj *simobj;

  for (i=0; i<ntypes; i++) {
    n = objman[i]->get_N_LOC();
    for (j=0; j<n; j++) {
      simobj = objman[i]->get_obj(j);
      simobj->print();
    }
  }

}


/***************************************************/
/*  Add simobj as subscriber to an interaction     */
/***************************************************/
void SpMasterSimObjMgr::AddSimObjInteraction(SpString80 key,
					     SpObjHandle oh,int uniqueID)
{
  if (!Interactions) {
    Interactions = new RB_SpBinaryTree();
    Interactions->SetBalancedTreeMode();
  }
  SpInteractionName *iname = (SpInteractionName *) Interactions->Find(key);
  if (!iname) {
    iname = RB_NEW_SpInteractionName(new SpInteractionName(this));
    Interactions->Insert(iname,key);

  }
  if (!iname->LocalRecipients->GetNumElements()) {
    // If this is the first such interaction to which an object
    // on this node has subscribed, then broadcast to all other
    // nodes that this node is itself a subscriber to this 
    // interaction
    int remotenode;
    int totalnodes = get_N_NODES();
    int thisnode = get_NODE();
    SpObjHandle remotemgr;
    for (remotenode=0; remotenode<totalnodes; remotenode++) {
      if (remotenode != thisnode) {
	remotemgr.NodeId = remotenode;
	remotemgr.ObjManId = -1;
	remotemgr.SimObjId = -1;
	// the current time is given by
	// CurrentEvent->TIME_TAG.GetTime()
	// I'd rather just write the first argument to the
	// next function as NOW 
	ScheduleAddNodeInteraction(GetTime(),remotemgr, key, thisnode);
	
      }
    }
  }
  SpObjHandle *noh = RB_NEW_SpObjHandle(); 
  RB_memcpy((char *) noh,(char *) &oh,sizeof(SpObjHandle));
  
  iname->LocalRecipients->Insert((void *) noh, uniqueID);
}

/***************************************************/
/*  Add node as subscriber to an interaction       */
/***************************************************/
void SpMasterSimObjMgr::AddNodeInteraction(SpString80 key,
					   NET_INT node)
{
  if (!Interactions) {
    Interactions = new RB_SpBinaryTree();
    Interactions->SetBalancedTreeMode();
  }
  SpInteractionName *iname = (SpInteractionName *) Interactions->Find(key);
  if (!iname) {
    iname = RB_NEW_SpInteractionName(new SpInteractionName(this));
    Interactions->Insert(iname,key);
  }
  SpDestination tmp_dest(get_N_NODES());
  memcpy(tmp_dest.GetDestination(),iname->RemoteNodes.GetDestination(),
	 iname->RemoteNodes.GetNbytes());

  tmp_dest.Set(node);
  // Kludge to make SpDestination work with rollbacks
//   RB_memcpy((char *) &iname->RemoteNodes,(char *)&tmp_dest,
// 	    sizeof(SpDestination));
  RB_memcpy(iname->RemoteNodes.GetDestination(),
	    tmp_dest.GetDestination(),tmp_dest.GetNbytes());
}

// This event method allows a simobj to unsubscribe itself 
// from an interaction
void SpMasterSimObjMgr::RemoveSimObjInteraction(SpString80 key,
						int uniqueID)
{
  //SpObjHandle *subscriber;
  SpInteractionName *iname;
  if (Interactions) {
    if ((iname = (SpInteractionName *)Interactions->Find(key))) {
      if (/*subscriber = */(SpObjHandle *)iname->LocalRecipients->Find(uniqueID)) {
	iname->LocalRecipients->Remove(uniqueID);
	if (!iname->LocalRecipients->GetNumElements()) {
	  // Unsubscribe this node if no subscribed simobjs remain
	  int remotenode;
	  int totalnodes = get_N_NODES();
	  int thisnode = get_NODE();
	  SpObjHandle remotemgr;
	  for(remotenode=0; remotenode<totalnodes; remotenode++) {
	    if (remotenode != thisnode) {
	      remotemgr.NodeId = remotenode;
	      remotemgr.ObjManId = -1;
	      remotemgr.SimObjId = -1;
	      ScheduleRemoveNodeInteraction(CurrentEvent->TIME_TAG.GetTime(),
					    remotemgr, key, thisnode);
	    }
	  }
	  // Delete this interaction name from Interactions table
	  delete iname;
	  Interactions->Remove(key);
	}
      }
    }
  }
}

// This event method is invoked indirectly when the last simobj
// on a node unsubscribes itself from an interaction. Then the
// node in turn unsubscribes from the interaction by scheduling
// this event method on each of its fellow nodes
void SpMasterSimObjMgr::RemoveNodeInteraction(SpString80 key,NET_INT node)
{
  SpInteractionName *iname;
  if (Interactions) {
    if ((iname = (SpInteractionName *) Interactions->Find(key))) {  
      iname->RemoteNodes.Reset(node);
    }
  }
}

// This event method schedules event handler events for each of
// the simobjs that have subscribed with the master simobj mgr
// to receive event handler events identified by key, of type
// ehtype
void SpMasterSimObjMgr::ScheduleUndirectedEventHandlers(
						      SpString80 key, 
						      NET_INT ehType,
						      NET_INT locallyScheduled)
{

  if (Interactions) {
    SpInteractionName *iname = (SpInteractionName *) Interactions->Find(key);
    if (iname) {
      SpObjHandle *oh = (SpObjHandle *) iname->
	LocalRecipients->GetFirstElement();
//       char *buff;
//       char *data = GetData();
//       int datasize = GetDataBytes();
//       int offset;
//       int keylength = strlen(key)+1;
// #define ALIGNMENT sizeof(double)      
//       offset = ALIGNMENT*(keylength/ALIGNMENT + (keylength%ALIGNMENT?1:0));
// #undef ALIGNMENT

      while (oh) {
	*CurrentTag << "SpMasterSimObjMgr::ScheduleUndirected";
	*CurrentTag << "\n" << endl;
	ScheduleEventHandler(GetTime(),key,oh,GetData(),GetDataBytes(),
			     (enum SpEventHandlerType) (int) ehType);

// 	SpCancelHandle cancelHandle;
// 	M_SpEventHandler *eventHandlerEventMsg = (M_SpEventHandler *)
// 	  CurrentEvent->schedule(&cancelHandle,
// 				 GetTime(),
// 				 EVENT_HANDLER_EVENT,
// 				 oh->ObjManId,
// 				 oh->SimObjId,
// 				 oh->NodeId,
// 				 datasize+offset,
// 				 buff);
	
// 	eventHandlerEventMsg->DataBytes = datasize;
// 	eventHandlerEventMsg->ExternalId = -1;
// 	eventHandlerEventMsg->EHtype = ehType;
// 	eventHandlerEventMsg->Undirected = 1;
// 	strcpy(buff, key);

// 	if (datasize > 0) {
// 	  buff += offset;
// 	  memcpy(buff, data, datasize);
// 	}
	oh = (SpObjHandle *) iname->LocalRecipients->GetNextElement();
      }
      
      if (locallyScheduled) {
	int remotenodenumber=iname->RemoteNodes.GetFirstNode();
	int thisnode = get_NODE();

	while(remotenodenumber>=0) {
	  if (remotenodenumber != thisnode) {
	    SpObjHandle remotemgr;
	    remotemgr.NodeId = remotenodenumber;
	    remotemgr.ObjManId = -1;
	    remotemgr.SimObjId = -1;

	    ScheduleScheduleUndirectedEventHandlers(
						    GetTime(),
						    remotemgr,
						    key,
						    ehType,
						    REMOTELYSCHEDULED,
						    GetData(),
						    GetDataBytes()
						    );
	    remotenodenumber = iname->RemoteNodes.GetNextNode(
							      remotenodenumber
							      );
	  }
	}
      }
    }
  }
}

SpInteractionName::SpInteractionName(SpMasterSimObjMgr *mgr) 
:LocalRecipients(new RB_SpBinaryTree)
{
  LocalRecipients->SetBalancedTreeMode();
  RemoteNodes.SetNnodes(mgr->get_N_NODES());
}

SpInteractionName::SpInteractionName() 
{
  if (SpPoDataBase::DoNotAllocateMemoryInConstructor){
  }
  else{
    LocalRecipients = new RB_SpBinaryTree;
    LocalRecipients->SetBalancedTreeMode();
    RemoteNodes.SetNnodes(0);
  }
}

SpInteractionName::~SpInteractionName(){
  delete LocalRecipients;
}

void SpMasterSimObjMgr::PersistenceRegisterPointers(){
  int i;

  SpEvent *event;
  SpSimObjMgrTypes *obman_temp;

  event = NULL;			// do this on purpose!!!
  event->set_objects(this);

  OBJECT_TYPE = -1;
  LOCAL_ID = -1;

  obman_temp = get_obman();
  ntypes = obman_temp->get_ntypes();
  PO_ADD(objman, ntypes*sizeof(SpSimObjMgr*));
  PO_ATTACH_PTR(objman);
  PO_ADD(ManagerName, ntypes*sizeof(char*));
  PO_ATTACH_PTR(ManagerName);
  if (NAME){
    PO_ADD_char(NAME, strlen(NAME)+1);
    PO_ATTACH_PTR_char(NAME);
  }

  for (i=0; i<ntypes; i++) {
    PO_ATTACH_PTR(objman[i]);
    char *TempName = ((SpSimObjMgr *)obman_temp)->get_obname(i);
    PO_ADD_char(ManagerName[i], strlen(TempName)+1);
    PO_ATTACH_PTR_char(ManagerName[i]);

    objman[i]->RegisterSimObjsWithPersistence();
    if (objman[i]->NAME == NULL) {
      objman[i]->set_NAME(strdup(TempName));
      PO_ATTACH_PTR_char(objman[i]->NAME);
    }
  }

  printf("Object managers registered with the persistence database\n");

}

void SpMasterSimObjMgr::ResetLocalRqueues()
{
  for (int i=0; i<ntypes; i++) {
    objman[i]->ResetLocalRqueues();
  }
  printf("Local rqueues have now been reset\n");
}

void SpMasterSimObjMgr::PersistenceRestartResetObjects()
{
  for (int i=0; i<ntypes; i++) {
    objman[i]->ResetObjectForRestart();
  }
  printf("Local rqueues have now been reset\n");

}


void RB_Register_SpObjHandle()
{
  RB_REGISTER_CLASS_SpObjHandle();
}

void RB_Register_SpInteractionName()
{
  RB_REGISTER_CLASS_SpInteractionName();
}


