// SpMasterSimObjMgr.H header file

#ifndef objects_object
#define objects_object

#include "SpSimObjMgr.H"
#include "SpSimObj.H"
#include "SpSimObjMgrTypes.H"
#include "PO.H"
#include "SpDestination.H"
#include "SpString80.H"
class RB_SpBinaryTree;


/************************************************************************
*	objects object 							*
************************************************************************/

class SpInteractionName 
{
public:
  SpInteractionName(SpMasterSimObjMgr *mgr);
  SpInteractionName();
  ~SpInteractionName();
  RB_SpBinaryTree* LocalRecipients;
  SpDestination RemoteNodes;
};

class SpMasterSimObjMgr : public SpSimObj {


  private:
  
    int ntypes;			// number of types of objects
    SpSimObjMgr **objman;		// object managers
    char **ManagerName;		// names of object managers
  RB_SpBinaryTree *Interactions;

  protected:

  public:

    SpMasterSimObjMgr();
    void init_events();
    int GetNmanagers() {return ntypes;}
    int get_N_LOC(int ty) {return objman[ty]->get_N_LOC();}
    int get_N_TOT(int ty) {return objman[ty]->get_N_TOT();}
    void get_nodid(int ot, int oi, int &n, int &i)
		{objman[ot]->get_nodid(oi,n,i);}
    SpSimObj *get_obj(int type, int i) {return objman[type]->get_obj(i);}
    SpSimObj *get_objman(int type) {
      SpSimObj *simobj = NULL;
      if ((0 <= type) && (type < ntypes)) simobj = objman[type];
      return simobj;
    }
    char *get_allids(int &size);
    char *GetManagerName(int i) {return ManagerName[i];}
    void print();
    void term(double tend);
    void ComputeCriticalPath(double &CPU_Time,
			     double &criticalPathTime,
			     double &maxSpeedup);

    void PersistenceRegisterPointers();
    void ResetLocalRqueues();
    void PersistenceRestartResetObjects();
  void AddSimObjInteraction(SpString80 key,SpObjectHandle objHandle,
			    int uniqueID);
  void AddNodeInteraction(SpString80 key,NET_INT node);
  void RemoveSimObjInteraction(SpString80 key,int uniqueID);
  void RemoveNodeInteraction(SpString80 key,NET_INT node);
  void ScheduleUndirectedEventHandlers(SpString80 key, NET_INT ehType,
				       NET_INT locallyScheduled);
};

/*
** Some common functions that access global data
*/





typedef SpMasterSimObjMgr C_OBJECTS;

//PO_DEFINE_CLASS(SpMasterSimObjMgr);

#endif
