// SpMsg.H message file

#include "SpSimTime.H"  //GEB2
#include "SpNetTypes.H"

#ifndef headers_object
#define headers_object

#define EM_QUERY 1
#define EM_MONITOR 2
#define EM_COMMAND 4
#define EM_MODULE 8
#define EM_CONNECT 16
#define EM_DISCONNECT 32
#define EM_BLOCK 64
#define EM_AGGRESSIVE 128
#define EM_BLOCKING 256
#define EM_GETID 512

/************************************************************************
*	header object 							*
************************************************************************/
class SpMsg {

  public :

    SpSimTime time_tag;		// time tag for the message (future event) GEB2
    NET_INT evtype;	       	// event type
    NET_INT obtype;	       	// destination object type
    NET_INT objid;	       	// destination object id
    NET_INT ext;	       	// external output flag
    NET_INT rbid;	       	// roll back id
    NET_INT cancel_id;		// cancel event id
    NET_INT ExternalId;		// External Id of external module
    NET_INT bytes;	       	// bytes in data for variable size message
    NET_DOUBLE EarliestStartTime; // Earliest start time for critical path

  SpMsg():EarliestStartTime(0){}

};

/************************************************************************
*       EM_header object                                                *
************************************************************************/
class C_EM_HEADER : public SpMsg {

  public:

    NET_INT EM_socket;          // socket of External Module
    NET_INT EM_interaction;     // Interaction type 
    NET_INT EM_flag;		// useful flag
    NET_INT data_bytes;         // number of data bytes

    void print();

};

/************************************************************************
*       EM_command object                                               *
************************************************************************/
class C_EM_COMMAND : public C_EM_HEADER {

  public:

    char EM_command[40];	// External Module command

};

/************************************************************************
*       EM_command object                                               *
************************************************************************/
class C_EM_MODULE : public C_EM_COMMAND {

  public:

    double EM_done_time;	// External Module done time

};

typedef SpMsg C_HEADER;

#endif
