#ifndef SpPrimativeTypes_H
#define SpPrimativeTypes_H

class P_double{
private:
  double Val;
public:
  P_double();
  P_double(double v)           {Val = v;}
  operator double()            {return Val;}
  double operator ++()         {Val++; return Val;}
  double operator --()         {Val--; return Val;}
  double operator ++(int)      {Val++; return(Val-1);}
  double operator --(int)      {Val--; return(Val+1);}
  double operator +=(double x) {Val += x; return Val;}
  double operator -=(double x) {Val -= x; return Val;}
  double operator *=(double x) {Val *= x; return Val;}
  double operator /=(double x) {Val /= x; return Val;}
};


class P_PTR_double  {
private:
  double* value;
public:
  P_PTR_double();
  P_PTR_double(double* v){value = v;}
  double* operator =(double* v){return value = v;}
};

class P_float{
private:
  float Val;
public:
  P_float();
  P_float(float v)           {Val = v;}
  operator float()           {return Val;}
  float operator ++()        {Val++; return Val;}
  float operator --()        {Val--; return Val;}
  float operator ++(int)     {Val++; return(Val-1);}
  float operator --(int)     {Val--; return(Val+1);}
  float operator +=(float x) {Val += x; return Val;}
  float operator -=(float x) {Val -= x; return Val;}
  float operator *=(float x) {Val *= x; return Val;}
  float operator /=(float x) {Val /= x; return Val;}
};


class P_PTR_float  {
private:
  float* value;
public:
  P_PTR_float();
  P_PTR_float(float* v){value = v;}
  float* operator =(float* v){return value = v;}
};


class P_int {
private:
  int  Val;
public:
  P_int();
  P_int(int v)             {Val = v;}
  operator int()           {return Val;}
  int  operator --()       {Val--; return Val;}
  int  operator ++()       {Val++; return Val;}
  int  operator --(int)    {Val--; return(Val+1);}
  int  operator ++(int)    {Val++; return(Val-1);}
  int  operator +=(int x)  {Val += x; return Val;}
  int  operator -=(int x)  {Val -= x; return Val;}
  int  operator *=(int x)  {Val *= x; return Val;}
  int  operator /=(int x)  {Val /= x; return Val;}
  int  operator %=(int x)  {Val %= x; return Val;}
  int  operator ^=(int x)  {Val ^= x; return Val;}
  int  operator &=(int x)  {Val &= x; return Val;}
  int  operator |=(int x)  {Val |= x; return Val;}
  int  operator >>=(int x) {Val >>= x; return Val;}
  int  operator <<=(int x) {Val <<= x; return Val;}
};

class P_unsigned_int {
private:
  unsigned int  Val;
public:
  P_unsigned_int();
  P_unsigned_int(unsigned int v)             {Val = v;}
  operator unsigned int()                    {return Val;}
  unsigned int  operator --()                {Val--; return Val;}
  unsigned int  operator ++()                {Val++; return Val;}
  unsigned int  operator --(int)             {Val--; return(Val+1);}
  unsigned int  operator ++(int)             {Val++; return(Val-1);}
  unsigned int  operator +=(unsigned int x)  {Val += x; return Val;}
  unsigned int  operator -=(unsigned int x)  {Val -= x; return Val;}
  unsigned int  operator *=(unsigned int x)  {Val *= x; return Val;}
  unsigned int  operator /=(unsigned int x)  {Val /= x; return Val;}
  unsigned int  operator %=(unsigned int x)  {Val %= x; return Val;}
  unsigned int  operator ^=(unsigned int x)  {Val ^= x; return Val;}
  unsigned int  operator &=(unsigned int x)  {Val &= x; return Val;}
  unsigned int  operator |=(unsigned int x)  {Val |= x; return Val;}
  unsigned int  operator >>=(unsigned int x) {Val >>= x; return Val;}
  unsigned int  operator <<=(unsigned int x) {Val <<= x; return Val;}
};



class P_PTR_int   {
private:
  int * value;
public:
  P_PTR_int();
  P_PTR_int(int* v){value = v;}
  int* operator =(int* v){return value = v;}
};


class P_PTR_unsigned_int {
private:
  unsigned int * value;
public:
  P_PTR_unsigned_int();
  P_PTR_unsigned_int(unsigned int* v){value = v;}
  unsigned int* operator =(unsigned int* v){return value = v;}
};

class P_char {
private:
  char  Val;
public:
  P_char();
  P_char(char v)             {Val = v;}
  operator char()            {return Val;}
  char  operator --()        {Val--; return Val;}
  char  operator ++()        {Val++; return Val;}
  char  operator --(int)     {Val--; return(Val+1);}
  char  operator ++(int)     {Val++; return(Val-1);}
  char  operator +=(char x)  {Val += x; return Val;}
  char  operator -=(char x)  {Val -= x; return Val;}
  char  operator *=(char x)  {Val *= x; return Val;}
  char  operator /=(char x)  {Val /= x; return Val;}
  char  operator %=(char x)  {Val %= x; return Val;}
  char  operator ^=(char x)  {Val ^= x; return Val;}
  char  operator &=(char x)  {Val &= x; return Val;}
  char  operator |=(char x)  {Val |= x; return Val;}
  char  operator >>=(char x) {Val >>= x; return Val;}
  char  operator <<=(char x) {Val <<= x; return Val;}
};

class P_unsigned_char {
private:
  unsigned char  Val;
public:
  P_unsigned_char();
  P_unsigned_char(unsigned char v)             {Val = v;}
  operator unsigned char()                     {return Val;}
  unsigned char  operator --()                 {Val--; return Val;}
  unsigned char  operator ++()                 {Val++; return Val;}
  unsigned char  operator --(int)              {Val--; return(Val+1);}
  unsigned char  operator ++(int)              {Val++; return(Val-1);}
  unsigned char  operator +=(unsigned char x)  {Val += x; return Val;}
  unsigned char  operator -=(unsigned char x)  {Val -= x; return Val;}
  unsigned char  operator *=(unsigned char x)  {Val *= x; return Val;}
  unsigned char  operator /=(unsigned char x)  {Val /= x; return Val;}
  unsigned char  operator %=(unsigned char x)  {Val %= x; return Val;}
  unsigned char  operator ^=(unsigned char x)  {Val ^= x; return Val;}
  unsigned char  operator &=(unsigned char x)  {Val &= x; return Val;}
  unsigned char  operator |=(unsigned char x)  {Val |= x; return Val;}
  unsigned char  operator >>=(unsigned char x) {Val >>= x; return Val;}
  unsigned char  operator <<=(unsigned char x) {Val <<= x; return Val;}
};



class P_PTR_char   {
private:
  char * value;
public:
  P_PTR_char();
  P_PTR_char(char* v){value = v;}
  char* operator =(char* v){return value = v;}
};


class P_PTR_unsigned_char   {
private:
  unsigned char * value;
public:
  P_PTR_unsigned_char();
  P_PTR_unsigned_char(unsigned char* v){value = v;}
  unsigned char* operator =(unsigned char* v){return value = v;}
};

class P_long {
private:
  long  Val;
public:
  P_long();
  P_long(long v)             {Val = v;}
  operator long()            {return Val;}
  long  operator --()        {Val--; return Val;}
  long  operator ++()        {Val++; return Val;}
  long  operator --(int)     {Val--; return(Val+1);}
  long  operator ++(int)     {Val++; return(Val-1);}
  long  operator +=(long x)  {Val += x; return Val;}
  long  operator -=(long x)  {Val -= x; return Val;}
  long  operator *=(long x)  {Val *= x; return Val;}
  long  operator /=(long x)  {Val /= x; return Val;}
  long  operator %=(long x)  {Val %= x; return Val;}
  long  operator ^=(long x)  {Val ^= x; return Val;}
  long  operator &=(long x)  {Val &= x; return Val;}
  long  operator |=(long x)  {Val |= x; return Val;}
  long  operator >>=(long x) {Val >>= x; return Val;}
  long  operator <<=(long x) {Val <<= x; return Val;}
};

class P_unsigned_long {
private:
  unsigned long  Val;
public:
  P_unsigned_long();
  P_unsigned_long(unsigned long v)             {Val = v;}
  operator unsigned long()                     {return Val;}
  unsigned long  operator --()                 {Val--; return Val;}
  unsigned long  operator ++()                 {Val++; return Val;}
  unsigned long  operator --(int)              {Val--; return(Val+1);}
  unsigned long  operator ++(int)              {Val++; return(Val-1);}
  unsigned long  operator +=(unsigned long x)  {Val += x; return Val;}
  unsigned long  operator -=(unsigned long x)  {Val -= x; return Val;}
  unsigned long  operator *=(unsigned long x)  {Val *= x; return Val;}
  unsigned long  operator /=(unsigned long x)  {Val /= x; return Val;}
  unsigned long  operator %=(unsigned long x)  {Val %= x; return Val;}
  unsigned long  operator ^=(unsigned long x)  {Val ^= x; return Val;}
  unsigned long  operator &=(unsigned long x)  {Val &= x; return Val;}
  unsigned long  operator |=(unsigned long x)  {Val |= x; return Val;}
  unsigned long  operator >>=(unsigned long x) {Val >>= x; return Val;}
  unsigned long  operator <<=(unsigned long x) {Val <<= x; return Val;}
};



class P_PTR_long   {
private:
  long * value;
public:
  P_PTR_long();
  P_PTR_long(long* v){value = v;}
  long* operator =(long* v){return value = v;}
};


class P_PTR_unsigned_long   {
private:
  unsigned long * value;
public:
  P_PTR_unsigned_long();
  P_PTR_unsigned_long(unsigned long* v){value = v;}
  unsigned long* operator =(unsigned long* v){return value = v;}
};


#endif
