/***************************************************************************
* debugging (user and non-user) macros:                                    *
***************************************************************************/

#define CHECK(a) cout << "------ " <<                       _M_C_ \
                 NODE << ": " << #a                         _M_C_ \
                 << "-> e= " << EVENT_TYPE <<               _M_C_ \
                 " t= " << TIME_TAG.GetTime () << endl;

#define _PREMARK(mark) sprintf (LV->_##mark,
#define _MIDMARK(mark, var)                                  _M_C_ \
	    "%d at %s, t = %2.0f, %s = %2d\n",               _M_C_ \
	    LOCAL_ID, _M_C_ #mark, _M_C_ TIME_TAG.GetTime (), _M_C_ #var,
#define _MIDMARK0(mark, var)                                 _M_C_ \
	    "%s, t = %2.0f, %s = %2d\n",                     _M_C_ \
	    #mark, _M_C_ TIME_TAG.GetTime (), _M_C_ #var,
#define _POSTMARK(mark)  + 0); RB_PRINT (stdout, LV->_##mark);

#define SUPPORT_MARKS char _MARK[128]
#define SUPPORT_P_MARKS char _PMARK[128]
#define MARK(mark, var)    _PREMARK  (MARK)                  _M_C_ \
	                   _MIDMARK  (mark, var) LV->##var   _M_C_ \
	                   _POSTMARK (MARK)
#define P_MARK(mark, var)  _PREMARK (PMARK)                  _M_C_ \
	                   _MIDMARK  (mark, var) var         _M_C_ \
	                   _POSTMARK (PMARK)
#define MARK0(mark, var)   if (LOCAL_ID + NODE == 0) {       _M_C_ \
                           _PREMARK (MARK)                   _M_C_ \
	                   _MIDMARK0 (mark, var) LV->##var   _M_C_ \
	                   _POSTMARK (MARK) }
#define P_MARK0(mark, var) if (LOCAL_ID + NODE == 0) {       _M_C_ \
                           _PREMARK (PMARK)                  _M_C_ \
			   _MIDMARK0 (mark, var) var         _M_C_ \
			   _POSTMARK (PMARK) }
