// SpBTW.H header file

#ifndef btw_evtq_object
#define btw_evtq_object

//#include "speedes_comm.H"
#include "SpTimeMgtAlg.H"
#include "SpSimTime.H" //GEB2


class ABROAD {
  public:
    SpSimTime time;
    int cycle;
    int spare;
};

/************************************************************************
*	btw_evtq object 						*
************************************************************************/
class SpBTW : public SpTimeMgtAlg {

  private:

  protected:

    C_DBL_QUEUE dbl_qproc;	// queue of processed events
    int n_not_valid;		// # not valid events processed this cycle
    SpSimTime event_horizon;	// event horizon GEB2
    SpSimTime glob_eh;		// global event horizon
    SpSimTime tmin;		// minimum time for event
    SpSimTime tblock;		// blocking time for external messages
    int mess_count;		// time warp message counter
    int n_mrec;			// number of messages received this cycle
    int gvtupdate;		// flag that tells if we are in a gvt update
    int nevtgvt;		// number of events processed during gvt
    MSG_STRUCT mess_broadcast_out;     // Mercury outgoing message structure
    MSG_STRUCT mess_broadcast_in;      // Mercury incomming message structure
    ABROAD abroadout;		       // asynchronous output broadcast message
    ABROAD *abroadin;		       // asynchronous input broadcast message
    int asb_cycle;		       // cycle
    int state;			       // 0 = haven't crossed event horizon
    double asbtime;		       // time of last asynchronous broadcast
    double nasb;		       // # of asy. broadcasts received
    SpStopWatch StopWatchBTW;	       // used to time phases of BTW
    int NumProcConservative;	       // num events processed conservatively
    int NoValidEvents;		       // could not process an event
    SpSimTime GvtPlusL;		       // gvt plus lookahead

  public:

    SpBTW();

    void process_event();
    void messages();
    void antimessages();

    virtual void temp_process();
    virtual void perm_process();
    virtual void find_gvt();
    //virtual void get_blocked_messages();
    virtual int RollBack();	//Rolls back all events to GVT
    virtual int RollsForward(); //Rolls all events forward as far as possible

};


typedef SpBTW C_BTW_EVTQ;

#endif
