#ifndef STATSMESSAGE_H
#define STATSMESSAGE_H

#include "SpSimTime.H"

class StatsMessage {
private:
  NET_INT NodeId;
  NET_INT WhichCycle;
  SpSimTime TheGVT;
  NET_DOUBLE TheCPU;
  NET_DOUBLE Wall;
  NET_DOUBLE TheSTAR;
  NET_DOUBLE Tproc;
  NET_DOUBLE Tcmt;
  NET_DOUBLE Eff;
  NET_INT Phase1;
  NET_INT Phase2;
  NET_INT Events;
  NET_INT EventsPerCycle;
  NET_INT EvtGVT;
  NET_INT NumRollBacks;
  NET_INT NumMessages;
  NET_INT NumAntiMessages;
  NET_INT NumCancels;
  NET_INT NumExternalMessages;

  NET_DOUBLE LocalTime;		// local time of my node

  NET_DOUBLE PhaseBTB;		// time spent in BTB event processing
  NET_DOUBLE PhaseFBen;		// time spent entering the fuzzy barrier
  NET_DOUBLE PhaseFBex;		// time spent exiting the fuzzy barrier
  NET_DOUBLE PhaseGVT;		// time spent updating GVT
  NET_DOUBLE PhaseCMT;		// time spent committing events

protected:
public:
  void SetNode(int n){NodeId = n;}
  int GetNode(){ return NodeId;}

  void SetWhichCycle(int c){WhichCycle = c;}
  int GetWhichCycle(){ return WhichCycle;}

  void SetNodeCPU(double c){TheCPU = c;}
  double GetNodeCPU(){ return TheCPU;}

  void SetGVT(SpSimTime g){TheGVT = g;}
  SpSimTime GetGVT(){ return TheGVT;}

  void SetWall(double w){Wall = w;}
  double GetWall(){ return Wall;}

  void SetSTAR(double s){TheSTAR = s;}
  double GetSTAR(){ return TheSTAR;}

  void SetTproc(double t){Tproc = t;}
  double GetTproc(){ return Tproc;}

  void SetTcmt(double t){Tcmt = t;}
  double GetTcmt(){ return Tcmt;}

  void SetEff(double e){Eff = e;}
  double GetEff(){ return Eff;}

  void SetPhase1(int p){Phase1 = p;}
  int GetPhase1(){ return Phase1;}

  void SetPhase2(int p){Phase2 = p;}
  int GetPhase2(){ return Phase2;}

  void SetEvents(int e){Events = e;}
  int GetEvents(){ return Events;}

  void SetEventsPerCycle(int e){EventsPerCycle = e;}
  int GetEventsPerCycle(){ return EventsPerCycle;}

  void SetEvtGVT(int e){EvtGVT = e;}
  int GetEvtGVT(){ return EvtGVT;}

  void SetNumRollBacks(int n){NumRollBacks = n;}
  int GetNumRollBacks(){ return NumRollBacks;}

  void SetNumMessages(int n){NumMessages = n;}
  int GetNumMessages(){ return NumMessages;}

  void SetNumAntiMessages(int n){NumAntiMessages = n;}
  int GetNumAntiMessages(){ return NumAntiMessages;}

  void SetNumCancels(int n){NumCancels = n;}
  int GetNumCancels(){ return NumCancels;}

  void SetNumExternalMessages(int n){NumExternalMessages = n;}
  int GetNumExternalMessages(){ return NumExternalMessages;}

  void SetPhaseBTB(double phaseBTB) {PhaseBTB = phaseBTB;}
  double GetPhaseBTB() {return PhaseBTB;}

  void SetPhaseFBen(double phaseFBen) {PhaseFBen = phaseFBen;}
  double GetPhaseFBen() {return PhaseFBen;}

  void SetPhaseFBex(double phaseFBex) {PhaseFBex = phaseFBex;}
  double GetPhaseFBex() {return PhaseFBex;}

  void SetPhaseGVT(double phaseGVT) {PhaseGVT = phaseGVT;}
  double GetPhaseGVT() {return PhaseGVT;}

  void SetPhaseCMT(double phaseCMT) {PhaseCMT = phaseCMT;}
  double GetPhaseCMT() {return PhaseCMT;}

  void SetLocalTime(double localTime) {LocalTime = localTime;}
  double GetLocalTime() {return LocalTime;}

};

#endif
