#ifndef Ho_U_object
#define Ho_U_object

//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
// Normally, the standard speedes make system defines this 
// variable, but WarGame 2000 wants to use the Apex GUI instead
// of the command line make system interface, so we will define
// it directly in the file.  Note that I took it out of the makefiles.
//

#define HOST

//
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

#ifdef HOST

#ifndef __SPEEDES_NT__
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#else
#include <windows.h>
#endif
#include "SpStdio.H"

#define hostfile "SPEEDES.resrc"
#define PARSER_FILE

#include "SpMsg.H"
#include "query_data.H"
#include "queue.H"
#include "holder.H"

/************************************************************************
*	Host_User object 						*
************************************************************************/
class C_HOST_USER {

  private:

    int Nodock;				// socket for my node
    struct sockaddr_in Host_Server;	// socket address

#ifdef PARSER_FILE
    char *Host_Server_Name;		// Host server name
#else
    char Host_Server_Name[40];		// Host server name
#endif

    int Host_Server_Port;		// Host server port
    int node;				// my node number
    int looping;			// flag for looping
    C_EM_HEADER header;			// fixed header
    int connected;			// connected flag
    int conid;				// id of connected object
    int bytes_flush;			// number of bytes to be flushed
    C_QUEUE message_queue;		// normal message queue

    char *input_file;			// file name for input
    char *output_file;			// file name for input
    FILE *fp_input;			// input file pointer
    FILE *fp_output;			// output file pointer
    int input_file_flag;		// flag for input through a file
    int output_file_flag;		// flag for output to a file

  protected:

  public:

    C_HOST_USER();
    C_HOST_USER(char *fname);
    void set_output_file(char *fname);

    ~C_HOST_USER() {if (connected) disconnect();}
    C_EM_HEADER *get_message() {return get_message(-1);}
    C_EM_HEADER *get_message(int message_type);
    void set_node(int nd) {node = nd;}
    int get_node() {return node;}
    void send_message(C_EM_HEADER *EM_header);
    void send_node_objects(int size, char *node_objects);

    int getid(char *name);
    void flush();

    C_EM_HEADER *query(int oid);
    C_QUERY_DATA *query(int oid, int &n);
    C_EM_HEADER *monitor(int oid);
    C_QUERY_DATA *monitor(int oid, int &n);
    void disconnect();

    C_EM_HEADER *module(C_EM_HEADER *EM_header);
    C_EM_HEADER *get_module();
    void send_module(C_EM_HEADER *EM_header);
    C_EM_HEADER *blocking_module(C_EM_HEADER *EM_header);
    C_EM_HEADER *aggressive_module(C_EM_HEADER *EM_header);

    void command(C_EM_HEADER *EM_header);

    void reset() {looping = 0;}
    void reset_looping() {looping = 0;}
    void set_looping() {looping = 1;}
    int get_looping() {return looping;}
    void print_query(C_EM_HEADER *EM_header);

};

#else

no_one_should_attempt_to_compile_this_code
#include "SpMsg.H"

/************************************************************************
*	Host_User object 						*
************************************************************************/
class C_HOST_USER {

  private:

  protected:

  public:

    C_HOST_USER() {;}
    C_EM_HEADER *get_message() {return NULL;}
    void set_node(int nd) {;}
    int get_node() {return -1;}
    void send_message(C_EM_HEADER *EM_header) {;}
    void send_node_objects(int size, char *node_objects) {;}

    int getid(char *name) {return -1;}
    C_EM_HEADER *query(int oid) {return NULL;}
    C_EM_HEADER *monitor(int oid) {return NULL;}
    void disconnect() {;}

    C_EM_HEADER *module(C_EM_HEADER *EM_header) {return NULL;}
    C_EM_HEADER *get_module() {return NULL;}
    void send_module(C_EM_HEADER *EM_header) {;}

    void command(C_EM_HEADER *EM_header) {;}

    void reset() {;}
    void print_query(C_EM_HEADER *EM_header) {;}

};


#endif

#endif
