#ifndef speedescomm
#define speedescomm

#include "SpComm.H"
/*
** speedes_comm.H header file that defines all of the SPEEDES Communications
** routines.
*/

#ifndef SPEEDESCOMM_H
void startup();
void comm_cleanup();
void f_subcube(FILE *, int);
#endif

/*
** Structure declaration used by scparam()
*/

struct scubenv {
        int doc;                /* dim of hypercube */
        int procnum;            /* processor number */
        int nproc;              /* number of processors in hypercube */
        int cpmask;             /* mask to CP */
        int cubemask;           /* only used on CP */
        int dosc;               /* dim of sub-hypercube */
        int nsproc;             /* number of processors in sub-hypercube */
        int corner;             /* corner node with in sub-hypercube */
        int bmask;              /* sub-hyercube braodcast mask */
};

#ifndef SPEEDESCOMM_H
void scparam(scubenv *);
int get_n_nodes();
int get_node();
void exit_all_other_nodes();
#endif

/*
** Global synchronization calls
*/

#ifndef SPEEDESCOMM_H
void b_sync();
void nb_sync();
int nb_check();
#endif

/*
** Global Reduction Operations
*/

#ifndef SPEEDESCOMM_H
enum {
  SP_MAXINT,
  SP_MININT,
  ORINT,
  SUMINT,
  CHECK,
  EQUAL,
  MINDBL,
  N_REDUCTIONS
};

int scombine(int *buf, int type, int size, int num);
int combine(int *buf, int type, int size, int num);
#endif

/*
** Mercury stuff
*/

#define ALL -1
#define ANY -2
#define CP  -3

#define N_MERC_TYPES 256

enum {
  WARNING,
  OK
};

typedef struct mstrct {
  int blen;
  int mlen;
  int dest;
  int source;
  int type;
  int dummy_byte_align;
  int *buf;
} MSG_STRUCT, *MSG_STR_PTR;

#ifndef SPEEDESCOMM_H
void Start_Merc(int, int);
int get_msg(MSG_STRUCT *msg);
int send_msg(MSG_STRUCT *msg, int &status);
int send_msg_w(MSG_STRUCT *msg);
int give_buf(MSG_STRUCT *msg);
#endif




#endif
