// SpCreateObjProxyEvent.C source file

#include "SpCreateObjProxyEvent.H"

#include "SpObjFactory.H"
#include "F_SpProxyItem.H"

#include "RB_SpContainerFuncs.H"

extern SpObjFactory *ObjFact;

void SpCreateObjProxyEvent::Process() {
  F_SpProxyItem *ProxyItem;
  int HashId;

  cout << "Processing: SpCreateObjProxyEvent at time " << time_tag << endl;
  GlobalState->IncrementNumberOfProxies();

  ObjectProxy = ObjFact->GenerateObjectProxy((SpObjProxyMsg *)Data);

/*
** Put the object proxy in a global id hash table
*/

  ProxyItem = new F_SpProxyItem();
  ProxyItem->SetObjectProxy(ObjectProxy);
  RB_INSERT(ObjectProxyIdHash, ProxyItem);

/*
** Put the object proxy in a named hash table
*/

  ProxyItem = new F_SpProxyItem();
  ProxyItem->SetObjectProxy(ObjectProxy);
  HashId = ObjectProxyNameHash->get_hashid(ObjectProxy->GetObjectName());
  ProxyItem->set_id(HashId);
  RB_INSERT(ObjectProxyNameHash, ProxyItem);

/*
** Put the object proxy in a typed hash table
*/

  ProxyItem = new F_SpProxyItem();
  ProxyItem->SetObjectProxy(ObjectProxy);
  HashId = ObjectProxyTypeHash->get_hashid(ObjectProxy->ObjProxyGetClassName());
  ProxyItem->set_id(HashId);
  RB_INSERT(ObjectProxyTypeHash, ProxyItem);

  delete [] Data;

//  ObjectProxy->PrintStream();

}
