// SpExtFedRecvInteractionEvent.C source file

#include "SpExtFedRecvInteractionEvent.H"
#include "SpParmSet.H"


void SpExtFedRecvInteractionEvent::Process() {

  /* Once the RTI interfaces are up, we'll want to pass this off
   * to a federate ambassador.  For now we'll just print out the
   * parameter values.
   */

  cout << "Processing: SpReceiveInteraction at time " << time_tag << endl;

  SpParmSet params(Data, DataBytes);
  cout << "*** Got interaction type " << EventName << " with "
       << params.GetNumElements() << " elements" << endl;

  /* Here we're assuming that the set is using integer keys and string 
   * values; anything else and the parm set will complain loudly.
   */
#if 0
  for(int *key = params.GetFirstIntParmId(); key != NULL;
      key = params.GetNextIntParmId()) {
    cout << "*** params[" << *key << "] = \"" << (char*)params[*key] << "\"\n";
  }
  cout << flush;
#else
  for(char *key = params.GetFirstStringParmId(); key != NULL;
      key = params.GetNextStringParmId()) {
    cout << "*** params[" << key << "] = \"" << (char*)params[key] << "\"\n";
  }
  cout << flush;
#endif

  delete [] Data;
}
