// SpExtFedStateMgr.H header file

#ifndef SpExtFedStateMgrGate
#define SpExtFedStateMgrGate

#include "SpFedStateMgr.H"

#ifndef RTI_hh
#define RTI_hh
class RTI {
public:
  class RTIambassador {
  public:
    RTIambassador () { ; }
  };
  class FederateAmbassador {
  public:
    FederateAmabassador () { ; }
  };
};
#endif

class SpExtFedStateMgr : public SpFedStateMgr {

  private:

    RTI::FederateAmbassador *FedAmb;
    RTI::RTIambassador *RTIAmb;

  protected:
  public:

    SpExtFedStateMgr(char *machineName, int port, int groupId);

    SpExtFedStateMgr(SpDataParser *parser);

    SpExtFedStateMgr(char *fileName);

    char* Connect(const char *fedName, const char *fedexName,
		  SpSimTime connectTime=-1.0e20);
    void Disconnect();

    virtual void SubscribeInteraction(char *className);
    virtual void NextEventRequest (SpSimTime &time);

    void SetFedAmb (RTI::FederateAmbassador *fedAmb) { FedAmb = fedAmb; }
    RTI::FederateAmbassador* GetFedAmb () { return FedAmb; }
    void SetRTIAmb (RTI::RTIambassador *rtiAmb) { RTIAmb = rtiAmb; }
    RTI::RTIambassador* GetRTIAmb () { return RTIAmb; }
};

#endif
