// SpGatewayStateMgr.C source file

#include "SpGatewayStateMgr.H"

void SpGatewayStateMgr::Connect (SpSimTime connectTime) {
  char *data;
  SpSimTime time;
  int dataBytes;

  Mode = HLA_MODE_GATEWAY;
  FedName = strdup("HLA Gateway");
  NodeId = EmHostUser->GetNextNode();
  MgrId = EmHostUser->ObjectManagerType("SpFedGhost");
  EmHostUser->SendCommand("CreateFedGhost",
			  NodeId, MgrId, -1,
			  connectTime,
			  "HLA Gateway", strlen("HLA Gateway")+1);

  data = NULL;
  while (!data) {
    data = EmHostUser->ReceiveNamedData("SimObj Ids",
                                        time,
                                        dataBytes,
                                        GlobalId);
  }

  TimeGranted = time;
}



SpSimTime
SpGatewayStateMgr::GetMinMsgTime () {
  SpSimTime minMsgTime = EmHostUser->GetMinMsgTime();
  return ((minMsgTime < TimeGranted) ? TimeGranted : minMsgTime);
}



/*****************************************************************************
 * Subscribe Interaction methods
 *****************************************************************************/

void SpGatewayStateMgr::SubscribeInteraction(char *className) {

  SpSimTime eventTime = TimeGranted;
  eventTime += TimeLag;
  EmHostUser->SendCommand("Subscribe Interaction",
                          NodeId,
                          MgrId,
                          LocalId,
                          eventTime,
                          className,
                          strlen(className) + 1);

}

void SpGatewayStateMgr::SubscribeInteraction(char *className,
                                             SpStateMgrEvent *(*f)())
{
  SubscribeInteraction(className);
  PlugInEvent(className, f);
}

