#include "RB_SpDynPtrArray.H"
#include "RB_SpDefineClass.H"

RB_DEFINE_CLASS(RB_voidPtr);


void RB_SpDynPtrArray::EnlargeSize( int arraySize ) {
  // Create a larger array using RB_NEW_ARRAY_RB_voidPtr function
  RB_voidPtr* tempArray = RB_NEW_ARRAY_RB_voidPtr( arraySize );

  // Copy the old pointers to the new array
  memcpy( ( void* )tempArray,
	  ( void* )Array,
	  ArraySize * sizeof( RB_voidPtr ) );

  // Delete the old array using RB_DELETE_RB_voidPtr function
  RB_DELETE_ARRAY_RB_voidPtr( ( RB_voidPtr* ) ( void* )  Array );
  Array = tempArray;

  // Store the new size
  ArraySize = arraySize;
}



RB_SpDynPtrArray::RB_SpDynPtrArray( int arraySize ) {
  Array = RB_NEW_ARRAY_RB_voidPtr( arraySize );
  ArraySize = arraySize;
}



RB_SpDynPtrArray::~RB_SpDynPtrArray() {
  RB_DELETE_ARRAY_RB_voidPtr( ( RB_voidPtr* ) ( void* )  Array );
}

