#ifndef RB_SpDynPtrArray_Header
#define RB_SpDynPtrArray_Header

#include "RB_Types.H"
#include "RB_SpDefineClass.H"

/**********************************************************************
 * 
 **********************************************************************/
class RB_SpDynPtrArray {
public:
  RB_SpDynPtrArray( int arraySize = 2);
  ~RB_SpDynPtrArray();
  int GetArraySize();
  RB_voidPtr& operator []( int index );
private:
  void EnlargeSize( int size );
  RB_voidPtr Array;
  RB_int ArraySize;
};

/**********************************************************************
 * 
 **********************************************************************/
inline
int
RB_SpDynPtrArray::GetArraySize() {
  return ArraySize;
}

/**********************************************************************
 * 
 **********************************************************************/
inline
RB_voidPtr&
RB_SpDynPtrArray::operator []( int index ) {
  if( index >= ArraySize ) {
    EnlargeSize( index + index );
  }
  return (( RB_voidPtr* ) ( void* )  Array)[index];
}

typedef RB_SpDynPtrArray RB_DYN_PTR_ARRAY;

#endif

