#include "SpAltMgr.H"
#include "SpAltHiGridChange.H"
#include "RB_SpHiGrid.H"

void RB_SpHiGrid::PutOnSpAltMgrQ
  (SpPubSub e, SpMainPubSubItem *mainPubSubItem, int remove_p)
{
  assert(get_Ndimensions() == mainPubSubItem->GetNdimensions());
  if (SpCurrentAltMgr->GetOptimistic()) {
    SpAltHiGridChange* altItem = ALLOCATE_SpAltHiGridChange();
    altItem->Alter(this, e, mainPubSubItem, remove_p);
    SpCurrentAltMgr->Insert(altItem);
  }
}

int RB_SpHiGrid::Add(SpPubSub e, SpMainPubSubItem *MainPubSubItem)
{
  if (SpHiGrid::Add(e, MainPubSubItem))
  {
    PutOnSpAltMgrQ(e, MainPubSubItem, 1);
    return 1;
  }
  else
    return 0;
}

int RB_SpHiGrid::AddAndGet(SpPubSub e, SpMainPubSubItem *MainPubSubItem,
		     SpList *matchingPubsOrSubs)
{
  if (SpHiGrid::AddAndGet(e, MainPubSubItem, matchingPubsOrSubs))
  {
    PutOnSpAltMgrQ(e, MainPubSubItem, 1);
    return 1;
  }
  else
    return 0;
}

SpMainPubSubItem *RB_SpHiGrid::Remove(SpPubSub e, int uniqueKey)
{
  SpMainPubSubItem *MainPubSubItem = SpHiGrid::Remove(e, uniqueKey);
  if (MainPubSubItem != NULL)
  {
    assert(MainPubSubItem->GetUniqueKey() == uniqueKey);
    PutOnSpAltMgrQ(e, MainPubSubItem, 0);
  }
  return MainPubSubItem;
}
