#ifndef __RB_SpHiGrid__
#define __RB_SpHiGrid__

#include "SpHiGrid.H"

class RB_SpHiGrid : public SpHiGrid {
    friend class SpAltHiGridChange;
    
    void PutOnSpAltMgrQ
      (SpPubSub e, SpMainPubSubItem *mainPubSubItem, int remove_p);
    
  public:
    // This function is NOT roll-back-able
    SpHiGrid::init;

    int AddPublisher(SpMainPubSubItem *MainPubSubItem) {
      return Add(PUBLISHER, MainPubSubItem);
    }
    int AddSubscriber(SpMainPubSubItem *MainPubSubItem) {
      return Add(SUBSCRIBER, MainPubSubItem);
    }
    int Add(SpPubSub e, SpMainPubSubItem *MainPubSubItem);


    int AddPublisherAndGet
      (MAIN_PUBSUB_ITEM *publication_region, SpList *subscibers) {
      return AddAndGet(PUBLISHER, publication_region, subscibers);
    }
    int AddSubscriberAndGet
      (MAIN_PUBSUB_ITEM *subscription_region, SpList *publishers) {
      return AddAndGet(SUBSCRIBER, subscription_region, publishers);
    }
    int AddAndGet(SpPubSub e, SpMainPubSubItem *MainPubSubItem,
	    SpList *matchingPubsOrSubs);



    SpMainPubSubItem *RemovePublisher(int uniqueKey) {
      return Remove(PUBLISHER, uniqueKey);
    }
    SpMainPubSubItem *RemoveSubscriber(int uniqueKey) {
      return Remove(SUBSCRIBER, uniqueKey);
    }
    SpMainPubSubItem *Remove(SpPubSub e, int uniqueKey);

    
    SpHiGrid::GetPublishers;
    SpHiGrid::GetPublishersWithKey;
    SpHiGrid::GetSubscribers;
    SpHiGrid::GetSubscribersWithKey;
    SpHiGrid::Get;
    SpHiGrid::get_SpaceName;
    SpHiGrid::get_SpaceNum;
    SpHiGrid::get_Ndimensions;
    SpHiGrid::get_Resolution;
    SpHiGrid::get_Nresolution;
    SpHiGrid::get_Hi;
    SpHiGrid::get_Lo;
    SpHiGrid::get_DimName;
    SpHiGrid::print;
    SpHiGrid::RecursivePrint;
    SpHiGrid::CheckIntegrity;
};

#endif
