#include "RB_SpList.H"

#ifndef USE_OLD_FUNCTIONALITY

int RB_SpList::PoFreeId = -1;


#ifdef __VACPP__


void* jj1(){return (void*) new PersistentRB_SpListItem;}
void* jj2(int nItems){return (void*) new PersistentRB_SpListItem[nItems];}

PO_DEFINE_PERSISTENT_CLASS(PersistentRB_SpListItem);
static void PO_REGISTER_CLASS_PersistentRB_SplistItem()
{
  int junk;
  PO_GET_NEW_ID("PersistentRB_SpListItem",
		junk,
		jj1,
		jj2,
		sizeof(PersistentRB_SpListItem));
}

#endif



void RB_SpList::AllocateMoreItems()
{
  extern int PersistenceEnabled;
  if (GlobalSpPoMempool == NULL){
    GlobalSpPoMempool = new SpPoMempool;
  }
  if (PersistenceEnabled){
    PoFreeId =
      GlobalSpPoMempool->AddChunk(PO_NEW_ARRAY_PersistentRB_SpListItem(FREE_LIST_SIZE),
				  PoFreeId,
				  FREE_LIST_SIZE,
				  sizeof(PersistentRB_SpListItem));
  }
  else{
    PoFreeId =
      GlobalSpPoMempool->AddChunk(new NonPersistentRB_SpListItem[FREE_LIST_SIZE],
				  PoFreeId,
				  FREE_LIST_SIZE,
				  sizeof(NonPersistentRB_SpListItem));
  }
}

/******************************************************************************
* Method: RemoveTopItem
* Summary: Remove a list item from the top of the list
* Description:
* Return: Pointer to the removed list item
******************************************************************************/
inline RB_SpListItem *RB_SpList::RemoveTopItem(){
  RB_SpListItem *item;
  if (length == 0) {
    return NULL;
  }else{
    item = top;
    if (current == top){
      current = top->GetForwardLink();
    }
    top = top->GetForwardLink();
    length--;
    if (length == 0){
      top = bot = current = NULL;
    }
    return item;
  }
}

/******************************************************************************
* Method: RemoveBotItem
* Summary: Remove a list item from the bottom of the list
* Description:
* Return: Pointer to the removed list item
******************************************************************************/
inline RB_SpListItem * RB_SpList::RemoveBotItem(){
  RB_SpListItem *item;
  if (length == 0) {
    return NULL;
  }else{
    item = bot;
    if (current == bot){
      current = bot->GetBackwardLink();
    }
    bot = bot->GetBackwardLink();
    length--;
    if (length == 0){
      top = bot = current = NULL;
    }
    return item;
  }
}




void RB_SpList::InternalRemove(void *v) {
  RB_SpListItem* item;
  RB_SpListItem* previous;
  RB_SpListItem* next;

  if (length == 0) return;

  if (v == top->GetReference()) {
    if (current == top && length >= 2){
      current = top->GetForwardLink();
    }
    DeleteItem(RemoveTopItem());
    return;
  }

  if (v == bot->GetReference()) {
    if (current == bot){
      current = bot->GetBackwardLink();
    }
    DeleteItem(RemoveBotItem());
    return;
  }

  previous = top;
  item = top->GetForwardLink();
  next = item->GetForwardLink();

  while (item != bot) {
    if (item->GetReference() == v) {
      previous->SetForwardLink(next);
      next->SetBackwardLink(previous);
      DeleteItem(item);
      length--;
      if (length == 0){
	top = bot = current = NULL;
      }
      return;
    }else{
      previous = item;
      item = next;
      next = item->GetForwardLink();
    }
  }

  cout << "Error (remove): Could not remove item" << endl;

}


#endif
