#ifndef SpAltPriorityChange_Header
#define SpAltPriorityChange_Header

#include "xpriority.H"

#include "SpAlt.H"

/**********************************************************************
 * 
 **********************************************************************/
class SpAltPriorityChange : public SpAlt {
public:
  void Alter( C_XPRIORITY* priority, C_SQ_ITEM* item, int pop );
  virtual void Rollback();
private:
  C_XPRIORITY* Priority;
  C_SQ_ITEM* Item;
  int Pop;
};

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltPriorityChange::Alter( C_XPRIORITY* priority, C_SQ_ITEM* item, int pop ) {
  Priority = priority;
  Item = item;
  Pop = pop;
}

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltPriorityChange::Rollback() {
  C_QUEUE queue;
  C_SQ_ITEM* item;

  if( Pop ) {
    while( ( item = Priority->pop() ) != Item ) {
      queue.push_bot( item );
    }
    while( queue.get_length() > 0 ) {
      Priority->insert( ( C_SQ_ITEM* ) queue.pop_top() );
    }
  }
  else {
    Priority->insert( Item );
  }
  Pop = ! Pop;
}

DEFINE_MEMPOOL( SpAltPriorityChange, ALT_CHUNK_SIZE )

#endif

