#ifndef SpAltQueueChange_Header
#define SpAltQueueChange_Header

#include "xqueue.H"

#include "SpAlt.H"

/**********************************************************************
 * 
 **********************************************************************/
class SpAltQueueChange : public SpAlt {
public:
  void Alter( C_XQUEUE* queue, C_SQ_ITEM* item, int pop, int top );
  virtual void Rollback();
private:
  C_XQUEUE* Queue;
  C_SQ_ITEM* Item;
  int Pop;
  int Top;
};

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltQueueChange::Alter( C_XQUEUE* queue, C_SQ_ITEM* item, int pop, int top ) {
  Queue = queue;
  Item = item;
  Pop = pop;
  Top = top;
}

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpAltQueueChange::Rollback() {
  if( Pop ) {
    Queue->remove( Item );
  }
  else {
    if( Top ) {
      Queue->push_top( Item );
    }
    else {
      Queue->push_bot( Item );
    }
  }
  Pop = ! Pop;
}

DEFINE_MEMPOOL( SpAltQueueChange, ALT_CHUNK_SIZE )

#endif

