#include "SpAltTreeChange.H"
#include "RB_SpBinaryTree.H"

/**********************************************************************
 * 
 **********************************************************************/
void
SpAltTreeChange::Rollback() {
  if( Insert ) {
    Tree->InternalRemove( Key );
  }
  else {
    Tree->InternalInsert( Item, Key, TieBreaker );
  }
  Insert = ! Insert;
}

/**********************************************************************
 * 
 **********************************************************************/
void
SpAltTreeChange::Alter( RB_SpBinaryTree* tree,
			void* item,
			RBSpKey* key,
			int tieBreaker,
			int insert ) {
  Tree = tree;
  Item = item;
  Key = RB_SpBinaryTree::Clone(key); //Use the tree's free lists
  TieBreaker = tieBreaker;
  Insert = insert;
}

/**********************************************************************
 * 
 **********************************************************************/
void
SpAltTreeChange::Cleanup() {
  switch (Key->GetMode()){
  case STRING_KEY_MODE:
    Tree->DeleteSpStringKey((RBSpStringKey*)Key);
    break;
  case DOUBLE_KEY_MODE:
    Tree->DeleteSpDoubleKey((RBSpDoubleKey*)Key);
    break;
  default:
  cout<<"Unknown key tpe in SpAltTreeChange::Cleanup"<<endl;
  }
    //    delete Key;
}

PLUGIN_MEMPOOL( SpAltTreeChange )

