// SpDimInfo.H header file

#ifndef DimInfo_object
#define DimInfo_object

#include "SpStdlib.H"

/*
** This class provides the dimension information for the Hierarchical Grid
** data structure.
*/

class SpDimInfo {

  private:
    char *DimName;	// Name of the dimension (referenced)
    int DimNum;		// Number of the dimension
    double Lo;		// Lo value for the dimension
    double Hi;		// Hi value for the dimension
    int Nresolutions;	// Number of resolutions for the dimension
    double *Resolution;	// Array of resolutions for the dimension

  protected:

  public:

    SpDimInfo() {DimName = NULL; Resolution = NULL; Nresolutions = 0;}
    ~SpDimInfo() {delete [] Resolution;}

    void SetDimName(char *n) {DimName = n;}
    char *GetDimName() {return DimName;}

    void SetDimNum(int d) {DimNum = d;}
    int GetDimNum() {return DimNum;}

    void SetNresolutions(int n) {
      Nresolutions = n;
      Resolution = new double[n];
    }

    int GetNresolutions() {return Nresolutions;}

    void SetResolution(int i, double v) {
      Resolution[i] = v;
    }

    double GetResolution(int i) {return Resolution[i];}

    void SetLo(double L) {Lo = L;}
    double GetLo() {return Lo;}
    void SetHi(double H) {Hi = H;}
    double GetHi() {return Hi;}

};

typedef SpDimInfo DIM_INFO;

#endif
