// DynPtrArray.H header file defines the dynamic pointer array class

#ifndef DYN_PTR_ARR_CLASS
#define DYN_PTR_ARR_CLASS

#include "SpIostream.H"
#include "SpFstream.H"
#include "SpStrstream.H"
#include "SpIomanip.H"
#include "SpMemory.H"

class SpDynPtrArray {

  private:

    void **PointerArray;
    int ArraySize;

    void EnlargeSize(int size) {
      void **tempArray = new void*[size];
      memcpy((char *)tempArray,
	     (char *)PointerArray,
	     ArraySize * sizeof(void *));
      memset((void *)(tempArray + ArraySize),
             0,
             (size - ArraySize) * sizeof(void *));
      delete [] PointerArray;
      PointerArray = tempArray;
      ArraySize = size;
    }

  protected:

  public:

    SpDynPtrArray(int sizeOfArray = 2) {
      PointerArray = new void*[sizeOfArray];
      memset(PointerArray, 0, sizeOfArray * sizeof(void *));
      ArraySize = sizeOfArray;
    }

    ~SpDynPtrArray() {
      delete [] PointerArray;
    }

    int GetArraySize() {return ArraySize;}

// Dynamic array operators

    void *&operator [](int index) {
      if (index >= ArraySize) EnlargeSize(index+index);
      return PointerArray[index];
    }

};

typedef SpDynPtrArray DYN_PTR_ARRAY;

#endif
