#include "SpHolderItem.H"

PLUGIN_MEMPOOL(SpHolderItem);


SpPoMempool* GlobalSpPoMempool = NULL;

inline void SpPoMempool::GetMoreLists()
{
  int newNumLists = (1+NumLists)*2;
  PoolList =(SpHolderItemMempoolItemStack*)
    realloc(PoolList, sizeof(SpHolderItemMempoolItemStack)*newNumLists);
  memset(&(PoolList[NumLists]), 0, newNumLists - NumLists);
  NumLists = newNumLists;
}


int SpPoMempool::AddChunk(void* chunk,
			  int freeId,
			  int numElements,
			  int sizeOfElement)
{
  int rc = freeId;
  if (freeId == -1){
    if (NextId == NumLists){
      GetMoreLists();
    }
    rc = NextId++;
  }
  char* chunkPtr = (char*)chunk;
  for (int i = 0; i < numElements; ++i){
    //Following class defined by the DEFINE_MEMPOOL macro above
    SpHolderItemMempool* holder= (SpHolderItemMempool*)ALLOCATE_SpHolderItem();
    holder->SetValue(chunkPtr);
    PoolList[rc].Insert(holder);
    chunkPtr += sizeOfElement;
  }
  return rc;
}


SpPoMempool::SpPoMempool():NextId(0), NumLists(1000)
{
  PoolList = (SpHolderItemMempoolItemStack*)
    malloc(sizeof(SpHolderItemMempoolItemStack)*NumLists);
  memset(PoolList, 0, sizeof(SpHolderItemMempoolItemStack)*NumLists);
}

SpPoMempool::~SpPoMempool(){ free(PoolList); }
