#include "SpItemStack.H"
#include "SpHolderItem.H"

class SpHolderItemStack : private SpItemStack
{
public:
  SpHolderItemStack(int itemSize);
  int AddBlock(char* block, int numChunks);
  void* Remove();
private:
  int ItemSize;
};

inline SpHolderItemStack::SpHolderItemStack(int itemSize){ItemSize = itemSize;}

inline int SpHolderItemStack::AddBlock(char* block, int numChunks){
  int rc = 0;
  if (ItemSize != -1){
    rc = 1;
    for (int i=0; i < numChunks; ++i){
      SpHolderItem* holderItem= ALLOCATE_SpHolderItem();
      holderItem->SetValue(block);
      Insert(holderItem);
      block += ItemSize;
    }
  }
  return rc;
}

inline void* Remove()
{
  void* rc = NULL;
  SpItem* spItem = SpItemStack::Remove();
  if (spItem){
    rc = spItem->GetValue();
    DEALLOCATE_SpItem(spItem);
  }
  return rc;
}
