#ifndef SpItemQueue_Header
#define SpItemQueue_Header

#include "SpStdlib.H"

#include "SpItem.H"

/**********************************************************************
 * 
 **********************************************************************/
class SpItemQueue
{
public:
  SpItemQueue() : Bot( NULL ), Top( NULL ) {}
  void Append( SpItem* );
  void Insert( SpItem* );
  SpItem* Remove();
private:
  SpItem* Bot;
  SpItem* Top;
};

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpItemQueue::Append( SpItem* item )
{
  item->Next = NULL;
  if( Bot ) {
    Bot = Bot->Next = item;
  }
  else {
    Bot = Top = item;
  }
}

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpItemQueue::Insert( SpItem* item )
{
  item->Next = Top;
  if( Top ) {
    Top = item;
  }
  else {
    Top = Bot = item;
  }
}

/**********************************************************************
 * 
 **********************************************************************/
inline
SpItem*
SpItemQueue::Remove()
{
  SpItem* item = Top;

  if( Top ) {
    Top = Top->Next;
  }
  if( ! Top ) {
    Bot = Top;
  }

  return item;
}

/**********************************************************************
 * 
 **********************************************************************/
#define ITEM_QUEUE( Class )						\
									\
Class##ItemQueue							\
/*********************************************************************/

/**********************************************************************
 * 
 **********************************************************************/
#define DEFINE_ITEM_QUEUE( Class )					\
									\
class ITEM_QUEUE( Class )						\
{									\
public:									\
  void Append( Class##* );						\
  void Insert( Class##* );						\
  Class##* Remove();							\
private:								\
  SpItemQueue Queue;							\
};									\
									\
inline									\
void									\
ITEM_QUEUE( Class )::Append( Class##* item )				\
{									\
  Queue.Append( item );							\
}									\
									\
inline									\
void									\
ITEM_QUEUE( Class )::Insert( Class##* item )				\
{									\
  Queue.Insert( item );							\
}									\
									\
inline									\
Class##*								\
ITEM_QUEUE( Class )::Remove()						\
{									\
  return ( Class##* ) Queue.Remove();					\
}									\
/*********************************************************************/

#endif

