#ifndef SpItemStack_Header
#define SpItemStack_Header

#include "SpStdlib.H"

#include "SpItem.H"

/**********************************************************************
 * 
 **********************************************************************/
class SpItemStack
{
public:
  SpItemStack() : Top( NULL ) {}
  void Insert( SpItem* );
  SpItem* Remove();
private:
  SpItem* Top;
};

/**********************************************************************
 * 
 **********************************************************************/
inline
void
SpItemStack::Insert( SpItem* item )
{
  item->Next = Top;
  Top = item;
}

/**********************************************************************
 * 
 **********************************************************************/
inline
SpItem*
SpItemStack::Remove()
{
  SpItem* item = Top;

  if( Top ) {
    Top = Top->Next;
  }

  return item;
}

/**********************************************************************
 * 
 **********************************************************************/
#define ITEM_STACK( Class )						\
									\
Class##ItemStack							\
/*********************************************************************/

/**********************************************************************
 * 
 **********************************************************************/
#define DEFINE_ITEM_STACK( Class )					\
									\
class ITEM_STACK( Class )						\
{									\
public:									\
  void Insert( Class##* );						\
  Class##* Remove();							\
private:								\
  SpItemStack Stack;							\
};									\
									\
inline									\
void									\
ITEM_STACK( Class )::Insert( Class##* item )				\
{									\
  Stack.Insert( item );							\
}									\
									\
inline									\
Class##*								\
ITEM_STACK( Class )::Remove()						\
{									\
  return ( Class##* ) Stack.Remove();					\
}									\
/*********************************************************************/

#endif

