// SpList.C method file

#include "SpList.H"

SpList *SpList::FreeList = NULL;
int SpList::done = 0;

SpList::SpList() {
  if (done == 0) {
    done = 1;
    FreeList = new SpList();
  }
  Reset();
}

void SpList::Reset() {
  length = 0;
  top = NULL;
  bot = NULL;
  current = NULL;
}

void SpList::Remove(void *v) {
  SpList_ITEM *item;
  SpList_ITEM *previous;
  SpList_ITEM *next;

  if (length == 0) return;

  if (v == top->Reference) {
    if (current == top && length >= 2){
      current = top->ForwardLink;
    }
    DeleteItem(pop_item_top());
    return;
  }

  if (v == bot->Reference) {
    if (current == bot){
      current = bot->BackwardLink;
    }
    DeleteItem(pop_item_bot());
    return;
  }

  previous = top;
  item = top->ForwardLink;
  next = item->ForwardLink;

  while (item != bot) {
    if (item->Reference == v) {
      previous->ForwardLink = next;
      next->BackwardLink = previous;
      DeleteItem(item);
      length--;
      if (length == 0){
	top = bot = current = NULL;
      }
      return;
    }else{
      previous = item;
      item = next;
      next = item->ForwardLink;
    }
  }

  cout << "Error (remove): Could not remove item" << endl;

}
