// SpBasetype.H header file

#ifndef basetype_object
#define basetype_object

#include "namit.H"
#include "queue.H"

/************************************************************************
*	basetype object 						*
************************************************************************/
class SpBasetype : public C_NAMIT {

  private:

    C_QUEUE elements;
    int ntypes;
    int nenum;
    int counter;
    void *next_pointer;

  protected:

  public:

    SpBasetype(char *string);
    ~SpBasetype();
    
    void add(C_ITEM *item) {elements.push_bot(item);}
    void add_type(C_ITEM *item) {elements.push_top(item); ntypes++;}
    int get_ntypes() {return ntypes;}
    int get_enumid(char *s);
    int get_nenum() {return nenum;}
    void set_enum(int enm) {nenum = enm;}
    C_NAMIT *get_element(char *s);
    int exists(char *s);
    C_QUEUE *get_elements() {return &elements;}

    SpBasetype *get_first_type();
    SpBasetype *get_next_type();

    SpBasetype *get_type(char *s);

    int get_int(char *s, int i=-1);
    float get_float(char *s, int i=-1);
    char *get_string(char *s, int i=-1);
    int get_logical(char *s, int i=-1);
    int get_enum(char *s);
    char *get_enum(int i);

    int get_array_size(char *s);

    virtual void printfile(FILE *fp);

};


typedef SpBasetype C_BASETYPE;

#endif
