#ifndef __SpCrashOnDivZero__
#define __SpCrashOnDivZero__

//   The crash_on_divide_by_zero function should be called from the
// beginning of the main function.  There is more than one main
// function in all of speedes.  For example, there is one in speedes.C
// and in interact.C, etc.  All of these main functions should call
// crash_on_divide_by_zero.
//   The initial call to crash_on_divide_by_zero will later cause the
// program to crash if it does a divide by zero.  This function only
// does things on IRIX and Linux.  To get this same crashing effect on HPUX
// and SunOS, function calls are not necessary, but rather compiler
// options are used.  For more info see the file
// speedes/Admin/include_only_once.mak

#ifdef IRIX
#include <sigfpe.h>
#endif
  
#ifdef Linux
#include <fpu_control.h>
#endif

static inline void crash_on_divide_by_zero(void)
{
#ifdef ERROR_CHECK

#ifdef IRIX
  sigfpe_[_DIVZERO].abort=1;
  handle_sigfpes(_ON, _EN_DIVZERO, 0, _ABORT_ON_ERROR, 0);
#endif

#ifdef Linux
  __setfpucw(_FPU_DEFAULT & (~ _FPU_MASK_ZM));
#endif
  
#endif
}

#endif
