/**********************************************************************
*
*	C++ Source:		SpOS.C
*	Instance:		1
*	Description:	
*	%created_by:	vaniwaar %
*	%date_created:	Thu Jan  7 11:18:35 1999 %
*
**********************************************************************/
#ifndef lint
static char *_cxxsrc = "@(#) %filespec: SpOS.C-20 %  (%full_filespec: SpOS.C-20:c++:2 %)";

static char * this_function_is_only_here_so_that_the_compiler_does_not_complain_about_cxxsrc_being_unused() { this_function_is_only_here_so_that_the_compiler_does_not_complain_about_cxxsrc_being_unused(); return _cxxsrc; }
#endif

#include "SpStdlib.H"
#include "SpString.H"
#include "SpOS.H"
#include "SpIostream.H"

void SpeedesMicroSleep(int us)
{
  struct timeval NOP_Timeout;

  NOP_Timeout.tv_sec = 0;
  NOP_Timeout.tv_usec = us;
  select(0, NULL, NULL, NULL, &NOP_Timeout);
}


void SpeedesSleep(int s)
{
  struct timeval NOP_Timeout;

  NOP_Timeout.tv_sec = s;
  NOP_Timeout.tv_usec = 0;
  select(0, NULL, NULL, NULL, &NOP_Timeout);
}


int GETSOCKOPT(int s, int level, int optname,
	       char *optval, int *optlen) {
  return getsockopt(s, level, optname, optval,
#if __GNUC__ > 2 || (__GNUC__ == 2 && __GNUC_MINOR__ >= 90)
  (unsigned int *)
#endif
		    optlen);
}
int SELECT(int n, fd_set *readfds, fd_set *writefds,
		  fd_set *exceptfds, struct timeval *timeout)
{
  return select(n,
#if defined (HPUXA0905) ||  defined (HPUXB1001)
		(int*)
#endif
		readfds,
#if defined (HPUXA0905) ||  defined (HPUXB1001)
		(int*)
#endif
		writefds,
#if defined (HPUXA0905) ||  defined (HPUXB1001)
		(int*)
#endif
		exceptfds,
		timeout);
}


#ifndef __SPEEDES_NT__
#include <sys/types.h>
#include <sys/wait.h>

void SpeedesSpawn(char * name, char * arg0, ...)
{
  //int childPid;
  va_list va;
  va_start(va, arg0);
  char * argPtr = va_arg(va, char*);
  int numArgs = 1;
  while (argPtr != NULL){
    ++numArgs;
    argPtr = va_arg(va, char*);
  }
  char ** argv = new char*[numArgs+1];

  argv[0] = arg0;
  numArgs = 1;
  va_start(va, arg0);

  /* Note we are guaranteed argv is going to be NULL terminated */

  do {
    argPtr = va_arg(va, char*);
    argv[numArgs] = argPtr;
    ++numArgs;
  } while (argPtr != NULL);

  if (!(/*childPid = */fork())){ 
    if (execvp(name, argv)){ 
      char * Name2 = new char[strlen(name)+3]; 
      sprintf(Name2, "./%s",name); 
      if (execvp(Name2, argv)){ 
        cout<<'\a'<<"Could not exec the children!!!!  Command line is"<<endl; 
        for (int i=0; argv[i]; ++i){ 
          cout<<argv[i]<<" "; 
        } 
        cout<<endl; 
        char junkstr[1000]; 
        cout<<"and curent working directory is "<<getcwd(junkstr, 1000)<<endl; 
        exit(-17); 
      } 
    } 
  } 
  delete [] argv;
}


void SpeedesSpawnWait(char * name, char * arg0, ...){

  pid_t childPid;
  va_list va;
  va_start(va, arg0);
  char * argPtr = va_arg(va, char*);
  int numArgs = 1;
  while (argPtr != NULL){
    ++numArgs;
    argPtr = va_arg(va, char*);
  }
  char ** argv = new char*[numArgs+1];

  argv[0] = arg0;
  numArgs = 1;
  va_start(va, arg0);

  /* Note we are guaranteed argv is going to be NULL terminated */

  do {
    argPtr = va_arg(va, char*);
    argv[numArgs] = argPtr;
    ++numArgs;
  } while (argPtr != NULL);

  if (!(childPid = fork())){ 
    if (execvp(name, argv)){ 
      char * Name2 = new char[strlen(name)+3]; 
      sprintf(Name2, "./%s",name); 
      if (execvp(Name2, argv)){ 
        cout<<'\a'<<"Could not exec the children!!!!  Command line is"<<endl; 
        for (int i=0; argv[i]; ++i){ 
          cout<<argv[i]<<" "; 
        } 
        cout<<endl; 
        char junkstr[1000]; 
        cout<<"and curent working directory is "<<getcwd(junkstr, 1000)<<endl; 
        exit(-17); 
      } 
    } 
  } 
  delete [] argv;
  waitpid(childPid, NULL, 0);
}

#else //__IBMVACPP__


inline  void SpeedesMemset(char * ptr, const unsigned int size, const char val)
{
  for (int i=0; i < size; ++i){
    *ptr++ = val;
  }
}


void SpeedesSpawn(char * name, char * arg0, ...)
{
  HANDLE rc;
  va_list va;
  va_start(va, arg0);
  char * argPtr = va_arg(va, char*);
  int stringLength = strlen(arg0)+1; /* Add in the null terminator initially */
  STARTUPINFO startupInfo;
  PROCESS_INFORMATION processInformation;

  startupInfo.cb = sizeof(startupInfo);
  SpeedesMemset((char*)&startupInfo, sizeof(startupInfo), '\0');
  while (argPtr != NULL){
    if (argPtr != NULL){
      stringLength += strlen(argPtr)+1; /* +1 since I want a space to
					   separate every argument */
    }
    argPtr = va_arg(va, char*);
  }
  char * commandLine = new char[stringLength];
  char * commandPtr = commandLine;

  strcpy(commandPtr, arg0);
  commandPtr+= strlen(arg0);
  *commandPtr = ' ';
  ++commandPtr;

  va_start(va, arg0);
  argPtr = va_arg(va, char*);

  while (argPtr != NULL){
    if (argPtr != NULL){
      strcpy(commandPtr, argPtr);
      commandPtr+= strlen(argPtr);
      *commandPtr = ' ';
      ++commandPtr;
    }
    argPtr = va_arg(va, char*);
  }
  --commandPtr;
  *commandPtr = '\0';


  /* needed for the GNU compiler under NT */

  for (int jj=0; jj < stringLength; ++jj){
    if (commandLine[jj] == '/'){
      commandLine[jj] == '\\';
    }
  }


  CreateProcess(NULL,
		commandLine,
		NULL,
		NULL,
		1,
		NORMAL_PRIORITY_CLASS,
		//NORMAL_PRIORITY_CLASS | CREATE_NEW_CONSOLE,
		//NORMAL_PRIORITY_CLASS | DETACHED_PROCESS,
		NULL,
		NULL,
		&startupInfo,
		&processInformation
		);
}


void SpeedesSpawnWait(char * name, char * arg0, ...)
{
  HANDLE rc;
  va_list va;
  va_start(va, arg0);
  char * argPtr = va_arg(va, char*);
  int stringLength = strlen(arg0)+1; /* Add in the null terminator initially */
  STARTUPINFO startupInfo;
  PROCESS_INFORMATION processInformation;

  startupInfo.cb = sizeof(startupInfo);
  SpeedesMemset((char*)&startupInfo, sizeof(startupInfo), '\0');
  while (argPtr != NULL){
    if (argPtr != NULL){
      stringLength += strlen(argPtr)+1; /* +1 since I want a space to
					   separate every argument */
    }
    argPtr = va_arg(va, char*);
  }
  char * commandLine = new char[stringLength];
  char * commandPtr = commandLine;

  strcpy(commandPtr, arg0);
  commandPtr+= strlen(arg0);
  *commandPtr = ' ';
  ++commandPtr;

  va_start(va, arg0);
  argPtr = va_arg(va, char*);

  while (argPtr != NULL){
    if (argPtr != NULL){
      strcpy(commandPtr, argPtr);
      commandPtr+= strlen(argPtr);
      *commandPtr = ' ';
      ++commandPtr;
    }
    argPtr = va_arg(va, char*);
  }
  --commandPtr;
  *commandPtr = '\0';


  /* needed for the GNU compiler under NT */

  for (int jj=0; jj < stringLength; ++jj){
    if (commandLine[jj] == '/'){
      commandLine[jj] == '\\';
    }
  }


  CreateProcess(NULL,
		commandLine,
		NULL,
		NULL,
		1,
		NORMAL_PRIORITY_CLASS,
		//NORMAL_PRIORITY_CLASS | CREATE_NEW_CONSOLE,
		//NORMAL_PRIORITY_CLASS | DETACHED_PROCESS,
		NULL,
		NULL,
		&startupInfo,
		&processInformation
		);

  WaitForSingleObject(processInformation.hProcess, INFINITE);
}

#endif

#ifdef NEED_SEND_MSG

int sendmsg(int s, const struct msghdr * msg, int flags)
{
  int bytes = 0;
  int bytes2 = 0;
  
  if (msg->msg_iov[0].iov_len){
    bytes = send(s, msg->msg_iov[0].iov_base, msg->msg_iov[0].iov_len, flags);
  }
  if (bytes == msg->msg_iov[0].iov_len){
    bytes2 = send(s, msg->msg_iov[1].iov_base, msg->msg_iov[1].iov_len, flags);
  }
  if (bytes2 != -1){
    bytes += bytes2;
  }
  return bytes;
}

int recvmsg(int s, struct msghdr * msg, int flags)

{
  cout<<"recvmsg() is not implemented for CYGNUS or OS/2!!!!!!"<<endl;
  return 17;
}


#endif

