/**********************************************************************
*
*	C Header:		SpOS.H
*	Instance:		2
*	Description:	
*	%created_by:	vaniwaar %
*	%date_created:	Thu Dec 31 06:37:41 1998 %
*
**********************************************************************/
#ifndef _2_OS_Specific_H_H
#define _2_OS_Specific_H_H

#ifdef DEBUG
#define inline
#endif

#include "SpStdarg.H"
#include "SpStdio.H"
#include "SpTime.H"

#include <sys/types.h>
#ifndef __IBMCPP__
#include <sys/socket.h>
#endif

#ifdef __EMX__
static inline strcasecmp (const char * a, const char * b){return stricmp(a,b);}
#endif

#if defined (__EMX__) ||  defined (__CYGWIN32__)
#include <sys/uio.h>
#define NEED_SEND_MSG
#endif


#if defined (__SPEEDES_NT__)
#include <windows.h>
#define NEED_SEND_MSG 1
#endif

#if defined (__SPEEDES_NT__) &&  defined(__IBMCPP__)

#include <sys/timeb.h>
#define EWOULDBLOCK             WSAEWOULDBLOCK
#define ECONNREFUSED            WSAECONNREFUSED



#define strcasecmp(a, b) strcmpi((a), (b))

typedef char* caddr_t;
struct iovec
{
  caddr_t iov_base;
  int     iov_len;
};

struct msghdr {
        caddr_t msg_name;               /* optional address */
        int     msg_namelen;            /* size of address */
        struct  iovec *msg_iov;         /* scatter/gather array */
        int     msg_iovlen;             /* # elements in msg_iov */
        caddr_t msg_accrights;          /* access rights sent/received */
        int     msg_accrightslen;
};                                                                             

inline int gettimeofday(struct timeval *tp,struct timezone * tz)
{
  static struct timeb t;
  ftime(&t);
  tp->tv_sec = t.time;
  tp->tv_usec = t. millitm * 1000;
  return 0;
}

#endif



#ifndef __SPEEDES_NT__
#include <sys/time.h>
#include <netinet/tcp.h>
#endif



#ifndef __SPEEDES_NT__
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#endif


int SELECT(int n, fd_set *readfds, fd_set *writefds,
	   fd_set *exceptfds, struct timeval *timeout);

inline int ACCEPT(int s, struct sockaddr *addr, int *addrlen) {
  return accept(s, addr,
#if __GNUC__ > 2 || (__GNUC__ == 2 && __GNUC_MINOR__ >= 90)
		(unsigned int *)
#endif
		addrlen);
}


inline int GETSOCKNAME(int s, struct sockaddr *name, int *namelen) {
  return getsockname(s, name,
#if __GNUC__ > 2 || (__GNUC__ == 2 && __GNUC_MINOR__ >= 90)
		     (unsigned int *)
#endif
		     namelen);
}


int GETSOCKOPT(int s, int level, int optname,
	       char *optval, int *optlen);

#ifdef NEED_SEND_MSG

int sendmsg(int s, const struct msghdr * msg, int flags);

int recvmsg(int s, struct msghdr * msg, int flags);

#endif

void SpeedesSpawn(char * name, char * arg0, ...);
void SpeedesSpawnWait(char * name, char * arg0, ...);

void SpeedesMicroSleep(int us);


void SpeedesSleep(int s);

#endif
