#ifndef __SPEEDES_NT__
#include <unistd.h>
#else
#include <windows.h>
#include <winsock.h>
#endif

/*
** definitions of socket utility convenience functions
*/

struct hostent *get_host_by_name(char *name);
int set_nodelay(int sockno);
int socket_write(int sock, char *buff, int bytes);
int nb_socket_write(int sock,char *buff, int bytes);
int socket_read(int sock, char *buff, int bytes);
int nb_socket_read(int sock, char *buff, int bytes);
int set_nonblocking(int p_socket);
int set_blocking(int p_socket);


#define MAX_SOCK_BUFF (50000)  //GEB7: max size (bytes) of socket send/recv buffer
#define SEND_BUFF_SIZE MAX_SOCK_BUFF  //GEB7
#define RECV_BUFF_SIZE MAX_SOCK_BUFF  //GEB7


// Set the size of the Unix internal "send" buffer associated with 
// connection whose file descriptor is fd:
int setSendBuffsize(int fd, int sizeInBytes); //GEB7

// Set the size of the Unix internal "receive" buffer associated with 
// connection whose file descriptor is fd:
int setRecvBuffsize(int fd, int sizeInBytes); //GEB7
