#ifndef SpMempool_Header
#define SpMempool_Header

#include "SpItem.H"
#include "SpItemStack.H"

/**********************************************************************
 * 
 **********************************************************************/
class SpMempool : public SpItem
{
public:
  virtual void Deallocate() = 0;
};

/**********************************************************************
 * 
 **********************************************************************/
#define DEFINE_MEMPOOL( Class, Size )					\
									\
class ITEM_STACK( Class##Mempool );					\
									\
class Class##Mempool : public Class					\
{									\
public:									\
  static Class##Mempool* Allocate();					\
  virtual void Deallocate();						\
private:								\
  static ITEM_STACK( Class##Mempool ) Pool;				\
};									\
									\
DEFINE_ITEM_STACK( Class##Mempool )					\
									\
inline									\
Class##Mempool*								\
Class##Mempool::Allocate()						\
{									\
  Class##Mempool* temp;							\
  Class##Mempool* item;							\
									\
  if( ! ( item = Pool.Remove() ) ) {					\
    temp = new Class##Mempool[Size];					\
    for( item = temp; item < ( temp + Size ); Pool.Insert( item++ ) );	\
    item = Pool.Remove();						\
  }									\
  return item;								\
}									\
									\
inline									\
void									\
Class##Mempool::Deallocate()						\
{									\
  Pool.Insert( this );							\
}									\
									\
inline									\
Class##*								\
ALLOCATE_##Class##()							\
{									\
  return Class##Mempool::Allocate();					\
}									\
									\
inline									\
void									\
DEALLOCATE_##Class##( Class##* item )					\
{									\
  item->Deallocate();							\
}									\
/*********************************************************************/

/**********************************************************************
 * 
 **********************************************************************/
#define PLUGIN_MEMPOOL( Class )						\
									\
ITEM_STACK( Class##Mempool ) Class##Mempool::Pool;			\
/*********************************************************************/

#endif

