#ifndef definitions
#define definitions

#include "SpMath.H"

#define RPST    7.27220521664303950994e-05
#define GM      398601.3

#ifdef __SPEEDES_NT__

extern const double NauticalMiles_per_Mile;
extern const double Miles_per_Kilometer;
extern const double NauticalMiles_per_Kilometer;

extern const double Kilometers_per_Mile;
extern const double Kilometers_per_NauticalMile;

extern const double Seconds_per_Day;
extern const double Days_per_Second;

extern const double Seconds_per_Hour;
extern const double Hours_per_Second;

extern const double Seconds_per_Minute;
extern const double Minutes_per_Second;

extern const double RE;
extern const double RE2;
#else

static const double NauticalMiles_per_Mile = 0.86897624;
static const double Miles_per_Kilometer = 0.6213711922;
static const double NauticalMiles_per_Kilometer =
  NauticalMiles_per_Mile * Miles_per_Kilometer;

static const double Kilometers_per_Mile = 1.0 / Miles_per_Kilometer;
static const double Kilometers_per_NauticalMile = 1.0 / NauticalMiles_per_Kilometer;

static const double Seconds_per_Day = 24 * 3600;
static const double Days_per_Second = 1.0 / Seconds_per_Day;

static const double Seconds_per_Hour = 3600;
static const double Hours_per_Second = 1.0 / Seconds_per_Hour;

static const double Seconds_per_Minute = 60;
static const double Minutes_per_Second = 1.0 / Seconds_per_Minute;

static const double RE = 6378.145;
static const double RE2 = (RE*RE);

#endif


#define REAT 	6478.145  
#define REAT2	(REAT*REAT)   

#ifndef M_PI
#define M_PI 3.141592654
#endif

#ifndef PI
#define PI	3.141592654
#endif

#define TWOPI   6.283185307
#define PI_OVER2 1.570796327
#define CONRAD  0.017453292
#define CKS	0.299792458
#define OMEGAE	7.2921158279144062e-5
#define G	0.00980665
#define DEGRAD  57.29577951308232
#define RADDEG  0.0174532925199432958

#ifndef INFINITY
#define INFINITY 1.0e20
#endif

#define RGEO 42164.2
#define GSAM 0.0

#define ECI 0
#define ECR 1
#define EARTH 2

#endif
