#include "SpStopWatch.H"
#include "SpOS.H"


SpStopWatch::SpStopWatch() {
  StartTime = 0.0;
  StartClockTime = 0;
  CumulativeTime = 0.0;
  CumulativeClockTime = 0.0;
  name = NULL;
  ClockFlag = 0;
}

SpStopWatch::SpStopWatch(char *n) {
  StartTime = 0.0;
  StartClockTime = 0;
  CumulativeTime = 0.0;
  CumulativeClockTime = 0.0;
  name = NULL;
  if (n) name = strdup(n);
  ClockFlag = 0;
}


SpStopWatch::~SpStopWatch() {
  if (name) free(name);
}

void SpStopWatch::print(ostream &out) const {
  out << "Stop Watch: " << name
      << " Cumulative Time = " << CumulativeTime
      << ", CPU Time = " << CumulativeClockTime << endl;
}

void SpStopWatch::StartTimer() {
  struct timeval tp;

  StartClockTime = clock();
  gettimeofday(&tp, NULL);
  StartTime = ((double)(tp.tv_sec) + (double)(tp.tv_usec) / 1000000.0);
}

double SpStopWatch::StopTimer() {
  struct timeval tp;
  double Time;
  double ClockTime;

  gettimeofday(&tp, NULL);
  Time = ((double)(tp.tv_sec) + (double)(tp.tv_usec) / 1000000.0)
    - StartTime;
  CumulativeTime += Time;

  ClockTime = double(clock()-StartClockTime)/CLOCKS_PER_SEC;
  CumulativeClockTime += ClockTime;

  if (ClockFlag == 0) {
    return Time;
  }else{
    return ClockTime;
  }

}
