#ifndef _SpParserCommon_H
#define _SpParserCommon_H

#if !defined(__GNUC__) && !defined(__SPEEDES_NT__)
#define bool short
#define false (short) 0
#define true (short) 1
#endif  // #ifndef __GNUC__

#define INITIAL_SEQUENCE_LENGTH 5

#include "SpSet.H"
#include "SpList.H"

class SpParserFlexLexer;
struct include_statement;

class SpSetStack: public SpList 
{
public:
  SpSetStack() {}
  void Push(SpSet *set) {
    InsertTop((void *) set);
  }
  SpSet *Pop() {
    SpSet *retval = (SpSet *) PopTop();
    return retval;
  }
  SpSet *Top() {
    SpSet *retval = (SpSet *) GetFirstElement();
    return retval;
  }
};

class SpIncludeStack: public SpList 
{
public:
  SpIncludeStack() {}
  void Push(struct include_statement *include) {
    InsertTop((void *) include);
  }
  struct include_statement *Pop() {
    struct include_statement *retval = (struct include_statement *) 
      PopTop();
    return retval;
  }
  struct include_statement *Top() {
    struct include_statement *retval = (struct include_statement *) 
      GetFirstElement();
    return retval;
  }
};

struct SpParserCommon {
  SpSet *toplev;
  SpBinaryTree *intro;
  SpSetStack set_stack;
  SpSetArray *current_array;
  SpIncludeStack include_statements;
  SpParserFlexLexer *scanner;
  SpParserCommon():toplev(NULL), intro(NULL), current_array(NULL),scanner(NULL)
    {}
};


struct floatval_seq {
  double *val;
  int length;
};

struct intval_seq {
  int *val;
  int length;
};

struct boolval_seq {
  bool *val;
  int length;
};

struct str_seq {
  char **val;
  int length;
};

struct kwd_struct {
  char *name;
  SpSetArray *typelist;
};

struct include_statement {
  SpSet *include_dest;
  char *include_target;
};

#endif // #ifndef _SpParserCommon_H
