#ifndef SpAltPOAddRemove_H
#define SpAltPOAddRemove_H

#include "SpAlt.H"
#include "SpPoDataBase.H"

class SpAltPoAddRemove : public SpAlt {
public:
  enum AddRemoveType
  {
    ADD = 0,
    REMOVE = 1
  };

  void Alter(void * valuePtr,
	     AddRemoveType addRemove,
	     SpPoDataBase* db,
	     int type,
	     int nBytes);
  virtual void Rollback();
  virtual void Cleanup();

private:
  void * Value;
  SpPoDataBase* POdb;
  AddRemoveType AddRemove;
  int Type;
  int Nbytes;


};

inline void SpAltPoAddRemove::Alter(void *valuePtr,
				    AddRemoveType addRemove,
				    SpPoDataBase* db,
				    int type,
				    int nBytes){
  Value = valuePtr;
  AddRemove = addRemove;
  POdb = db;
  Type = type;
  Nbytes = nBytes;
}

inline void SpAltPoAddRemove::Rollback() {
  if (AddRemove == ADD){
    POdb->Remove(Value);

    AddRemove = REMOVE;
  }
  else{
    POdb->Add(Value, Nbytes, Type);
    AddRemove = ADD;
  }
}

inline void SpAltPoAddRemove::Cleanup(){
}


DEFINE_MEMPOOL(SpAltPoAddRemove, ALT_CHUNK_SIZE)

#endif
