#include "SpStdlib.H"
#include "SpMemBlkHolder.H"
#include "BinaryTree.H"
#include "SpPersistencePtr.H"
class SpPoDataBase;
extern SpPoDataBase * DefaultDataBase;


SpMemBlkHolder::~SpMemBlkHolder(){
  if (TreeOfPointers){
    PERSISTENCE_PTR * ptr;
    while ((ptr=(PERSISTENCE_PTR*)(TreeOfPointers->RemoveFirstElement()))){
      delete ptr;
    }
    delete TreeOfPointers;
  }
}

void SpMemBlkHolder::AddPersistentPointer(PERSISTENCE_PTR* ptr){
  if (!TreeOfPointers){
    TreeOfPointers = new SpBinaryTree;
  }
  TreeOfPointers->Insert(ptr, ptr->GetOffset());
}




void SpMemBlkHolder::SetPointer(void * &pointer){
  int offset = ((int)&pointer) - (int)BaseAddr;
  if (!TreeOfPointers){
    TreeOfPointers = new SpBinaryTree;
  }
  
  PERSISTENCE_PTR* tPtr = (PERSISTENCE_PTR*)TreeOfPointers->Find(offset);
  if (!tPtr){
    tPtr = new PERSISTENCE_PTR;
    TreeOfPointers->Insert(tPtr, offset);
  }
  else{
    //cout<<"Resetting pointer"<<endl;
  }
  tPtr->SetOffset(offset);
}

void SpMemBlkHolder::UnsetPointer(void * &pointer){
  int offset = ((int)&pointer) - (int)BaseAddr;
  
  PERSISTENCE_PTR* tPtr =(PERSISTENCE_PTR*)TreeOfPointers->Remove(offset);
  
  if (!tPtr){
    //cout<<"Tried to unset a pointer that has not been set"<<endl;
  }
  else{
    //cout<<"Found a pointer to unset; removing and deleting"<<endl;
    delete tPtr;
  }
}

