#ifndef SP_MEM_BLK_HOLDER_H
#define SP_MEM_BLK_HOLDER_H

class PERSISTENCE_PTR;

class SpBinaryTree;

class SpMemBlkHolder {
public:

  SpMemBlkHolder(int size = -1, int type = -1);
  virtual ~SpMemBlkHolder();
  void SetSize(int p){MemorySize = p;}
  int  GetSize(){return MemorySize;}

  void AddPersistentPointer(PERSISTENCE_PTR* ptr);
  SpBinaryTree* GetPtrTree(){return TreeOfPointers;}
  
  void SetType(int o){Type = o;}
  int  GetType(){return Type;}

  void SetPointer(void * &pointer);

  void UnsetPointer(void * &pointer);
  void SetBaseAddr(void *bAddr){BaseAddr = bAddr;}
  void * GetBaseAddr(){ return BaseAddr;}


  void Init(){TreeOfPointers = 0; BaseAddr=this;}
protected:

private:
  SpBinaryTree * TreeOfPointers;	// List of   PERSISTENCE_PTRs
  unsigned int MemorySize;
  unsigned int Type;
  void * BaseAddr;		// For items that don't derive from this class
};


inline SpMemBlkHolder::SpMemBlkHolder(int size,
						      int type)
  :TreeOfPointers(0), MemorySize(size),Type(type),
   BaseAddr(0) {}

#endif
